#ifndef __c1_GPCA_h__
#define __c1_GPCA_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"

/* Type Definitions */
#ifndef struct_c1_DrugLibrary_tag
#define struct_c1_DrugLibrary_tag
typedef struct c1_DrugLibrary_tag {
  uint32_T drugID;
  real_T amount;
  real_T diluentVolume;
  real_T doseRateTypical;
  real_T doseRateUpperHardLimit;
  real_T doseRateUpperSoftLimit;
  real_T doseRateLowerHardLimit;
  real_T doseRateLowerSoftLimit;
  uint32_T doseRateUnit;
  real_T vtbiTypical;
  real_T vtbiUpperHardLimit;
  real_T vtbiUpperSoftLimit;
  real_T vtbiLowerHardLimit;
  real_T vtbiLowerSoftLimit;
  uint32_T vtbiUnit;
  real_T drugConcentrationTypical;
  real_T drugConcentrationUpperHardLimit;
  real_T drugConcentrationUpperSoftLimit;
  real_T drugConcentrationLowerHardLimit;
  real_T drugConcentrationLowerSoftLimit;
} c1_DrugLibrary;
#else
typedef struct c1_DrugLibrary_tag c1_DrugLibrary;
#endif

#ifndef struct_c1_PatientInformation_tag
#define struct_c1_PatientInformation_tag
typedef struct c1_PatientInformation_tag {
  uint32_T patientID;
  uint32_T patientAge;
  uint32_T patientGender;
  uint32_T patientWeight;
} c1_PatientInformation;
#else
typedef struct c1_PatientInformation_tag c1_PatientInformation;
#endif

#ifndef struct_c1_DrugInformation_tag
#define struct_c1_DrugInformation_tag
typedef struct c1_DrugInformation_tag {
  uint32_T drugID;
  real_T drugDoseAmount;
  real_T drugDiluentVolume;
  real_T drugConcentration;
  uint32_T drugDoseUnit;
  uint32_T drugVolumeUnit;
} c1_DrugInformation;
#else
typedef struct c1_DrugInformation_tag c1_DrugInformation;
#endif

#ifndef struct_c1_InfusionParameters_tag
#define struct_c1_InfusionParameters_tag
typedef struct c1_InfusionParameters_tag {
  real_T programmedVTBI;
  real_T programmedDoseRate;
} c1_InfusionParameters;
#else
typedef struct c1_InfusionParameters_tag c1_InfusionParameters;
#endif

#ifndef struct_c1_InfusionStatus_tag
#define struct_c1_InfusionStatus_tag
typedef struct c1_InfusionStatus_tag {
  boolean_T isBolusInProgress;
  real_T totalVolumeInfused;
  real_T remainingVolumeInReservoir;
} c1_InfusionStatus;
#else
typedef struct c1_InfusionStatus_tag c1_InfusionStatus;
#endif

#ifndef struct_c1_PumpConfigurationsStatus_tag
#define struct_c1_PumpConfigurationsStatus_tag
typedef struct c1_PumpConfigurationsStatus_tag {
  boolean_T isPOSTSuccessful;
  boolean_T isPumpPrimed;
  boolean_T isAdminSetCheckPassed;
} c1_PumpConfigurationsStatus;
#else
typedef struct c1_PumpConfigurationsStatus_tag c1_PumpConfigurationsStatus;
#endif

typedef struct {
  real_T c1_doseRate;
  real_T c1_temp;
  real_T c1_vtbi;
  SimStruct *S;
  int32_T c1_ioBusOffset[38];
  uint32_T c1_E_AlarmClearEventCounter;
  uint32_T c1_E_RequestToStartEventCounter;
  uint32_T c1_E_RestartEventCounter;
  uint32_T c1_MSG_ADMINCHECK;
  uint32_T c1_MSG_ADMINFAIL;
  uint32_T c1_MSG_AIRINLINE;
  uint32_T c1_MSG_ALMVTBI;
  uint32_T c1_MSG_ALRMDR;
  uint32_T c1_MSG_BLANK;
  uint32_T c1_MSG_BOLUSDENIED;
  uint32_T c1_MSG_BOLUSGRANT;
  uint32_T c1_MSG_CHANGEDR;
  uint32_T c1_MSG_CHANGEVTBI;
  uint32_T c1_MSG_CHECKCON;
  uint32_T c1_MSG_CHECKDR;
  uint32_T c1_MSG_CHECKDU;
  uint32_T c1_MSG_CHECKTYPE;
  uint32_T c1_MSG_CHECKVTBI;
  uint32_T c1_MSG_CONFIRMPAUSE;
  uint32_T c1_MSG_CONFIRMSTOP;
  uint32_T c1_MSG_CPUFAILURE;
  uint32_T c1_MSG_DANGECON;
  uint32_T c1_MSG_DANGERAP;
  uint32_T c1_MSG_DANGERENVTEMP;
  uint32_T c1_MSG_DANGERHUMD;
  uint32_T c1_MSG_DISPLAYDR;
  uint32_T c1_MSG_DISPLAYSET;
  uint32_T c1_MSG_DOOROPEN;
  uint32_T c1_MSG_DRUGINFO;
  uint32_T c1_MSG_EMPTYRESERVOIR;
  uint32_T c1_MSG_FLOWRATEVARY;
  uint32_T c1_MSG_INFUSING;
  uint32_T c1_MSG_INFUSIONPAUSED;
  uint32_T c1_MSG_INFUSIONSTOP;
  uint32_T c1_MSG_LESSTHANKVO;
  uint32_T c1_MSG_LOGERR;
  uint32_T c1_MSG_LOWBATT;
  uint32_T c1_MSG_LOWRESR;
  uint32_T c1_MSG_MEMORYCORRUPT;
  uint32_T c1_MSG_NOTREADY;
  uint32_T c1_MSG_OCCULUSION;
  uint32_T c1_MSG_OUTOFPOWER;
  uint32_T c1_MSG_OVERINFUSION;
  uint32_T c1_MSG_PATIENTINFO;
  uint32_T c1_MSG_PAUSELONG;
  uint32_T c1_MSG_PAUSETOOLONG;
  uint32_T c1_MSG_POST;
  uint32_T c1_MSG_POSTDONE;
  uint32_T c1_MSG_POSTFAIL;
  uint32_T c1_MSG_POWEROFF;
  uint32_T c1_MSG_PRIME;
  uint32_T c1_MSG_PRIMEFAIL;
  uint32_T c1_MSG_PUMPOVERHEAT;
  uint32_T c1_MSG_PUMPTOOHOT;
  uint32_T c1_MSG_RATEEXCEEDCAPACITY;
  uint32_T c1_MSG_REALTIMECLOCK;
  uint32_T c1_MSG_SPCHOOSE;
  uint32_T c1_MSG_STOPBOLUS;
  uint32_T c1_MSG_STOPPAUSE;
  uint32_T c1_MSG_UNDERINFUSION;
  uint32_T c1_MSG_VOLTOUTRANGE;
  uint32_T c1_MSG_VTBI;
  uint32_T c1_MSG_WATCHDOGALERT;
  uint32_T c1_MSG_WELCOME;
  uint32_T c1_MSG_WRNBATTERYCHARGE;
  uint32_T c1_MSG_WRNDR;
  uint32_T c1_MSG_WRNVTBI;
  uint32_T c1_MSG_WRONGCON;
  uint32_T c1_MSG_WRONGDRUG;
  uint32_T c1_MSG_WRONGDU;
  uint32_T c1_tempx;
  boolean_T c1_bolusing;
  uint8_T c1_is_CheckDrugRoutine;
  uint8_T c1_is_ConfigureInfusionProgram;
  uint8_T c1_is_InfusionInSession;
  uint8_T c1_is_InfusionStateMachine;
  uint8_T c1_is_InfusionSubMachine;
  uint8_T c1_is_active_c1_GPCA;
  uint8_T c1_is_c1_GPCA;
  uint8_T c1_was_CheckDrugRoutine;
  uint8_T c1_was_ConfigureInfusionProgram;
  uint8_T c1_was_InfusionInSession;
  ChartInfoStruct chartInfo;
} SFc1_GPCAInstanceStruct;

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
const mxArray *sf_c1_GPCA_get_eml_resolved_functions_info(void);

/* Function Definitions */

extern void sf_c1_GPCA_get_check_sum(mxArray *plhs[]);
extern void c1_GPCA_method_dispatcher(SimStruct *S, int_T method, void *data);

#endif

