#ifndef __c3_GPCA_h__
#define __c3_GPCA_h__

/* Include files */
#include "sfc_sf.h"
#include "sfc_mex.h"

/* Type Definitions */
#ifndef struct_c3_EnvironmentSensorSignals_tag
#define struct_c3_EnvironmentSensorSignals_tag
typedef struct c3_EnvironmentSensorSignals_tag {
  boolean_T isTemperatureOutOfRange;
  boolean_T isHumidityOutOfRange;
  boolean_T isAirPressureOutOfRange;
} c3_EnvironmentSensorSignals;
#else
typedef struct c3_EnvironmentSensorSignals_tag c3_EnvironmentSensorSignals;
#endif

#ifndef struct_c3_HardwareSensorSignals_tag
#define struct_c3_HardwareSensorSignals_tag
typedef struct c3_HardwareSensorSignals_tag {
  boolean_T isLoggingFailed;
  boolean_T isWatchDogInterruptDetected;
  boolean_T isReservoirDoorOpen;
  boolean_T isBatteryDepleted;
  boolean_T isBatteryLow;
  boolean_T isBatteryUnableToCharge;
  boolean_T isSupplyVoltageOutOfRange;
  boolean_T isCPUInError;
  boolean_T isRTCInError;
  boolean_T isMemoryCorrupted;
  boolean_T isPumpTooHot;
  boolean_T isPumpOverheated;
} c3_HardwareSensorSignals;
#else
typedef struct c3_HardwareSensorSignals_tag c3_HardwareSensorSignals;
#endif

#ifndef struct_c3_InfusionSensorSignals_tag
#define struct_c3_InfusionSensorSignals_tag
typedef struct c3_InfusionSensorSignals_tag {
  boolean_T isReservoirEmpty;
  boolean_T isReservoirLow;
  boolean_T isOcclusionDetected;
  boolean_T isInfusionRateTooHigh;
  boolean_T isInfusionRateTooLow;
  boolean_T isInfusionRateLessThanKVO;
  boolean_T isFlowRateNotStable;
  boolean_T isFlowRateOverPumpCapacity;
  boolean_T isInfusionPausedLong;
  boolean_T isInfusionPausedTooLong;
  boolean_T isAirInLineDetected;
} c3_InfusionSensorSignals;
#else
typedef struct c3_InfusionSensorSignals_tag c3_InfusionSensorSignals;
#endif

typedef struct {
  SimStruct *S;
  int32_T c3_ioBusOffset[26];
  uint32_T c3_E_AlarmEventCounter;
  uint32_T c3_E_NotReadyEventCounter;
  uint32_T c3_E_ReadyEventCounter;
  uint32_T c3_E_WarningEventCounter;
  uint32_T c3_LOneCond;
  uint32_T c3_LTwoCond;
  uint32_T c3_MSG_BLANK;
  uint32_T c3_WnCond;
  boolean_T c3_temp;
  uint8_T c3_is_CheckReady;
  uint8_T c3_is_Controller;
  uint8_T c3_is_LOne;
  uint8_T c3_is_LTwo;
  uint8_T c3_is_WRN;
  uint8_T c3_is_active_CheckReady;
  uint8_T c3_is_active_Controller;
  uint8_T c3_is_active_LOne;
  uint8_T c3_is_active_LTwo;
  uint8_T c3_is_active_WRN;
  uint8_T c3_is_active_c3_GPCA;
  uint8_T c3_is_c3_GPCA;
  ChartInfoStruct chartInfo;
} SFc3_GPCAInstanceStruct;

/* Named Constants */

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
const mxArray *sf_c3_GPCA_get_eml_resolved_functions_info(void);

/* Function Definitions */

extern void sf_c3_GPCA_get_check_sum(mxArray *plhs[]);
extern void c3_GPCA_method_dispatcher(SimStruct *S, int_T method, void *data);

#endif

