/* Include files */
#include "GPCA_Extension_sfun.h"
#include "c3_GPCA_Extension.h"

/* Type Definitions */

/* Named Constants */
#define c3_event_E_Restart              (10U)
#define c3_event_E_AlarmClear           (7U)
#define c3_event_E_LevelOneAlarm        (2U)
#define c3_event_E_LevelTwoAlarm        (14U)
#define c3_event_E_LevelOneClear        (6U)
#define c3_event_E_ResetOne             (4U)
#define c3_event_E_DoneOne              (8U)
#define c3_event_E_DoneThree            (11U)
#define c3_event_E_DoneTwo              (5U)
#define c3_event_E_ResetTwo             (9U)
#define c3_event_E_ResetThree           (13U)
#define c3_event_E_WarningAlarm         (0U)
#define c3_event_E_RequestToStart       (16U)
#define c3_event_E_Clock                (15U)
#define c3_IN_NO_ACTIVE_CHILD           (0)
#define c3_IN_HumidityCheck             (7)
#define c3_IN_BatteryChargingCheck      (2)
#define c3_IN_LowBatteryCheck           (10)
#define c3_IN_LoggingCheck              (9)
#define c3_IN_InfusionPausedDurationCheck (8)
#define c3_IN_EndState                  (3)
#define c3_IN_WNStart                   (14)
#define c3_IN_LowReservoirCheck         (11)
#define c3_IN_Hold                      (4)
#define c3_IN_HOLD                      (3)
#define c3_IN_AlarmingMachine           (1)
#define c3_IN_SinkTWOCheckOne           (7)
#define c3_IN_START                     (4)
#define c3_IN_WatchdogCheck             (9)
#define c3_IN_Sink24                    (15)
#define c3_IN_Sink26                    (17)
#define c3_IN_RateOverPumpCapacityCheck (10)
#define c3_IN_CheckLOne                 (1)
#define c3_IN_CheckWRN                  (3)
#define c3_IN_SinkOne                   (5)
#define c3_IN_LowInfusionRateCheck      (6)
#define c3_IN_RateLessThanKVOCheck      (9)
#define c3_IN_Sink25                    (16)
#define c3_IN_OcculusionCheck           (8)
#define c3_IN_Sink23                    (14)
#define c3_IN_HighInfusionRateCheck     (3)
#define c3_IN_SinkTWO                   (6)
#define c3_IN_Normal                    (7)
#define c3_IN_DoorOpenCheck             (2)
#define c3_IN_Sink22                    (13)
#define c3_b_IN_Normal                  (2)
#define c3_IN_s1                        (3)
#define c3_IN_ReservoirEmptyCheck       (11)
#define c3_IN_Sink21                    (12)
#define c3_IN_MemoryCheck               (5)
#define c3_IN_CPUCheck                  (2)
#define c3_IN_VoltageCheck              (13)
#define c3_IN_RTCCheck                  (8)
#define c3_IN_FlowRateStabilityCheck    (5)
#define c3_c_IN_Normal                  (6)
#define c3_IN_InfusionPauseDurationCheck (5)
#define c3_IN_Checking                  (1)
#define c3_IN_CheckLTwo                 (2)
#define c3_IN_Sink27                    (18)
#define c3_IN_AirInLineCheck            (1)
#define c3_IN_Sink29                    (20)
#define c3_IN_Sink28                    (19)
#define c3_IN_PumpTempCheck             (7)
#define c3_IN_s2                        (4)
#define c3_IN_L1Sink                    (4)
#define c3_IN_BatteryDepletionCheck     (1)
#define c3_IN_HoldOn                    (6)
#define c3_b_IN_PumpTempCheck           (12)
#define c3_IN_EnvTempCheck              (4)
#define c3_IN_APErrCheck                (1)
#define c3_const_MSG_BLANK              (30U)

/* Variable Declarations */

/* Variable Definitions */
static SFc3_GPCA_ExtensionInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c3_GPCA_Extension(void);
static void initialize_params_c3_GPCA_Extension(void);
static void enable_c3_GPCA_Extension(void);
static void disable_c3_GPCA_Extension(void);
static void finalize_c3_GPCA_Extension(void);
static void sf_c3_GPCA_Extension(void);
static void c3_c3_GPCA_Extension(void);
static void c3_WRN(void);
static void c3_Controller(void);
static void c3_LTwo(void);
static uint32_T c3_clearWarning(uint32_T c3_cond);
static uint32_T c3_isPumpReady(void);
static void c3_LOne(void);
static void init_script_number_translation(uint32_T c3_machineNumber, uint32_T
 c3_chartNumber);
static void init_io_bus_offset(void);
static void *get_HardwareSensorSignals_element(void *c3_addr, int32_T c3_idx);
static void *get_EnvironmentSensorSignals_element(void *c3_addr, int32_T c3_idx);
static void *get_InfusionSensorSignals_element(void *c3_addr, int32_T c3_idx);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c3_GPCA_Extension(void)
{
  real_T *c3_ErrCond;
  boolean_T *c3_E_Alarm;
  boolean_T *c3_E_Warning;
  boolean_T *c3_E_Ready;
  boolean_T *c3_E_NotReady;
  c3_E_Ready = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 4);
  c3_E_Alarm = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 2);
  c3_E_Warning = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 3);
  c3_E_NotReady = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 5);
  c3_ErrCond = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c3_is_active_CheckReady = 0U;
  chartInstance.c3_is_CheckReady = 0U;
  chartInstance.c3_is_active_Controller = 0U;
  chartInstance.c3_is_Controller = 0U;
  chartInstance.c3_is_active_LOne = 0U;
  chartInstance.c3_is_LOne = 0U;
  chartInstance.c3_is_active_LTwo = 0U;
  chartInstance.c3_is_LTwo = 0U;
  chartInstance.c3_is_active_WRN = 0U;
  chartInstance.c3_is_WRN = 0U;
  chartInstance.c3_is_active_c3_GPCA_Extension = 0U;
  chartInstance.c3_is_c3_GPCA_Extension = 0U;
  chartInstance.c3_LOneCond = 0U;
  chartInstance.c3_LTwoCond = 0U;
  chartInstance.c3_WnCond = 0U;
  chartInstance.c3_temp = 0U;
  chartInstance.c3_MSG_BLANK = 30U;
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 1) != 0)) {
    *c3_ErrCond = 0.0;
  }
  chartInstance.c3_E_AlarmEventCounter = 0U;
  *c3_E_Alarm = false;
  chartInstance.c3_E_WarningEventCounter = 0U;
  *c3_E_Warning = false;
  chartInstance.c3_E_ReadyEventCounter = 0U;
  *c3_E_Ready = false;
  chartInstance.c3_E_NotReadyEventCounter = 0U;
  *c3_E_NotReady = false;
}

static void initialize_params_c3_GPCA_Extension(void)
{
}

static void enable_c3_GPCA_Extension(void)
{
}

static void disable_c3_GPCA_Extension(void)
{
}

static void finalize_c3_GPCA_Extension(void)
{
}

static void sf_c3_GPCA_Extension(void)
{
  int32_T c3_inputEventFiredFlag;
  uint8_T c3_previousEvent;
  int8_T *c3_E_Restart;
  int8_T *c3_E_AlarmClear;
  int8_T *c3_E_RequestToStart;
  int8_T *c3_E_Clock;
  boolean_T *c3_E_Alarm;
  boolean_T *c3_E_Warning;
  boolean_T *c3_E_Ready;
  boolean_T *c3_E_NotReady;
  c3_E_RequestToStart = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 6)
   + 2);
  c3_E_Clock = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 6) + 3);
  c3_E_Ready = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 4);
  c3_E_Alarm = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 2);
  c3_E_Warning = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 3);
  c3_E_NotReady = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 5);
  c3_E_Restart = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 6) + 0);
  c3_E_AlarmClear = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 6) +
   1);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  c3_inputEventFiredFlag = 0;
  if(*c3_E_Restart == 1) {
    c3_inputEventFiredFlag = 1;
    c3_previousEvent = _sfEvent_;
    _sfEvent_ = c3_event_E_Restart;
    c3_c3_GPCA_Extension();
    _sfEvent_ = c3_previousEvent;
  }
  if(*c3_E_AlarmClear == 1) {
    c3_inputEventFiredFlag = 1;
    c3_previousEvent = _sfEvent_;
    _sfEvent_ = c3_event_E_AlarmClear;
    c3_c3_GPCA_Extension();
    _sfEvent_ = c3_previousEvent;
  }
  if(*c3_E_RequestToStart != 0) {
    c3_inputEventFiredFlag = 1;
    c3_previousEvent = _sfEvent_;
    _sfEvent_ = c3_event_E_RequestToStart;
    c3_c3_GPCA_Extension();
    _sfEvent_ = c3_previousEvent;
  }
  if(*c3_E_Clock == 1) {
    c3_inputEventFiredFlag = 1;
    c3_previousEvent = _sfEvent_;
    _sfEvent_ = c3_event_E_Clock;
    c3_c3_GPCA_Extension();
    _sfEvent_ = c3_previousEvent;
  }
  if((c3_inputEventFiredFlag != 0) && (chartInstance.c3_E_AlarmEventCounter >
    0U)) {
    *c3_E_Alarm = !(*c3_E_Alarm);
    chartInstance.c3_E_AlarmEventCounter = chartInstance.c3_E_AlarmEventCounter
      - 1U;
  }
  if((c3_inputEventFiredFlag != 0) && (chartInstance.c3_E_WarningEventCounter >
    0U)) {
    *c3_E_Warning = !(*c3_E_Warning);
    chartInstance.c3_E_WarningEventCounter =
      chartInstance.c3_E_WarningEventCounter - 1U;
  }
  if((c3_inputEventFiredFlag != 0) && (chartInstance.c3_E_ReadyEventCounter >
    0U)) {
    *c3_E_Ready = !(*c3_E_Ready);
    chartInstance.c3_E_ReadyEventCounter = chartInstance.c3_E_ReadyEventCounter
      - 1U;
  }
  if((c3_inputEventFiredFlag != 0) && (chartInstance.c3_E_NotReadyEventCounter >
    0U)) {
    *c3_E_NotReady = !(*c3_E_NotReady);
    chartInstance.c3_E_NotReadyEventCounter =
      chartInstance.c3_E_NotReadyEventCounter - 1U;
  }
}

static void c3_c3_GPCA_Extension(void)
{
  boolean_T *c3_infusionInProgress;
  real_T *c3_ErrCond;
  c3_ErrCond = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  c3_infusionInProgress = (boolean_T *)ssGetInputPortSignal(chartInstance.S, 1);
  if(chartInstance.c3_is_active_c3_GPCA_Extension == 0) {
    chartInstance.c3_is_active_c3_GPCA_Extension = 1U;
    chartInstance.c3_is_c3_GPCA_Extension = (uint8_T)c3_IN_AlarmingMachine;
    chartInstance.c3_is_active_Controller = 1U;
    if(chartInstance.c3_is_Controller != c3_IN_START) {
      chartInstance.c3_is_Controller = (uint8_T)c3_IN_START;
      chartInstance.c3_LOneCond = 0U;
      chartInstance.c3_LTwoCond = 0U;
      chartInstance.c3_WnCond = 0U;
      *c3_ErrCond = 0.0;
    }
    chartInstance.c3_is_active_CheckReady = 1U;
    chartInstance.c3_is_CheckReady = (uint8_T)c3_b_IN_Normal;
    chartInstance.c3_is_active_LOne = 1U;
    chartInstance.c3_is_LOne = (uint8_T)c3_c_IN_Normal;
    chartInstance.c3_is_active_LTwo = 1U;
    if(chartInstance.c3_is_LTwo != c3_IN_Normal) {
      chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Normal;
      chartInstance.c3_LTwoCond = 0U;
    }
    chartInstance.c3_is_active_WRN = 1U;
    if(chartInstance.c3_is_WRN != c3_IN_WNStart) {
      chartInstance.c3_is_WRN = (uint8_T)c3_IN_WNStart;
      chartInstance.c3_WnCond = 0U;
    }
  } else if(chartInstance.c3_is_c3_GPCA_Extension == c3_IN_AlarmingMachine) {
    c3_Controller();
    if(chartInstance.c3_is_active_CheckReady != 0) {
      switch(chartInstance.c3_is_CheckReady) {
       case c3_IN_Checking:
        if(_sfEvent_ == c3_event_E_Restart) {
          chartInstance.c3_is_CheckReady = (uint8_T)c3_b_IN_Normal;
        } else if(chartInstance.c3_temp > 0) {
          chartInstance.c3_is_CheckReady = (uint8_T)c3_IN_s1;
        } else if(chartInstance.c3_temp == 0) {
          chartInstance.c3_is_CheckReady = (uint8_T)c3_IN_s2;
        }
        break;
       case c3_b_IN_Normal:
        if(_sfEvent_ == c3_event_E_RequestToStart) {
          chartInstance.c3_is_CheckReady = (uint8_T)c3_IN_Checking;
          chartInstance.c3_temp = (c3_isPumpReady() != 0U);
        }
        break;
       case c3_IN_s1:
        if((_sfEvent_ == c3_event_E_Clock) && (*c3_infusionInProgress == 0)) {
          sf_mex_printf("%s\\n", "E_Ready");
          chartInstance.c3_E_ReadyEventCounter =
            chartInstance.c3_E_ReadyEventCounter + 1U;
          chartInstance.c3_is_CheckReady = (uint8_T)c3_IN_s1;
        } else if((_sfEvent_ == c3_event_E_Clock) && (*c3_infusionInProgress ==
          1)) {
          chartInstance.c3_is_CheckReady = (uint8_T)c3_b_IN_Normal;
        } else if(_sfEvent_ == c3_event_E_RequestToStart) {
          chartInstance.c3_is_CheckReady = (uint8_T)c3_IN_Checking;
          chartInstance.c3_temp = (c3_isPumpReady() != 0U);
        } else if(_sfEvent_ == c3_event_E_Restart) {
          chartInstance.c3_is_CheckReady = (uint8_T)c3_b_IN_Normal;
        }
        break;
       case c3_IN_s2:
        if(_sfEvent_ == c3_event_E_RequestToStart) {
          chartInstance.c3_is_CheckReady = (uint8_T)c3_IN_Checking;
          chartInstance.c3_temp = (c3_isPumpReady() != 0U);
        } else if(_sfEvent_ == c3_event_E_Clock) {
          sf_mex_printf("%s\\n", "E_NotReady");
          chartInstance.c3_E_NotReadyEventCounter =
            chartInstance.c3_E_NotReadyEventCounter + 1U;
          chartInstance.c3_is_CheckReady = (uint8_T)c3_IN_s2;
        } else if(_sfEvent_ == c3_event_E_Restart) {
          chartInstance.c3_is_CheckReady = (uint8_T)c3_b_IN_Normal;
        }
        break;
       default:
        chartInstance.c3_is_CheckReady = (uint8_T)c3_IN_NO_ACTIVE_CHILD;
        break;
      }
    }
    c3_LOne();
    c3_LTwo();
    c3_WRN();
  }
}

static void c3_WRN(void)
{
  boolean_T c3_guard1 = false;
  uint8_T c3_previousEvent;
  real_T c3_d0;
  real_T c3_d1;
  real_T c3_d2;
  real_T c3_d3;
  real_T c3_d4;
  boolean_T *c3_infusionInProgress;
  boolean_T *c3_infusionPaused;
  real_T *c3_ErrCond;
  void *c3_envSenData;
  void *c3_hardwareSenData;
  void *c3_infuSenData;
  c3_envSenData = (void *)ssGetInputPortSignal(chartInstance.S, 3);
  c3_hardwareSenData = (void *)ssGetInputPortSignal(chartInstance.S, 4);
  c3_infusionPaused = (boolean_T *)ssGetInputPortSignal(chartInstance.S, 2);
  c3_infuSenData = (void *)ssGetInputPortSignal(chartInstance.S, 5);
  c3_ErrCond = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  c3_infusionInProgress = (boolean_T *)ssGetInputPortSignal(chartInstance.S, 1);
  if(chartInstance.c3_is_active_WRN != 0) {
    c3_guard1 = false;
    switch(chartInstance.c3_is_WRN) {
     case c3_IN_APErrCheck:
      if(_sfEvent_ == c3_event_E_ResetThree) {
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_HoldOn;
      } else if(*((boolean_T
         *)get_EnvironmentSensorSignals_element(c3_envSenData, 2)) == 0) {
        c3_clearWarning(26U);
        if(_sfEvent_ == c3_event_E_Clock) {
          c3_previousEvent = _sfEvent_;
          _sfEvent_ = c3_event_E_DoneThree;
          c3_Controller();
          _sfEvent_ = c3_previousEvent;
          if(chartInstance.c3_is_WRN == c3_IN_APErrCheck) {
            chartInstance.c3_is_WRN = (uint8_T)c3_IN_WNStart;
            chartInstance.c3_WnCond = 0U;
          }
        } else {
          c3_guard1 = true;
        }
      } else {
        c3_guard1 = true;
      }
      break;
     case c3_IN_BatteryChargingCheck:
      if(_sfEvent_ == c3_event_E_ResetThree) {
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_HoldOn;
      } else if(*((boolean_T
         *)get_HardwareSensorSignals_element(c3_hardwareSenData, 5)) == 0) {
        c3_clearWarning(21U);
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_VoltageCheck;
      } else if(*((boolean_T
         *)get_HardwareSensorSignals_element(c3_hardwareSenData, 5)) > 0) {
        chartInstance.c3_WnCond = 21U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_WarningAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_WRN == c3_IN_BatteryChargingCheck) {
          chartInstance.c3_is_WRN = (uint8_T)c3_IN_VoltageCheck;
        }
      }
      break;
     case c3_IN_EndState:
      if(_sfEvent_ == c3_event_E_Clock) {
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_DoneThree;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_WRN == c3_IN_EndState) {
          chartInstance.c3_is_WRN = (uint8_T)c3_IN_WNStart;
          chartInstance.c3_WnCond = 0U;
        }
      }
      break;
     case c3_IN_EnvTempCheck:
      if(_sfEvent_ == c3_event_E_ResetThree) {
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_HoldOn;
      } else if(*((boolean_T
         *)get_EnvironmentSensorSignals_element(c3_envSenData, 0)) == 0) {
        c3_clearWarning(24U);
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_HumidityCheck;
      } else if(*((boolean_T
         *)get_EnvironmentSensorSignals_element(c3_envSenData, 0)) > 0) {
        chartInstance.c3_WnCond = 24U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_WarningAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_WRN == c3_IN_EnvTempCheck) {
          chartInstance.c3_is_WRN = (uint8_T)c3_IN_HumidityCheck;
        }
      }
      break;
     case c3_IN_FlowRateStabilityCheck:
      if(_sfEvent_ == c3_event_E_ResetThree) {
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_HoldOn;
      } else if((*((boolean_T
          *)get_InfusionSensorSignals_element(c3_infuSenData, 6)) == 0) ||
       (*c3_infusionInProgress == 0) || (*
        c3_infusionPaused == 0)) {
        c3_clearWarning(16U);
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_LowReservoirCheck;
      } else if((*((boolean_T
          *)get_InfusionSensorSignals_element(c3_infuSenData, 6)) > 0) &&
       (*c3_infusionInProgress > 0) && (*
        c3_infusionPaused == 0)) {
        chartInstance.c3_WnCond = 16U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_WarningAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_WRN == c3_IN_FlowRateStabilityCheck) {
          chartInstance.c3_is_WRN = (uint8_T)c3_IN_LowReservoirCheck;
        }
      }
      break;
     case c3_IN_HoldOn:
      if((chartInstance.c3_is_WRN == c3_IN_HoldOn) && (_sfEvent_ ==
        c3_event_E_Clock)) {
        chartInstance.c3_WnCond = 0U;
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_FlowRateStabilityCheck;
      }
      break;
     case c3_IN_HumidityCheck:
      if(_sfEvent_ == c3_event_E_ResetThree) {
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_HoldOn;
      } else if(*((boolean_T
         *)get_EnvironmentSensorSignals_element(c3_envSenData, 1)) == 0) {
        c3_clearWarning(25U);
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_APErrCheck;
      } else if(*((boolean_T
         *)get_EnvironmentSensorSignals_element(c3_envSenData, 1)) > 0) {
        chartInstance.c3_WnCond = 25U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_WarningAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_WRN == c3_IN_HumidityCheck) {
          chartInstance.c3_is_WRN = (uint8_T)c3_IN_APErrCheck;
        }
      }
      break;
     case c3_IN_InfusionPausedDurationCheck:
      if(_sfEvent_ == c3_event_E_ResetThree) {
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_HoldOn;
      } else if((*((boolean_T
          *)get_InfusionSensorSignals_element(c3_infuSenData, 8)) == 0) ||
       (*c3_infusionInProgress == 0) || (*
        c3_infusionPaused == 0)) {
        c3_clearWarning(18U);
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_LoggingCheck;
      } else if((*((boolean_T
          *)get_InfusionSensorSignals_element(c3_infuSenData, 8)) > 0) &&
       (*c3_infusionInProgress > 0) && (*
        c3_infusionPaused == 1)) {
        chartInstance.c3_WnCond = 18U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_WarningAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_WRN == c3_IN_InfusionPausedDurationCheck) {
          chartInstance.c3_is_WRN = (uint8_T)c3_IN_LoggingCheck;
        }
      }
      break;
     case c3_IN_LoggingCheck:
      if(_sfEvent_ == c3_event_E_ResetThree) {
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_HoldOn;
      } else if(*((boolean_T
         *)get_HardwareSensorSignals_element(c3_hardwareSenData, 0)) == 0) {
        if((!(*c3_ErrCond != 19.0)) && (*c3_ErrCond == 19.0)) {
          c3_d0 = (real_T)c3_const_MSG_BLANK;
          sf_mex_export("GAlrmMsg", sf_mex_create(&c3_d0, "GAlrmMsg", 0, 0U, 0U,
            0), 0);
          *c3_ErrCond = 0.0;
        }
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_LowBatteryCheck;
      } else if(*((boolean_T
         *)get_HardwareSensorSignals_element(c3_hardwareSenData, 0)) > 0) {
        chartInstance.c3_WnCond = 19U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_WarningAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_WRN == c3_IN_LoggingCheck) {
          chartInstance.c3_is_WRN = (uint8_T)c3_IN_LowBatteryCheck;
        }
      }
      break;
     case c3_IN_LowBatteryCheck:
      if(_sfEvent_ == c3_event_E_ResetThree) {
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_HoldOn;
      } else if(*((boolean_T
         *)get_HardwareSensorSignals_element(c3_hardwareSenData, 4)) == 0) {
        if((!(*c3_ErrCond != 20.0)) && (*c3_ErrCond == 20.0)) {
          c3_d1 = (real_T)c3_const_MSG_BLANK;
          sf_mex_export("GAlrmMsg", sf_mex_create(&c3_d1, "GAlrmMsg", 0, 0U, 0U,
            0), 0);
          *c3_ErrCond = 0.0;
        }
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_BatteryChargingCheck;
      } else if(*((boolean_T
         *)get_HardwareSensorSignals_element(c3_hardwareSenData, 4)) > 0) {
        chartInstance.c3_WnCond = 20U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_WarningAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_WRN == c3_IN_LowBatteryCheck) {
          chartInstance.c3_is_WRN = (uint8_T)c3_IN_BatteryChargingCheck;
        }
      }
      break;
     case c3_IN_LowReservoirCheck:
      if(_sfEvent_ == c3_event_E_ResetThree) {
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_HoldOn;
      } else if((*((boolean_T
          *)get_InfusionSensorSignals_element(c3_infuSenData, 1)) == 0) ||
       (*c3_infusionInProgress == 0)) {
        if((!(*c3_ErrCond != 17.0)) && (*c3_ErrCond == 17.0)) {
          c3_d2 = (real_T)c3_const_MSG_BLANK;
          sf_mex_export("GAlrmMsg", sf_mex_create(&c3_d2, "GAlrmMsg", 0, 0U, 0U,
            0), 0);
          *c3_ErrCond = 0.0;
        }
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_InfusionPausedDurationCheck;
      } else if((*((boolean_T
          *)get_InfusionSensorSignals_element(c3_infuSenData, 1)) > 0) &&
       (*c3_infusionInProgress > 0)) {
        chartInstance.c3_WnCond = 17U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_WarningAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_WRN == c3_IN_LowReservoirCheck) {
          chartInstance.c3_is_WRN = (uint8_T)c3_IN_InfusionPausedDurationCheck;
        }
      }
      break;
     case c3_b_IN_PumpTempCheck:
      if(_sfEvent_ == c3_event_E_ResetThree) {
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_HoldOn;
      } else if(*((boolean_T
         *)get_HardwareSensorSignals_element(c3_hardwareSenData, 11)) == 0) {
        if((!(*c3_ErrCond != 23.0)) && (*c3_ErrCond == 23.0)) {
          c3_d3 = (real_T)c3_const_MSG_BLANK;
          sf_mex_export("GAlrmMsg", sf_mex_create(&c3_d3, "GAlrmMsg", 0, 0U, 0U,
            0), 0);
          *c3_ErrCond = 0.0;
        }
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_EnvTempCheck;
      } else if(*((boolean_T
         *)get_HardwareSensorSignals_element(c3_hardwareSenData, 11)) > 0) {
        chartInstance.c3_WnCond = 23U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_WarningAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_WRN == c3_b_IN_PumpTempCheck) {
          chartInstance.c3_is_WRN = (uint8_T)c3_IN_EnvTempCheck;
        }
      }
      break;
     case c3_IN_VoltageCheck:
      if(_sfEvent_ == c3_event_E_ResetThree) {
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_HoldOn;
      } else if(*((boolean_T
         *)get_HardwareSensorSignals_element(c3_hardwareSenData, 6)) == 0) {
        if((!(*c3_ErrCond != 22.0)) && (*c3_ErrCond == 22.0)) {
          c3_d4 = (real_T)c3_const_MSG_BLANK;
          sf_mex_export("GAlrmMsg", sf_mex_create(&c3_d4, "GAlrmMsg", 0, 0U, 0U,
            0), 0);
          *c3_ErrCond = 0.0;
        }
        chartInstance.c3_is_WRN = (uint8_T)c3_b_IN_PumpTempCheck;
      } else if(*((boolean_T
         *)get_HardwareSensorSignals_element(c3_hardwareSenData, 6)) > 0) {
        chartInstance.c3_WnCond = 22U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_WarningAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_WRN == c3_IN_VoltageCheck) {
          chartInstance.c3_is_WRN = (uint8_T)c3_b_IN_PumpTempCheck;
        }
      }
      break;
     case c3_IN_WNStart:
      if((chartInstance.c3_is_WRN == c3_IN_WNStart) && (_sfEvent_ ==
        c3_event_E_ResetThree)) {
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_HoldOn;
      }
      break;
     default:
      chartInstance.c3_is_WRN = (uint8_T)c3_IN_NO_ACTIVE_CHILD;
      break;
    }
    if(c3_guard1 == true) {
      if(*((boolean_T *)get_EnvironmentSensorSignals_element(c3_envSenData, 2))
       > 0) {
        chartInstance.c3_WnCond = 26U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_WarningAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_WRN == c3_IN_APErrCheck) {
          chartInstance.c3_is_WRN = (uint8_T)c3_IN_EndState;
        }
      }
    }
  }
}

static void c3_Controller(void)
{
  uint8_T c3_previousEvent;
  real_T *c3_ErrCond;
  c3_ErrCond = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  if(chartInstance.c3_is_active_Controller != 0) {
    switch(chartInstance.c3_is_Controller) {
     case c3_IN_CheckLOne:
      if(_sfEvent_ == c3_event_E_LevelOneAlarm) {
        *c3_ErrCond = (real_T)chartInstance.c3_LOneCond;
        chartInstance.c3_is_Controller = (uint8_T)c3_IN_SinkOne;
      } else if(_sfEvent_ == c3_event_E_DoneOne) {
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_ResetTwo;
        c3_LTwo();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_Controller == c3_IN_CheckLOne) {
          chartInstance.c3_is_Controller = (uint8_T)c3_IN_CheckLTwo;
        }
      }
      break;
     case c3_IN_CheckLTwo:
      if(_sfEvent_ == c3_event_E_Restart) {
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_ResetOne;
        c3_LOne();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_Controller == c3_IN_CheckLTwo) {
          chartInstance.c3_is_Controller = (uint8_T)c3_IN_CheckLOne;
          chartInstance.c3_LOneCond = 0U;
          chartInstance.c3_LTwoCond = 0U;
          chartInstance.c3_WnCond = 0U;
          *c3_ErrCond = 0.0;
        }
      } else if(_sfEvent_ == c3_event_E_LevelTwoAlarm) {
        *c3_ErrCond = (real_T)chartInstance.c3_LTwoCond;
        chartInstance.c3_is_Controller = (uint8_T)c3_IN_SinkTWO;
      } else if(_sfEvent_ == c3_event_E_DoneTwo) {
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_ResetThree;
        c3_WRN();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_Controller == c3_IN_CheckLTwo) {
          chartInstance.c3_is_Controller = (uint8_T)c3_IN_CheckWRN;
        }
      }
      break;
     case c3_IN_CheckWRN:
      if(_sfEvent_ == c3_event_E_WarningAlarm) {
        *c3_ErrCond = (real_T)chartInstance.c3_WnCond;
        sf_mex_printf("%s\\n", "E_Warning");
        chartInstance.c3_E_WarningEventCounter =
          chartInstance.c3_E_WarningEventCounter + 1U;
        chartInstance.c3_is_Controller = (uint8_T)c3_IN_CheckWRN;
      } else if(_sfEvent_ == c3_event_E_DoneThree) {
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_ResetOne;
        c3_LOne();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_Controller == c3_IN_CheckWRN) {
          chartInstance.c3_is_Controller = (uint8_T)c3_IN_CheckLOne;
          chartInstance.c3_LOneCond = 0U;
          chartInstance.c3_LTwoCond = 0U;
          chartInstance.c3_WnCond = 0U;
          *c3_ErrCond = 0.0;
        }
      } else if(_sfEvent_ == c3_event_E_Restart) {
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_ResetOne;
        c3_LOne();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_Controller == c3_IN_CheckWRN) {
          chartInstance.c3_is_Controller = (uint8_T)c3_IN_CheckLOne;
          chartInstance.c3_LOneCond = 0U;
          chartInstance.c3_LTwoCond = 0U;
          chartInstance.c3_WnCond = 0U;
          *c3_ErrCond = 0.0;
        }
      }
      break;
     case c3_IN_START:
      if(_sfEvent_ == c3_event_E_Restart) {
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_ResetOne;
        c3_LOne();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_Controller == c3_IN_START) {
          chartInstance.c3_is_Controller = (uint8_T)c3_IN_CheckLOne;
          chartInstance.c3_LOneCond = 0U;
          chartInstance.c3_LTwoCond = 0U;
          chartInstance.c3_WnCond = 0U;
          *c3_ErrCond = 0.0;
        }
      }
      break;
     case c3_IN_SinkOne:
      if(_sfEvent_ == c3_event_E_Restart) {
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_ResetOne;
        c3_LOne();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_Controller == c3_IN_SinkOne) {
          chartInstance.c3_is_Controller = (uint8_T)c3_IN_CheckLOne;
          chartInstance.c3_LOneCond = 0U;
          chartInstance.c3_LTwoCond = 0U;
          chartInstance.c3_WnCond = 0U;
          *c3_ErrCond = 0.0;
        }
      }
      break;
     case c3_IN_SinkTWO:
      if((_sfEvent_ == c3_event_E_Clock) && (chartInstance.c3_LTwoCond == 0U)) {
        *c3_ErrCond = 0.0;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_ResetOne;
        c3_LOne();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_Controller == c3_IN_SinkTWO) {
          chartInstance.c3_is_Controller = (uint8_T)c3_IN_CheckLOne;
          chartInstance.c3_LOneCond = 0U;
          chartInstance.c3_LTwoCond = 0U;
          chartInstance.c3_WnCond = 0U;
          *c3_ErrCond = 0.0;
        }
      } else if((_sfEvent_ == c3_event_E_Restart) || (_sfEvent_ ==
        c3_event_E_AlarmClear)) {
        *c3_ErrCond = 0.0;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_ResetOne;
        c3_LOne();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_Controller == c3_IN_SinkTWO) {
          chartInstance.c3_is_Controller = (uint8_T)c3_IN_CheckLOne;
          chartInstance.c3_LOneCond = 0U;
          chartInstance.c3_LTwoCond = 0U;
          chartInstance.c3_WnCond = 0U;
          *c3_ErrCond = 0.0;
        }
      } else if(chartInstance.c3_LTwoCond > 0U) {
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_ResetOne;
        c3_LOne();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_Controller == c3_IN_SinkTWO) {
          chartInstance.c3_is_Controller = (uint8_T)c3_IN_SinkTWOCheckOne;
        }
      }
      break;
     case c3_IN_SinkTWOCheckOne:
      if(_sfEvent_ == c3_event_E_LevelOneAlarm) {
        *c3_ErrCond = (real_T)chartInstance.c3_LOneCond;
        chartInstance.c3_is_Controller = (uint8_T)c3_IN_SinkOne;
      } else if(_sfEvent_ == c3_event_E_DoneOne) {
        chartInstance.c3_is_Controller = (uint8_T)c3_IN_SinkTWO;
      } else if((_sfEvent_ == c3_event_E_Restart) || (_sfEvent_ ==
        c3_event_E_AlarmClear)) {
        *c3_ErrCond = (real_T)chartInstance.c3_LOneCond;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_ResetOne;
        c3_LOne();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_Controller == c3_IN_SinkTWOCheckOne) {
          chartInstance.c3_is_Controller = (uint8_T)c3_IN_CheckLOne;
          chartInstance.c3_LOneCond = 0U;
          chartInstance.c3_LTwoCond = 0U;
          chartInstance.c3_WnCond = 0U;
          *c3_ErrCond = 0.0;
        }
      }
      break;
     default:
      chartInstance.c3_is_Controller = (uint8_T)c3_IN_NO_ACTIVE_CHILD;
      break;
    }
  }
}

static void c3_LTwo(void)
{
  uint8_T c3_previousEvent;
  boolean_T *c3_infusionInProgress;
  boolean_T *c3_infusionPaused;
  void *c3_infuSenData;
  void *c3_hardwareSenData;
  c3_hardwareSenData = (void *)ssGetInputPortSignal(chartInstance.S, 4);
  c3_infusionPaused = (boolean_T *)ssGetInputPortSignal(chartInstance.S, 2);
  c3_infuSenData = (void *)ssGetInputPortSignal(chartInstance.S, 5);
  c3_infusionInProgress = (boolean_T *)ssGetInputPortSignal(chartInstance.S, 1);
  if(chartInstance.c3_is_active_LTwo != 0) {
    switch(chartInstance.c3_is_LTwo) {
     case c3_IN_AirInLineCheck:
      if(_sfEvent_ == c3_event_E_ResetTwo) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Hold;
      } else if((*((boolean_T
          *)get_InfusionSensorSignals_element(c3_infuSenData, 10)) > 0) &&
       (*c3_infusionInProgress > 0)) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Sink29;
        chartInstance.c3_LTwoCond = 15U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_LevelTwoAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
      } else if((*((boolean_T
          *)get_InfusionSensorSignals_element(c3_infuSenData, 10)) == 0) ||
       (*c3_infusionInProgress == 0)) {
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_DoneTwo;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_LTwo == c3_IN_AirInLineCheck) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Normal;
          chartInstance.c3_LTwoCond = 0U;
        }
      }
      break;
     case c3_IN_DoorOpenCheck:
      if(_sfEvent_ == c3_event_E_ResetTwo) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Hold;
      } else if((*((boolean_T
          *)get_HardwareSensorSignals_element(c3_hardwareSenData, 2)) > 0) &&
       (*c3_infusionInProgress > 0)) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Sink21;
        chartInstance.c3_LTwoCond = 7U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_LevelTwoAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
      } else if((*((boolean_T
          *)get_HardwareSensorSignals_element(c3_hardwareSenData, 2)) == 0) ||
       (*c3_infusionInProgress == 0)) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_ReservoirEmptyCheck;
      }
      break;
     case c3_IN_HighInfusionRateCheck:
      if(_sfEvent_ == c3_event_E_ResetTwo) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Hold;
      } else if((*((boolean_T
          *)get_InfusionSensorSignals_element(c3_infuSenData, 3)) > 0) &&
       (*c3_infusionInProgress > 0) && (*
        c3_infusionPaused == 0)) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Sink24;
        chartInstance.c3_LTwoCond = 10U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_LevelTwoAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
      } else if((*((boolean_T
          *)get_InfusionSensorSignals_element(c3_infuSenData, 3)) == 0) ||
       (*c3_infusionInProgress == 0) || (*
        c3_infusionPaused > 0)) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_LowInfusionRateCheck;
      }
      break;
     case c3_IN_Hold:
      if((chartInstance.c3_is_LTwo == c3_IN_Hold) && (_sfEvent_ ==
        c3_event_E_Clock)) {
        chartInstance.c3_LTwoCond = 0U;
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_DoorOpenCheck;
      }
      break;
     case c3_IN_InfusionPauseDurationCheck:
      if(_sfEvent_ == c3_event_E_ResetTwo) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Hold;
      } else if((*((boolean_T
          *)get_InfusionSensorSignals_element(c3_infuSenData, 9)) > 0) &&
       (*c3_infusionInProgress > 0) && (*
        c3_infusionPaused == 1)) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Sink28;
        chartInstance.c3_LTwoCond = 14U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_LevelTwoAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
      } else if((*((boolean_T
          *)get_InfusionSensorSignals_element(c3_infuSenData, 9)) == 0) ||
       (*c3_infusionInProgress == 0) || (*
        c3_infusionPaused == 0)) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_AirInLineCheck;
      }
      break;
     case c3_IN_LowInfusionRateCheck:
      if(_sfEvent_ == c3_event_E_ResetTwo) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Hold;
      } else if((*((boolean_T
          *)get_InfusionSensorSignals_element(c3_infuSenData, 4)) > 0) &&
       (*c3_infusionInProgress > 0) && (*
        c3_infusionPaused == 0)) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Sink25;
        chartInstance.c3_LTwoCond = 11U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_LevelTwoAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
      } else if((*((boolean_T
          *)get_InfusionSensorSignals_element(c3_infuSenData, 4)) == 0) ||
       (*c3_infusionInProgress == 0) || (*
        c3_infusionPaused > 0)) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_RateLessThanKVOCheck;
      }
      break;
     case c3_IN_Normal:
      if((chartInstance.c3_is_LTwo == c3_IN_Normal) && (_sfEvent_ ==
        c3_event_E_ResetTwo)) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Hold;
      }
      break;
     case c3_IN_OcculusionCheck:
      if(_sfEvent_ == c3_event_E_ResetTwo) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Hold;
      } else if((*((boolean_T
          *)get_InfusionSensorSignals_element(c3_infuSenData, 2)) > 0) &&
       (*c3_infusionInProgress > 0)) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Sink23;
        chartInstance.c3_LTwoCond = 9U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_LevelTwoAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
      } else if((*((boolean_T
          *)get_InfusionSensorSignals_element(c3_infuSenData, 2)) == 0) ||
       (*c3_infusionInProgress == 0)) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_HighInfusionRateCheck;
      }
      break;
     case c3_IN_RateLessThanKVOCheck:
      if(_sfEvent_ == c3_event_E_ResetTwo) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Hold;
      } else if((*((boolean_T
          *)get_InfusionSensorSignals_element(c3_infuSenData, 5)) > 0) &&
       (*c3_infusionInProgress > 0)) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Sink26;
        chartInstance.c3_LTwoCond = 12U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_LevelTwoAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
      } else if((*((boolean_T
          *)get_InfusionSensorSignals_element(c3_infuSenData, 5)) == 0) ||
       (*c3_infusionInProgress == 0)) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_RateOverPumpCapacityCheck;
      }
      break;
     case c3_IN_RateOverPumpCapacityCheck:
      if(_sfEvent_ == c3_event_E_ResetTwo) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Hold;
      } else if((*((boolean_T
          *)get_InfusionSensorSignals_element(c3_infuSenData, 7)) > 0) &&
       (*c3_infusionInProgress > 0)) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Sink27;
        chartInstance.c3_LTwoCond = 13U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_LevelTwoAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
      } else if((*((boolean_T
          *)get_InfusionSensorSignals_element(c3_infuSenData, 7)) == 0) ||
       (*c3_infusionInProgress == 0)) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_InfusionPauseDurationCheck;
      }
      break;
     case c3_IN_ReservoirEmptyCheck:
      if(_sfEvent_ == c3_event_E_ResetTwo) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Hold;
      } else if((*((boolean_T
          *)get_InfusionSensorSignals_element(c3_infuSenData, 0)) > 0) &&
       (*c3_infusionInProgress > 0)) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Sink22;
        chartInstance.c3_LTwoCond = 8U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_LevelTwoAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
      } else if((*((boolean_T
          *)get_InfusionSensorSignals_element(c3_infuSenData, 0)) == 0) ||
       (*c3_infusionInProgress == 0)) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_OcculusionCheck;
      }
      break;
     case c3_IN_Sink21:
      if(chartInstance.c3_is_LTwo == c3_IN_Sink21) {
        if(_sfEvent_ == c3_event_E_ResetTwo) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_DoorOpenCheck;
        } else if(((*((boolean_T
             *)get_HardwareSensorSignals_element(c3_hardwareSenData, 2)) == 0)
          || (*c3_infusionInProgress == 0)) && (
          _sfEvent_ == c3_event_E_Clock)) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_DoorOpenCheck;
        }
      }
      break;
     case c3_IN_Sink22:
      if(chartInstance.c3_is_LTwo == c3_IN_Sink22) {
        if(_sfEvent_ == c3_event_E_ResetTwo) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_DoorOpenCheck;
        } else if(((*((boolean_T
             *)get_InfusionSensorSignals_element(c3_infuSenData, 0)) == 0) ||
          (*c3_infusionInProgress == 0)) && (
          _sfEvent_ == c3_event_E_Clock)) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_DoorOpenCheck;
        }
      }
      break;
     case c3_IN_Sink23:
      if(chartInstance.c3_is_LTwo == c3_IN_Sink23) {
        if(_sfEvent_ == c3_event_E_ResetTwo) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_DoorOpenCheck;
        } else if(((*((boolean_T
             *)get_InfusionSensorSignals_element(c3_infuSenData, 2)) == 0) ||
          (*c3_infusionInProgress == 0)) && (
          _sfEvent_ == c3_event_E_Clock)) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_DoorOpenCheck;
        }
      }
      break;
     case c3_IN_Sink24:
      if(chartInstance.c3_is_LTwo == c3_IN_Sink24) {
        if(_sfEvent_ == c3_event_E_ResetTwo) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_DoorOpenCheck;
        } else if(((*((boolean_T
             *)get_InfusionSensorSignals_element(c3_infuSenData, 3)) == 0) ||
          (*c3_infusionInProgress == 0) || (*
           c3_infusionPaused > 0)) && (_sfEvent_ == c3_event_E_Clock)) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_DoorOpenCheck;
        }
      }
      break;
     case c3_IN_Sink25:
      if(chartInstance.c3_is_LTwo == c3_IN_Sink25) {
        if(_sfEvent_ == c3_event_E_ResetTwo) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_DoorOpenCheck;
        } else if(((*((boolean_T
             *)get_InfusionSensorSignals_element(c3_infuSenData, 4)) == 0) ||
          (*c3_infusionInProgress == 0) || (*
           c3_infusionPaused > 0)) && (_sfEvent_ == c3_event_E_Clock)) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_DoorOpenCheck;
        }
      }
      break;
     case c3_IN_Sink26:
      if(chartInstance.c3_is_LTwo == c3_IN_Sink26) {
        if(_sfEvent_ == c3_event_E_ResetTwo) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_DoorOpenCheck;
        } else if(((*((boolean_T
             *)get_InfusionSensorSignals_element(c3_infuSenData, 5)) == 0) ||
          (*c3_infusionInProgress == 0)) && (
          _sfEvent_ == c3_event_E_Clock)) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_DoorOpenCheck;
        }
      }
      break;
     case c3_IN_Sink27:
      if(chartInstance.c3_is_LTwo == c3_IN_Sink27) {
        if(_sfEvent_ == c3_event_E_ResetTwo) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_DoorOpenCheck;
        } else if(((*((boolean_T
             *)get_InfusionSensorSignals_element(c3_infuSenData, 7)) == 0) ||
          (*c3_infusionInProgress == 0)) && (
          _sfEvent_ == c3_event_E_Clock)) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_DoorOpenCheck;
        }
      }
      break;
     case c3_IN_Sink28:
      if(chartInstance.c3_is_LTwo == c3_IN_Sink28) {
        if(_sfEvent_ == c3_event_E_ResetTwo) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_DoorOpenCheck;
        } else if(((*((boolean_T
             *)get_InfusionSensorSignals_element(c3_infuSenData, 9)) == 0) ||
          (*c3_infusionInProgress == 0) || (*
           c3_infusionPaused == 0)) && (_sfEvent_ == c3_event_E_Clock)) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_DoorOpenCheck;
        }
      }
      break;
     case c3_IN_Sink29:
      if(chartInstance.c3_is_LTwo == c3_IN_Sink29) {
        if(_sfEvent_ == c3_event_E_ResetTwo) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_DoorOpenCheck;
        } else if(((*((boolean_T
             *)get_InfusionSensorSignals_element(c3_infuSenData, 10)) == 0) ||
          (*c3_infusionInProgress == 0)) && (
          _sfEvent_ == c3_event_E_Clock)) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_DoorOpenCheck;
        }
      }
      break;
     default:
      chartInstance.c3_is_LTwo = (uint8_T)c3_IN_NO_ACTIVE_CHILD;
      break;
    }
  }
}

static uint32_T c3_clearWarning(uint32_T c3_cond)
{
  uint32_T c3_x;
  real_T c3_d5;
  real_T *c3_ErrCond;
  c3_ErrCond = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  c3_x = 0U;
  if(*c3_ErrCond != (real_T)c3_cond) {
    return 0U;
  } else if(*c3_ErrCond == (real_T)c3_cond) {
    c3_d5 = (real_T)c3_const_MSG_BLANK;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c3_d5, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
    *c3_ErrCond = 0.0;
  }
  return c3_x;
}

static uint32_T c3_isPumpReady(void)
{
  uint32_T c3_x;
  void *c3_infuSenData;
  void *c3_hardwareSenData;
  c3_hardwareSenData = (void *)ssGetInputPortSignal(chartInstance.S, 4);
  c3_infuSenData = (void *)ssGetInputPortSignal(chartInstance.S, 5);
  c3_x = 0U;
  if(*((boolean_T *)get_InfusionSensorSignals_element(c3_infuSenData, 0)) > 0) {
    return 0U;
  } else if(*((boolean_T *)get_InfusionSensorSignals_element(c3_infuSenData, 0))
   == 0) {
    if(*((boolean_T *)get_HardwareSensorSignals_element(c3_hardwareSenData, 2))
     > 0) {
      return 0U;
    } else if(*((boolean_T
       *)get_HardwareSensorSignals_element(c3_hardwareSenData, 2)) == 0) {
      if(*((boolean_T *)get_InfusionSensorSignals_element(c3_infuSenData, 7)) >
       0) {
        return 0U;
      } else if(*((boolean_T *)get_InfusionSensorSignals_element(c3_infuSenData,
         7)) == 0) {
        return 1U;
      }
    }
  }
  return c3_x;
}

static void c3_LOne(void)
{
  uint8_T c3_previousEvent;
  void *c3_hardwareSenData;
  c3_hardwareSenData = (void *)ssGetInputPortSignal(chartInstance.S, 4);
  if(chartInstance.c3_is_active_LOne != 0) {
    switch(chartInstance.c3_is_LOne) {
     case c3_IN_BatteryDepletionCheck:
      if(_sfEvent_ == c3_event_E_ResetOne) {
        chartInstance.c3_is_LOne = (uint8_T)c3_IN_HOLD;
      } else if(*((boolean_T
         *)get_HardwareSensorSignals_element(c3_hardwareSenData, 3)) > 0) {
        chartInstance.c3_LOneCond = 1U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_LevelOneAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_LOne == c3_IN_BatteryDepletionCheck) {
          chartInstance.c3_is_LOne = (uint8_T)c3_IN_L1Sink;
        }
      } else if(*((boolean_T
         *)get_HardwareSensorSignals_element(c3_hardwareSenData, 3)) == 0) {
        chartInstance.c3_is_LOne = (uint8_T)c3_IN_RTCCheck;
      }
      break;
     case c3_IN_CPUCheck:
      if(_sfEvent_ == c3_event_E_ResetOne) {
        chartInstance.c3_is_LOne = (uint8_T)c3_IN_HOLD;
      } else if(*((boolean_T
         *)get_HardwareSensorSignals_element(c3_hardwareSenData, 7)) > 0) {
        chartInstance.c3_LOneCond = 3U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_LevelOneAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_LOne == c3_IN_CPUCheck) {
          chartInstance.c3_is_LOne = (uint8_T)c3_IN_L1Sink;
        }
      } else if(*((boolean_T
         *)get_HardwareSensorSignals_element(c3_hardwareSenData, 7)) == 0) {
        chartInstance.c3_is_LOne = (uint8_T)c3_IN_MemoryCheck;
      }
      break;
     case c3_IN_HOLD:
      if(_sfEvent_ == c3_event_E_Clock) {
        chartInstance.c3_LOneCond = 0U;
        chartInstance.c3_is_LOne = (uint8_T)c3_IN_BatteryDepletionCheck;
      }
      break;
     case c3_IN_L1Sink:
      if(_sfEvent_ == c3_event_E_ResetOne) {
        chartInstance.c3_is_LOne = (uint8_T)c3_IN_HOLD;
      }
      break;
     case c3_IN_MemoryCheck:
      if(_sfEvent_ == c3_event_E_ResetOne) {
        chartInstance.c3_is_LOne = (uint8_T)c3_IN_HOLD;
      } else if(*((boolean_T
         *)get_HardwareSensorSignals_element(c3_hardwareSenData, 9)) > 0) {
        chartInstance.c3_LOneCond = 4U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_LevelOneAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_LOne == c3_IN_MemoryCheck) {
          chartInstance.c3_is_LOne = (uint8_T)c3_IN_L1Sink;
        }
      } else if(*((boolean_T
         *)get_HardwareSensorSignals_element(c3_hardwareSenData, 9)) == 0) {
        chartInstance.c3_is_LOne = (uint8_T)c3_IN_PumpTempCheck;
      }
      break;
     case c3_c_IN_Normal:
      if((chartInstance.c3_is_LOne == c3_c_IN_Normal) && (_sfEvent_ ==
        c3_event_E_ResetOne)) {
        chartInstance.c3_is_LOne = (uint8_T)c3_IN_HOLD;
      }
      break;
     case c3_IN_PumpTempCheck:
      if(_sfEvent_ == c3_event_E_ResetOne) {
        chartInstance.c3_is_LOne = (uint8_T)c3_IN_HOLD;
      } else if(*((boolean_T
         *)get_HardwareSensorSignals_element(c3_hardwareSenData, 10)) > 0) {
        chartInstance.c3_LOneCond = 5U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_LevelOneAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_LOne == c3_IN_PumpTempCheck) {
          chartInstance.c3_is_LOne = (uint8_T)c3_IN_L1Sink;
        }
      } else if(*((boolean_T
         *)get_HardwareSensorSignals_element(c3_hardwareSenData, 10)) == 0) {
        chartInstance.c3_is_LOne = (uint8_T)c3_IN_WatchdogCheck;
      }
      break;
     case c3_IN_RTCCheck:
      if(_sfEvent_ == c3_event_E_ResetOne) {
        chartInstance.c3_is_LOne = (uint8_T)c3_IN_HOLD;
      } else if((*((boolean_T
          *)get_HardwareSensorSignals_element(c3_hardwareSenData, 8)) > 0) > 0) {
        chartInstance.c3_LOneCond = 2U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_LevelOneAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_LOne == c3_IN_RTCCheck) {
          chartInstance.c3_is_LOne = (uint8_T)c3_IN_L1Sink;
        }
      } else if(*((boolean_T
         *)get_HardwareSensorSignals_element(c3_hardwareSenData, 8)) > 0 == 0) {
        chartInstance.c3_is_LOne = (uint8_T)c3_IN_CPUCheck;
      }
      break;
     case c3_IN_WatchdogCheck:
      if(_sfEvent_ == c3_event_E_ResetOne) {
        chartInstance.c3_is_LOne = (uint8_T)c3_IN_HOLD;
      } else if(*((boolean_T
         *)get_HardwareSensorSignals_element(c3_hardwareSenData, 1)) > 0) {
        chartInstance.c3_LOneCond = 6U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_LevelOneAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_LOne == c3_IN_WatchdogCheck) {
          chartInstance.c3_is_LOne = (uint8_T)c3_IN_L1Sink;
        }
      } else if(*((boolean_T
         *)get_HardwareSensorSignals_element(c3_hardwareSenData, 1)) == 0) {
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_DoneOne;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if((chartInstance.c3_is_LOne == c3_IN_WatchdogCheck) && (_sfEvent_ ==
          c3_event_E_Clock)) {
          chartInstance.c3_is_LOne = (uint8_T)c3_c_IN_Normal;
        }
      }
      break;
     default:
      chartInstance.c3_is_LOne = (uint8_T)c3_IN_NO_ACTIVE_CHILD;
      break;
    }
  }
}

static void init_script_number_translation(uint32_T c3_machineNumber, uint32_T
 c3_chartNumber)
{
}

const mxArray *sf_c3_GPCA_Extension_get_eml_resolved_functions_info(void)
{
  const mxArray *c3_nameCaptureInfo = NULL;
  c3_nameCaptureInfo = NULL;
  sf_mex_assign(&c3_nameCaptureInfo, sf_mex_create(NULL, "nameCaptureInfo", 0,
    0U, 1U, 2, 0, 1));
  return c3_nameCaptureInfo;
}

static void init_io_bus_offset(void)
{
  slDataTypeAccess *c3_dta;
  const char *c3_bpath;
  DTypeId c3_HardwareSensorSignalsId;
  DTypeId c3_EnvironmentSensorSignalsId;
  DTypeId c3_InfusionSensorSignalsId;
  c3_dta = ssGetDataTypeAccess(chartInstance.S);
  c3_bpath = ssGetPath(chartInstance.S);
  c3_HardwareSensorSignalsId = ssGetDataTypeId(chartInstance.S,
   "HardwareSensorSignals");
  c3_EnvironmentSensorSignalsId = ssGetDataTypeId(chartInstance.S,
   "EnvironmentSensorSignals");
  c3_InfusionSensorSignalsId = ssGetDataTypeId(chartInstance.S,
   "InfusionSensorSignals");
  chartInstance.c3_ioBusOffset[3] = dtaGetDataTypeElementOffset(c3_dta,
   c3_bpath, c3_HardwareSensorSignalsId, 0);
  chartInstance.c3_ioBusOffset[4] = dtaGetDataTypeElementOffset(c3_dta,
   c3_bpath, c3_HardwareSensorSignalsId, 1);
  chartInstance.c3_ioBusOffset[5] = dtaGetDataTypeElementOffset(c3_dta,
   c3_bpath, c3_HardwareSensorSignalsId, 2);
  chartInstance.c3_ioBusOffset[6] = dtaGetDataTypeElementOffset(c3_dta,
   c3_bpath, c3_HardwareSensorSignalsId, 3);
  chartInstance.c3_ioBusOffset[7] = dtaGetDataTypeElementOffset(c3_dta,
   c3_bpath, c3_HardwareSensorSignalsId, 4);
  chartInstance.c3_ioBusOffset[8] = dtaGetDataTypeElementOffset(c3_dta,
   c3_bpath, c3_HardwareSensorSignalsId, 5);
  chartInstance.c3_ioBusOffset[9] = dtaGetDataTypeElementOffset(c3_dta,
   c3_bpath, c3_HardwareSensorSignalsId, 6);
  chartInstance.c3_ioBusOffset[10] = dtaGetDataTypeElementOffset(c3_dta,
   c3_bpath, c3_HardwareSensorSignalsId, 7);
  chartInstance.c3_ioBusOffset[11] = dtaGetDataTypeElementOffset(c3_dta,
   c3_bpath, c3_HardwareSensorSignalsId, 8);
  chartInstance.c3_ioBusOffset[12] = dtaGetDataTypeElementOffset(c3_dta,
   c3_bpath, c3_HardwareSensorSignalsId, 9);
  chartInstance.c3_ioBusOffset[13] = dtaGetDataTypeElementOffset(c3_dta,
   c3_bpath, c3_HardwareSensorSignalsId, 10);
  chartInstance.c3_ioBusOffset[14] = dtaGetDataTypeElementOffset(c3_dta,
   c3_bpath, c3_HardwareSensorSignalsId, 11);
  chartInstance.c3_ioBusOffset[0] = dtaGetDataTypeElementOffset(c3_dta,
   c3_bpath, c3_EnvironmentSensorSignalsId, 0);
  chartInstance.c3_ioBusOffset[1] = dtaGetDataTypeElementOffset(c3_dta,
   c3_bpath, c3_EnvironmentSensorSignalsId, 1);
  chartInstance.c3_ioBusOffset[2] = dtaGetDataTypeElementOffset(c3_dta,
   c3_bpath, c3_EnvironmentSensorSignalsId, 2);
  chartInstance.c3_ioBusOffset[15] = dtaGetDataTypeElementOffset(c3_dta,
   c3_bpath, c3_InfusionSensorSignalsId, 0);
  chartInstance.c3_ioBusOffset[16] = dtaGetDataTypeElementOffset(c3_dta,
   c3_bpath, c3_InfusionSensorSignalsId, 1);
  chartInstance.c3_ioBusOffset[17] = dtaGetDataTypeElementOffset(c3_dta,
   c3_bpath, c3_InfusionSensorSignalsId, 2);
  chartInstance.c3_ioBusOffset[18] = dtaGetDataTypeElementOffset(c3_dta,
   c3_bpath, c3_InfusionSensorSignalsId, 3);
  chartInstance.c3_ioBusOffset[19] = dtaGetDataTypeElementOffset(c3_dta,
   c3_bpath, c3_InfusionSensorSignalsId, 4);
  chartInstance.c3_ioBusOffset[20] = dtaGetDataTypeElementOffset(c3_dta,
   c3_bpath, c3_InfusionSensorSignalsId, 5);
  chartInstance.c3_ioBusOffset[21] = dtaGetDataTypeElementOffset(c3_dta,
   c3_bpath, c3_InfusionSensorSignalsId, 6);
  chartInstance.c3_ioBusOffset[22] = dtaGetDataTypeElementOffset(c3_dta,
   c3_bpath, c3_InfusionSensorSignalsId, 7);
  chartInstance.c3_ioBusOffset[23] = dtaGetDataTypeElementOffset(c3_dta,
   c3_bpath, c3_InfusionSensorSignalsId, 8);
  chartInstance.c3_ioBusOffset[24] = dtaGetDataTypeElementOffset(c3_dta,
   c3_bpath, c3_InfusionSensorSignalsId, 9);
  chartInstance.c3_ioBusOffset[25] = dtaGetDataTypeElementOffset(c3_dta,
   c3_bpath, c3_InfusionSensorSignalsId, 10);
}

static void *get_HardwareSensorSignals_element(void *c3_addr, int32_T c3_idx)
{
  return (void *)((char *)c3_addr + chartInstance.c3_ioBusOffset[c3_idx + 3]);
}

static void *get_EnvironmentSensorSignals_element(void *c3_addr, int32_T c3_idx)
{
  return (void *)((char *)c3_addr + chartInstance.c3_ioBusOffset[c3_idx]);
}

static void *get_InfusionSensorSignals_element(void *c3_addr, int32_T c3_idx)
{
  return (void *)((char *)c3_addr + chartInstance.c3_ioBusOffset[c3_idx + 15]);
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c3_GPCA_Extension_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2404257661U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(1788066296U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(1696877583U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2958399077U);
}

mxArray *sf_c3_GPCA_Extension_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] =
  {"checksum","inputs","parameters","outputs"};
  mxArray *mxAutoinheritanceInfo =
  mxCreateStructMatrix(1,1,4,autoinheritanceFields);
  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(2182403662U);
    pr[1] = (double)(925392783U);
    pr[2] = (double)(2902468067U);
    pr[3] = (double)(1381318347U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,6,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(7));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(7));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(8));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }
    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(8));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }
    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(13));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(17));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }
    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(13));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(18));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }
    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(13));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(19));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }
    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }
  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,mxREAL));
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }
  return(mxAutoinheritanceInfo);
}

static void sf_opaque_initialize_c3_GPCA_Extension(void *chartInstanceVar)
{
  initialize_params_c3_GPCA_Extension();
  initialize_c3_GPCA_Extension();
}

static void sf_opaque_enable_c3_GPCA_Extension(void *chartInstanceVar)
{
  enable_c3_GPCA_Extension();
}

static void sf_opaque_disable_c3_GPCA_Extension(void *chartInstanceVar)
{
  disable_c3_GPCA_Extension();
}

static void sf_opaque_gateway_c3_GPCA_Extension(void *chartInstanceVar)
{
  sf_c3_GPCA_Extension();
}

static void sf_opaque_terminate_c3_GPCA_Extension(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) ||
   sim_mode_is_external(chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }
  finalize_c3_GPCA_Extension();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c3_GPCA_Extension(SimStruct *S)
{
  int i;
  for(i=0;i<ssGetNumRunTimeParams(S);i++) {
    if(ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }
  if(sf_machine_global_initializer_called()) {
    initialize_params_c3_GPCA_Extension();
  }
}

static void mdlSetWorkWidths_c3_GPCA_Extension(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("GPCA_Extension",3);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("GPCA_Extension",3,"gatewayCannotBeInlinedMultipleTimes"));
    if(chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 5, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"GPCA_Extension",3,6);
      sf_mark_chart_reusable_outputs(S,"GPCA_Extension",3,1);
    }
    ssSetInputPortOptimOpts(S, 6, SS_REUSABLE_AND_LOCAL);
    sf_set_rtw_dwork_info(S,"GPCA_Extension",3);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(1552185716U));
  ssSetChecksum1(S,(3276397465U));
  ssSetChecksum2(S,(3421352088U));
  ssSetChecksum3(S,(3829977970U));

  ssSetmdlDerivatives(S, NULL);

  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c3_GPCA_Extension(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "GPCA_Extension", 3);
    ssWriteRTWStrParam(S, "StateflowChartType", "Stateflow");
  }
}

static void mdlStart_c3_GPCA_Extension(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 0;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c3_GPCA_Extension;
  chartInstance.chartInfo.initializeChart =
    sf_opaque_initialize_c3_GPCA_Extension;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c3_GPCA_Extension;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c3_GPCA_Extension;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c3_GPCA_Extension;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c3_GPCA_Extension;
  chartInstance.chartInfo.mdlStart = mdlStart_c3_GPCA_Extension;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c3_GPCA_Extension;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo))); /* register the chart instance with simstruct */

  if(!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }
  init_io_bus_offset();
}

void c3_GPCA_Extension_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c3_GPCA_Extension(S);
    break;
   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c3_GPCA_Extension(S);
    break;
   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c3_GPCA_Extension(S);
    break;
   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
     "Error calling c3_GPCA_Extension_method_dispatcher.\n"
     "Can't handle method %d.\n", method);
    break;
  }
}

