/* Include files */
#include "StateChanger2_mod_sfun.h"
#include "c3_StateChanger2_mod.h"

/* Type Definitions */

/* Named Constants */
#define c3_event_E_Restart              (10U)
#define c3_event_E_AlarmClear           (7U)
#define c3_event_E_LevelOneAlarm        (2U)
#define c3_event_E_LevelTwoAlarm        (14U)
#define c3_event_E_LevelOneClear        (6U)
#define c3_event_E_ResetOne             (4U)
#define c3_event_E_DoneOne              (8U)
#define c3_event_E_DoneThree            (11U)
#define c3_event_E_DoneTwo              (5U)
#define c3_event_E_ResetTwo             (9U)
#define c3_event_E_ResetThree           (13U)
#define c3_event_E_WarningAlarm         (0U)
#define c3_event_E_RequestToStart       (16U)
#define c3_event_E_Clock                (15U)
#define c3_IN_NO_ACTIVE_CHILD           (0)
#define c3_IN_APErrCheck                (1)
#define c3_IN_HumCheck                  (8)
#define c3_IN_ETCheck                   (4)
#define c3_IN_LRCheck                   (11)
#define c3_IN_LBCheck                   (9)
#define c3_IN_EndState                  (5)
#define c3_IN_WNStart                   (12)
#define c3_IN_LGCheck                   (10)
#define c3_IN_Hold                      (7)
#define c3_IN_HOLD                      (2)
#define c3_IN_AlarmingMachine           (1)
#define c3_IN_SinkTWOCheckOne           (7)
#define c3_IN_START                     (4)
#define c3_IN_Sink213                   (17)
#define c3_IN_Sink25                    (20)
#define c3_IN_Sink27                    (22)
#define c3_IN_FRVarCheck                (6)
#define c3_IN_CheckLOne                 (1)
#define c3_IN_CheckWRN                  (3)
#define c3_IN_SinkOne                   (5)
#define c3_IN_OccuCheck                 (11)
#define c3_IN_LonePauseCheck            (8)
#define c3_IN_Sink26                    (21)
#define c3_IN_DOCheck                   (2)
#define c3_IN_Sink24                    (19)
#define c3_IN_AILCheck                  (1)
#define c3_IN_SinkTWO                   (6)
#define c3_IN_Normal                    (9)
#define c3_IN_ERCheck                   (3)
#define c3_IN_Sink22                    (18)
#define c3_IN_BatterFunctionCheck       (2)
#define c3_IN_WDCheck                   (26)
#define c3_IN_Sink21                    (13)
#define c3_IN_MemoryCheck               (4)
#define c3_IN_NoPowerCheck              (5)
#define c3_IN_PumpTooHot                (12)
#define c3_IN_WDCCheck                  (8)
#define c3_IN_FRACCheck                 (4)
#define c3_b_IN_Normal                  (6)
#define c3_IN_FRLessCheck               (5)
#define c3_IN_Sink212                   (16)
#define c3_IN_OICheck                   (10)
#define c3_IN_Sink211                   (15)
#define c3_IN_CheckLTwo                 (2)
#define c3_IN_Sink28                    (23)
#define c3_IN_UnderInfuCheck            (25)
#define c3_IN_Sink210                   (14)
#define c3_IN_Sink29                    (24)
#define c3_IN_CPUAlarming               (1)
#define c3_IN_WDICheck                  (9)
#define c3_IN_L1Sink                    (3)
#define c3_IN_RTCCheck                  (7)
#define c3_IN_HoldOn                    (7)
#define c3_c_IN_Normal                  (2)
#define c3_IN_Checking                  (1)
#define c3_IN_BatteryChargeCheck        (3)
#define c3_IN_FRVCheck                  (6)
#define c3_IN_s1                        (3)
#define c3_IN_s2                        (4)
#define c3_const_MSG_BLANK              (30U)

/* Variable Declarations */

/* Variable Definitions */
static SFc3_StateChanger2_modInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c3_StateChanger2_mod(void);
static void initialize_params_c3_StateChanger2_mod(void);
static void enable_c3_StateChanger2_mod(void);
static void disable_c3_StateChanger2_mod(void);
static void finalize_c3_StateChanger2_mod(void);
static void sf_c3_StateChanger2_mod(void);
static void c3_c3_StateChanger2_mod(void);
static void c3_WRN(void);
static void c3_Sink25(void);
static void c3_Sink27(void);
static void c3_Sink26(void);
static void c3_Controller(void);
static real_T c3_clearBatteryFunction(void);
static void c3_LTwo(void);
static void c3_Sink28(void);
static void c3_Sink29(void);
static void c3_LOne(void);
static real_T c3_clearet(void);
static real_T c3_clearap(void);
static real_T c3_clearBatteryCharge(void);
static real_T c3_clearfrv(void);
static void init_script_number_translation(uint32_T c3_machineNumber, uint32_T
 c3_chartNumber);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c3_StateChanger2_mod(void)
{
  real_T *c3_ErrCond;
  boolean_T *c3_E_Alarm;
  boolean_T *c3_E_Warning;
  boolean_T *c3_E_Ready;
  boolean_T *c3_E_NotReady;
  c3_E_Ready = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 4);
  c3_E_Alarm = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 2);
  c3_E_Warning = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 3);
  c3_E_NotReady = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 5);
  c3_ErrCond = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c3_is_active_CheckReady = 0U;
  chartInstance.c3_is_CheckReady = 0U;
  chartInstance.c3_is_active_Controller = 0U;
  chartInstance.c3_is_Controller = 0U;
  chartInstance.c3_is_active_LOne = 0U;
  chartInstance.c3_is_LOne = 0U;
  chartInstance.c3_is_active_LTwo = 0U;
  chartInstance.c3_is_LTwo = 0U;
  chartInstance.c3_is_active_WRN = 0U;
  chartInstance.c3_is_WRN = 0U;
  chartInstance.c3_is_active_c3_StateChanger2_mod = 0U;
  chartInstance.c3_is_c3_StateChanger2_mod = 0U;
  chartInstance.c3_LOneCond = 0U;
  chartInstance.c3_LTwoCond = 0U;
  chartInstance.c3_WnCond = 0U;
  chartInstance.c3_lgflag = 0U;
  chartInstance.c3_lbflag = 0U;
  chartInstance.c3_lrflag = 0U;
  chartInstance.c3_etflag = 0U;
  chartInstance.c3_humflag = 0U;
  chartInstance.c3_apflag = 0U;
  chartInstance.c3_bcflag = 0;
  chartInstance.c3_bfflag = 0;
  chartInstance.c3_frvflag = 0;
  chartInstance.c3_MSG_BLANK = 30U;
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 1) != 0)) {
    *c3_ErrCond = 0.0;
  }
  chartInstance.c3_E_AlarmEventCounter = 0U;
  *c3_E_Alarm = false;
  chartInstance.c3_E_WarningEventCounter = 0U;
  *c3_E_Warning = false;
  chartInstance.c3_E_ReadyEventCounter = 0U;
  *c3_E_Ready = false;
  chartInstance.c3_E_NotReadyEventCounter = 0U;
  *c3_E_NotReady = false;
}

static void initialize_params_c3_StateChanger2_mod(void)
{
}

static void enable_c3_StateChanger2_mod(void)
{
}

static void disable_c3_StateChanger2_mod(void)
{
}

static void finalize_c3_StateChanger2_mod(void)
{
}

static void sf_c3_StateChanger2_mod(void)
{
  int32_T c3_inputEventFiredFlag;
  uint8_T c3_previousEvent;
  int8_T *c3_E_Restart;
  int8_T *c3_E_AlarmClear;
  int8_T *c3_E_RequestToStart;
  int8_T *c3_E_Clock;
  boolean_T *c3_E_Alarm;
  boolean_T *c3_E_Warning;
  boolean_T *c3_E_Ready;
  boolean_T *c3_E_NotReady;
  c3_E_AlarmClear = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 30) +
   1);
  c3_E_RequestToStart = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S,
    30) + 2);
  c3_E_Restart = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 30) + 0);
  c3_E_Clock = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 30) + 3);
  c3_E_Ready = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 4);
  c3_E_Alarm = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 2);
  c3_E_Warning = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 3);
  c3_E_NotReady = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 5);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  c3_inputEventFiredFlag = 0;
  if(*c3_E_Restart == 1) {
    c3_inputEventFiredFlag = 1;
    c3_previousEvent = _sfEvent_;
    _sfEvent_ = c3_event_E_Restart;
    c3_c3_StateChanger2_mod();
    _sfEvent_ = c3_previousEvent;
  }
  if(*c3_E_AlarmClear == 1) {
    c3_inputEventFiredFlag = 1;
    c3_previousEvent = _sfEvent_;
    _sfEvent_ = c3_event_E_AlarmClear;
    c3_c3_StateChanger2_mod();
    _sfEvent_ = c3_previousEvent;
  }
  if(*c3_E_RequestToStart != 0) {
    c3_inputEventFiredFlag = 1;
    c3_previousEvent = _sfEvent_;
    _sfEvent_ = c3_event_E_RequestToStart;
    c3_c3_StateChanger2_mod();
    _sfEvent_ = c3_previousEvent;
  }
  if(*c3_E_Clock == 1) {
    c3_inputEventFiredFlag = 1;
    c3_previousEvent = _sfEvent_;
    _sfEvent_ = c3_event_E_Clock;
    c3_c3_StateChanger2_mod();
    _sfEvent_ = c3_previousEvent;
  }
  if((c3_inputEventFiredFlag != 0) && (chartInstance.c3_E_AlarmEventCounter >
    0U)) {
    *c3_E_Alarm = !(*c3_E_Alarm);
    chartInstance.c3_E_AlarmEventCounter = chartInstance.c3_E_AlarmEventCounter
      - 1U;
  }
  if((c3_inputEventFiredFlag != 0) && (chartInstance.c3_E_WarningEventCounter >
    0U)) {
    *c3_E_Warning = !(*c3_E_Warning);
    chartInstance.c3_E_WarningEventCounter =
      chartInstance.c3_E_WarningEventCounter - 1U;
  }
  if((c3_inputEventFiredFlag != 0) && (chartInstance.c3_E_ReadyEventCounter >
    0U)) {
    *c3_E_Ready = !(*c3_E_Ready);
    chartInstance.c3_E_ReadyEventCounter = chartInstance.c3_E_ReadyEventCounter
      - 1U;
  }
  if((c3_inputEventFiredFlag != 0) && (chartInstance.c3_E_NotReadyEventCounter >
    0U)) {
    *c3_E_NotReady = !(*c3_E_NotReady);
    chartInstance.c3_E_NotReadyEventCounter =
      chartInstance.c3_E_NotReadyEventCounter - 1U;
  }
}

static void c3_c3_StateChanger2_mod(void)
{
  boolean_T *c3_EmptyReservoir;
  real_T *c3_DoorOpen;
  uint32_T *c3_Infusing;
  c3_EmptyReservoir = (boolean_T *)ssGetInputPortSignal(chartInstance.S, 2);
  c3_DoorOpen = (real_T *)ssGetInputPortSignal(chartInstance.S, 9);
  c3_Infusing = (uint32_T *)ssGetInputPortSignal(chartInstance.S, 1);
  if(chartInstance.c3_is_active_c3_StateChanger2_mod == 0) {
    chartInstance.c3_is_active_c3_StateChanger2_mod = 1U;
    chartInstance.c3_is_c3_StateChanger2_mod = (uint8_T)c3_IN_AlarmingMachine;
    chartInstance.c3_is_active_Controller = 1U;
    chartInstance.c3_is_Controller = (uint8_T)c3_IN_START;
    chartInstance.c3_is_active_CheckReady = 1U;
    chartInstance.c3_is_CheckReady = (uint8_T)c3_c_IN_Normal;
    chartInstance.c3_is_active_LOne = 1U;
    chartInstance.c3_is_LOne = (uint8_T)c3_b_IN_Normal;
    chartInstance.c3_is_active_LTwo = 1U;
    if(chartInstance.c3_is_LTwo != c3_IN_Normal) {
      chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Normal;
      chartInstance.c3_LTwoCond = 0U;
    }
    chartInstance.c3_is_active_WRN = 1U;
    if(chartInstance.c3_is_WRN != c3_IN_WNStart) {
      chartInstance.c3_is_WRN = (uint8_T)c3_IN_WNStart;
      chartInstance.c3_WnCond = 0U;
    }
  } else if(chartInstance.c3_is_c3_StateChanger2_mod == c3_IN_AlarmingMachine) {
    c3_Controller();
    if(chartInstance.c3_is_active_CheckReady != 0) {
      switch(chartInstance.c3_is_CheckReady) {
       case c3_IN_Checking:
        if(_sfEvent_ == c3_event_E_Restart) {
          chartInstance.c3_is_CheckReady = (uint8_T)c3_c_IN_Normal;
        } else if((*c3_EmptyReservoir == 0) && (*c3_DoorOpen == 0.0)) {
          chartInstance.c3_is_CheckReady = (uint8_T)c3_IN_s1;
        } else if((*c3_EmptyReservoir > 0) || (*c3_DoorOpen > 0.0)) {
          chartInstance.c3_is_CheckReady = (uint8_T)c3_IN_s2;
        }
        break;
       case c3_c_IN_Normal:
        if(_sfEvent_ == c3_event_E_RequestToStart) {
          chartInstance.c3_is_CheckReady = (uint8_T)c3_IN_Checking;
        }
        break;
       case c3_IN_s1:
        if((_sfEvent_ == c3_event_E_Clock) && (*c3_Infusing == 0U)) {
          sf_mex_printf("%s\\n", "E_Ready");
          chartInstance.c3_E_ReadyEventCounter =
            chartInstance.c3_E_ReadyEventCounter + 1U;
          chartInstance.c3_is_CheckReady = (uint8_T)c3_IN_s1;
        } else if(_sfEvent_ == c3_event_E_RequestToStart) {
          chartInstance.c3_is_CheckReady = (uint8_T)c3_IN_Checking;
        } else if(_sfEvent_ == c3_event_E_Restart) {
          chartInstance.c3_is_CheckReady = (uint8_T)c3_c_IN_Normal;
        } else if(*c3_Infusing == 1U) {
          chartInstance.c3_is_CheckReady = (uint8_T)c3_c_IN_Normal;
        }
        break;
       case c3_IN_s2:
        if(_sfEvent_ == c3_event_E_RequestToStart) {
          chartInstance.c3_is_CheckReady = (uint8_T)c3_IN_Checking;
        } else if(_sfEvent_ == c3_event_E_Clock) {
          sf_mex_printf("%s\\n", "E_NotReady");
          chartInstance.c3_E_NotReadyEventCounter =
            chartInstance.c3_E_NotReadyEventCounter + 1U;
          chartInstance.c3_is_CheckReady = (uint8_T)c3_IN_s2;
        } else if(_sfEvent_ == c3_event_E_Restart) {
          chartInstance.c3_is_CheckReady = (uint8_T)c3_c_IN_Normal;
        }
        break;
       default:
        chartInstance.c3_is_CheckReady = (uint8_T)c3_IN_NO_ACTIVE_CHILD;
        break;
      }
    }
    c3_LOne();
    c3_LTwo();
    c3_WRN();
  }
}

static void c3_WRN(void)
{
  boolean_T c3_guard1 = false;
  uint8_T c3_previousEvent;
  real_T c3_d0;
  real_T c3_d1;
  real_T c3_d2;
  real_T c3_d3;
  real_T c3_d4;
  real_T c3_d5;
  real_T c3_d6;
  real_T c3_d7;
  real_T c3_d8;
  real_T c3_d9;
  real_T c3_d10;
  real_T c3_d11;
  real_T *c3_AirPressure;
  real_T *c3_BatteryFunction;
  real_T *c3_BatteryCharge;
  real_T *c3_EnvTempOutRange;
  real_T *c3_FlowRateVariance;
  uint32_T *c3_Infusing;
  real_T *c3_Humidity;
  boolean_T *c3_LowBattery;
  real_T *c3_LogError;
  boolean_T *c3_LowReservoir;
  c3_LogError = (real_T *)ssGetInputPortSignal(chartInstance.S, 12);
  c3_LowReservoir = (boolean_T *)ssGetInputPortSignal(chartInstance.S, 13);
  c3_Humidity = (real_T *)ssGetInputPortSignal(chartInstance.S, 23);
  c3_EnvTempOutRange = (real_T *)ssGetInputPortSignal(chartInstance.S, 22);
  c3_AirPressure = (real_T *)ssGetInputPortSignal(chartInstance.S, 24);
  c3_FlowRateVariance = (real_T *)ssGetInputPortSignal(chartInstance.S, 15);
  c3_Infusing = (uint32_T *)ssGetInputPortSignal(chartInstance.S, 1);
  c3_LowBattery = (boolean_T *)ssGetInputPortSignal(chartInstance.S, 14);
  c3_BatteryFunction = (real_T *)ssGetInputPortSignal(chartInstance.S, 28);
  c3_BatteryCharge = (real_T *)ssGetInputPortSignal(chartInstance.S, 27);
  if(chartInstance.c3_is_active_WRN != 0) {
    c3_guard1 = false;
    switch(chartInstance.c3_is_WRN) {
     case c3_IN_APErrCheck:
      if(_sfEvent_ == c3_event_E_ResetThree) {
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_HoldOn;
      } else if(*c3_AirPressure == 0.0) {
        c3_clearap();
        c3_guard1 = true;
      } else if((*c3_AirPressure > 0.0) && (chartInstance.c3_apflag > 0U)) {
        c3_guard1 = true;
      } else if((*c3_AirPressure > 0.0) && (chartInstance.c3_apflag == 0U)) {
        chartInstance.c3_WnCond = 25U;
        chartInstance.c3_apflag = 1U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_WarningAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_WRN == c3_IN_APErrCheck) {
          chartInstance.c3_is_WRN = (uint8_T)c3_IN_EndState;
        }
      }
      break;
     case c3_IN_BatterFunctionCheck:
      if(_sfEvent_ == c3_event_E_ResetThree) {
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_HoldOn;
      } else if((*c3_BatteryFunction > 0.0) && (chartInstance.c3_bfflag == 0)) {
        chartInstance.c3_WnCond = 27U;
        chartInstance.c3_bfflag = 1;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_WarningAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_WRN == c3_IN_BatterFunctionCheck) {
          chartInstance.c3_is_WRN = (uint8_T)c3_IN_APErrCheck;
        }
      } else if(*c3_BatteryFunction == 0.0) {
        c3_clearBatteryFunction();
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_APErrCheck;
      } else if((*c3_BatteryFunction > 0.0) && (chartInstance.c3_bfflag > 0)) {
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_APErrCheck;
      }
      break;
     case c3_IN_BatteryChargeCheck:
      if(_sfEvent_ == c3_event_E_ResetThree) {
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_HoldOn;
      } else if((*c3_BatteryCharge > 0.0) && (chartInstance.c3_bcflag == 0)) {
        chartInstance.c3_WnCond = 26U;
        chartInstance.c3_bcflag = 1;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_WarningAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_WRN == c3_IN_BatteryChargeCheck) {
          chartInstance.c3_is_WRN = (uint8_T)c3_IN_BatterFunctionCheck;
        }
      } else if(*c3_BatteryCharge == 0.0) {
        c3_clearBatteryCharge();
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_BatterFunctionCheck;
      } else if((*c3_BatteryCharge > 0.0) && (chartInstance.c3_bcflag > 0)) {
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_BatterFunctionCheck;
      }
      break;
     case c3_IN_ETCheck:
      if(_sfEvent_ == c3_event_E_ResetThree) {
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_HoldOn;
      } else if((*c3_EnvTempOutRange > 0.0) && (chartInstance.c3_etflag == 0U)) {
        chartInstance.c3_WnCond = 23U;
        chartInstance.c3_etflag = 1U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_WarningAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_WRN == c3_IN_ETCheck) {
          chartInstance.c3_is_WRN = (uint8_T)c3_IN_HumCheck;
        }
      } else if(*c3_EnvTempOutRange == 0.0) {
        c3_clearet();
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_HumCheck;
      } else if((*c3_EnvTempOutRange > 0.0) && (chartInstance.c3_etflag > 0U)) {
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_HumCheck;
      }
      break;
     case c3_IN_EndState:
      if(_sfEvent_ == c3_event_E_Clock) {
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_DoneThree;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_WRN == c3_IN_EndState) {
          chartInstance.c3_is_WRN = (uint8_T)c3_IN_WNStart;
          chartInstance.c3_WnCond = 0U;
        }
      }
      break;
     case c3_IN_FRVCheck:
      if(_sfEvent_ == c3_event_E_ResetThree) {
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_HoldOn;
      } else if((*c3_FlowRateVariance > 0.0) && (chartInstance.c3_frvflag == 0)
       && (*c3_Infusing > 0U)) {
        chartInstance.c3_WnCond = 19U;
        chartInstance.c3_frvflag = 1;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_WarningAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_WRN == c3_IN_FRVCheck) {
          chartInstance.c3_is_WRN = (uint8_T)c3_IN_LGCheck;
        }
      } else if((*c3_FlowRateVariance == 0.0) || (*c3_Infusing == 0U)) {
        c3_clearfrv();
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_LGCheck;
      } else if((*c3_FlowRateVariance > 0.0) && (chartInstance.c3_frvflag > 0)
       && (*c3_Infusing > 0U)) {
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_LGCheck;
      }
      break;
     case c3_IN_HoldOn:
      if((chartInstance.c3_is_WRN == c3_IN_HoldOn) && (_sfEvent_ ==
        c3_event_E_Clock)) {
        chartInstance.c3_WnCond = 0U;
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_FRVCheck;
      }
      break;
     case c3_IN_HumCheck:
      if(_sfEvent_ == c3_event_E_ResetThree) {
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_HoldOn;
      } else if((*c3_Humidity > 0.0) && (chartInstance.c3_humflag == 0U)) {
        chartInstance.c3_WnCond = 24U;
        chartInstance.c3_humflag = 1U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_WarningAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_WRN == c3_IN_HumCheck) {
          chartInstance.c3_is_WRN = (uint8_T)c3_IN_BatteryChargeCheck;
        }
      } else if(*c3_Humidity == 0.0) {
        sf_mex_import(sf_mex_get_ml_var("GAlrmMsg", 0), "GAlrmMsg", &c3_d0, 0,
         0, 0U, 0, 0);
        if(c3_d0 == 24.0) {
          chartInstance.c3_humflag = 0U;
          c3_d1 = (real_T)c3_const_MSG_BLANK;
          sf_mex_export("GAlrmMsg", sf_mex_create(&c3_d1, "GAlrmMsg", 0, 0U, 0U,
            0), 0);
        } else {
          sf_mex_import(sf_mex_get_ml_var("GAlrmMsg", 0), "GAlrmMsg", &c3_d2, 0,
           0, 0U, 0, 0);
          if(c3_d2 != 24.0) {
            chartInstance.c3_humflag = 0U;
          }
        }
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_BatteryChargeCheck;
      } else if((*c3_Humidity > 0.0) && (chartInstance.c3_humflag > 0U)) {
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_BatteryChargeCheck;
      }
      break;
     case c3_IN_LBCheck:
      if(_sfEvent_ == c3_event_E_ResetThree) {
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_HoldOn;
      } else if((*c3_LowBattery > 0) && (chartInstance.c3_lbflag == 0U)) {
        chartInstance.c3_WnCond = 21U;
        chartInstance.c3_lbflag = 1U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_WarningAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_WRN == c3_IN_LBCheck) {
          chartInstance.c3_is_WRN = (uint8_T)c3_IN_LRCheck;
        }
      } else if(*c3_LowBattery == 0) {
        sf_mex_import(sf_mex_get_ml_var("GAlrmMsg", 0), "GAlrmMsg", &c3_d3, 0,
         0, 0U, 0, 0);
        if(c3_d3 == 20.0) {
          chartInstance.c3_lbflag = 0U;
          c3_d4 = (real_T)c3_const_MSG_BLANK;
          sf_mex_export("GAlrmMsg", sf_mex_create(&c3_d4, "GAlrmMsg", 0, 0U, 0U,
            0), 0);
        } else {
          sf_mex_import(sf_mex_get_ml_var("GAlrmMsg", 0), "GAlrmMsg", &c3_d5, 0,
           0, 0U, 0, 0);
          if(c3_d5 != 20.0) {
            chartInstance.c3_lbflag = 0U;
          }
        }
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_LRCheck;
      } else if((*c3_LowBattery > 0) && (chartInstance.c3_lbflag > 0U)) {
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_LRCheck;
      }
      break;
     case c3_IN_LGCheck:
      if(_sfEvent_ == c3_event_E_ResetThree) {
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_HoldOn;
      } else if((*c3_LogError > 0.0) && (chartInstance.c3_lgflag == 0U)) {
        chartInstance.c3_WnCond = 20U;
        chartInstance.c3_lgflag = 1U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_WarningAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_WRN == c3_IN_LGCheck) {
          chartInstance.c3_is_WRN = (uint8_T)c3_IN_LBCheck;
        }
      } else if(*c3_LogError == 0.0) {
        sf_mex_import(sf_mex_get_ml_var("GAlrmMsg", 0), "GAlrmMsg", &c3_d6, 0,
         0, 0U, 0, 0);
        if(c3_d6 == 19.0) {
          chartInstance.c3_lgflag = 0U;
          c3_d7 = (real_T)c3_const_MSG_BLANK;
          sf_mex_export("GAlrmMsg", sf_mex_create(&c3_d7, "GAlrmMsg", 0, 0U, 0U,
            0), 0);
        } else {
          sf_mex_import(sf_mex_get_ml_var("GAlrmMsg", 0), "GAlrmMsg", &c3_d8, 0,
           0, 0U, 0, 0);
          if(c3_d8 != 19.0) {
            chartInstance.c3_lgflag = 0U;
          }
        }
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_LBCheck;
      } else if((*c3_LogError > 0.0) && (chartInstance.c3_lgflag > 0U)) {
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_LBCheck;
      }
      break;
     case c3_IN_LRCheck:
      if(_sfEvent_ == c3_event_E_ResetThree) {
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_HoldOn;
      } else if((*c3_LowReservoir > 0) && (chartInstance.c3_lrflag == 0U)) {
        chartInstance.c3_WnCond = 22U;
        chartInstance.c3_lrflag = 1U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_WarningAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_WRN == c3_IN_LRCheck) {
          chartInstance.c3_is_WRN = (uint8_T)c3_IN_ETCheck;
        }
      } else if(*c3_LowReservoir == 0) {
        sf_mex_import(sf_mex_get_ml_var("GAlrmMsg", 0), "GAlrmMsg", &c3_d9, 0,
         0, 0U, 0, 0);
        if(c3_d9 == 21.0) {
          chartInstance.c3_lrflag = 0U;
          c3_d10 = (real_T)c3_const_MSG_BLANK;
          sf_mex_export("GAlrmMsg", sf_mex_create(&c3_d10, "GAlrmMsg", 0, 0U,
            0U, 0), 0);
        } else {
          sf_mex_import(sf_mex_get_ml_var("GAlrmMsg", 0), "GAlrmMsg", &c3_d11,
           0, 0, 0U, 0, 0);
          if(c3_d11 != 21.0) {
            chartInstance.c3_lrflag = 0U;
          }
        }
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_ETCheck;
      } else if((*c3_LowReservoir > 0) || (chartInstance.c3_lrflag > 0U)) {
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_ETCheck;
      }
      break;
     case c3_IN_WNStart:
      if((chartInstance.c3_is_WRN == c3_IN_WNStart) && (_sfEvent_ ==
        c3_event_E_ResetThree)) {
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_HoldOn;
      }
      break;
     default:
      chartInstance.c3_is_WRN = (uint8_T)c3_IN_NO_ACTIVE_CHILD;
      break;
    }
    if(c3_guard1 == true) {
      c3_previousEvent = _sfEvent_;
      _sfEvent_ = c3_event_E_DoneThree;
      c3_Controller();
      _sfEvent_ = c3_previousEvent;
      if(chartInstance.c3_is_WRN == c3_IN_APErrCheck) {
        chartInstance.c3_is_WRN = (uint8_T)c3_IN_WNStart;
        chartInstance.c3_WnCond = 0U;
      }
    }
  }
}

static void c3_Sink25(void)
{
  boolean_T *c3_AirInLine;
  uint32_T *c3_Infusing;
  c3_AirInLine = (boolean_T *)ssGetInputPortSignal(chartInstance.S, 8);
  c3_Infusing = (uint32_T *)ssGetInputPortSignal(chartInstance.S, 1);
  if(chartInstance.c3_is_LTwo == c3_IN_Sink25) {
    if(_sfEvent_ == c3_event_E_ResetTwo) {
      chartInstance.c3_is_LTwo = (uint8_T)c3_IN_ERCheck;
    } else if((*c3_AirInLine == 0) || (*c3_Infusing == 0U)) {
      chartInstance.c3_is_LTwo = (uint8_T)c3_IN_ERCheck;
    }
  }
}

static void c3_Sink27(void)
{
  boolean_T *c3_TooLongPause;
  real_T *c3_InfusionPaused;
  c3_InfusionPaused = (real_T *)ssGetInputPortSignal(chartInstance.S, 26);
  c3_TooLongPause = (boolean_T *)ssGetInputPortSignal(chartInstance.S, 11);
  if(chartInstance.c3_is_LTwo == c3_IN_Sink27) {
    if(_sfEvent_ == c3_event_E_ResetTwo) {
      chartInstance.c3_is_LTwo = (uint8_T)c3_IN_ERCheck;
    } else if((*c3_TooLongPause == 0) || (*c3_InfusionPaused == 0.0)) {
      chartInstance.c3_is_LTwo = (uint8_T)c3_IN_ERCheck;
    }
  }
}

static void c3_Sink26(void)
{
  boolean_T *c3_Occlusion;
  uint32_T *c3_Infusing;
  c3_Occlusion = (boolean_T *)ssGetInputPortSignal(chartInstance.S, 7);
  c3_Infusing = (uint32_T *)ssGetInputPortSignal(chartInstance.S, 1);
  if(chartInstance.c3_is_LTwo == c3_IN_Sink26) {
    if(_sfEvent_ == c3_event_E_ResetTwo) {
      chartInstance.c3_is_LTwo = (uint8_T)c3_IN_ERCheck;
    } else if((*c3_Occlusion == 0) || (*c3_Infusing == 0U)) {
      chartInstance.c3_is_LTwo = (uint8_T)c3_IN_ERCheck;
    }
  }
}

static void c3_Controller(void)
{
  uint8_T c3_previousEvent;
  real_T *c3_ErrCond;
  c3_ErrCond = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  if(chartInstance.c3_is_active_Controller != 0) {
    switch(chartInstance.c3_is_Controller) {
     case c3_IN_CheckLOne:
      if(_sfEvent_ == c3_event_E_LevelOneAlarm) {
        *c3_ErrCond = (real_T)chartInstance.c3_LOneCond;
        chartInstance.c3_is_Controller = (uint8_T)c3_IN_SinkOne;
      } else if(_sfEvent_ == c3_event_E_DoneOne) {
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_ResetTwo;
        c3_LTwo();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_Controller == c3_IN_CheckLOne) {
          chartInstance.c3_is_Controller = (uint8_T)c3_IN_CheckLTwo;
        }
      }
      break;
     case c3_IN_CheckLTwo:
      if(_sfEvent_ == c3_event_E_Restart) {
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_ResetOne;
        c3_LOne();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_Controller == c3_IN_CheckLTwo) {
          chartInstance.c3_is_Controller = (uint8_T)c3_IN_CheckLOne;
          chartInstance.c3_LOneCond = 0U;
          chartInstance.c3_LTwoCond = 0U;
          chartInstance.c3_WnCond = 0U;
          *c3_ErrCond = 0.0;
        }
      } else if(_sfEvent_ == c3_event_E_LevelTwoAlarm) {
        *c3_ErrCond = (real_T)chartInstance.c3_LTwoCond;
        chartInstance.c3_is_Controller = (uint8_T)c3_IN_SinkTWO;
      } else if(_sfEvent_ == c3_event_E_DoneTwo) {
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_ResetThree;
        c3_WRN();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_Controller == c3_IN_CheckLTwo) {
          chartInstance.c3_is_Controller = (uint8_T)c3_IN_CheckWRN;
        }
      }
      break;
     case c3_IN_CheckWRN:
      if(_sfEvent_ == c3_event_E_WarningAlarm) {
        *c3_ErrCond = (real_T)chartInstance.c3_WnCond;
        sf_mex_printf("%s\\n", "E_Warning");
        chartInstance.c3_E_WarningEventCounter =
          chartInstance.c3_E_WarningEventCounter + 1U;
        chartInstance.c3_is_Controller = (uint8_T)c3_IN_CheckWRN;
      } else if(_sfEvent_ == c3_event_E_DoneThree) {
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_ResetOne;
        c3_LOne();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_Controller == c3_IN_CheckWRN) {
          chartInstance.c3_is_Controller = (uint8_T)c3_IN_CheckLOne;
          chartInstance.c3_LOneCond = 0U;
          chartInstance.c3_LTwoCond = 0U;
          chartInstance.c3_WnCond = 0U;
          *c3_ErrCond = 0.0;
        }
      } else if(_sfEvent_ == c3_event_E_Restart) {
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_ResetOne;
        c3_LOne();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_Controller == c3_IN_CheckWRN) {
          chartInstance.c3_is_Controller = (uint8_T)c3_IN_CheckLOne;
          chartInstance.c3_LOneCond = 0U;
          chartInstance.c3_LTwoCond = 0U;
          chartInstance.c3_WnCond = 0U;
          *c3_ErrCond = 0.0;
        }
      }
      break;
     case c3_IN_START:
      if(_sfEvent_ == c3_event_E_Restart) {
        chartInstance.c3_lgflag = 0U;
        chartInstance.c3_lbflag = 0U;
        chartInstance.c3_lrflag = 0U;
        chartInstance.c3_etflag = 0U;
        chartInstance.c3_humflag = 0U;
        chartInstance.c3_apflag = 0U;
        chartInstance.c3_bcflag = 0;
        chartInstance.c3_bfflag = 0;
        chartInstance.c3_frvflag = 0;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_ResetOne;
        c3_LOne();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_Controller == c3_IN_START) {
          chartInstance.c3_is_Controller = (uint8_T)c3_IN_CheckLOne;
          chartInstance.c3_LOneCond = 0U;
          chartInstance.c3_LTwoCond = 0U;
          chartInstance.c3_WnCond = 0U;
          *c3_ErrCond = 0.0;
        }
      }
      break;
     case c3_IN_SinkOne:
      if(_sfEvent_ == c3_event_E_Restart) {
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_ResetOne;
        c3_LOne();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_Controller == c3_IN_SinkOne) {
          chartInstance.c3_is_Controller = (uint8_T)c3_IN_CheckLOne;
          chartInstance.c3_LOneCond = 0U;
          chartInstance.c3_LTwoCond = 0U;
          chartInstance.c3_WnCond = 0U;
          *c3_ErrCond = 0.0;
        }
      }
      break;
     case c3_IN_SinkTWO:
      if((_sfEvent_ == c3_event_E_Clock) && (chartInstance.c3_LTwoCond == 0U)) {
        *c3_ErrCond = 0.0;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_ResetOne;
        c3_LOne();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_Controller == c3_IN_SinkTWO) {
          chartInstance.c3_is_Controller = (uint8_T)c3_IN_CheckLOne;
          chartInstance.c3_LOneCond = 0U;
          chartInstance.c3_LTwoCond = 0U;
          chartInstance.c3_WnCond = 0U;
          *c3_ErrCond = 0.0;
        }
      } else if((_sfEvent_ == c3_event_E_Restart) || (_sfEvent_ ==
        c3_event_E_AlarmClear)) {
        *c3_ErrCond = 0.0;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_ResetOne;
        c3_LOne();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_Controller == c3_IN_SinkTWO) {
          chartInstance.c3_is_Controller = (uint8_T)c3_IN_CheckLOne;
          chartInstance.c3_LOneCond = 0U;
          chartInstance.c3_LTwoCond = 0U;
          chartInstance.c3_WnCond = 0U;
          *c3_ErrCond = 0.0;
        }
      } else if(chartInstance.c3_LTwoCond > 0U) {
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_ResetOne;
        c3_LOne();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_Controller == c3_IN_SinkTWO) {
          chartInstance.c3_is_Controller = (uint8_T)c3_IN_SinkTWOCheckOne;
        }
      }
      break;
     case c3_IN_SinkTWOCheckOne:
      if(_sfEvent_ == c3_event_E_LevelOneAlarm) {
        *c3_ErrCond = (real_T)chartInstance.c3_LOneCond;
        chartInstance.c3_is_Controller = (uint8_T)c3_IN_SinkOne;
      } else if(_sfEvent_ == c3_event_E_DoneOne) {
        chartInstance.c3_is_Controller = (uint8_T)c3_IN_SinkTWO;
      } else if((_sfEvent_ == c3_event_E_Restart) || (_sfEvent_ ==
        c3_event_E_AlarmClear)) {
        *c3_ErrCond = (real_T)chartInstance.c3_LOneCond;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_ResetOne;
        c3_LOne();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_Controller == c3_IN_SinkTWOCheckOne) {
          chartInstance.c3_is_Controller = (uint8_T)c3_IN_CheckLOne;
          chartInstance.c3_LOneCond = 0U;
          chartInstance.c3_LTwoCond = 0U;
          chartInstance.c3_WnCond = 0U;
          *c3_ErrCond = 0.0;
        }
      }
      break;
     default:
      chartInstance.c3_is_Controller = (uint8_T)c3_IN_NO_ACTIVE_CHILD;
      break;
    }
  }
}

static real_T c3_clearBatteryFunction(void)
{
  real_T c3_x;
  real_T c3_d12;
  real_T c3_d13;
  real_T c3_d14;
  c3_x = 0.0;
  sf_mex_import(sf_mex_get_ml_var("GAlrmMsg", 0), "GAlrmMsg", &c3_d12, 0, 0, 0U,
   0, 0);
  if(c3_d12 == 31.0) {
    chartInstance.c3_bfflag = 0;
    c3_d13 = (real_T)c3_const_MSG_BLANK;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c3_d13, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else {
    sf_mex_import(sf_mex_get_ml_var("GAlrmMsg", 0), "GAlrmMsg", &c3_d14, 0, 0,
     0U, 0, 0);
    if(c3_d14 != 31.0) {
      chartInstance.c3_bfflag = 0;
    }
  }
  return c3_x;
}

static void c3_LTwo(void)
{
  uint8_T c3_previousEvent;
  uint32_T *c3_Infusing;
  boolean_T *c3_AirInLine;
  real_T *c3_DoorOpen;
  boolean_T *c3_EmptyReservoir;
  boolean_T *c3_FlowAboveCapacity;
  boolean_T *c3_FlowLessThanKVO;
  real_T *c3_OverInfusion;
  real_T *c3_FlowRateVariance;
  real_T *c3_InfusionPaused;
  boolean_T *c3_TooLongPause;
  boolean_T *c3_Occlusion;
  real_T *c3_PumpTooHot;
  real_T *c3_UnderInfusion;
  real_T *c3_VoltOutRange;
  c3_EmptyReservoir = (boolean_T *)ssGetInputPortSignal(chartInstance.S, 2);
  c3_Occlusion = (boolean_T *)ssGetInputPortSignal(chartInstance.S, 7);
  c3_VoltOutRange = (real_T *)ssGetInputPortSignal(chartInstance.S, 29);
  c3_DoorOpen = (real_T *)ssGetInputPortSignal(chartInstance.S, 9);
  c3_OverInfusion = (real_T *)ssGetInputPortSignal(chartInstance.S, 16);
  c3_AirInLine = (boolean_T *)ssGetInputPortSignal(chartInstance.S, 8);
  c3_UnderInfusion = (real_T *)ssGetInputPortSignal(chartInstance.S, 17);
  c3_InfusionPaused = (real_T *)ssGetInputPortSignal(chartInstance.S, 26);
  c3_FlowRateVariance = (real_T *)ssGetInputPortSignal(chartInstance.S, 15);
  c3_PumpTooHot = (real_T *)ssGetInputPortSignal(chartInstance.S, 21);
  c3_Infusing = (uint32_T *)ssGetInputPortSignal(chartInstance.S, 1);
  c3_FlowLessThanKVO = (boolean_T *)ssGetInputPortSignal(chartInstance.S, 18);
  c3_FlowAboveCapacity = (boolean_T *)ssGetInputPortSignal(chartInstance.S, 19);
  c3_TooLongPause = (boolean_T *)ssGetInputPortSignal(chartInstance.S, 11);
  if(chartInstance.c3_is_active_LTwo != 0) {
    switch(chartInstance.c3_is_LTwo) {
     case c3_IN_AILCheck:
      if(_sfEvent_ == c3_event_E_ResetTwo) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Hold;
      } else if((*c3_Infusing > 0U) && (*c3_AirInLine > 0)) {
        chartInstance.c3_LTwoCond = 11U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_LevelTwoAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_LTwo == c3_IN_AILCheck) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Sink25;
        }
      } else if((*c3_AirInLine == 0) || (*c3_Infusing == 0U)) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_OccuCheck;
      }
      break;
     case c3_IN_DOCheck:
      if(_sfEvent_ == c3_event_E_ResetTwo) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Hold;
      } else if((*c3_Infusing > 0U) && (*c3_DoorOpen > 0.0)) {
        chartInstance.c3_LTwoCond = 10U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_LevelTwoAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_LTwo == c3_IN_DOCheck) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Sink24;
        }
      } else if((*c3_DoorOpen == 0.0) || (*c3_Infusing == 0U)) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_AILCheck;
      }
      break;
     case c3_IN_ERCheck:
      if(_sfEvent_ == c3_event_E_ResetTwo) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Hold;
      } else if((*c3_Infusing > 0U) && (*c3_EmptyReservoir > 0)) {
        chartInstance.c3_LTwoCond = 7U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_LevelTwoAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_LTwo == c3_IN_ERCheck) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Sink21;
        }
      } else if((*c3_EmptyReservoir == 0) || (*c3_Infusing == 0U)) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_WDCheck;
      }
      break;
     case c3_IN_FRACCheck:
      if(_sfEvent_ == c3_event_E_ResetTwo) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Hold;
      } else if((*c3_FlowAboveCapacity > 0) && (*c3_Infusing > 0U)) {
        chartInstance.c3_LTwoCond = 14U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_LevelTwoAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_LTwo == c3_IN_FRACCheck) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Sink212;
        }
      } else if((*c3_FlowAboveCapacity == 0) || (*c3_Infusing == 0U)) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_PumpTooHot;
      }
      break;
     case c3_IN_FRLessCheck:
      if(_sfEvent_ == c3_event_E_ResetTwo) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Hold;
      } else if((*c3_FlowLessThanKVO > 0) && (*c3_Infusing > 0U)) {
        chartInstance.c3_LTwoCond = 17U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_LevelTwoAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_LTwo == c3_IN_FRLessCheck) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Sink211;
        }
      } else if((*c3_FlowLessThanKVO == 0) || (*c3_Infusing == 0U)) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_FRACCheck;
      }
      break;
     case c3_IN_FRVarCheck:
      if(_sfEvent_ == c3_event_E_ResetTwo) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Hold;
      } else if((*c3_OverInfusion > 0.0) && (*c3_Infusing > 0U)) {
        chartInstance.c3_LTwoCond = 14U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_LevelTwoAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_LTwo == c3_IN_FRVarCheck) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Sink28;
        }
      } else if((*c3_FlowRateVariance == 0.0) || (*c3_Infusing == 0U)) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_OICheck;
      }
      break;
     case c3_IN_Hold:
      if((chartInstance.c3_is_LTwo == c3_IN_Hold) && (_sfEvent_ ==
        c3_event_E_Clock)) {
        chartInstance.c3_LTwoCond = 0U;
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_ERCheck;
      }
      break;
     case c3_IN_LonePauseCheck:
      if(_sfEvent_ == c3_event_E_ResetTwo) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Hold;
      } else if((*c3_InfusionPaused > 0.0) && (*c3_TooLongPause > 0)) {
        chartInstance.c3_LTwoCond = 13U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_LevelTwoAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_LTwo == c3_IN_LonePauseCheck) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Sink27;
        }
      } else if((*c3_TooLongPause == 0) || (*c3_InfusionPaused == 0.0)) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_FRVarCheck;
      }
      break;
     case c3_IN_Normal:
      if((chartInstance.c3_is_LTwo == c3_IN_Normal) && (_sfEvent_ ==
        c3_event_E_ResetTwo)) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Hold;
      }
      break;
     case c3_IN_OICheck:
      if(_sfEvent_ == c3_event_E_ResetTwo) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Hold;
      } else if((*c3_OverInfusion > 0.0) && (*c3_Infusing > 0U)) {
        chartInstance.c3_LTwoCond = 15U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_LevelTwoAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_LTwo == c3_IN_OICheck) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Sink29;
        }
      } else if((*c3_OverInfusion == 0.0) || (*c3_Infusing == 0U)) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_UnderInfuCheck;
      }
      break;
     case c3_IN_OccuCheck:
      if(_sfEvent_ == c3_event_E_ResetTwo) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Hold;
      } else if((*c3_Infusing > 0U) && (*c3_Occlusion > 0)) {
        chartInstance.c3_LTwoCond = 12U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_LevelTwoAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_LTwo == c3_IN_OccuCheck) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Sink26;
        }
      } else if((*c3_Occlusion == 0) || (*c3_Infusing == 0U)) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_LonePauseCheck;
      }
      break;
     case c3_IN_PumpTooHot:
      if((_sfEvent_ == c3_event_E_Clock) && (*c3_PumpTooHot == 0.0)) {
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_DoneTwo;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_LTwo == c3_IN_PumpTooHot) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Normal;
          chartInstance.c3_LTwoCond = 0U;
        }
      } else if((_sfEvent_ == c3_event_E_Clock) && (*c3_PumpTooHot > 0.0)) {
        chartInstance.c3_LTwoCond = 9U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_LevelTwoAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_LTwo == c3_IN_PumpTooHot) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Sink213;
        }
      } else if(_sfEvent_ == c3_event_E_ResetTwo) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Hold;
      }
      break;
     case c3_IN_Sink21:
      if(chartInstance.c3_is_LTwo == c3_IN_Sink21) {
        if(_sfEvent_ == c3_event_E_ResetTwo) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_ERCheck;
        } else if((*c3_EmptyReservoir == 0) || (*c3_Infusing == 0U)) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_ERCheck;
        }
      }
      break;
     case c3_IN_Sink210:
      if(chartInstance.c3_is_LTwo == c3_IN_Sink210) {
        if(_sfEvent_ == c3_event_E_ResetTwo) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_ERCheck;
        } else if((*c3_UnderInfusion == 0.0) || (*c3_Infusing == 0U)) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_ERCheck;
        }
      }
      break;
     case c3_IN_Sink211:
      if(chartInstance.c3_is_LTwo == c3_IN_Sink211) {
        if(_sfEvent_ == c3_event_E_ResetTwo) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_ERCheck;
        } else if((*c3_FlowLessThanKVO == 0) || (*c3_Infusing == 0U)) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_ERCheck;
        }
      }
      break;
     case c3_IN_Sink212:
      if(chartInstance.c3_is_LTwo == c3_IN_Sink212) {
        if(_sfEvent_ == c3_event_E_ResetTwo) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_ERCheck;
        } else if((*c3_FlowAboveCapacity == 0) || (*c3_Infusing == 0U)) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_ERCheck;
        }
      }
      break;
     case c3_IN_Sink213:
      if(chartInstance.c3_is_LTwo == c3_IN_Sink213) {
        if(_sfEvent_ == c3_event_E_ResetTwo) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_ERCheck;
        } else if(*c3_PumpTooHot == 0.0) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_ERCheck;
        }
      }
      break;
     case c3_IN_Sink22:
      if(chartInstance.c3_is_LTwo == c3_IN_Sink22) {
        if(_sfEvent_ == c3_event_E_ResetTwo) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_ERCheck;
        } else if((*c3_VoltOutRange == 0.0) || (*c3_Infusing == 0U)) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_ERCheck;
        }
      }
      break;
     case c3_IN_Sink24:
      if(chartInstance.c3_is_LTwo == c3_IN_Sink24) {
        if(_sfEvent_ == c3_event_E_ResetTwo) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_ERCheck;
        } else if((*c3_DoorOpen == 0.0) || (*c3_Infusing == 0U)) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_ERCheck;
        }
      }
      break;
     case c3_IN_Sink25:
      c3_Sink25();
      break;
     case c3_IN_Sink26:
      c3_Sink26();
      break;
     case c3_IN_Sink27:
      c3_Sink27();
      break;
     case c3_IN_Sink28:
      c3_Sink28();
      break;
     case c3_IN_Sink29:
      c3_Sink29();
      break;
     case c3_IN_UnderInfuCheck:
      if(_sfEvent_ == c3_event_E_ResetTwo) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Hold;
      } else if((*c3_UnderInfusion > 0.0) && (*c3_Infusing > 0U)) {
        chartInstance.c3_LTwoCond = 16U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_LevelTwoAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_LTwo == c3_IN_UnderInfuCheck) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Sink210;
        }
      } else if((*c3_UnderInfusion == 0.0) || (*c3_Infusing == 0U)) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_FRLessCheck;
      }
      break;
     case c3_IN_WDCheck:
      if(_sfEvent_ == c3_event_E_ResetTwo) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Hold;
      } else if((*c3_Infusing > 0U) && (*c3_VoltOutRange > 0.0)) {
        chartInstance.c3_LTwoCond = 8U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_LevelTwoAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_LTwo == c3_IN_WDCheck) {
          chartInstance.c3_is_LTwo = (uint8_T)c3_IN_Sink22;
        }
      } else if((*c3_VoltOutRange == 0.0) || (*c3_Infusing == 0U)) {
        chartInstance.c3_is_LTwo = (uint8_T)c3_IN_DOCheck;
      }
      break;
     default:
      chartInstance.c3_is_LTwo = (uint8_T)c3_IN_NO_ACTIVE_CHILD;
      break;
    }
  }
}

static void c3_Sink28(void)
{
  real_T *c3_FlowRateVariance;
  uint32_T *c3_Infusing;
  c3_FlowRateVariance = (real_T *)ssGetInputPortSignal(chartInstance.S, 15);
  c3_Infusing = (uint32_T *)ssGetInputPortSignal(chartInstance.S, 1);
  if(chartInstance.c3_is_LTwo == c3_IN_Sink28) {
    if(_sfEvent_ == c3_event_E_ResetTwo) {
      chartInstance.c3_is_LTwo = (uint8_T)c3_IN_ERCheck;
    } else if((*c3_FlowRateVariance == 0.0) || (*c3_Infusing == 0U)) {
      chartInstance.c3_is_LTwo = (uint8_T)c3_IN_ERCheck;
    }
  }
}

static void c3_Sink29(void)
{
  real_T *c3_OverInfusion;
  uint32_T *c3_Infusing;
  c3_OverInfusion = (real_T *)ssGetInputPortSignal(chartInstance.S, 16);
  c3_Infusing = (uint32_T *)ssGetInputPortSignal(chartInstance.S, 1);
  if(chartInstance.c3_is_LTwo == c3_IN_Sink29) {
    if(_sfEvent_ == c3_event_E_ResetTwo) {
      chartInstance.c3_is_LTwo = (uint8_T)c3_IN_ERCheck;
    } else if((*c3_OverInfusion == 0.0) || (*c3_Infusing == 0U)) {
      chartInstance.c3_is_LTwo = (uint8_T)c3_IN_ERCheck;
    }
  }
}

static void c3_LOne(void)
{
  uint8_T c3_previousEvent;
  boolean_T *c3_CPUError;
  real_T *c3_MemoryError;
  boolean_T *c3_OutOfBattery;
  boolean_T *c3_RTCError;
  boolean_T *c3_WatchDogCorrupt;
  real_T *c3_WatchDogInterrupt;
  c3_RTCError = (boolean_T *)ssGetInputPortSignal(chartInstance.S, 3);
  c3_MemoryError = (real_T *)ssGetInputPortSignal(chartInstance.S, 4);
  c3_CPUError = (boolean_T *)ssGetInputPortSignal(chartInstance.S, 25);
  c3_WatchDogCorrupt = (boolean_T *)ssGetInputPortSignal(chartInstance.S, 5);
  c3_WatchDogInterrupt = (real_T *)ssGetInputPortSignal(chartInstance.S, 6);
  c3_OutOfBattery = (boolean_T *)ssGetInputPortSignal(chartInstance.S, 10);
  if(chartInstance.c3_is_active_LOne != 0) {
    switch(chartInstance.c3_is_LOne) {
     case c3_IN_CPUAlarming:
      if((_sfEvent_ == c3_event_E_Clock) && (*c3_CPUError > 0)) {
        chartInstance.c3_LOneCond = 6U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_LevelOneAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_LOne == c3_IN_CPUAlarming) {
          chartInstance.c3_is_LOne = (uint8_T)c3_IN_L1Sink;
        }
      } else if((_sfEvent_ == c3_event_E_Clock) && (*c3_CPUError == 0)) {
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_DoneOne;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_LOne == c3_IN_CPUAlarming) {
          chartInstance.c3_is_LOne = (uint8_T)c3_b_IN_Normal;
        }
      } else if(_sfEvent_ == c3_event_E_ResetOne) {
        chartInstance.c3_is_LOne = (uint8_T)c3_IN_HOLD;
      }
      break;
     case c3_IN_HOLD:
      if(_sfEvent_ == c3_event_E_Clock) {
        chartInstance.c3_LOneCond = 0U;
        chartInstance.c3_is_LOne = (uint8_T)c3_IN_RTCCheck;
      }
      break;
     case c3_IN_L1Sink:
      if(_sfEvent_ == c3_event_E_ResetOne) {
        chartInstance.c3_is_LOne = (uint8_T)c3_IN_HOLD;
      }
      break;
     case c3_IN_MemoryCheck:
      if(_sfEvent_ == c3_event_E_ResetOne) {
        chartInstance.c3_is_LOne = (uint8_T)c3_IN_HOLD;
      } else if(*c3_MemoryError > 0.0) {
        chartInstance.c3_LOneCond = 5U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_LevelOneAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_LOne == c3_IN_MemoryCheck) {
          chartInstance.c3_is_LOne = (uint8_T)c3_IN_L1Sink;
        }
      } else if(*c3_MemoryError == 0.0) {
        chartInstance.c3_is_LOne = (uint8_T)c3_IN_CPUAlarming;
      }
      break;
     case c3_IN_NoPowerCheck:
      if(_sfEvent_ == c3_event_E_ResetOne) {
        chartInstance.c3_is_LOne = (uint8_T)c3_IN_HOLD;
      } else if(*c3_OutOfBattery > 0) {
        chartInstance.c3_LOneCond = 4U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_LevelOneAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_LOne == c3_IN_NoPowerCheck) {
          chartInstance.c3_is_LOne = (uint8_T)c3_IN_L1Sink;
        }
      } else if(*c3_OutOfBattery == 0) {
        chartInstance.c3_is_LOne = (uint8_T)c3_IN_MemoryCheck;
      }
      break;
     case c3_b_IN_Normal:
      if((chartInstance.c3_is_LOne == c3_b_IN_Normal) && (_sfEvent_ ==
        c3_event_E_ResetOne)) {
        chartInstance.c3_is_LOne = (uint8_T)c3_IN_HOLD;
      }
      break;
     case c3_IN_RTCCheck:
      if(_sfEvent_ == c3_event_E_ResetOne) {
        chartInstance.c3_is_LOne = (uint8_T)c3_IN_HOLD;
      } else if(*c3_RTCError > 0) {
        chartInstance.c3_LOneCond = 1U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_LevelOneAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_LOne == c3_IN_RTCCheck) {
          chartInstance.c3_is_LOne = (uint8_T)c3_IN_L1Sink;
        }
      } else if(*c3_RTCError == 0) {
        chartInstance.c3_is_LOne = (uint8_T)c3_IN_WDCCheck;
      }
      break;
     case c3_IN_WDCCheck:
      if(_sfEvent_ == c3_event_E_ResetOne) {
        chartInstance.c3_is_LOne = (uint8_T)c3_IN_HOLD;
      } else if(*c3_WatchDogCorrupt > 0) {
        chartInstance.c3_LOneCond = 2U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_LevelOneAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_LOne == c3_IN_WDCCheck) {
          chartInstance.c3_is_LOne = (uint8_T)c3_IN_L1Sink;
        }
      } else if(*c3_WatchDogCorrupt == 0) {
        chartInstance.c3_is_LOne = (uint8_T)c3_IN_WDICheck;
      }
      break;
     case c3_IN_WDICheck:
      if(_sfEvent_ == c3_event_E_ResetOne) {
        chartInstance.c3_is_LOne = (uint8_T)c3_IN_HOLD;
      } else if(*c3_WatchDogInterrupt > 0.0) {
        chartInstance.c3_LOneCond = 3U;
        c3_previousEvent = _sfEvent_;
        _sfEvent_ = c3_event_E_LevelOneAlarm;
        c3_Controller();
        _sfEvent_ = c3_previousEvent;
        if(chartInstance.c3_is_LOne == c3_IN_WDICheck) {
          chartInstance.c3_is_LOne = (uint8_T)c3_IN_L1Sink;
        }
      } else if(*c3_WatchDogInterrupt == 0.0) {
        chartInstance.c3_is_LOne = (uint8_T)c3_IN_NoPowerCheck;
      }
      break;
     default:
      chartInstance.c3_is_LOne = (uint8_T)c3_IN_NO_ACTIVE_CHILD;
      break;
    }
  }
}

static real_T c3_clearet(void)
{
  real_T c3_x;
  real_T c3_d15;
  real_T c3_d16;
  real_T c3_d17;
  c3_x = 0.0;
  sf_mex_import(sf_mex_get_ml_var("GAlrmMsg", 0), "GAlrmMsg", &c3_d15, 0, 0, 0U,
   0, 0);
  if(c3_d15 == 23.0) {
    chartInstance.c3_etflag = 0U;
    c3_d16 = (real_T)c3_const_MSG_BLANK;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c3_d16, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else {
    sf_mex_import(sf_mex_get_ml_var("GAlrmMsg", 0), "GAlrmMsg", &c3_d17, 0, 0,
     0U, 0, 0);
    if(c3_d17 != 23.0) {
      chartInstance.c3_etflag = 0U;
    }
  }
  return c3_x;
}

static real_T c3_clearap(void)
{
  real_T c3_x;
  real_T c3_d18;
  real_T c3_d19;
  real_T c3_d20;
  c3_x = 0.0;
  sf_mex_import(sf_mex_get_ml_var("GAlrmMsg", 0), "GAlrmMsg", &c3_d18, 0, 0, 0U,
   0, 0);
  if(c3_d18 == 25.0) {
    chartInstance.c3_apflag = 0U;
    c3_d19 = (real_T)c3_const_MSG_BLANK;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c3_d19, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else {
    sf_mex_import(sf_mex_get_ml_var("GAlrmMsg", 0), "GAlrmMsg", &c3_d20, 0, 0,
     0U, 0, 0);
    if(c3_d20 != 25.0) {
      chartInstance.c3_apflag = 0U;
    }
  }
  return c3_x;
}

static real_T c3_clearBatteryCharge(void)
{
  real_T c3_x;
  real_T c3_d21;
  real_T c3_d22;
  real_T c3_d23;
  c3_x = 0.0;
  sf_mex_import(sf_mex_get_ml_var("GAlrmMsg", 0), "GAlrmMsg", &c3_d21, 0, 0, 0U,
   0, 0);
  if(c3_d21 == 30.0) {
    chartInstance.c3_bcflag = 0;
    c3_d22 = (real_T)c3_const_MSG_BLANK;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c3_d22, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else {
    sf_mex_import(sf_mex_get_ml_var("GAlrmMsg", 0), "GAlrmMsg", &c3_d23, 0, 0,
     0U, 0, 0);
    if(c3_d23 != 30.0) {
      chartInstance.c3_bcflag = 0;
    }
  }
  return c3_x;
}

static real_T c3_clearfrv(void)
{
  real_T c3_x;
  real_T c3_d24;
  real_T c3_d25;
  real_T c3_d26;
  c3_x = 0.0;
  sf_mex_import(sf_mex_get_ml_var("GAlrmMsg", 0), "GAlrmMsg", &c3_d24, 0, 0, 0U,
   0, 0);
  if(c3_d24 == 7.0) {
    chartInstance.c3_frvflag = 0;
    c3_d25 = (real_T)c3_const_MSG_BLANK;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c3_d25, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else {
    sf_mex_import(sf_mex_get_ml_var("GAlrmMsg", 0), "GAlrmMsg", &c3_d26, 0, 0,
     0U, 0, 0);
    if(c3_d26 != 7.0) {
      chartInstance.c3_frvflag = 0;
    }
  }
  return c3_x;
}

static void init_script_number_translation(uint32_T c3_machineNumber, uint32_T
 c3_chartNumber)
{
}

const mxArray *sf_c3_StateChanger2_mod_get_eml_resolved_functions_info(void)
{
  const mxArray *c3_nameCaptureInfo = NULL;
  c3_nameCaptureInfo = NULL;
  sf_mex_assign(&c3_nameCaptureInfo, sf_mex_create(NULL, "nameCaptureInfo", 0,
    0U, 1U, 2, 0, 1));
  return c3_nameCaptureInfo;
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c3_StateChanger2_mod_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2346116309U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(217589623U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(1795943960U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3575840138U);
}

mxArray *sf_c3_StateChanger2_mod_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] =
  {"checksum","inputs","parameters","outputs"};
  mxArray *mxAutoinheritanceInfo =
  mxCreateStructMatrix(1,1,4,autoinheritanceFields);
  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(1922597307U);
    pr[1] = (double)(1928505065U);
    pr[2] = (double)(611952512U);
    pr[3] = (double)(1827397945U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,30,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(7));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(7));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(7));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(7));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }
    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(8));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }
    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(8));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }
    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }
    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(8));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }
    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,6,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,6,"type",mxType);
    }
    mxSetField(mxData,6,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,7,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(8));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,7,"type",mxType);
    }
    mxSetField(mxData,7,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,8,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(8));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,8,"type",mxType);
    }
    mxSetField(mxData,8,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,9,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,9,"type",mxType);
    }
    mxSetField(mxData,9,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,10,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(8));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,10,"type",mxType);
    }
    mxSetField(mxData,10,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,11,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(8));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,11,"type",mxType);
    }
    mxSetField(mxData,11,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,12,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,12,"type",mxType);
    }
    mxSetField(mxData,12,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,13,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(8));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,13,"type",mxType);
    }
    mxSetField(mxData,13,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,14,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(8));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,14,"type",mxType);
    }
    mxSetField(mxData,14,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,15,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,15,"type",mxType);
    }
    mxSetField(mxData,15,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,16,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,16,"type",mxType);
    }
    mxSetField(mxData,16,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,17,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,17,"type",mxType);
    }
    mxSetField(mxData,17,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,18,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(8));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,18,"type",mxType);
    }
    mxSetField(mxData,18,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,19,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(8));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,19,"type",mxType);
    }
    mxSetField(mxData,19,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,20,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,20,"type",mxType);
    }
    mxSetField(mxData,20,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,21,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,21,"type",mxType);
    }
    mxSetField(mxData,21,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,22,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,22,"type",mxType);
    }
    mxSetField(mxData,22,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,23,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,23,"type",mxType);
    }
    mxSetField(mxData,23,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,24,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,24,"type",mxType);
    }
    mxSetField(mxData,24,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,25,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(8));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,25,"type",mxType);
    }
    mxSetField(mxData,25,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,26,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,26,"type",mxType);
    }
    mxSetField(mxData,26,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,27,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,27,"type",mxType);
    }
    mxSetField(mxData,27,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,28,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,28,"type",mxType);
    }
    mxSetField(mxData,28,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,29,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,29,"type",mxType);
    }
    mxSetField(mxData,29,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }
  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,mxREAL));
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }
  return(mxAutoinheritanceInfo);
}

static void sf_opaque_initialize_c3_StateChanger2_mod(void *chartInstanceVar)
{
  initialize_params_c3_StateChanger2_mod();
  initialize_c3_StateChanger2_mod();
}

static void sf_opaque_enable_c3_StateChanger2_mod(void *chartInstanceVar)
{
  enable_c3_StateChanger2_mod();
}

static void sf_opaque_disable_c3_StateChanger2_mod(void *chartInstanceVar)
{
  disable_c3_StateChanger2_mod();
}

static void sf_opaque_gateway_c3_StateChanger2_mod(void *chartInstanceVar)
{
  sf_c3_StateChanger2_mod();
}

static void sf_opaque_terminate_c3_StateChanger2_mod(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) ||
   sim_mode_is_external(chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }
  finalize_c3_StateChanger2_mod();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c3_StateChanger2_mod(SimStruct *S)
{
  int i;
  for(i=0;i<ssGetNumRunTimeParams(S);i++) {
    if(ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }
  if(sf_machine_global_initializer_called()) {
    initialize_params_c3_StateChanger2_mod();
  }
}

static void mdlSetWorkWidths_c3_StateChanger2_mod(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("StateChanger2_mod",3);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("StateChanger2_mod",3,"gatewayCannotBeInlinedMultipleTimes"));
    if(chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 5, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 6, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 7, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 8, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 9, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 10, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 11, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 12, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 13, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 14, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 15, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 16, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 17, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 18, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 19, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 20, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 21, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 22, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 23, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 24, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 25, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 26, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 27, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 28, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 29, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"StateChanger2_mod",3,30);
      sf_mark_chart_reusable_outputs(S,"StateChanger2_mod",3,1);
    }
    ssSetInputPortOptimOpts(S, 30, SS_REUSABLE_AND_LOCAL);
    sf_set_rtw_dwork_info(S,"StateChanger2_mod",3);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(1477258412U));
  ssSetChecksum1(S,(2353434490U));
  ssSetChecksum2(S,(3426348300U));
  ssSetChecksum3(S,(3448901603U));

  ssSetmdlDerivatives(S, NULL);

  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c3_StateChanger2_mod(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "StateChanger2_mod", 3);
    ssWriteRTWStrParam(S, "StateflowChartType", "Stateflow");
  }
}

static void mdlStart_c3_StateChanger2_mod(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 0;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway =
    sf_opaque_gateway_c3_StateChanger2_mod;
  chartInstance.chartInfo.initializeChart =
    sf_opaque_initialize_c3_StateChanger2_mod;
  chartInstance.chartInfo.terminateChart =
    sf_opaque_terminate_c3_StateChanger2_mod;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c3_StateChanger2_mod;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c3_StateChanger2_mod;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c3_StateChanger2_mod;
  chartInstance.chartInfo.mdlStart = mdlStart_c3_StateChanger2_mod;
  chartInstance.chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c3_StateChanger2_mod;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo))); /* register the chart instance with simstruct */

  if(!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }
}

void c3_StateChanger2_mod_method_dispatcher(SimStruct *S, int_T method, void
 *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c3_StateChanger2_mod(S);
    break;
   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c3_StateChanger2_mod(S);
    break;
   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c3_StateChanger2_mod(S);
    break;
   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
     "Error calling c3_StateChanger2_mod_method_dispatcher.\n"
     "Can't handle method %d.\n", method);
    break;
  }
}

