/* Include files */
#include "GPCA_Extension_sfun.h"
#include "c1_GPCA_Extension.h"

/* Type Definitions */

/* Named Constants */
#define c1_event_E_Clock                (0U)
#define c1_event_E_Alarm                (24U)
#define c1_event_E_Warning              (5U)
#define c1_event_E_Ready                (1U)
#define c1_event_E_NotReady             (15U)
#define c1_event_E_StartSimulation      (16U)
#define c1_event_E_PowerButton          (12U)
#define c1_event_E_NewInfusion          (7U)
#define c1_event_E_CheckAdminSet        (3U)
#define c1_event_E_Prime                (6U)
#define c1_event_E_CheckDrug            (14U)
#define c1_event_E_ConfigureInfusionProgram (13U)
#define c1_event_E_ConfirmConcentration (25U)
#define c1_event_E_ConfirmDoseRate      (17U)
#define c1_event_E_ConfirmVTBI          (27U)
#define c1_event_E_StartInfusion        (28U)
#define c1_event_E_ChangeDoseRate       (9U)
#define c1_event_E_ChangeVTBI           (10U)
#define c1_event_E_PauseInfusion        (21U)
#define c1_event_E_ConfirmPauseInfusion (8U)
#define c1_event_E_StopInfusion         (19U)
#define c1_event_E_ConfirmStopInfusion  (2U)
#define c1_event_E_RequestBolus         (26U)
#define c1_event_E_ClearAlarm           (20U)
#define c1_event_E_ConfirmPowerDown     (11U)
#define c1_event_E_Cancel               (4U)
#define c1_IN_NO_ACTIVE_CHILD           (0)
#define c1_IN_ALM_VTBIOutBound          (2)
#define c1_IN_DisplayDoseRate           (7)
#define c1_IN_ConfirmPowerDown          (4)
#define c1_IN_PowerOff                  (10)
#define c1_IN_POST                      (8)
#define c1_IN_ALM_POSTFailed            (1)
#define c1_IN_CheckAdminSet             (2)
#define c1_IN_CheckPrime                (4)
#define c1_IN_ALM_WrongAdminCheck       (1)
#define c1_IN_PrimeFailed               (10)
#define c1_IN_DisplayDrugInfo           (7)
#define c1_IN_CheckDrug_CheckType       (3)
#define c1_IN_UnknownDrug               (11)
#define c1_IN_Check_DrugUnits           (6)
#define c1_IN_IncorrectDrugUnits        (9)
#define c1_IN_Check_Concen              (5)
#define c1_IN_WrongConcentration        (13)
#define c1_IN_WRN_DangerCon             (12)
#define c1_IN_DisplayPatientProfile     (8)
#define c1_IN_DisplayVTBI               (9)
#define c1_IN_ChangeVTBI                (4)
#define c1_IN_CheckVTBI                 (6)
#define c1_IN_ChangeDoseRate            (3)
#define c1_IN_CheckDoseRate             (5)
#define c1_IN_ALM_DoseRateOutBound      (1)
#define c1_IN_DisplaySettings           (8)
#define c1_IN_Infusing                  (7)
#define c1_IN_InfusionInSession         (5)
#define c1_IN_ChangeRate                (3)
#define c1_IN_CheckNewRate              (4)
#define c1_IN_ALM_NewRateOutBound       (1)
#define c1_IN_ConfirmStop               (6)
#define c1_IN_ConfirmPause              (5)
#define c1_IN_InfusionPaused            (4)
#define c1_IN_ReadyToStart              (10)
#define c1_IN_PausedStopConfirm         (8)
#define c1_IN_InfusionStopped           (5)
#define c1_IN_EmptyReservoir            (3)
#define c1_IN_CheckDrugWhileInfusing    (2)
#define c1_IN_ALMWrongDrug              (1)
#define c1_IN_Init                      (6)
#define c1_IN_LevelTwoAlarming          (7)
#define c1_IN_InfusionSubMachine        (6)
#define c1_IN_POSTDONE                  (9)
#define c1_IN_WRN_VTBIOutBound          (12)
#define c1_IN_LEVELONEALRM              (7)
#define c1_IN_BolusRequest              (2)
#define c1_IN_WRN_DOSERATEOUTSOFTLIMITS (11)
#define c1_IN_PausedTooLong             (9)
#define c1_IN_CheckDrugRoutine          (2)
#define c1_IN_ConfigureInfusionProgram  (3)
#define c1_IN_InfusionStateMachine      (1)
#define c1_const_MSG_WELCOME            (1U)
#define c1_const_MSG_POWEROFF           (2U)
#define c1_const_MSG_POST               (3U)
#define c1_const_MSG_POSTFAIL           (4U)
#define c1_const_MSG_ADMINCHECK         (5U)
#define c1_const_MSG_ADMINFAIL          (6U)
#define c1_const_MSG_PRIME              (7U)
#define c1_const_MSG_PRIMEFAIL          (8U)
#define c1_const_MSG_CHECKTYPE          (9U)
#define c1_const_MSG_WRONGDRUG          (10U)
#define c1_const_MSG_CHECKDU            (11U)
#define c1_const_MSG_WRONGDU            (12U)
#define c1_const_MSG_CHECKCON           (13U)
#define c1_const_MSG_WRONGCON           (14U)
#define c1_const_MSG_DANGECON           (15U)
#define c1_const_MSG_PATIENTINFO        (16U)
#define c1_const_MSG_CHANGEVTBI         (18U)
#define c1_const_MSG_VTBI               (17U)
#define c1_const_MSG_CHECKVTBI          (19U)
#define c1_const_MSG_ALMVTBI            (20U)
#define c1_const_MSG_DISPLAYDR          (21U)
#define c1_const_MSG_CHECKDR            (22U)
#define c1_const_MSG_CHANGEDR           (23U)
#define c1_const_MSG_DISPLAYSET         (24U)
#define c1_const_MSG_ALRMDR             (25U)
#define c1_const_MSG_INFUSING           (26U)
#define c1_const_MSG_DANGERENVTEMP      (24U)
#define c1_const_MSG_DANGERHUMD         (25U)
#define c1_const_MSG_DANGERAP           (26U)
#define c1_const_MSG_POSTDONE           (27U)
#define c1_const_MSG_DRUGINFO           (28U)
#define c1_const_MSG_BOLUSGRANT         (28U)
#define c1_const_MSG_BOLUSDENIED        (29U)
#define c1_const_MSG_STOPBOLUS          (30U)
#define c1_const_MSG_EMPTYRESERVOIR     (8U)
#define c1_const_MSG_DOOROPEN           (7U)
#define c1_const_MSG_AIRINLINE          (15U)
#define c1_const_MSG_OCCULUSION         (9U)
#define c1_const_MSG_PAUSETOOLONG       (14U)
#define c1_const_MSG_FLOWRATEVARY       (16U)
#define c1_const_MSG_OVERINFUSION       (10U)
#define c1_const_MSG_UNDERINFUSION      (11U)
#define c1_const_MSG_LESSTHANKVO        (12U)
#define c1_const_MSG_RATEEXCEEDCAPACITY (13U)
#define c1_const_MSG_REALTIMECLOCK      (2U)
#define c1_const_MSG_WATCHDOGALERT      (6U)
#define c1_const_MSG_OUTOFPOWER         (1U)
#define c1_const_MSG_MEMORYCORRUPT      (4U)
#define c1_const_MSG_CPUFAILURE         (3U)
#define c1_const_MSG_INFUSIONSTOP       (29U)
#define c1_const_MSG_SPCHOOSE           (30U)
#define c1_const_MSG_INFUSIONPAUSED     (31U)
#define c1_const_MSG_CONFIRMPAUSE       (32U)
#define c1_const_MSG_CONFIRMSTOP        (33U)
#define c1_const_MSG_STOPPAUSE          (34U)
#define c1_const_MSG_LOGERR             (19U)
#define c1_const_MSG_LOWBATT            (20U)
#define c1_const_MSG_LOWRESR            (17U)
#define c1_const_MSG_WRNDR              (35U)
#define c1_const_MSG_WRNVTBI            (36U)
#define c1_const_MSG_NOTREADY           (27U)
#define c1_const_MSG_BLANK              (31U)
#define c1_const_MSG_WRNBATTERYCHARGE   (21U)
#define c1_const_MSG_VOLTOUTRANGE       (22U)
#define c1_const_MSG_PUMPTOOHOT         (5U)
#define c1_const_MSG_PAUSELONG          (18U)
#define c1_const_MSG_PUMPOVERHEAT       (23U)
#define c1_const_MSG_DISPINFU           (32U)

/* Variable Declarations */

/* Variable Definitions */
static SFc1_GPCA_ExtensionInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c1_GPCA_Extension(void);
static void initialize_params_c1_GPCA_Extension(void);
static void enable_c1_GPCA_Extension(void);
static void disable_c1_GPCA_Extension(void);
static void finalize_c1_GPCA_Extension(void);
static void sf_c1_GPCA_Extension(void);
static void c1_PowerOff(void);
static void c1_UnknownDrug(void);
static void c1_WrongConcentration(void);
static void c1_WRN_DangerCon(void);
static real_T c1_displayBolusInfo(void);
static void c1_DisplayVTBI(void);
static uint32_T c1_warning(void);
static void c1_Infusing(void);
static void c1_enter_internal_InfusionInSession(void);
static void c1_InfusionInSession(void);
static void c1_ConfirmStop(void);
static void c1_ConfirmPause(void);
static void c1_ReadyToStart(void);
static void c1_PausedStopConfirm(void);
static real_T c1_setDrugLibInfo(void);
static void c1_LevelTwoAlarming(void);
static uint32_T c1_setLOneMsg(uint32_T c1_fcond);
static uint32_T c1_alrmLevel(void);
static uint32_T c1_setLTwoMsg(uint32_T c1_fCond);
static void c1_InfusionSubMachine(void);
static void c1_WRN_VTBIOutBound(void);
static real_T c1_checkDrugConcentration(void);
static void c1_PausedTooLong(void);
static void c1_CheckDrugRoutine(void);
static void c1_enter_internal_ConfigureInfusionProgram(void);
static void c1_ConfigureInfusionProgram(void);
static void c1_InfusionStateMachine(void);
static real_T c1_checkDrug(void);
static real_T c1_stopInfusion(void);
static real_T c1_resetInfusionInstructions(void);
static real_T c1_copyInfuStatus(void);
static void c1_broadcast_E_Clock(void);
static void c1_broadcast_E_Alarm(void);
static void c1_broadcast_E_Warning(void);
static void c1_broadcast_E_Ready(void);
static void c1_broadcast_E_NotReady(void);
static void c1_broadcast_E_StartSimulation(void);
static void c1_broadcast_E_PowerButton(void);
static void c1_broadcast_E_NewInfusion(void);
static void c1_broadcast_E_CheckAdminSet(void);
static void c1_broadcast_E_Prime(void);
static void c1_broadcast_E_CheckDrug(void);
static void c1_broadcast_E_ConfigureInfusionProgram(void);
static void c1_broadcast_E_ConfirmConcentration(void);
static void c1_broadcast_E_ConfirmDoseRate(void);
static void c1_broadcast_E_ConfirmVTBI(void);
static void c1_broadcast_E_StartInfusion(void);
static void c1_broadcast_E_ChangeDoseRate(void);
static void c1_broadcast_E_ChangeVTBI(void);
static void c1_broadcast_E_PauseInfusion(void);
static void init_script_number_translation(uint32_T c1_machineNumber, uint32_T
 c1_chartNumber);
static void init_io_bus_offset(void);
static void *get_PumpConfigurationsStatus_element(void *c1_addr, int32_T c1_idx);
static void *get_DrugLibrary_element(void *c1_addr, int32_T c1_idx);
static void *get_DrugInformation_element(void *c1_addr, int32_T c1_idx);
static void *get_InfusionParameters_element(void *c1_addr, int32_T c1_idx);
static void *get_InfusionStatus_element(void *c1_addr, int32_T c1_idx);
static void *get_PatientInformation_element(void *c1_addr, int32_T c1_idx);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c1_GPCA_Extension(void)
{
  uint32_T *c1_ClearCond;
  boolean_T *c1_O_InfusionInProgress;
  boolean_T *c1_O_InfusionPaused;
  boolean_T *c1_O_BolusRequested;
  real_T *c1_O_ProgrammedVTBI;
  real_T *c1_O_ProgrammedFlowRate;
  uint32_T *c1_O_CurrentState;
  uint32_T *c1_O_AlarmCond;
  void *c1_O_DrugLibInfo;
  void *c1_O_PatientInfo;
  void *c1_O_InfuStatus;
  boolean_T *c1_E_Restart;
  boolean_T *c1_E_AlarmClear;
  boolean_T *c1_E_RequestToStart;
  c1_E_Restart = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 12);
  c1_E_AlarmClear = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 13);
  c1_E_RequestToStart = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 14);
  c1_O_CurrentState = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 7);
  c1_O_ProgrammedVTBI = (real_T *)ssGetOutputPortSignal(chartInstance.S, 5);
  c1_ClearCond = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  c1_O_AlarmCond = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 11);
  c1_O_ProgrammedFlowRate = (real_T *)ssGetOutputPortSignal(chartInstance.S, 6);
  c1_O_InfuStatus = (void *)ssGetOutputPortSignal(chartInstance.S, 10);
  c1_O_InfusionInProgress = (boolean_T *)ssGetOutputPortSignal(chartInstance.S,
   2);
  c1_O_PatientInfo = (void *)ssGetOutputPortSignal(chartInstance.S, 9);
  c1_O_InfusionPaused = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 3);
  c1_O_DrugLibInfo = (void *)ssGetOutputPortSignal(chartInstance.S, 8);
  c1_O_BolusRequested = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 4);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c1_is_InfusionStateMachine = 0U;
  chartInstance.c1_is_CheckDrugRoutine = 0U;
  chartInstance.c1_was_CheckDrugRoutine = 0U;
  chartInstance.c1_is_ConfigureInfusionProgram = 0U;
  chartInstance.c1_was_ConfigureInfusionProgram = 0U;
  chartInstance.c1_is_InfusionInSession = 0U;
  chartInstance.c1_was_InfusionInSession = 0U;
  chartInstance.c1_is_InfusionSubMachine = 0U;
  chartInstance.c1_is_active_c1_GPCA_Extension = 0U;
  chartInstance.c1_is_c1_GPCA_Extension = 0U;
  chartInstance.c1_temp = 0.0;
  chartInstance.c1_tempx = 0U;
  chartInstance.c1_infusing = 0U;
  chartInstance.c1_bolusing = 0U;
  chartInstance.c1_vtbi = 0.0;
  chartInstance.c1_doseRate = 0.0;
  chartInstance.c1_MSG_WELCOME = 1U;
  chartInstance.c1_MSG_POWEROFF = 2U;
  chartInstance.c1_MSG_POST = 3U;
  chartInstance.c1_MSG_POSTFAIL = 4U;
  chartInstance.c1_MSG_ADMINCHECK = 5U;
  chartInstance.c1_MSG_ADMINFAIL = 6U;
  chartInstance.c1_MSG_PRIME = 7U;
  chartInstance.c1_MSG_PRIMEFAIL = 8U;
  chartInstance.c1_MSG_CHECKTYPE = 9U;
  chartInstance.c1_MSG_WRONGDRUG = 10U;
  chartInstance.c1_MSG_CHECKDU = 11U;
  chartInstance.c1_MSG_WRONGDU = 12U;
  chartInstance.c1_MSG_CHECKCON = 13U;
  chartInstance.c1_MSG_WRONGCON = 14U;
  chartInstance.c1_MSG_DANGECON = 15U;
  chartInstance.c1_MSG_PATIENTINFO = 16U;
  chartInstance.c1_MSG_CHANGEVTBI = 18U;
  chartInstance.c1_MSG_VTBI = 17U;
  chartInstance.c1_MSG_CHECKVTBI = 19U;
  chartInstance.c1_MSG_ALMVTBI = 20U;
  chartInstance.c1_MSG_DISPLAYDR = 21U;
  chartInstance.c1_MSG_CHECKDR = 22U;
  chartInstance.c1_MSG_CHANGEDR = 23U;
  chartInstance.c1_MSG_DISPLAYSET = 24U;
  chartInstance.c1_MSG_ALRMDR = 25U;
  chartInstance.c1_MSG_INFUSING = 26U;
  chartInstance.c1_MSG_DANGERENVTEMP = 24U;
  chartInstance.c1_MSG_DANGERHUMD = 25U;
  chartInstance.c1_MSG_DANGERAP = 26U;
  chartInstance.c1_MSG_POSTDONE = 27U;
  chartInstance.c1_MSG_DRUGINFO = 28U;
  chartInstance.c1_MSG_BOLUSGRANT = 28U;
  chartInstance.c1_MSG_BOLUSDENIED = 29U;
  chartInstance.c1_MSG_STOPBOLUS = 30U;
  chartInstance.c1_MSG_EMPTYRESERVOIR = 8U;
  chartInstance.c1_MSG_DOOROPEN = 7U;
  chartInstance.c1_MSG_AIRINLINE = 15U;
  chartInstance.c1_MSG_OCCULUSION = 9U;
  chartInstance.c1_MSG_PAUSETOOLONG = 14U;
  chartInstance.c1_MSG_FLOWRATEVARY = 16U;
  chartInstance.c1_MSG_OVERINFUSION = 10U;
  chartInstance.c1_MSG_UNDERINFUSION = 11U;
  chartInstance.c1_MSG_LESSTHANKVO = 12U;
  chartInstance.c1_MSG_RATEEXCEEDCAPACITY = 13U;
  chartInstance.c1_MSG_REALTIMECLOCK = 2U;
  chartInstance.c1_MSG_WATCHDOGALERT = 6U;
  chartInstance.c1_MSG_OUTOFPOWER = 1U;
  chartInstance.c1_MSG_MEMORYCORRUPT = 4U;
  chartInstance.c1_MSG_CPUFAILURE = 3U;
  chartInstance.c1_MSG_INFUSIONSTOP = 29U;
  chartInstance.c1_MSG_SPCHOOSE = 30U;
  chartInstance.c1_MSG_INFUSIONPAUSED = 31U;
  chartInstance.c1_MSG_CONFIRMPAUSE = 32U;
  chartInstance.c1_MSG_CONFIRMSTOP = 33U;
  chartInstance.c1_MSG_STOPPAUSE = 34U;
  chartInstance.c1_MSG_LOGERR = 19U;
  chartInstance.c1_MSG_LOWBATT = 20U;
  chartInstance.c1_MSG_LOWRESR = 17U;
  chartInstance.c1_MSG_WRNDR = 35U;
  chartInstance.c1_MSG_WRNVTBI = 36U;
  chartInstance.c1_MSG_NOTREADY = 27U;
  chartInstance.c1_MSG_BLANK = 31U;
  chartInstance.c1_MSG_WRNBATTERYCHARGE = 21U;
  chartInstance.c1_MSG_VOLTOUTRANGE = 22U;
  chartInstance.c1_MSG_PUMPTOOHOT = 5U;
  chartInstance.c1_MSG_PAUSELONG = 18U;
  chartInstance.c1_MSG_PUMPOVERHEAT = 23U;
  chartInstance.c1_MSG_DISPINFU = 32U;
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 1) != 0)) {
    *c1_ClearCond = 0U;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 2) != 0)) {
    *c1_O_InfusionInProgress = 0U;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 3) != 0)) {
    *c1_O_InfusionPaused = 0U;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 4) != 0)) {
    *c1_O_BolusRequested = 0U;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 5) != 0)) {
    *c1_O_ProgrammedVTBI = 0.0;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 6) != 0)) {
    *c1_O_ProgrammedFlowRate = 0.0;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 7) != 0)) {
    *c1_O_CurrentState = 0U;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 8) != 0)) {
    *((uint32_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 0)) = 0U;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 1)) = 0.0;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 2)) = 0.0;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 3)) = 0.0;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 4)) = 0.0;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 5)) = 0.0;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 6)) = 0.0;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 7)) = 0.0;
    *((uint32_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 8)) = 0U;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 9)) = 0.0;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 10)) = 0.0;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 11)) = 0.0;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 12)) = 0.0;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 13)) = 0.0;
    *((uint32_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 14)) = 0U;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 15)) = 0.0;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 16)) = 0.0;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 17)) = 0.0;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 18)) = 0.0;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 19)) = 0.0;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 9) != 0)) {
    *((uint32_T *)get_PatientInformation_element(c1_O_PatientInfo, 0)) = 0U;
    *((uint32_T *)get_PatientInformation_element(c1_O_PatientInfo, 1)) = 0U;
    *((uint32_T *)get_PatientInformation_element(c1_O_PatientInfo, 2)) = 0U;
    *((uint32_T *)get_PatientInformation_element(c1_O_PatientInfo, 3)) = 0U;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 10) != 0)) {
    *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) = 0U;
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = 0.0;
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = 0.0;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 11) != 0)) {
    *c1_O_AlarmCond = 0U;
  }
  chartInstance.c1_E_RestartEventCounter = 0U;
  *c1_E_Restart = false;
  chartInstance.c1_E_AlarmClearEventCounter = 0U;
  *c1_E_AlarmClear = false;
  chartInstance.c1_E_RequestToStartEventCounter = 0U;
  *c1_E_RequestToStart = false;
}

static void initialize_params_c1_GPCA_Extension(void)
{
}

static void enable_c1_GPCA_Extension(void)
{
}

static void disable_c1_GPCA_Extension(void)
{
}

static void finalize_c1_GPCA_Extension(void)
{
}

static void sf_c1_GPCA_Extension(void)
{
  int32_T c1_inputEventFiredFlag;
  uint8_T c1_previousEvent;
  int8_T *c1_E_Clock;
  int8_T *c1_E_Alarm;
  int8_T *c1_E_Warning;
  int8_T *c1_E_Ready;
  int8_T *c1_E_NotReady;
  int8_T *c1_E_StartSimulation;
  int8_T *c1_E_PowerButton;
  int8_T *c1_E_NewInfusion;
  int8_T *c1_E_CheckAdminSet;
  int8_T *c1_E_Prime;
  int8_T *c1_E_CheckDrug;
  int8_T *c1_E_ConfigureInfusionProgram;
  int8_T *c1_E_ConfirmConcentration;
  int8_T *c1_E_ConfirmDoseRate;
  int8_T *c1_E_ConfirmVTBI;
  int8_T *c1_E_StartInfusion;
  int8_T *c1_E_ChangeDoseRate;
  int8_T *c1_E_ChangeVTBI;
  int8_T *c1_E_PauseInfusion;
  int8_T *c1_E_ConfirmPauseInfusion;
  int8_T *c1_E_StopInfusion;
  int8_T *c1_E_ConfirmStopInfusion;
  int8_T *c1_E_RequestBolus;
  int8_T *c1_E_ClearAlarm;
  int8_T *c1_E_ConfirmPowerDown;
  int8_T *c1_E_Cancel;
  boolean_T *c1_E_Restart;
  boolean_T *c1_E_AlarmClear;
  boolean_T *c1_E_RequestToStart;
  c1_E_NotReady = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 7) + 4);
  c1_E_ClearAlarm = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 7) +
   23);
  c1_E_StopInfusion = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 7) +
   20);
  c1_E_ChangeVTBI = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 7) +
   17);
  c1_E_ConfirmPauseInfusion = (int8_T
    *)*(ssGetInputPortSignalPtrs(chartInstance.S, 7) + 19);
  c1_E_ConfirmStopInfusion = (int8_T
    *)*(ssGetInputPortSignalPtrs(chartInstance.S, 7) + 21);
  c1_E_Cancel = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 7) + 25);
  c1_E_Restart = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 12);
  c1_E_Ready = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 7) + 3);
  c1_E_NewInfusion = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 7) +
   7);
  c1_E_Clock = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 7) + 0);
  c1_E_ChangeDoseRate = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 7)
   + 16);
  c1_E_AlarmClear = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 13);
  c1_E_Alarm = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 7) + 1);
  c1_E_CheckDrug = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 7) +
   10);
  c1_E_ConfirmConcentration = (int8_T
    *)*(ssGetInputPortSignalPtrs(chartInstance.S, 7) + 12);
  c1_E_StartSimulation = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S,
    7) + 5);
  c1_E_StartInfusion = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 7)
   + 15);
  c1_E_ConfigureInfusionProgram = (int8_T
    *)*(ssGetInputPortSignalPtrs(chartInstance.S, 7) + 11);
  c1_E_ConfirmPowerDown = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S,
    7) + 24);
  c1_E_ConfirmVTBI = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 7) +
   14);
  c1_E_Warning = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 7) + 2);
  c1_E_PowerButton = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 7) +
   6);
  c1_E_CheckAdminSet = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 7)
   + 8);
  c1_E_Prime = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 7) + 9);
  c1_E_ConfirmDoseRate = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S,
    7) + 13);
  c1_E_PauseInfusion = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 7)
   + 18);
  c1_E_RequestToStart = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 14);
  c1_E_RequestBolus = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 7) +
   22);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  c1_inputEventFiredFlag = 0;
  if(*c1_E_Clock != 0) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_Clock();
  }
  if(*c1_E_Alarm == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_Alarm();
  }
  if(*c1_E_Warning == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_Warning();
  }
  if(*c1_E_Ready == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_Ready();
  }
  if(*c1_E_NotReady == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_NotReady();
  }
  if(*c1_E_StartSimulation == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_StartSimulation();
  }
  if(*c1_E_PowerButton == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_PowerButton();
  }
  if(*c1_E_NewInfusion == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_NewInfusion();
  }
  if(*c1_E_CheckAdminSet == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_CheckAdminSet();
  }
  if(*c1_E_Prime == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_Prime();
  }
  if(*c1_E_CheckDrug == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_CheckDrug();
  }
  if(*c1_E_ConfigureInfusionProgram == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_ConfigureInfusionProgram();
  }
  if(*c1_E_ConfirmConcentration == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_ConfirmConcentration();
  }
  if(*c1_E_ConfirmDoseRate == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_ConfirmDoseRate();
  }
  if(*c1_E_ConfirmVTBI == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_ConfirmVTBI();
  }
  if(*c1_E_StartInfusion == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_StartInfusion();
  }
  if(*c1_E_ChangeDoseRate == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_ChangeDoseRate();
  }
  if(*c1_E_ChangeVTBI == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_ChangeVTBI();
  }
  if(*c1_E_PauseInfusion == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_PauseInfusion();
  }
  if(*c1_E_ConfirmPauseInfusion == 1) {
    c1_inputEventFiredFlag = 1;
    c1_previousEvent = _sfEvent_;
    _sfEvent_ = c1_event_E_ConfirmPauseInfusion;
    if(_sfEvent_ == c1_event_E_Clock) {
      if(chartInstance.c1_temporalCounter_i1 < 3) {
        chartInstance.c1_temporalCounter_i1 =
          (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
      } else {
        chartInstance.c1_temporalCounter_i1 = 1U;
      }
    }
    if(chartInstance.c1_is_active_c1_GPCA_Extension == 0) {
      chartInstance.c1_is_active_c1_GPCA_Extension = 1U;
      chartInstance.c1_is_c1_GPCA_Extension =
        (uint8_T)c1_IN_InfusionStateMachine;
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
    } else {
      c1_InfusionStateMachine();
    }
    if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1
      == 3)) {
      chartInstance.c1_temporalCounter_i1 = 0U;
    }
    _sfEvent_ = c1_previousEvent;
  }
  if(*c1_E_StopInfusion == 1) {
    c1_inputEventFiredFlag = 1;
    c1_previousEvent = _sfEvent_;
    _sfEvent_ = c1_event_E_StopInfusion;
    if(_sfEvent_ == c1_event_E_Clock) {
      if(chartInstance.c1_temporalCounter_i1 < 3) {
        chartInstance.c1_temporalCounter_i1 =
          (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
      } else {
        chartInstance.c1_temporalCounter_i1 = 1U;
      }
    }
    if(chartInstance.c1_is_active_c1_GPCA_Extension == 0) {
      chartInstance.c1_is_active_c1_GPCA_Extension = 1U;
      chartInstance.c1_is_c1_GPCA_Extension =
        (uint8_T)c1_IN_InfusionStateMachine;
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
    } else {
      c1_InfusionStateMachine();
    }
    if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1
      == 3)) {
      chartInstance.c1_temporalCounter_i1 = 0U;
    }
    _sfEvent_ = c1_previousEvent;
  }
  if(*c1_E_ConfirmStopInfusion == 1) {
    c1_inputEventFiredFlag = 1;
    c1_previousEvent = _sfEvent_;
    _sfEvent_ = c1_event_E_ConfirmStopInfusion;
    if(_sfEvent_ == c1_event_E_Clock) {
      if(chartInstance.c1_temporalCounter_i1 < 3) {
        chartInstance.c1_temporalCounter_i1 =
          (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
      } else {
        chartInstance.c1_temporalCounter_i1 = 1U;
      }
    }
    if(chartInstance.c1_is_active_c1_GPCA_Extension == 0) {
      chartInstance.c1_is_active_c1_GPCA_Extension = 1U;
      chartInstance.c1_is_c1_GPCA_Extension =
        (uint8_T)c1_IN_InfusionStateMachine;
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
    } else {
      c1_InfusionStateMachine();
    }
    if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1
      == 3)) {
      chartInstance.c1_temporalCounter_i1 = 0U;
    }
    _sfEvent_ = c1_previousEvent;
  }
  if(*c1_E_RequestBolus == 1) {
    c1_inputEventFiredFlag = 1;
    c1_previousEvent = _sfEvent_;
    _sfEvent_ = c1_event_E_RequestBolus;
    if(_sfEvent_ == c1_event_E_Clock) {
      if(chartInstance.c1_temporalCounter_i1 < 3) {
        chartInstance.c1_temporalCounter_i1 =
          (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
      } else {
        chartInstance.c1_temporalCounter_i1 = 1U;
      }
    }
    if(chartInstance.c1_is_active_c1_GPCA_Extension == 0) {
      chartInstance.c1_is_active_c1_GPCA_Extension = 1U;
      chartInstance.c1_is_c1_GPCA_Extension =
        (uint8_T)c1_IN_InfusionStateMachine;
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
    } else {
      c1_InfusionStateMachine();
    }
    if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1
      == 3)) {
      chartInstance.c1_temporalCounter_i1 = 0U;
    }
    _sfEvent_ = c1_previousEvent;
  }
  if(*c1_E_ClearAlarm == 1) {
    c1_inputEventFiredFlag = 1;
    c1_previousEvent = _sfEvent_;
    _sfEvent_ = c1_event_E_ClearAlarm;
    if(_sfEvent_ == c1_event_E_Clock) {
      if(chartInstance.c1_temporalCounter_i1 < 3) {
        chartInstance.c1_temporalCounter_i1 =
          (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
      } else {
        chartInstance.c1_temporalCounter_i1 = 1U;
      }
    }
    if(chartInstance.c1_is_active_c1_GPCA_Extension == 0) {
      chartInstance.c1_is_active_c1_GPCA_Extension = 1U;
      chartInstance.c1_is_c1_GPCA_Extension =
        (uint8_T)c1_IN_InfusionStateMachine;
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
    } else {
      c1_InfusionStateMachine();
    }
    if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1
      == 3)) {
      chartInstance.c1_temporalCounter_i1 = 0U;
    }
    _sfEvent_ = c1_previousEvent;
  }
  if(*c1_E_ConfirmPowerDown == 1) {
    c1_inputEventFiredFlag = 1;
    c1_previousEvent = _sfEvent_;
    _sfEvent_ = c1_event_E_ConfirmPowerDown;
    if(_sfEvent_ == c1_event_E_Clock) {
      if(chartInstance.c1_temporalCounter_i1 < 3) {
        chartInstance.c1_temporalCounter_i1 =
          (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
      } else {
        chartInstance.c1_temporalCounter_i1 = 1U;
      }
    }
    if(chartInstance.c1_is_active_c1_GPCA_Extension == 0) {
      chartInstance.c1_is_active_c1_GPCA_Extension = 1U;
      chartInstance.c1_is_c1_GPCA_Extension =
        (uint8_T)c1_IN_InfusionStateMachine;
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
    } else {
      c1_InfusionStateMachine();
    }
    if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1
      == 3)) {
      chartInstance.c1_temporalCounter_i1 = 0U;
    }
    _sfEvent_ = c1_previousEvent;
  }
  if(*c1_E_Cancel == 1) {
    c1_inputEventFiredFlag = 1;
    c1_previousEvent = _sfEvent_;
    _sfEvent_ = c1_event_E_Cancel;
    if(_sfEvent_ == c1_event_E_Clock) {
      if(chartInstance.c1_temporalCounter_i1 < 3) {
        chartInstance.c1_temporalCounter_i1 =
          (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
      } else {
        chartInstance.c1_temporalCounter_i1 = 1U;
      }
    }
    if(chartInstance.c1_is_active_c1_GPCA_Extension == 0) {
      chartInstance.c1_is_active_c1_GPCA_Extension = 1U;
      chartInstance.c1_is_c1_GPCA_Extension =
        (uint8_T)c1_IN_InfusionStateMachine;
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
    } else {
      c1_InfusionStateMachine();
    }
    if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1
      == 3)) {
      chartInstance.c1_temporalCounter_i1 = 0U;
    }
    _sfEvent_ = c1_previousEvent;
  }
  if((c1_inputEventFiredFlag != 0) && (chartInstance.c1_E_RestartEventCounter >
    0U)) {
    *c1_E_Restart = !(*c1_E_Restart);
    chartInstance.c1_E_RestartEventCounter =
      chartInstance.c1_E_RestartEventCounter - 1U;
  }
  if((c1_inputEventFiredFlag != 0) && (chartInstance.c1_E_AlarmClearEventCounter
    > 0U)) {
    *c1_E_AlarmClear = !(*c1_E_AlarmClear);
    chartInstance.c1_E_AlarmClearEventCounter =
      chartInstance.c1_E_AlarmClearEventCounter - 1U;
  }
  if((c1_inputEventFiredFlag != 0) &&
   (chartInstance.c1_E_RequestToStartEventCounter > 0U)) {
    *c1_E_RequestToStart = !(*c1_E_RequestToStart);
    chartInstance.c1_E_RequestToStartEventCounter =
      chartInstance.c1_E_RequestToStartEventCounter - 1U;
  }
}

static void c1_PowerOff(void)
{
  real_T c1_d0;
  real_T c1_d1;
  uint32_T *c1_O_CurrentState;
  uint32_T *c1_ClearCond;
  boolean_T *c1_O_InfusionInProgress;
  boolean_T *c1_O_InfusionPaused;
  boolean_T *c1_O_BolusRequested;
  real_T *c1_O_ProgrammedVTBI;
  real_T *c1_O_ProgrammedFlowRate;
  uint32_T *c1_O_AlarmCond;
  void *c1_pumpConfigData;
  void *c1_O_PatientInfo;
  void *c1_O_DrugLibInfo;
  c1_O_CurrentState = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 7);
  c1_O_ProgrammedVTBI = (real_T *)ssGetOutputPortSignal(chartInstance.S, 5);
  c1_ClearCond = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  c1_O_AlarmCond = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 11);
  c1_O_ProgrammedFlowRate = (real_T *)ssGetOutputPortSignal(chartInstance.S, 6);
  c1_pumpConfigData = (void *)ssGetInputPortSignal(chartInstance.S, 6);
  c1_O_InfusionInProgress = (boolean_T *)ssGetOutputPortSignal(chartInstance.S,
   2);
  c1_O_PatientInfo = (void *)ssGetOutputPortSignal(chartInstance.S, 9);
  c1_O_InfusionPaused = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 3);
  c1_O_DrugLibInfo = (void *)ssGetOutputPortSignal(chartInstance.S, 8);
  c1_O_BolusRequested = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 4);
  if(_sfEvent_ == c1_event_E_PowerButton) {
    *c1_ClearCond = 0U;
    *c1_O_InfusionInProgress = 0U;
    *c1_O_InfusionPaused = 0U;
    *c1_O_BolusRequested = 0U;
    *c1_O_ProgrammedVTBI = 0.0;
    *c1_O_ProgrammedFlowRate = 0.0;
    *c1_O_CurrentState = 0U;
    *c1_O_AlarmCond = 0U;
    *((uint32_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 0)) = 0U;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 1)) = 0.0;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 2)) = 0.0;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 3)) = 0.0;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 4)) = 0.0;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 5)) = 0.0;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 6)) = 0.0;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 7)) = 0.0;
    *((uint32_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 8)) = 0U;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 9)) = 0.0;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 10)) = 0.0;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 11)) = 0.0;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 12)) = 0.0;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 13)) = 0.0;
    *((uint32_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 14)) = 0U;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 15)) = 0.0;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 16)) = 0.0;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 17)) = 0.0;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 18)) = 0.0;
    *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 19)) = 0.0;
    *((uint32_T *)get_PatientInformation_element(c1_O_PatientInfo, 0)) = 0U;
    *((uint32_T *)get_PatientInformation_element(c1_O_PatientInfo, 1)) = 0U;
    *((uint32_T *)get_PatientInformation_element(c1_O_PatientInfo, 2)) = 0U;
    *((uint32_T *)get_PatientInformation_element(c1_O_PatientInfo, 3)) = 0U;
    chartInstance.c1_temp = 0.0;
    chartInstance.c1_tempx = 0U;
    chartInstance.c1_infusing = 0U;
    chartInstance.c1_bolusing = 0U;
    c1_d0 = (real_T)c1_const_MSG_POST;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d0, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    c1_d1 = (real_T)c1_const_MSG_WELCOME;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d1, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_POST;
    *c1_O_CurrentState = 3U;
    chartInstance.c1_tempx = (uint32_T)*((boolean_T
      *)get_PumpConfigurationsStatus_element(c1_pumpConfigData, 0));
  }
}

static void c1_UnknownDrug(void)
{
  real_T c1_d2;
  real_T c1_d3;
  uint32_T *c1_O_CurrentState;
  void *c1_drugInfo;
  void *c1_drugLibInfo;
  c1_O_CurrentState = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 7);
  c1_drugLibInfo = (void *)ssGetInputPortSignal(chartInstance.S, 1);
  c1_drugInfo = (void *)ssGetInputPortSignal(chartInstance.S, 3);
  if(_sfEvent_ == c1_event_E_Warning) {
    c1_warning();
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_UnknownDrug;
    chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_UnknownDrug;
    *c1_O_CurrentState = 11U;
    c1_d2 = (real_T)c1_const_MSG_WRONGDRUG;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d2, "GMsgConStr", 0, 0U, 0U,
      0), 0);
  } else if(_sfEvent_ == c1_event_E_CheckDrug) {
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_CheckDrug_CheckType;
    chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_CheckDrug_CheckType;
    *c1_O_CurrentState = 10U;
    c1_d3 = (real_T)c1_const_MSG_CHECKTYPE;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d3, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    chartInstance.c1_tempx = 0U;
    if(*((uint32_T *)get_DrugInformation_element(c1_drugInfo, 0)) != *((uint32_T
       *)get_DrugLibrary_element(c1_drugLibInfo, 0))) {
      chartInstance.c1_tempx = 1U;
    } else if(*((uint32_T *)get_DrugInformation_element(c1_drugInfo, 0)) ==
     *((uint32_T *)get_DrugLibrary_element(c1_drugLibInfo, 0))) {
      if(*((real_T *)get_DrugInformation_element(c1_drugInfo, 1)) != *((real_T
         *)get_DrugLibrary_element(c1_drugLibInfo, 1))) {
        chartInstance.c1_tempx = 1U;
      } else if(*((real_T *)get_DrugInformation_element(c1_drugInfo, 1)) ==
       *((real_T *)get_DrugLibrary_element(c1_drugLibInfo, 1))) {
        chartInstance.c1_tempx = 0U;
      }
    }
  }
}

static void c1_WrongConcentration(void)
{
  real_T c1_d4;
  real_T c1_d5;
  uint32_T *c1_O_CurrentState;
  void *c1_drugInfo;
  void *c1_drugLibInfo;
  c1_O_CurrentState = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 7);
  c1_drugLibInfo = (void *)ssGetInputPortSignal(chartInstance.S, 1);
  c1_drugInfo = (void *)ssGetInputPortSignal(chartInstance.S, 3);
  if(_sfEvent_ == c1_event_E_CheckDrug) {
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_CheckDrug_CheckType;
    chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_CheckDrug_CheckType;
    *c1_O_CurrentState = 10U;
    c1_d4 = (real_T)c1_const_MSG_CHECKTYPE;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d4, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    chartInstance.c1_tempx = 0U;
    if(*((uint32_T *)get_DrugInformation_element(c1_drugInfo, 0)) != *((uint32_T
       *)get_DrugLibrary_element(c1_drugLibInfo, 0))) {
      chartInstance.c1_tempx = 1U;
    } else if(*((uint32_T *)get_DrugInformation_element(c1_drugInfo, 0)) ==
     *((uint32_T *)get_DrugLibrary_element(c1_drugLibInfo, 0))) {
      if(*((real_T *)get_DrugInformation_element(c1_drugInfo, 1)) != *((real_T
         *)get_DrugLibrary_element(c1_drugLibInfo, 1))) {
        chartInstance.c1_tempx = 1U;
      } else if(*((real_T *)get_DrugInformation_element(c1_drugInfo, 1)) ==
       *((real_T *)get_DrugLibrary_element(c1_drugLibInfo, 1))) {
        chartInstance.c1_tempx = 0U;
      }
    }
  } else if(_sfEvent_ == c1_event_E_Warning) {
    c1_warning();
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_WrongConcentration;
    chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_WrongConcentration;
    *c1_O_CurrentState = 15U;
    c1_d5 = (real_T)c1_const_MSG_WRONGCON;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d5, "GMsgConStr", 0, 0U, 0U,
      0), 0);
  }
}

static void c1_WRN_DangerCon(void)
{
  real_T c1_d6;
  real_T c1_d7;
  real_T c1_d8;
  uint32_T *c1_O_CurrentState;
  void *c1_drugInfo;
  void *c1_drugLibInfo;
  void *c1_O_PatientInfo;
  void *c1_patientInfo;
  c1_O_CurrentState = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 7);
  c1_drugLibInfo = (void *)ssGetInputPortSignal(chartInstance.S, 1);
  c1_patientInfo = (void *)ssGetInputPortSignal(chartInstance.S, 2);
  c1_O_PatientInfo = (void *)ssGetOutputPortSignal(chartInstance.S, 9);
  c1_drugInfo = (void *)ssGetInputPortSignal(chartInstance.S, 3);
  if(_sfEvent_ == c1_event_E_CheckDrug) {
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_CheckDrug_CheckType;
    chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_CheckDrug_CheckType;
    *c1_O_CurrentState = 10U;
    c1_d6 = (real_T)c1_const_MSG_CHECKTYPE;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d6, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    chartInstance.c1_tempx = 0U;
    if(*((uint32_T *)get_DrugInformation_element(c1_drugInfo, 0)) != *((uint32_T
       *)get_DrugLibrary_element(c1_drugLibInfo, 0))) {
      chartInstance.c1_tempx = 1U;
    } else if(*((uint32_T *)get_DrugInformation_element(c1_drugInfo, 0)) ==
     *((uint32_T *)get_DrugLibrary_element(c1_drugLibInfo, 0))) {
      if(*((real_T *)get_DrugInformation_element(c1_drugInfo, 1)) != *((real_T
         *)get_DrugLibrary_element(c1_drugLibInfo, 1))) {
        chartInstance.c1_tempx = 1U;
      } else if(*((real_T *)get_DrugInformation_element(c1_drugInfo, 1)) ==
       *((real_T *)get_DrugLibrary_element(c1_drugLibInfo, 1))) {
        chartInstance.c1_tempx = 0U;
      }
    }
  } else if(_sfEvent_ == c1_event_E_ConfirmConcentration) {
    *((uint32_T *)get_PatientInformation_element(c1_O_PatientInfo, 0)) =
      *((uint32_T *)get_PatientInformation_element(c1_patientInfo, 0)
     );
    *((uint32_T *)get_PatientInformation_element(c1_O_PatientInfo, 1)) =
      *((uint32_T *)get_PatientInformation_element(c1_patientInfo, 1)
     );
    *((uint32_T *)get_PatientInformation_element(c1_O_PatientInfo, 2)) =
      *((uint32_T *)get_PatientInformation_element(c1_patientInfo, 2)
     );
    *((uint32_T *)get_PatientInformation_element(c1_O_PatientInfo, 3)) =
      *((uint32_T *)get_PatientInformation_element(c1_patientInfo, 3)
     );
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_DisplayPatientProfile;
    chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_DisplayPatientProfile;
    *c1_O_CurrentState = 18U;
    c1_d7 = (real_T)c1_const_MSG_PATIENTINFO;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d7, "GMsgConStr", 0, 0U, 0U,
      0), 0);
  } else if(_sfEvent_ == c1_event_E_Warning) {
    c1_warning();
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_WRN_DangerCon;
    chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_WRN_DangerCon;
    *c1_O_CurrentState = 16U;
    c1_d8 = (real_T)c1_const_MSG_DANGECON;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d8, "GMsgConStr", 0, 0U, 0U,
      0), 0);
  }
}

static real_T c1_displayBolusInfo(void)
{
  real_T c1_x;
  real_T c1_d9;
  real_T c1_d10;
  void *c1_infuStatus;
  c1_infuStatus = (void *)ssGetInputPortSignal(chartInstance.S, 5);
  c1_x = 0.0;
  if(*((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0)) == 1) {
    chartInstance.c1_bolusing = 1U;
    c1_d9 = (real_T)c1_const_MSG_BOLUSGRANT;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d9, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(*((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0)) == 0) {
    c1_d10 = (real_T)c1_const_MSG_BOLUSDENIED;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d10, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  }
  return c1_x;
}

static void c1_DisplayVTBI(void)
{
  real_T c1_d11;
  real_T c1_d12;
  real_T c1_d13;
  uint32_T *c1_O_CurrentState;
  void *c1_drugLibInfo;
  c1_O_CurrentState = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 7);
  c1_drugLibInfo = (void *)ssGetInputPortSignal(chartInstance.S, 1);
  if(_sfEvent_ == c1_event_E_ChangeVTBI) {
    chartInstance.c1_is_ConfigureInfusionProgram = (uint8_T)c1_IN_ChangeVTBI;
    chartInstance.c1_was_ConfigureInfusionProgram = (uint8_T)c1_IN_ChangeVTBI;
    *c1_O_CurrentState = 20U;
    c1_d11 = (real_T)c1_const_MSG_CHANGEVTBI;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d11, "GMsgConStr", 0, 0U, 0U,
      0), 0);
  } else if(_sfEvent_ == c1_event_E_ConfirmVTBI) {
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_DisplayDoseRate;
    chartInstance.c1_was_ConfigureInfusionProgram =
      (uint8_T)c1_IN_DisplayDoseRate;
    *c1_O_CurrentState = 23U;
    c1_d12 = (real_T)c1_const_MSG_DISPLAYDR;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d12, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    chartInstance.c1_tempx = 0U;
    chartInstance.c1_doseRate = *((real_T
      *)get_DrugLibrary_element(c1_drugLibInfo, 3));
  } else if(_sfEvent_ == c1_event_E_Warning) {
    c1_warning();
    chartInstance.c1_is_ConfigureInfusionProgram = (uint8_T)c1_IN_DisplayVTBI;
    chartInstance.c1_was_ConfigureInfusionProgram = (uint8_T)c1_IN_DisplayVTBI;
    *c1_O_CurrentState = 19U;
    c1_d13 = (real_T)c1_const_MSG_VTBI;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d13, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    chartInstance.c1_vtbi = *((real_T *)get_DrugLibrary_element(c1_drugLibInfo,
      9));
  }
}

static uint32_T c1_warning(void)
{
  uint32_T c1_x;
  real_T c1_d14;
  real_T c1_d15;
  real_T c1_d16;
  real_T c1_d17;
  real_T c1_d18;
  real_T c1_d19;
  real_T c1_d20;
  real_T c1_d21;
  real_T c1_d22;
  real_T c1_d23;
  real_T c1_d24;
  real_T *c1_ErrCond;
  uint32_T *c1_O_AlarmCond;
  c1_ErrCond = (real_T *)ssGetInputPortSignal(chartInstance.S, 0);
  c1_O_AlarmCond = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 11);
  c1_x = 0U;
  *c1_O_AlarmCond = (uint32_T)*c1_ErrCond;
  if(*c1_ErrCond == 16.0) {
    c1_d14 = (real_T)c1_const_MSG_FLOWRATEVARY;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d14, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(*c1_ErrCond == 17.0) {
    c1_d15 = (real_T)c1_const_MSG_LOWRESR;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d15, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(*c1_ErrCond == 18.0) {
    c1_d16 = (real_T)c1_const_MSG_PAUSELONG;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d16, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(*c1_ErrCond == 19.0) {
    c1_d17 = (real_T)c1_const_MSG_LOGERR;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d17, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(*c1_ErrCond == 20.0) {
    c1_d18 = (real_T)c1_const_MSG_LOWBATT;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d18, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(*c1_ErrCond == 21.0) {
    c1_d19 = (real_T)c1_const_MSG_WRNBATTERYCHARGE;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d19, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(*c1_ErrCond == 22.0) {
    c1_d20 = (real_T)c1_const_MSG_VOLTOUTRANGE;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d20, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(*c1_ErrCond == 23.0) {
    c1_d21 = (real_T)c1_const_MSG_PUMPOVERHEAT;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d21, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(*c1_ErrCond == 24.0) {
    c1_d22 = (real_T)c1_const_MSG_DANGERENVTEMP;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d22, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(*c1_ErrCond == 25.0) {
    c1_d23 = (real_T)c1_const_MSG_DANGERHUMD;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d23, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(*c1_ErrCond == 26.0) {
    c1_d24 = (real_T)c1_const_MSG_DANGERAP;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d24, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  }
  return c1_x;
}

static void c1_Infusing(void)
{
  int32_T c1_x;
  real_T c1_d25;
  real_T c1_d26;
  boolean_T c1_guard1 = false;
  real_T c1_d27;
  real_T c1_d28;
  real_T c1_d29;
  real_T c1_d30;
  real_T c1_d31;
  real_T c1_d32;
  real_T c1_d33;
  real_T c1_d34;
  boolean_T *c1_O_BolusRequested;
  uint32_T *c1_O_CurrentState;
  boolean_T *c1_O_InfusionInProgress;
  boolean_T *c1_O_InfusionPaused;
  real_T *c1_O_ProgrammedVTBI;
  real_T *c1_O_ProgrammedFlowRate;
  void *c1_infuStatus;
  void *c1_O_InfuStatus;
  c1_O_CurrentState = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 7);
  c1_O_ProgrammedVTBI = (real_T *)ssGetOutputPortSignal(chartInstance.S, 5);
  c1_O_ProgrammedFlowRate = (real_T *)ssGetOutputPortSignal(chartInstance.S, 6);
  c1_infuStatus = (void *)ssGetInputPortSignal(chartInstance.S, 5);
  c1_O_InfuStatus = (void *)ssGetOutputPortSignal(chartInstance.S, 10);
  c1_O_InfusionInProgress = (boolean_T *)ssGetOutputPortSignal(chartInstance.S,
   2);
  c1_O_InfusionPaused = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 3);
  c1_O_BolusRequested = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 4);
  c1_x = 0;
  if(*((real_T *)get_InfusionStatus_element(c1_infuStatus, 1)) >=
   chartInstance.c1_vtbi) {
    c1_x = 1;
  } else if(*((real_T *)get_InfusionStatus_element(c1_infuStatus, 1)) <
   chartInstance.c1_vtbi) {
    c1_x = 0;
  }
  if(c1_x == 1) {
    c1_d25 = (real_T)c1_const_MSG_BLANK;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d25, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionStopped;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_InfusionStopped;
    *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
      *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 1));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 2));
    chartInstance.c1_infusing = 0U;
    chartInstance.c1_bolusing = 0U;
    *c1_O_InfusionInProgress = 0U;
    *c1_O_InfusionPaused = 0U;
    *c1_O_BolusRequested = 0U;
    *c1_O_ProgrammedVTBI = 0.0;
    *c1_O_ProgrammedFlowRate = 0.0;
    c1_d26 = (real_T)c1_const_MSG_INFUSIONSTOP;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d26, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_O_CurrentState = 39U;
  } else {
    c1_guard1 = false;
    if(_sfEvent_ == c1_event_E_ChangeDoseRate) {
      chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_ChangeRate;
      chartInstance.c1_temporalCounter_i1 = 0U;
      c1_d27 = (real_T)c1_const_MSG_CHANGEDR;
      sf_mex_export("GMsgConStr", sf_mex_create(&c1_d27, "GMsgConStr", 0, 0U,
        0U, 0), 0);
      sf_mex_export("GSetConVal", sf_mex_create(&chartInstance.c1_temp,
        "GSetConVal", 0, 0U, 0U, 0), 0);
      *c1_O_CurrentState = 30U;
      *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
        *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
      *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
        *)get_InfusionStatus_element(c1_infuStatus, 1));
      *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
        *)get_InfusionStatus_element(c1_infuStatus, 2));
    } else if(_sfEvent_ == c1_event_E_StopInfusion) {
      chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_ConfirmStop;
      chartInstance.c1_temporalCounter_i1 = 0U;
      c1_d28 = (real_T)c1_const_MSG_CONFIRMSTOP;
      sf_mex_export("GMsgConStr", sf_mex_create(&c1_d28, "GMsgConStr", 0, 0U,
        0U, 0), 0);
      *c1_O_CurrentState = 35U;
      *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
        *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
      *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
        *)get_InfusionStatus_element(c1_infuStatus, 1));
      *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
        *)get_InfusionStatus_element(c1_infuStatus, 2));
    } else if(_sfEvent_ == c1_event_E_PauseInfusion) {
      chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_ConfirmPause;
      chartInstance.c1_temporalCounter_i1 = 0U;
      c1_d29 = (real_T)c1_const_MSG_CONFIRMPAUSE;
      sf_mex_export("GMsgConStr", sf_mex_create(&c1_d29, "GMsgConStr", 0, 0U,
        0U, 0), 0);
      *c1_O_CurrentState = 34U;
      *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
        *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
      *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
        *)get_InfusionStatus_element(c1_infuStatus, 1));
      *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
        *)get_InfusionStatus_element(c1_infuStatus, 2));
    } else if(_sfEvent_ == c1_event_E_RequestBolus) {
      if(*((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0)) == 0) {
        *c1_O_BolusRequested = 1U;
        chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_BolusRequest;
        *c1_O_CurrentState = 29U;
      } else if(*((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0)) ==
       1) {
        c1_d30 = (real_T)c1_const_MSG_BOLUSDENIED;
        sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d30, "GAlrmMsg", 0, 0U, 0U,
          0), 0);
        chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
        chartInstance.c1_temporalCounter_i1 = 0U;
        c1_d31 = (real_T)c1_const_MSG_INFUSING;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d31, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_O_CurrentState = 28U;
        *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
          *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 1));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 2));
      } else {
        c1_guard1 = true;
      }
    } else {
      c1_guard1 = true;
    }
    if(c1_guard1 == true) {
      if(_sfEvent_ == c1_event_E_Warning) {
        c1_warning();
        chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
        chartInstance.c1_temporalCounter_i1 = 0U;
        c1_d32 = (real_T)c1_const_MSG_INFUSING;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d32, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_O_CurrentState = 28U;
        *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
          *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 1));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 2));
      } else if((chartInstance.c1_infusing > 0) && (chartInstance.c1_bolusing >
        0) && (*((boolean_T *)get_InfusionStatus_element(
          c1_infuStatus, 0)) == 0)) {
        chartInstance.c1_bolusing = 0U;
        c1_d33 = (real_T)c1_const_MSG_STOPBOLUS;
        sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d33, "GAlrmMsg", 0, 0U, 0U,
          0), 0);
        chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
        chartInstance.c1_temporalCounter_i1 = 0U;
        c1_d34 = (real_T)c1_const_MSG_INFUSING;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d34, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_O_CurrentState = 28U;
        *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
          *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 1));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 2));
      } else if((_sfEvent_ == c1_event_E_Clock) &&
       (chartInstance.c1_temporalCounter_i1 == 3)) {
        *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
          *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 1));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 2));
      }
    }
  }
}

static void c1_enter_internal_InfusionInSession(void)
{
  real_T c1_d35;
  real_T c1_d36;
  real_T c1_d37;
  real_T c1_d38;
  real_T c1_d39;
  real_T c1_d40;
  real_T c1_d41;
  real_T c1_d42;
  real_T c1_d43;
  real_T *c1_ErrCond;
  uint32_T *c1_O_CurrentState;
  boolean_T *c1_O_InfusionInProgress;
  boolean_T *c1_O_InfusionPaused;
  boolean_T *c1_O_BolusRequested;
  real_T *c1_O_ProgrammedVTBI;
  real_T *c1_O_ProgrammedFlowRate;
  void *c1_O_InfuStatus;
  void *c1_infuStatus;
  c1_ErrCond = (real_T *)ssGetInputPortSignal(chartInstance.S, 0);
  c1_O_CurrentState = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 7);
  c1_O_ProgrammedVTBI = (real_T *)ssGetOutputPortSignal(chartInstance.S, 5);
  c1_O_ProgrammedFlowRate = (real_T *)ssGetOutputPortSignal(chartInstance.S, 6);
  c1_infuStatus = (void *)ssGetInputPortSignal(chartInstance.S, 5);
  c1_O_InfuStatus = (void *)ssGetOutputPortSignal(chartInstance.S, 10);
  c1_O_InfusionInProgress = (boolean_T *)ssGetOutputPortSignal(chartInstance.S,
   2);
  c1_O_InfusionPaused = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 3);
  c1_O_BolusRequested = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 4);
  switch(chartInstance.c1_was_InfusionInSession) {
   case c1_IN_ALMWrongDrug:
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_ALMWrongDrug;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_ALMWrongDrug;
    c1_d35 = (real_T)c1_const_MSG_WRONGDRUG;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d35, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_O_CurrentState = 42U;
    break;
   case c1_IN_CheckDrugWhileInfusing:
    chartInstance.c1_is_InfusionInSession =
      (uint8_T)c1_IN_CheckDrugWhileInfusing;
    chartInstance.c1_was_InfusionInSession =
      (uint8_T)c1_IN_CheckDrugWhileInfusing;
    c1_d36 = (real_T)c1_const_MSG_CHECKTYPE;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d36, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    sf_mex_printf("%s =\\n", "ml.GMsgConStr");
    sf_mex_call("disp", 0U, 1U, 14, sf_mex_get_ml_var("GMsgConStr", 0));
    *c1_O_CurrentState = 41U;
    chartInstance.c1_tempx = (uint32_T)c1_checkDrug();
    break;
   case c1_IN_EmptyReservoir:
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_EmptyReservoir;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_EmptyReservoir;
    *c1_O_CurrentState = 40U;
    c1_d37 = (real_T)c1_const_MSG_EMPTYRESERVOIR;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d37, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
    break;
   case c1_IN_InfusionPaused:
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionPaused;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_InfusionPaused;
    *c1_O_CurrentState = 36U;
    chartInstance.c1_infusing = 0U;
    chartInstance.c1_bolusing = 0U;
    *c1_O_InfusionInProgress = 1U;
    *c1_O_InfusionPaused = 1U;
    *c1_O_BolusRequested = 0U;
    c1_d38 = (real_T)c1_const_MSG_INFUSIONPAUSED;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d38, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    break;
   case c1_IN_InfusionStopped:
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionStopped;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_InfusionStopped;
    *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
      *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 1));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 2));
    chartInstance.c1_infusing = 0U;
    chartInstance.c1_bolusing = 0U;
    *c1_O_InfusionInProgress = 0U;
    *c1_O_InfusionPaused = 0U;
    *c1_O_BolusRequested = 0U;
    *c1_O_ProgrammedVTBI = 0.0;
    *c1_O_ProgrammedFlowRate = 0.0;
    c1_d39 = (real_T)c1_const_MSG_INFUSIONSTOP;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d39, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_O_CurrentState = 39U;
    break;
   case c1_IN_InfusionSubMachine:
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionSubMachine;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_InfusionSubMachine;
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
    chartInstance.c1_temporalCounter_i1 = 0U;
    c1_d40 = (real_T)c1_const_MSG_INFUSING;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d40, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_O_CurrentState = 28U;
    *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
      *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 1));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 2));
    break;
   case c1_IN_LevelTwoAlarming:
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_LevelTwoAlarming;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_LevelTwoAlarming;
    *c1_O_CurrentState = 44U;
    c1_setLTwoMsg((uint32_T)*c1_ErrCond);
    break;
   case c1_IN_PausedStopConfirm:
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_PausedStopConfirm;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_PausedStopConfirm;
    c1_d41 = (real_T)c1_const_MSG_SPCHOOSE;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d41, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_O_CurrentState = 38U;
    break;
   case c1_IN_PausedTooLong:
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_PausedTooLong;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_PausedTooLong;
    *c1_O_CurrentState = 37U;
    c1_d42 = (real_T)c1_const_MSG_PAUSETOOLONG;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d42, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
    break;
   default:
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionSubMachine;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_InfusionSubMachine;
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
    chartInstance.c1_temporalCounter_i1 = 0U;
    c1_d43 = (real_T)c1_const_MSG_INFUSING;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d43, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_O_CurrentState = 28U;
    *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
      *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 1));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 2));
    break;
  }
}

static void c1_InfusionInSession(void)
{
  real_T c1_d44;
  real_T c1_d45;
  real_T c1_d46;
  real_T c1_d47;
  real_T c1_d48;
  real_T c1_d49;
  real_T c1_d50;
  real_T c1_d51;
  real_T c1_d52;
  real_T c1_d53;
  real_T c1_d54;
  real_T c1_d55;
  real_T c1_d56;
  real_T c1_d57;
  real_T c1_d58;
  real_T *c1_ErrCond;
  uint32_T *c1_O_CurrentState;
  boolean_T *c1_O_InfusionInProgress;
  boolean_T *c1_O_InfusionPaused;
  boolean_T *c1_O_BolusRequested;
  real_T *c1_O_ProgrammedVTBI;
  real_T *c1_O_ProgrammedFlowRate;
  void *c1_O_InfuStatus;
  void *c1_infuStatus;
  void *c1_pumpConfigData;
  c1_ErrCond = (real_T *)ssGetInputPortSignal(chartInstance.S, 0);
  c1_O_CurrentState = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 7);
  c1_O_ProgrammedVTBI = (real_T *)ssGetOutputPortSignal(chartInstance.S, 5);
  c1_O_ProgrammedFlowRate = (real_T *)ssGetOutputPortSignal(chartInstance.S, 6);
  c1_pumpConfigData = (void *)ssGetInputPortSignal(chartInstance.S, 6);
  c1_infuStatus = (void *)ssGetInputPortSignal(chartInstance.S, 5);
  c1_O_InfuStatus = (void *)ssGetOutputPortSignal(chartInstance.S, 10);
  c1_O_InfusionInProgress = (boolean_T *)ssGetOutputPortSignal(chartInstance.S,
   2);
  c1_O_InfusionPaused = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 3);
  c1_O_BolusRequested = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 4);
  if(_sfEvent_ == c1_event_E_PowerButton) {
    chartInstance.c1_tempx = 3U;
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_ConfirmPowerDown;
    *c1_O_CurrentState = 2U;
    c1_d44 = (real_T)c1_const_MSG_POWEROFF;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d44, "GMsgConStr", 0, 0U, 0U,
      0), 0);
  } else if(c1_alrmLevel() == 1U) {
    c1_resetInfusionInstructions();
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_LEVELONEALRM;
    c1_setLOneMsg((uint32_T)*c1_ErrCond);
    *c1_O_CurrentState = 43U;
  } else {
    switch(chartInstance.c1_is_InfusionInSession) {
     case c1_IN_ALMWrongDrug:
      if(_sfEvent_ == c1_event_E_StopInfusion) {
        chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionStopped;
        chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_InfusionStopped;
        c1_copyInfuStatus();
        c1_stopInfusion();
        c1_d45 = (real_T)c1_const_MSG_INFUSIONSTOP;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d45, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_O_CurrentState = 39U;
      } else if(_sfEvent_ == c1_event_E_CheckDrug) {
        chartInstance.c1_is_InfusionInSession =
          (uint8_T)c1_IN_CheckDrugWhileInfusing;
        chartInstance.c1_was_InfusionInSession =
          (uint8_T)c1_IN_CheckDrugWhileInfusing;
        c1_d46 = (real_T)c1_const_MSG_CHECKTYPE;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d46, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        sf_mex_printf("%s =\\n", "ml.GMsgConStr");
        sf_mex_call("disp", 0U, 1U, 14, sf_mex_get_ml_var("GMsgConStr", 0));
        *c1_O_CurrentState = 41U;
        chartInstance.c1_tempx = (uint32_T)c1_checkDrug();
      } else if(_sfEvent_ == c1_event_E_Warning) {
        c1_warning();
        chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_ALMWrongDrug;
        chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_ALMWrongDrug;
        c1_d47 = (real_T)c1_const_MSG_WRONGDRUG;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d47, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_O_CurrentState = 42U;
      }
      break;
     case c1_IN_CheckDrugWhileInfusing:
      if(chartInstance.c1_tempx > 0U) {
        chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_ALMWrongDrug;
        chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_ALMWrongDrug;
        c1_d48 = (real_T)c1_const_MSG_WRONGDRUG;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d48, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_O_CurrentState = 42U;
      } else if(chartInstance.c1_tempx == 0U) {
        chartInstance.c1_infusing = 1U;
        chartInstance.c1_bolusing = 0U;
        *c1_O_InfusionInProgress = 1U;
        *c1_O_InfusionPaused = 0U;
        *c1_O_BolusRequested = 0U;
        chartInstance.c1_is_InfusionInSession =
          (uint8_T)c1_IN_InfusionSubMachine;
        chartInstance.c1_was_InfusionInSession =
          (uint8_T)c1_IN_InfusionSubMachine;
        chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
        chartInstance.c1_temporalCounter_i1 = 0U;
        c1_d49 = (real_T)c1_const_MSG_INFUSING;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d49, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_O_CurrentState = 28U;
        *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
          *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 1));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 2));
      }
      break;
     case c1_IN_EmptyReservoir:
      if(_sfEvent_ == c1_event_E_Warning) {
        c1_warning();
        chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_EmptyReservoir;
        chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_EmptyReservoir;
        *c1_O_CurrentState = 40U;
        c1_d50 = (real_T)c1_const_MSG_EMPTYRESERVOIR;
        sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d50, "GAlrmMsg", 0, 0U, 0U,
          0), 0);
      } else if(_sfEvent_ == c1_event_E_CheckDrug) {
        chartInstance.c1_is_InfusionInSession =
          (uint8_T)c1_IN_CheckDrugWhileInfusing;
        chartInstance.c1_was_InfusionInSession =
          (uint8_T)c1_IN_CheckDrugWhileInfusing;
        c1_d51 = (real_T)c1_const_MSG_CHECKTYPE;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d51, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        sf_mex_printf("%s =\\n", "ml.GMsgConStr");
        sf_mex_call("disp", 0U, 1U, 14, sf_mex_get_ml_var("GMsgConStr", 0));
        *c1_O_CurrentState = 41U;
        chartInstance.c1_tempx = (uint32_T)c1_checkDrug();
      } else if(_sfEvent_ == c1_event_E_StopInfusion) {
        chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionStopped;
        chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_InfusionStopped;
        *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
          *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 1));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 2));
        chartInstance.c1_infusing = 0U;
        chartInstance.c1_bolusing = 0U;
        *c1_O_InfusionInProgress = 0U;
        *c1_O_InfusionPaused = 0U;
        *c1_O_BolusRequested = 0U;
        *c1_O_ProgrammedVTBI = 0.0;
        *c1_O_ProgrammedFlowRate = 0.0;
        c1_d52 = (real_T)c1_const_MSG_INFUSIONSTOP;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d52, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_O_CurrentState = 39U;
      }
      break;
     case c1_IN_InfusionPaused:
      if((_sfEvent_ == c1_event_E_Alarm) && (*c1_ErrCond == 13.0)) {
        chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_PausedTooLong;
        chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_PausedTooLong;
        *c1_O_CurrentState = 37U;
        c1_d53 = (real_T)c1_const_MSG_PAUSETOOLONG;
        sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d53, "GAlrmMsg", 0, 0U, 0U,
          0), 0);
      } else if(_sfEvent_ == c1_event_E_Warning) {
        c1_warning();
        chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionPaused;
        chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_InfusionPaused;
        *c1_O_CurrentState = 36U;
        chartInstance.c1_infusing = 0U;
        chartInstance.c1_bolusing = 0U;
        *c1_O_InfusionInProgress = 1U;
        *c1_O_InfusionPaused = 1U;
        *c1_O_BolusRequested = 0U;
        c1_d54 = (real_T)c1_const_MSG_INFUSIONPAUSED;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d54, "GMsgConStr", 0, 0U,
          0U, 0), 0);
      } else if(_sfEvent_ == c1_event_E_StopInfusion) {
        chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_PausedStopConfirm;
        chartInstance.c1_was_InfusionInSession =
          (uint8_T)c1_IN_PausedStopConfirm;
        c1_d55 = (real_T)c1_const_MSG_SPCHOOSE;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d55, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_O_CurrentState = 38U;
      } else if(_sfEvent_ == c1_event_E_Cancel) {
        chartInstance.c1_infusing = 1U;
        chartInstance.c1_bolusing = 0U;
        *c1_O_InfusionInProgress = 1U;
        *c1_O_InfusionPaused = 0U;
        *c1_O_BolusRequested = 0U;
        chartInstance.c1_is_InfusionInSession =
          (uint8_T)c1_IN_InfusionSubMachine;
        chartInstance.c1_was_InfusionInSession =
          (uint8_T)c1_IN_InfusionSubMachine;
        chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
        chartInstance.c1_temporalCounter_i1 = 0U;
        c1_d56 = (real_T)c1_const_MSG_INFUSING;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d56, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_O_CurrentState = 28U;
        *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
          *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 1));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 2));
      } else if(c1_alrmLevel() == 2U) {
        chartInstance.c1_infusing = 0U;
        chartInstance.c1_bolusing = 0U;
        *c1_O_InfusionInProgress = 1U;
        *c1_O_InfusionPaused = 1U;
        *c1_O_BolusRequested = 0U;
        chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_LevelTwoAlarming;
        chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_LevelTwoAlarming;
        *c1_O_CurrentState = 44U;
        c1_setLTwoMsg((uint32_T)*c1_ErrCond);
      }
      break;
     case c1_IN_InfusionStopped:
      if(_sfEvent_ == c1_event_E_NewInfusion) {
        chartInstance.c1_infusing = 0U;
        chartInstance.c1_bolusing = 0U;
        *c1_O_InfusionInProgress = 0U;
        *c1_O_InfusionPaused = 0U;
        *c1_O_BolusRequested = 0U;
        *c1_O_ProgrammedVTBI = 0.0;
        *c1_O_ProgrammedFlowRate = 0.0;
        *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) = 0U;
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = 0.0;
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 2));
        chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
        chartInstance.c1_is_InfusionStateMachine =
          (uint8_T)c1_IN_CheckDrugRoutine;
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_CheckAdminSet;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_CheckAdminSet;
        *c1_O_CurrentState = 5U;
        c1_d57 = (real_T)c1_const_MSG_ADMINCHECK;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d57, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        chartInstance.c1_tempx = (uint32_T)*((boolean_T
          *)get_PumpConfigurationsStatus_element(c1_pumpConfigData, 2));
      } else if(_sfEvent_ == c1_event_E_Warning) {
        c1_warning();
        chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionStopped;
        chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_InfusionStopped;
        *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
          *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 1));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 2));
        chartInstance.c1_infusing = 0U;
        chartInstance.c1_bolusing = 0U;
        *c1_O_InfusionInProgress = 0U;
        *c1_O_InfusionPaused = 0U;
        *c1_O_BolusRequested = 0U;
        *c1_O_ProgrammedVTBI = 0.0;
        *c1_O_ProgrammedFlowRate = 0.0;
        c1_d58 = (real_T)c1_const_MSG_INFUSIONSTOP;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d58, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_O_CurrentState = 39U;
      }
      break;
     case c1_IN_InfusionSubMachine:
      c1_InfusionSubMachine();
      break;
     case c1_IN_LevelTwoAlarming:
      c1_LevelTwoAlarming();
      break;
     case c1_IN_PausedStopConfirm:
      c1_PausedStopConfirm();
      break;
     case c1_IN_PausedTooLong:
      c1_PausedTooLong();
      break;
     default:
      chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
      break;
    }
  }
}

static void c1_ConfirmStop(void)
{
  real_T c1_d59;
  real_T c1_d60;
  real_T c1_d61;
  real_T c1_d62;
  real_T c1_d63;
  real_T c1_d64;
  int32_T c1_x;
  real_T c1_d65;
  uint32_T *c1_O_CurrentState;
  boolean_T *c1_O_InfusionInProgress;
  boolean_T *c1_O_InfusionPaused;
  boolean_T *c1_O_BolusRequested;
  real_T *c1_O_ProgrammedVTBI;
  real_T *c1_O_ProgrammedFlowRate;
  void *c1_infuStatus;
  void *c1_O_InfuStatus;
  c1_O_CurrentState = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 7);
  c1_O_ProgrammedVTBI = (real_T *)ssGetOutputPortSignal(chartInstance.S, 5);
  c1_O_ProgrammedFlowRate = (real_T *)ssGetOutputPortSignal(chartInstance.S, 6);
  c1_infuStatus = (void *)ssGetInputPortSignal(chartInstance.S, 5);
  c1_O_InfuStatus = (void *)ssGetOutputPortSignal(chartInstance.S, 10);
  c1_O_InfusionInProgress = (boolean_T *)ssGetOutputPortSignal(chartInstance.S,
   2);
  c1_O_InfusionPaused = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 3);
  c1_O_BolusRequested = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 4);
  if(_sfEvent_ == c1_event_E_ConfirmStopInfusion) {
    c1_d59 = (real_T)c1_const_MSG_BLANK;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d59, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionStopped;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_InfusionStopped;
    *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
      *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 1));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 2));
    chartInstance.c1_infusing = 0U;
    chartInstance.c1_bolusing = 0U;
    *c1_O_InfusionInProgress = 0U;
    *c1_O_InfusionPaused = 0U;
    *c1_O_BolusRequested = 0U;
    *c1_O_ProgrammedVTBI = 0.0;
    *c1_O_ProgrammedFlowRate = 0.0;
    c1_d60 = (real_T)c1_const_MSG_INFUSIONSTOP;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d60, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_O_CurrentState = 39U;
  } else if(_sfEvent_ == c1_event_E_Warning) {
    c1_warning();
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_ConfirmStop;
    chartInstance.c1_temporalCounter_i1 = 0U;
    c1_d61 = (real_T)c1_const_MSG_CONFIRMSTOP;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d61, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_O_CurrentState = 35U;
    *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
      *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 1));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 2));
  } else if(_sfEvent_ == c1_event_E_Cancel) {
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
    chartInstance.c1_temporalCounter_i1 = 0U;
    c1_d62 = (real_T)c1_const_MSG_INFUSING;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d62, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_O_CurrentState = 28U;
    *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
      *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 1));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 2));
  } else if((chartInstance.c1_infusing > 0) && (chartInstance.c1_bolusing > 0)
   && (*((boolean_T *)get_InfusionStatus_element(
      c1_infuStatus, 0)) == 0)) {
    chartInstance.c1_bolusing = 0U;
    c1_d63 = (real_T)c1_const_MSG_STOPBOLUS;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d63, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_ConfirmStop;
    chartInstance.c1_temporalCounter_i1 = 0U;
    c1_d64 = (real_T)c1_const_MSG_CONFIRMSTOP;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d64, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_O_CurrentState = 35U;
    *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
      *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 1));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 2));
  } else {
    c1_x = 0;
    if(*((real_T *)get_InfusionStatus_element(c1_infuStatus, 1)) >=
     chartInstance.c1_vtbi) {
      c1_x = 1;
    } else if(*((real_T *)get_InfusionStatus_element(c1_infuStatus, 1)) <
     chartInstance.c1_vtbi) {
      c1_x = 0;
    }
    if(c1_x == 1) {
      chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
      chartInstance.c1_temporalCounter_i1 = 0U;
      c1_d65 = (real_T)c1_const_MSG_INFUSING;
      sf_mex_export("GMsgConStr", sf_mex_create(&c1_d65, "GMsgConStr", 0, 0U,
        0U, 0), 0);
      *c1_O_CurrentState = 28U;
      *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
        *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
      *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
        *)get_InfusionStatus_element(c1_infuStatus, 1));
      *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
        *)get_InfusionStatus_element(c1_infuStatus, 2));
    } else if((_sfEvent_ == c1_event_E_Clock) &&
     (chartInstance.c1_temporalCounter_i1 == 3)) {
      *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
        *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
      *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
        *)get_InfusionStatus_element(c1_infuStatus, 1));
      *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
        *)get_InfusionStatus_element(c1_infuStatus, 2));
    }
  }
}

static void c1_ConfirmPause(void)
{
  real_T c1_d66;
  real_T c1_d67;
  real_T c1_d68;
  real_T c1_d69;
  real_T c1_d70;
  real_T c1_d71;
  int32_T c1_x;
  real_T c1_d72;
  boolean_T *c1_O_InfusionInProgress;
  boolean_T *c1_O_InfusionPaused;
  boolean_T *c1_O_BolusRequested;
  uint32_T *c1_O_CurrentState;
  void *c1_infuStatus;
  void *c1_O_InfuStatus;
  c1_O_CurrentState = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 7);
  c1_infuStatus = (void *)ssGetInputPortSignal(chartInstance.S, 5);
  c1_O_InfuStatus = (void *)ssGetOutputPortSignal(chartInstance.S, 10);
  c1_O_InfusionInProgress = (boolean_T *)ssGetOutputPortSignal(chartInstance.S,
   2);
  c1_O_InfusionPaused = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 3);
  c1_O_BolusRequested = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 4);
  if(_sfEvent_ == c1_event_E_ConfirmPauseInfusion) {
    c1_d66 = (real_T)c1_const_MSG_BLANK;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d66, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionPaused;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_InfusionPaused;
    *c1_O_CurrentState = 36U;
    chartInstance.c1_infusing = 0U;
    chartInstance.c1_bolusing = 0U;
    *c1_O_InfusionInProgress = 1U;
    *c1_O_InfusionPaused = 1U;
    *c1_O_BolusRequested = 0U;
    c1_d67 = (real_T)c1_const_MSG_INFUSIONPAUSED;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d67, "GMsgConStr", 0, 0U, 0U,
      0), 0);
  } else if(_sfEvent_ == c1_event_E_Warning) {
    c1_warning();
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_ConfirmPause;
    chartInstance.c1_temporalCounter_i1 = 0U;
    c1_d68 = (real_T)c1_const_MSG_CONFIRMPAUSE;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d68, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_O_CurrentState = 34U;
    *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
      *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 1));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 2));
  } else if(_sfEvent_ == c1_event_E_Cancel) {
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
    chartInstance.c1_temporalCounter_i1 = 0U;
    c1_d69 = (real_T)c1_const_MSG_INFUSING;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d69, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_O_CurrentState = 28U;
    *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
      *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 1));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 2));
  } else if((chartInstance.c1_infusing > 0) && (chartInstance.c1_bolusing > 0)
   && (*((boolean_T *)get_InfusionStatus_element(
      c1_infuStatus, 0)) == 0)) {
    chartInstance.c1_bolusing = 0U;
    c1_d70 = (real_T)c1_const_MSG_STOPBOLUS;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d70, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_ConfirmPause;
    chartInstance.c1_temporalCounter_i1 = 0U;
    c1_d71 = (real_T)c1_const_MSG_CONFIRMPAUSE;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d71, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_O_CurrentState = 34U;
    *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
      *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 1));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 2));
  } else {
    c1_x = 0;
    if(*((real_T *)get_InfusionStatus_element(c1_infuStatus, 1)) >=
     chartInstance.c1_vtbi) {
      c1_x = 1;
    } else if(*((real_T *)get_InfusionStatus_element(c1_infuStatus, 1)) <
     chartInstance.c1_vtbi) {
      c1_x = 0;
    }
    if(c1_x == 1) {
      chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
      chartInstance.c1_temporalCounter_i1 = 0U;
      c1_d72 = (real_T)c1_const_MSG_INFUSING;
      sf_mex_export("GMsgConStr", sf_mex_create(&c1_d72, "GMsgConStr", 0, 0U,
        0U, 0), 0);
      *c1_O_CurrentState = 28U;
      *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
        *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
      *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
        *)get_InfusionStatus_element(c1_infuStatus, 1));
      *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
        *)get_InfusionStatus_element(c1_infuStatus, 2));
    } else if((_sfEvent_ == c1_event_E_Clock) &&
     (chartInstance.c1_temporalCounter_i1 == 3)) {
      *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
        *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
      *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
        *)get_InfusionStatus_element(c1_infuStatus, 1));
      *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
        *)get_InfusionStatus_element(c1_infuStatus, 2));
    }
  }
}

static void c1_ReadyToStart(void)
{
  real_T c1_d73;
  real_T c1_d74;
  real_T c1_d75;
  uint32_T *c1_O_CurrentState;
  real_T *c1_O_ProgrammedVTBI;
  boolean_T *c1_O_InfusionInProgress;
  boolean_T *c1_O_InfusionPaused;
  boolean_T *c1_O_BolusRequested;
  real_T *c1_O_ProgrammedFlowRate;
  void *c1_O_InfuStatus;
  void *c1_infuStatus;
  void *c1_drugInfo;
  c1_O_CurrentState = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 7);
  c1_O_ProgrammedVTBI = (real_T *)ssGetOutputPortSignal(chartInstance.S, 5);
  c1_O_ProgrammedFlowRate = (real_T *)ssGetOutputPortSignal(chartInstance.S, 6);
  c1_infuStatus = (void *)ssGetInputPortSignal(chartInstance.S, 5);
  c1_O_InfuStatus = (void *)ssGetOutputPortSignal(chartInstance.S, 10);
  c1_O_InfusionInProgress = (boolean_T *)ssGetOutputPortSignal(chartInstance.S,
   2);
  c1_O_InfusionPaused = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 3);
  c1_O_BolusRequested = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 4);
  c1_drugInfo = (void *)ssGetInputPortSignal(chartInstance.S, 3);
  if(_sfEvent_ == c1_event_E_Ready) {
    *c1_O_ProgrammedFlowRate = chartInstance.c1_doseRate / *((real_T
      *)get_DrugInformation_element(c1_drugInfo, 3));
    *c1_O_ProgrammedVTBI = chartInstance.c1_vtbi;
    *c1_O_InfusionInProgress = 1U;
    *c1_O_InfusionPaused = 0U;
    *c1_O_BolusRequested = 0U;
    chartInstance.c1_infusing = 1U;
    chartInstance.c1_bolusing = 0U;
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_InfusionInSession;
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionSubMachine;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_InfusionSubMachine;
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
    chartInstance.c1_temporalCounter_i1 = 0U;
    c1_d73 = (real_T)c1_const_MSG_INFUSING;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d73, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_O_CurrentState = 28U;
    *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
      *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 1));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 2));
  } else if(_sfEvent_ == c1_event_E_Warning) {
    c1_warning();
    chartInstance.c1_is_ConfigureInfusionProgram = (uint8_T)c1_IN_ReadyToStart;
    chartInstance.c1_was_ConfigureInfusionProgram = (uint8_T)c1_IN_ReadyToStart;
    *c1_O_CurrentState = 48U;
  } else if(_sfEvent_ == c1_event_E_NotReady) {
    c1_d74 = (real_T)c1_const_MSG_NOTREADY;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d74, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_DisplaySettings;
    chartInstance.c1_was_ConfigureInfusionProgram =
      (uint8_T)c1_IN_DisplaySettings;
    *c1_O_CurrentState = 27U;
    c1_d75 = (real_T)c1_const_MSG_DISPLAYSET;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d75, "GMsgConStr", 0, 0U, 0U,
      0), 0);
  }
}

static void c1_PausedStopConfirm(void)
{
  real_T c1_d76;
  real_T c1_d77;
  real_T c1_d78;
  real_T *c1_ErrCond;
  uint32_T *c1_O_CurrentState;
  boolean_T *c1_O_InfusionInProgress;
  boolean_T *c1_O_InfusionPaused;
  boolean_T *c1_O_BolusRequested;
  real_T *c1_O_ProgrammedVTBI;
  real_T *c1_O_ProgrammedFlowRate;
  void *c1_O_InfuStatus;
  void *c1_infuStatus;
  c1_ErrCond = (real_T *)ssGetInputPortSignal(chartInstance.S, 0);
  c1_O_CurrentState = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 7);
  c1_O_ProgrammedVTBI = (real_T *)ssGetOutputPortSignal(chartInstance.S, 5);
  c1_O_ProgrammedFlowRate = (real_T *)ssGetOutputPortSignal(chartInstance.S, 6);
  c1_infuStatus = (void *)ssGetInputPortSignal(chartInstance.S, 5);
  c1_O_InfuStatus = (void *)ssGetOutputPortSignal(chartInstance.S, 10);
  c1_O_InfusionInProgress = (boolean_T *)ssGetOutputPortSignal(chartInstance.S,
   2);
  c1_O_InfusionPaused = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 3);
  c1_O_BolusRequested = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 4);
  if(_sfEvent_ == c1_event_E_ConfirmStopInfusion) {
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionStopped;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_InfusionStopped;
    *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
      *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 1));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 2));
    chartInstance.c1_infusing = 0U;
    chartInstance.c1_bolusing = 0U;
    *c1_O_InfusionInProgress = 0U;
    *c1_O_InfusionPaused = 0U;
    *c1_O_BolusRequested = 0U;
    *c1_O_ProgrammedVTBI = 0.0;
    *c1_O_ProgrammedFlowRate = 0.0;
    c1_d76 = (real_T)c1_const_MSG_INFUSIONSTOP;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d76, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_O_CurrentState = 39U;
  } else if(_sfEvent_ == c1_event_E_Warning) {
    c1_warning();
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_PausedStopConfirm;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_PausedStopConfirm;
    c1_d77 = (real_T)c1_const_MSG_SPCHOOSE;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d77, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_O_CurrentState = 38U;
  } else if(_sfEvent_ == c1_event_E_Cancel) {
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionPaused;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_InfusionPaused;
    *c1_O_CurrentState = 36U;
    chartInstance.c1_infusing = 0U;
    chartInstance.c1_bolusing = 0U;
    *c1_O_InfusionInProgress = 1U;
    *c1_O_InfusionPaused = 1U;
    *c1_O_BolusRequested = 0U;
    c1_d78 = (real_T)c1_const_MSG_INFUSIONPAUSED;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d78, "GMsgConStr", 0, 0U, 0U,
      0), 0);
  } else if(c1_alrmLevel() == 2U) {
    chartInstance.c1_infusing = 0U;
    chartInstance.c1_bolusing = 0U;
    *c1_O_InfusionInProgress = 1U;
    *c1_O_InfusionPaused = 1U;
    *c1_O_BolusRequested = 0U;
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_LevelTwoAlarming;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_LevelTwoAlarming;
    *c1_O_CurrentState = 44U;
    c1_setLTwoMsg((uint32_T)*c1_ErrCond);
  }
}

static real_T c1_setDrugLibInfo(void)
{
  real_T c1_x;
  void *c1_O_DrugLibInfo;
  void *c1_drugLibInfo;
  c1_drugLibInfo = (void *)ssGetInputPortSignal(chartInstance.S, 1);
  c1_O_DrugLibInfo = (void *)ssGetOutputPortSignal(chartInstance.S, 8);
  c1_x = 0.0;
  *((uint32_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 0)) = *((uint32_T
    *)get_DrugLibrary_element(c1_drugLibInfo, 0));
  *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 1)) = *((real_T
    *)get_DrugLibrary_element(c1_drugLibInfo, 1));
  *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 3)) = *((real_T
    *)get_DrugLibrary_element(c1_drugLibInfo, 3));
  *((uint32_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 8)) = *((uint32_T
    *)get_DrugLibrary_element(c1_drugLibInfo, 8));
  *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 4)) = *((real_T
    *)get_DrugLibrary_element(c1_drugLibInfo, 4));
  *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 5)) = *((real_T
    *)get_DrugLibrary_element(c1_drugLibInfo, 5));
  *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 7)) = *((real_T
    *)get_DrugLibrary_element(c1_drugLibInfo, 7));
  *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 6)) = *((real_T
    *)get_DrugLibrary_element(c1_drugLibInfo, 6));
  *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 9)) = *((real_T
    *)get_DrugLibrary_element(c1_drugLibInfo, 9));
  *((uint32_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 14)) = *((uint32_T
    *)get_DrugLibrary_element(c1_drugLibInfo, 14));
  *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 10)) = *((real_T
    *)get_DrugLibrary_element(c1_drugLibInfo, 10));
  *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 11)) = *((real_T
    *)get_DrugLibrary_element(c1_drugLibInfo, 11));
  *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 13)) = *((real_T
    *)get_DrugLibrary_element(c1_drugLibInfo, 13));
  *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 12)) = *((real_T
    *)get_DrugLibrary_element(c1_drugLibInfo, 12));
  *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 15)) = *((real_T
    *)get_DrugLibrary_element(c1_drugLibInfo, 15));
  *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 16)) = *((real_T
    *)get_DrugLibrary_element(c1_drugLibInfo, 16));
  *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 17)) = *((real_T
    *)get_DrugLibrary_element(c1_drugLibInfo, 17));
  *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 19)) = *((real_T
    *)get_DrugLibrary_element(c1_drugLibInfo, 19));
  *((real_T *)get_DrugLibrary_element(c1_O_DrugLibInfo, 18)) = *((real_T
    *)get_DrugLibrary_element(c1_drugLibInfo, 18));
  return c1_x;
}

static void c1_LevelTwoAlarming(void)
{
  real_T c1_d79;
  real_T c1_d80;
  real_T c1_d81;
  real_T c1_d82;
  real_T c1_d83;
  real_T *c1_ErrCond;
  uint32_T *c1_O_CurrentState;
  boolean_T *c1_O_InfusionInProgress;
  boolean_T *c1_O_InfusionPaused;
  boolean_T *c1_O_BolusRequested;
  real_T *c1_O_ProgrammedVTBI;
  real_T *c1_O_ProgrammedFlowRate;
  void *c1_O_InfuStatus;
  void *c1_infuStatus;
  c1_ErrCond = (real_T *)ssGetInputPortSignal(chartInstance.S, 0);
  c1_O_CurrentState = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 7);
  c1_O_ProgrammedVTBI = (real_T *)ssGetOutputPortSignal(chartInstance.S, 5);
  c1_O_ProgrammedFlowRate = (real_T *)ssGetOutputPortSignal(chartInstance.S, 6);
  c1_infuStatus = (void *)ssGetInputPortSignal(chartInstance.S, 5);
  c1_O_InfuStatus = (void *)ssGetOutputPortSignal(chartInstance.S, 10);
  c1_O_InfusionInProgress = (boolean_T *)ssGetOutputPortSignal(chartInstance.S,
   2);
  c1_O_InfusionPaused = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 3);
  c1_O_BolusRequested = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 4);
  if(_sfEvent_ == c1_event_E_Warning) {
    c1_warning();
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_LevelTwoAlarming;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_LevelTwoAlarming;
    *c1_O_CurrentState = 44U;
    c1_setLTwoMsg((uint32_T)*c1_ErrCond);
  } else if(_sfEvent_ == c1_event_E_StopInfusion) {
    c1_d79 = (real_T)c1_const_MSG_BLANK;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d79, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
    chartInstance.c1_E_AlarmClearEventCounter =
      chartInstance.c1_E_AlarmClearEventCounter + 1U;
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionStopped;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_InfusionStopped;
    *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
      *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 1));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 2));
    chartInstance.c1_infusing = 0U;
    chartInstance.c1_bolusing = 0U;
    *c1_O_InfusionInProgress = 0U;
    *c1_O_InfusionPaused = 0U;
    *c1_O_BolusRequested = 0U;
    *c1_O_ProgrammedVTBI = 0.0;
    *c1_O_ProgrammedFlowRate = 0.0;
    c1_d80 = (real_T)c1_const_MSG_INFUSIONSTOP;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d80, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_O_CurrentState = 39U;
  } else if(_sfEvent_ == c1_event_E_ClearAlarm) {
    c1_d81 = (real_T)c1_const_MSG_BLANK;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d81, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
    chartInstance.c1_E_AlarmClearEventCounter =
      chartInstance.c1_E_AlarmClearEventCounter + 1U;
    chartInstance.c1_infusing = 1U;
    chartInstance.c1_bolusing = 0U;
    *c1_O_InfusionInProgress = 1U;
    *c1_O_InfusionPaused = 0U;
    *c1_O_BolusRequested = 0U;
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionSubMachine;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_InfusionSubMachine;
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
    chartInstance.c1_temporalCounter_i1 = 0U;
    c1_d82 = (real_T)c1_const_MSG_INFUSING;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d82, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_O_CurrentState = 28U;
    *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
      *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 1));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 2));
  } else if(*c1_ErrCond == 7.0) {
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_EmptyReservoir;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_EmptyReservoir;
    *c1_O_CurrentState = 40U;
    c1_d83 = (real_T)c1_const_MSG_EMPTYRESERVOIR;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d83, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  }
}

static uint32_T c1_setLOneMsg(uint32_T c1_fcond)
{
  uint32_T c1_x;
  real_T c1_d84;
  real_T c1_d85;
  real_T c1_d86;
  real_T c1_d87;
  real_T c1_d88;
  real_T c1_d89;
  uint32_T *c1_O_AlarmCond;
  c1_O_AlarmCond = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 11);
  c1_x = 0U;
  *c1_O_AlarmCond = c1_fcond;
  if(c1_fcond == 1U) {
    c1_d84 = (real_T)c1_const_MSG_OUTOFPOWER;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d84, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(c1_fcond == 2U) {
    c1_d85 = (real_T)c1_const_MSG_REALTIMECLOCK;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d85, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(c1_fcond == 3U) {
    c1_d86 = (real_T)c1_const_MSG_CPUFAILURE;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d86, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(c1_fcond == 4U) {
    c1_d87 = (real_T)c1_const_MSG_MEMORYCORRUPT;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d87, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(c1_fcond == 5U) {
    c1_d88 = (real_T)c1_const_MSG_PUMPTOOHOT;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d88, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(c1_fcond == 6U) {
    c1_d89 = (real_T)c1_const_MSG_WATCHDOGALERT;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d89, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  }
  return c1_x;
}

static uint32_T c1_alrmLevel(void)
{
  uint32_T c1_x;
  real_T *c1_ErrCond;
  uint32_T *c1_O_AlarmCond;
  c1_ErrCond = (real_T *)ssGetInputPortSignal(chartInstance.S, 0);
  c1_O_AlarmCond = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 11);
  c1_x = 0U;
  if((*c1_ErrCond > 0.0) && (*c1_ErrCond < 7.0)) {
    *c1_O_AlarmCond = (uint32_T)*c1_ErrCond;
    return 1U;
  } else if((*c1_ErrCond >= 7.0) && (*c1_ErrCond < 16.0)) {
    *c1_O_AlarmCond = (uint32_T)*c1_ErrCond;
    return 2U;
  } else if(*c1_ErrCond >= 16.0) {
    *c1_O_AlarmCond = (uint32_T)*c1_ErrCond;
    return 3U;
  } else if(*c1_ErrCond == 0.0) {
    *c1_O_AlarmCond = (uint32_T)*c1_ErrCond;
    return 0U;
  }
  return c1_x;
}

static uint32_T c1_setLTwoMsg(uint32_T c1_fCond)
{
  uint32_T c1_x;
  real_T c1_d90;
  real_T c1_d91;
  real_T c1_d92;
  real_T c1_d93;
  real_T c1_d94;
  real_T c1_d95;
  real_T c1_d96;
  real_T c1_d97;
  real_T c1_d98;
  uint32_T *c1_O_AlarmCond;
  c1_O_AlarmCond = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 11);
  c1_x = 0U;
  *c1_O_AlarmCond = c1_fCond;
  if(c1_fCond == 7U) {
    c1_d90 = (real_T)c1_const_MSG_DOOROPEN;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d90, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(c1_fCond == 8U) {
    c1_d91 = (real_T)c1_const_MSG_EMPTYRESERVOIR;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d91, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(c1_fCond == 9U) {
    c1_d92 = (real_T)c1_const_MSG_OCCULUSION;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d92, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(c1_fCond == 10U) {
    c1_d93 = (real_T)c1_const_MSG_OVERINFUSION;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d93, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(c1_fCond == 11U) {
    c1_d94 = (real_T)c1_const_MSG_UNDERINFUSION;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d94, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(c1_fCond == 12U) {
    c1_d95 = (real_T)c1_const_MSG_LESSTHANKVO;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d95, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(c1_fCond == 13U) {
    c1_d96 = (real_T)c1_const_MSG_RATEEXCEEDCAPACITY;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d96, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(c1_fCond == 14U) {
    c1_d97 = (real_T)c1_const_MSG_PAUSETOOLONG;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d97, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(c1_fCond == 15U) {
    c1_d98 = (real_T)c1_const_MSG_AIRINLINE;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d98, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  }
  return c1_x;
}

static void c1_InfusionSubMachine(void)
{
  real_T c1_d99;
  real_T c1_d100;
  real_T c1_d101;
  real_T c1_d102;
  real_T c1_d103;
  int32_T c1_x;
  real_T c1_d104;
  real_T c1_d105;
  real_T c1_d106;
  real_T c1_d107;
  real_T c1_iRate;
  real_T c1_d108;
  real_T c1_d109;
  real_T c1_d110;
  real_T c1_d111;
  real_T c1_d112;
  real_T c1_d113;
  boolean_T *c1_O_BolusRequested;
  real_T *c1_ErrCond;
  uint32_T *c1_O_CurrentState;
  real_T *c1_O_ProgrammedFlowRate;
  boolean_T *c1_O_InfusionInProgress;
  boolean_T *c1_O_InfusionPaused;
  void *c1_infuStatus;
  void *c1_O_InfuStatus;
  void *c1_infuParameters;
  void *c1_drugLibInfo;
  void *c1_drugInfo;
  c1_ErrCond = (real_T *)ssGetInputPortSignal(chartInstance.S, 0);
  c1_O_CurrentState = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 7);
  c1_drugLibInfo = (void *)ssGetInputPortSignal(chartInstance.S, 1);
  c1_infuParameters = (void *)ssGetInputPortSignal(chartInstance.S, 4);
  c1_O_ProgrammedFlowRate = (real_T *)ssGetOutputPortSignal(chartInstance.S, 6);
  c1_infuStatus = (void *)ssGetInputPortSignal(chartInstance.S, 5);
  c1_O_InfuStatus = (void *)ssGetOutputPortSignal(chartInstance.S, 10);
  c1_O_InfusionInProgress = (boolean_T *)ssGetOutputPortSignal(chartInstance.S,
   2);
  c1_O_InfusionPaused = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 3);
  c1_O_BolusRequested = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 4);
  c1_drugInfo = (void *)ssGetInputPortSignal(chartInstance.S, 3);
  if(c1_alrmLevel() == 2U) {
    chartInstance.c1_infusing = 0U;
    chartInstance.c1_bolusing = 0U;
    *c1_O_InfusionInProgress = 1U;
    *c1_O_InfusionPaused = 1U;
    *c1_O_BolusRequested = 0U;
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_LevelTwoAlarming;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_LevelTwoAlarming;
    *c1_O_CurrentState = 44U;
    c1_setLTwoMsg((uint32_T)*c1_ErrCond);
  } else {
    switch(chartInstance.c1_is_InfusionSubMachine) {
     case c1_IN_ALM_NewRateOutBound:
      if(_sfEvent_ == c1_event_E_Warning) {
        c1_warning();
        chartInstance.c1_is_InfusionSubMachine =
          (uint8_T)c1_IN_ALM_NewRateOutBound;
        chartInstance.c1_temporalCounter_i1 = 0U;
        c1_d99 = (real_T)c1_const_MSG_ALRMDR;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d99, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_O_CurrentState = 32U;
        *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
          *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 1));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 2));
      } else if(_sfEvent_ == c1_event_E_ChangeDoseRate) {
        chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_ChangeRate;
        chartInstance.c1_temporalCounter_i1 = 0U;
        c1_d100 = (real_T)c1_const_MSG_CHANGEDR;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d100, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        sf_mex_export("GSetConVal", sf_mex_create(&chartInstance.c1_temp,
          "GSetConVal", 0, 0U, 0U, 0), 0);
        *c1_O_CurrentState = 30U;
        *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
          *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 1));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 2));
      } else if(_sfEvent_ == c1_event_E_Cancel) {
        chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
        chartInstance.c1_temporalCounter_i1 = 0U;
        c1_d101 = (real_T)c1_const_MSG_INFUSING;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d101, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_O_CurrentState = 28U;
        *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
          *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 1));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 2));
      } else if((chartInstance.c1_infusing > 0) && (chartInstance.c1_bolusing >
        0) && (*((boolean_T *)get_InfusionStatus_element(
          c1_infuStatus, 0)) == 0)) {
        chartInstance.c1_bolusing = 0U;
        c1_d102 = (real_T)c1_const_MSG_STOPBOLUS;
        sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d102, "GAlrmMsg", 0, 0U, 0U,
          0), 0);
        chartInstance.c1_is_InfusionSubMachine =
          (uint8_T)c1_IN_ALM_NewRateOutBound;
        chartInstance.c1_temporalCounter_i1 = 0U;
        c1_d103 = (real_T)c1_const_MSG_ALRMDR;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d103, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_O_CurrentState = 32U;
        *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
          *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 1));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 2));
      } else {
        c1_x = 0;
        if(*((real_T *)get_InfusionStatus_element(c1_infuStatus, 1)) >=
         chartInstance.c1_vtbi) {
          c1_x = 1;
        } else if(*((real_T *)get_InfusionStatus_element(c1_infuStatus, 1)) <
         chartInstance.c1_vtbi) {
          c1_x = 0;
        }
        if(c1_x == 1) {
          chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
          chartInstance.c1_temporalCounter_i1 = 0U;
          c1_d104 = (real_T)c1_const_MSG_INFUSING;
          sf_mex_export("GMsgConStr", sf_mex_create(&c1_d104, "GMsgConStr", 0,
            0U, 0U, 0), 0);
          *c1_O_CurrentState = 28U;
          *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
            *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
          *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) =
            *((real_T *)get_InfusionStatus_element(c1_infuStatus, 1));
          *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) =
            *((real_T *)get_InfusionStatus_element(c1_infuStatus, 2));
        } else if((_sfEvent_ == c1_event_E_Clock) &&
         (chartInstance.c1_temporalCounter_i1 == 3)) {
          *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
            *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
          *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) =
            *((real_T *)get_InfusionStatus_element(c1_infuStatus, 1));
          *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) =
            *((real_T *)get_InfusionStatus_element(c1_infuStatus, 2));
        }
      }
      break;
     case c1_IN_BolusRequest:
      *c1_O_BolusRequested = 0U;
      c1_displayBolusInfo();
      chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
      chartInstance.c1_temporalCounter_i1 = 0U;
      c1_d105 = (real_T)c1_const_MSG_INFUSING;
      sf_mex_export("GMsgConStr", sf_mex_create(&c1_d105, "GMsgConStr", 0, 0U,
        0U, 0), 0);
      *c1_O_CurrentState = 28U;
      *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
        *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
      *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
        *)get_InfusionStatus_element(c1_infuStatus, 1));
      *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
        *)get_InfusionStatus_element(c1_infuStatus, 2));
      break;
     case c1_IN_ChangeRate:
      if(_sfEvent_ == c1_event_E_Warning) {
        c1_warning();
        chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_ChangeRate;
        chartInstance.c1_temporalCounter_i1 = 0U;
        c1_d106 = (real_T)c1_const_MSG_CHANGEDR;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d106, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        sf_mex_export("GSetConVal", sf_mex_create(&chartInstance.c1_temp,
          "GSetConVal", 0, 0U, 0U, 0), 0);
        *c1_O_CurrentState = 30U;
        *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
          *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 1));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 2));
      } else if(_sfEvent_ == c1_event_E_ConfirmDoseRate) {
        chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_CheckNewRate;
        chartInstance.c1_temporalCounter_i1 = 0U;
        c1_d107 = (real_T)c1_const_MSG_CHECKDR;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d107, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        c1_iRate = *((real_T *)get_InfusionParameters_element(c1_infuParameters,
          1));
        chartInstance.c1_tempx = 0U;
        if((c1_iRate > *((real_T *)get_DrugLibrary_element(c1_drugLibInfo, 4)))
         || (c1_iRate < *((real_T *)get_DrugLibrary_element(
            c1_drugLibInfo, 6)))) {
          chartInstance.c1_tempx = 2U;
        } else if((c1_iRate <= *((real_T
            *)get_DrugLibrary_element(c1_drugLibInfo, 4))) && (c1_iRate >=
          *((real_T *)get_DrugLibrary_element(
            c1_drugLibInfo, 6)))) {
          if((c1_iRate > *((real_T *)get_DrugLibrary_element(c1_drugLibInfo,
              5))) || (c1_iRate < *((real_T *)get_DrugLibrary_element(
              c1_drugLibInfo, 7)))) {
            chartInstance.c1_tempx = 1U;
          } else if((c1_iRate <= *((real_T
              *)get_DrugLibrary_element(c1_drugLibInfo, 5))) && (c1_iRate >=
            *((real_T *)get_DrugLibrary_element(
              c1_drugLibInfo, 7)))) {
            chartInstance.c1_tempx = 0U;
          }
        }
        chartInstance.c1_temp = *((real_T
          *)get_InfusionParameters_element(c1_infuParameters, 1));
        *c1_O_CurrentState = 31U;
        *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
          *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 1));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 2));
      } else if(_sfEvent_ == c1_event_E_Cancel) {
        chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
        chartInstance.c1_temporalCounter_i1 = 0U;
        c1_d108 = (real_T)c1_const_MSG_INFUSING;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d108, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_O_CurrentState = 28U;
        *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
          *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 1));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 2));
      } else if((chartInstance.c1_infusing > 0) && (chartInstance.c1_bolusing >
        0) && (*((boolean_T *)get_InfusionStatus_element(
          c1_infuStatus, 0)) == 0)) {
        chartInstance.c1_bolusing = 0U;
        c1_d109 = (real_T)c1_const_MSG_STOPBOLUS;
        sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d109, "GAlrmMsg", 0, 0U, 0U,
          0), 0);
        chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_ChangeRate;
        chartInstance.c1_temporalCounter_i1 = 0U;
        c1_d110 = (real_T)c1_const_MSG_CHANGEDR;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d110, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        sf_mex_export("GSetConVal", sf_mex_create(&chartInstance.c1_temp,
          "GSetConVal", 0, 0U, 0U, 0), 0);
        *c1_O_CurrentState = 30U;
        *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
          *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 1));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 2));
      } else {
        c1_x = 0;
        if(*((real_T *)get_InfusionStatus_element(c1_infuStatus, 1)) >=
         chartInstance.c1_vtbi) {
          c1_x = 1;
        } else if(*((real_T *)get_InfusionStatus_element(c1_infuStatus, 1)) <
         chartInstance.c1_vtbi) {
          c1_x = 0;
        }
        if(c1_x == 1) {
          chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
          chartInstance.c1_temporalCounter_i1 = 0U;
          c1_d111 = (real_T)c1_const_MSG_INFUSING;
          sf_mex_export("GMsgConStr", sf_mex_create(&c1_d111, "GMsgConStr", 0,
            0U, 0U, 0), 0);
          *c1_O_CurrentState = 28U;
          *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
            *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
          *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) =
            *((real_T *)get_InfusionStatus_element(c1_infuStatus, 1));
          *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) =
            *((real_T *)get_InfusionStatus_element(c1_infuStatus, 2));
        } else if((_sfEvent_ == c1_event_E_Clock) &&
         (chartInstance.c1_temporalCounter_i1 == 3)) {
          *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
            *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
          *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) =
            *((real_T *)get_InfusionStatus_element(c1_infuStatus, 1));
          *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) =
            *((real_T *)get_InfusionStatus_element(c1_infuStatus, 2));
        }
      }
      break;
     case c1_IN_CheckNewRate:
      if(chartInstance.c1_tempx > 0U) {
        chartInstance.c1_is_InfusionSubMachine =
          (uint8_T)c1_IN_ALM_NewRateOutBound;
        chartInstance.c1_temporalCounter_i1 = 0U;
        c1_d112 = (real_T)c1_const_MSG_ALRMDR;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d112, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_O_CurrentState = 32U;
        *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
          *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 1));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 2));
      } else if(chartInstance.c1_tempx == 0U) {
        chartInstance.c1_doseRate = chartInstance.c1_temp;
        c1_iRate = chartInstance.c1_temp;
        *c1_O_ProgrammedFlowRate = c1_iRate / *((real_T
          *)get_DrugInformation_element(c1_drugInfo, 3));
        chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
        chartInstance.c1_temporalCounter_i1 = 0U;
        c1_d113 = (real_T)c1_const_MSG_INFUSING;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d113, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_O_CurrentState = 28U;
        *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
          *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 1));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 2));
      } else if((_sfEvent_ == c1_event_E_Clock) &&
       (chartInstance.c1_temporalCounter_i1 == 3)) {
        *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
          *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 1));
        *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
          *)get_InfusionStatus_element(c1_infuStatus, 2));
      }
      break;
     case c1_IN_ConfirmPause:
      c1_ConfirmPause();
      break;
     case c1_IN_ConfirmStop:
      c1_ConfirmStop();
      break;
     case c1_IN_Infusing:
      c1_Infusing();
      break;
     default:
      chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
      break;
    }
  }
}

static void c1_WRN_VTBIOutBound(void)
{
  real_T c1_d114;
  real_T c1_d115;
  real_T c1_d116;
  uint32_T *c1_O_CurrentState;
  void *c1_drugLibInfo;
  void *c1_infuParameters;
  c1_O_CurrentState = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 7);
  c1_drugLibInfo = (void *)ssGetInputPortSignal(chartInstance.S, 1);
  c1_infuParameters = (void *)ssGetInputPortSignal(chartInstance.S, 4);
  if(_sfEvent_ == c1_event_E_Warning) {
    c1_warning();
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_WRN_VTBIOutBound;
    chartInstance.c1_was_ConfigureInfusionProgram =
      (uint8_T)c1_IN_WRN_VTBIOutBound;
    *c1_O_CurrentState = 46U;
    c1_d114 = (real_T)c1_const_MSG_WRNVTBI;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d114, "GMsgConStr", 0, 0U, 0U,
      0), 0);
  } else if(_sfEvent_ == c1_event_E_ConfirmVTBI) {
    chartInstance.c1_vtbi = *((real_T
      *)get_InfusionParameters_element(c1_infuParameters, 0));
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_DisplayDoseRate;
    chartInstance.c1_was_ConfigureInfusionProgram =
      (uint8_T)c1_IN_DisplayDoseRate;
    *c1_O_CurrentState = 23U;
    c1_d115 = (real_T)c1_const_MSG_DISPLAYDR;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d115, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    chartInstance.c1_tempx = 0U;
    chartInstance.c1_doseRate = *((real_T
      *)get_DrugLibrary_element(c1_drugLibInfo, 3));
  } else if(_sfEvent_ == c1_event_E_ChangeVTBI) {
    chartInstance.c1_is_ConfigureInfusionProgram = (uint8_T)c1_IN_ChangeVTBI;
    chartInstance.c1_was_ConfigureInfusionProgram = (uint8_T)c1_IN_ChangeVTBI;
    *c1_O_CurrentState = 20U;
    c1_d116 = (real_T)c1_const_MSG_CHANGEVTBI;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d116, "GMsgConStr", 0, 0U, 0U,
      0), 0);
  }
}

static real_T c1_checkDrugConcentration(void)
{
  real_T c1_x;
  real_T c1_actualCon;
  real_T c1_upperHard;
  real_T c1_upperSoft;
  real_T c1_lowerHard;
  real_T c1_lowerSoft;
  void *c1_drugInfo;
  void *c1_drugLibInfo;
  c1_drugLibInfo = (void *)ssGetInputPortSignal(chartInstance.S, 1);
  c1_drugInfo = (void *)ssGetInputPortSignal(chartInstance.S, 3);
  c1_x = 0.0;
  c1_actualCon = *((real_T *)get_DrugInformation_element(c1_drugInfo, 3));
  c1_upperHard = *((real_T *)get_DrugLibrary_element(c1_drugLibInfo, 16));
  c1_upperSoft = *((real_T *)get_DrugLibrary_element(c1_drugLibInfo, 17));
  c1_lowerHard = *((real_T *)get_DrugLibrary_element(c1_drugLibInfo, 18));
  c1_lowerSoft = *((real_T *)get_DrugLibrary_element(c1_drugLibInfo, 19));
  if((c1_actualCon > c1_upperHard) || (c1_actualCon < c1_lowerHard)) {
    return 2.0;
  } else if((c1_actualCon <= c1_upperHard) && (c1_actualCon >= c1_lowerHard)) {
    if((c1_actualCon > c1_upperSoft) || (c1_actualCon < c1_lowerSoft)) {
      return 1.0;
    } else if((c1_actualCon <= c1_upperSoft) && (c1_actualCon >= c1_lowerSoft)) {
      return 0.0;
    }
  }
  return c1_x;
}

static void c1_PausedTooLong(void)
{
  real_T c1_d117;
  real_T c1_d118;
  real_T c1_d119;
  uint32_T *c1_ClearCond;
  uint32_T *c1_O_CurrentState;
  boolean_T *c1_O_InfusionInProgress;
  boolean_T *c1_O_InfusionPaused;
  boolean_T *c1_O_BolusRequested;
  real_T *c1_O_ProgrammedVTBI;
  real_T *c1_O_ProgrammedFlowRate;
  void *c1_O_InfuStatus;
  void *c1_infuStatus;
  c1_O_CurrentState = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 7);
  c1_O_ProgrammedVTBI = (real_T *)ssGetOutputPortSignal(chartInstance.S, 5);
  c1_ClearCond = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  c1_O_ProgrammedFlowRate = (real_T *)ssGetOutputPortSignal(chartInstance.S, 6);
  c1_infuStatus = (void *)ssGetInputPortSignal(chartInstance.S, 5);
  c1_O_InfuStatus = (void *)ssGetOutputPortSignal(chartInstance.S, 10);
  c1_O_InfusionInProgress = (boolean_T *)ssGetOutputPortSignal(chartInstance.S,
   2);
  c1_O_InfusionPaused = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 3);
  c1_O_BolusRequested = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 4);
  if(_sfEvent_ == c1_event_E_StopInfusion) {
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionStopped;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_InfusionStopped;
    *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
      *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 1));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 2));
    chartInstance.c1_infusing = 0U;
    chartInstance.c1_bolusing = 0U;
    *c1_O_InfusionInProgress = 0U;
    *c1_O_InfusionPaused = 0U;
    *c1_O_BolusRequested = 0U;
    *c1_O_ProgrammedVTBI = 0.0;
    *c1_O_ProgrammedFlowRate = 0.0;
    c1_d117 = (real_T)c1_const_MSG_INFUSIONSTOP;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d117, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_O_CurrentState = 39U;
  } else if(_sfEvent_ == c1_event_E_Warning) {
    c1_warning();
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_PausedTooLong;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_PausedTooLong;
    *c1_O_CurrentState = 37U;
    c1_d118 = (real_T)c1_const_MSG_PAUSETOOLONG;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d118, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(_sfEvent_ == c1_event_E_ClearAlarm) {
    *c1_ClearCond = 13U;
    chartInstance.c1_infusing = 1U;
    chartInstance.c1_bolusing = 0U;
    *c1_O_InfusionInProgress = 1U;
    *c1_O_InfusionPaused = 0U;
    *c1_O_BolusRequested = 0U;
    sf_mex_printf("%s\\n", "E_AlarmClear");
    chartInstance.c1_E_AlarmClearEventCounter =
      chartInstance.c1_E_AlarmClearEventCounter + 1U;
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionSubMachine;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_InfusionSubMachine;
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
    chartInstance.c1_temporalCounter_i1 = 0U;
    c1_d119 = (real_T)c1_const_MSG_INFUSING;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d119, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_O_CurrentState = 28U;
    *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) =
      *((boolean_T *)get_InfusionStatus_element(c1_infuStatus, 0));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 1));
    *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
      *)get_InfusionStatus_element(c1_infuStatus, 2));
  }
}

static void c1_CheckDrugRoutine(void)
{
  real_T c1_d120;
  real_T c1_d121;
  real_T c1_d122;
  real_T c1_d123;
  real_T c1_d124;
  real_T c1_d125;
  real_T c1_d126;
  int32_T c1_x;
  real_T c1_d127;
  real_T c1_d128;
  real_T c1_d129;
  real_T c1_d130;
  real_T c1_d131;
  real_T c1_d132;
  real_T c1_d133;
  real_T c1_d134;
  real_T c1_d135;
  real_T c1_d136;
  real_T c1_d137;
  real_T c1_d138;
  real_T c1_d139;
  real_T c1_d140;
  real_T c1_d141;
  real_T c1_d142;
  uint32_T *c1_O_CurrentState;
  real_T *c1_ErrCond;
  void *c1_pumpConfigData;
  void *c1_O_PatientInfo;
  void *c1_patientInfo;
  void *c1_drugInfo;
  void *c1_drugLibInfo;
  c1_ErrCond = (real_T *)ssGetInputPortSignal(chartInstance.S, 0);
  c1_O_CurrentState = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 7);
  c1_drugLibInfo = (void *)ssGetInputPortSignal(chartInstance.S, 1);
  c1_pumpConfigData = (void *)ssGetInputPortSignal(chartInstance.S, 6);
  c1_patientInfo = (void *)ssGetInputPortSignal(chartInstance.S, 2);
  c1_O_PatientInfo = (void *)ssGetOutputPortSignal(chartInstance.S, 9);
  c1_drugInfo = (void *)ssGetInputPortSignal(chartInstance.S, 3);
  if(_sfEvent_ == c1_event_E_PowerButton) {
    chartInstance.c1_tempx = 1U;
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_ConfirmPowerDown;
    *c1_O_CurrentState = 2U;
    c1_d120 = (real_T)c1_const_MSG_POWEROFF;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d120, "GMsgConStr", 0, 0U, 0U,
      0), 0);
  } else if(c1_alrmLevel() == 1U) {
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_LEVELONEALRM;
    c1_setLOneMsg((uint32_T)*c1_ErrCond);
    *c1_O_CurrentState = 43U;
  } else {
    switch(chartInstance.c1_is_CheckDrugRoutine) {
     case c1_IN_ALM_WrongAdminCheck:
      if(_sfEvent_ == c1_event_E_Warning) {
        c1_warning();
        chartInstance.c1_is_CheckDrugRoutine =
          (uint8_T)c1_IN_ALM_WrongAdminCheck;
        chartInstance.c1_was_CheckDrugRoutine =
          (uint8_T)c1_IN_ALM_WrongAdminCheck;
        *c1_O_CurrentState = 6U;
        c1_d121 = (real_T)c1_const_MSG_ADMINFAIL;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d121, "GMsgConStr", 0, 0U,
          0U, 0), 0);
      } else if(_sfEvent_ == c1_event_E_CheckAdminSet) {
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_CheckAdminSet;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_CheckAdminSet;
        *c1_O_CurrentState = 5U;
        c1_d122 = (real_T)c1_const_MSG_ADMINCHECK;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d122, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        chartInstance.c1_tempx = (uint32_T)*((boolean_T
          *)get_PumpConfigurationsStatus_element(c1_pumpConfigData, 2));
      }
      break;
     case c1_IN_CheckAdminSet:
      if(chartInstance.c1_tempx == 0U) {
        chartInstance.c1_is_CheckDrugRoutine =
          (uint8_T)c1_IN_ALM_WrongAdminCheck;
        chartInstance.c1_was_CheckDrugRoutine =
          (uint8_T)c1_IN_ALM_WrongAdminCheck;
        *c1_O_CurrentState = 6U;
        c1_d123 = (real_T)c1_const_MSG_ADMINFAIL;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d123, "GMsgConStr", 0, 0U,
          0U, 0), 0);
      } else if(chartInstance.c1_tempx == 1U) {
        chartInstance.c1_E_RestartEventCounter =
          chartInstance.c1_E_RestartEventCounter + 1U;
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_CheckPrime;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_CheckPrime;
        *c1_O_CurrentState = 7U;
        chartInstance.c1_tempx = 0U;
        c1_d124 = (real_T)c1_const_MSG_PRIME;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d124, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        chartInstance.c1_tempx = (uint32_T)*((boolean_T
          *)get_PumpConfigurationsStatus_element(c1_pumpConfigData, 1));
      }
      break;
     case c1_IN_CheckDrug_CheckType:
      if(chartInstance.c1_tempx == 1U) {
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_UnknownDrug;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_UnknownDrug;
        *c1_O_CurrentState = 11U;
        c1_d125 = (real_T)c1_const_MSG_WRONGDRUG;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d125, "GMsgConStr", 0, 0U,
          0U, 0), 0);
      } else if(chartInstance.c1_tempx == 0U) {
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_Check_DrugUnits;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_Check_DrugUnits;
        *c1_O_CurrentState = 12U;
        c1_d126 = (real_T)c1_const_MSG_CHECKDU;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d126, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        c1_x = 0;
        if(*((uint32_T *)get_DrugInformation_element(c1_drugInfo, 4)) !=
         *((uint32_T *)get_DrugLibrary_element(c1_drugLibInfo, 8))) {
          c1_x = 1;
        } else if(*((uint32_T *)get_DrugInformation_element(c1_drugInfo, 4)) ==
         *((uint32_T *)get_DrugLibrary_element(c1_drugLibInfo, 8))) {
          if(*((uint32_T *)get_DrugInformation_element(c1_drugInfo, 5)) !=
           *((uint32_T *)get_DrugLibrary_element(c1_drugLibInfo, 14))) {
            c1_x = 1;
          } else if(*((uint32_T *)get_DrugInformation_element(c1_drugInfo, 5))
           == *((uint32_T *)get_DrugLibrary_element(c1_drugLibInfo, 14))) {
            c1_x = 0;
          }
        }
        chartInstance.c1_tempx = (uint32_T)c1_x;
      }
      break;
     case c1_IN_CheckPrime:
      if(chartInstance.c1_tempx == 0U) {
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_PrimeFailed;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_PrimeFailed;
        *c1_O_CurrentState = 8U;
        c1_d127 = (real_T)c1_const_MSG_PRIMEFAIL;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d127, "GMsgConStr", 0, 0U,
          0U, 0), 0);
      } else if(chartInstance.c1_tempx == 1U) {
        c1_setDrugLibInfo();
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_DisplayDrugInfo;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_DisplayDrugInfo;
        *c1_O_CurrentState = 9U;
        chartInstance.c1_tempx = 0U;
        c1_d128 = (real_T)c1_const_MSG_DRUGINFO;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d128, "GMsgConStr", 0, 0U,
          0U, 0), 0);
      }
      break;
     case c1_IN_Check_Concen:
      if(chartInstance.c1_tempx == 2U) {
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_WrongConcentration;
        chartInstance.c1_was_CheckDrugRoutine =
          (uint8_T)c1_IN_WrongConcentration;
        *c1_O_CurrentState = 15U;
        c1_d129 = (real_T)c1_const_MSG_WRONGCON;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d129, "GMsgConStr", 0, 0U,
          0U, 0), 0);
      } else if(chartInstance.c1_tempx == 1U) {
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_WRN_DangerCon;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_WRN_DangerCon;
        *c1_O_CurrentState = 16U;
        c1_d130 = (real_T)c1_const_MSG_DANGECON;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d130, "GMsgConStr", 0, 0U,
          0U, 0), 0);
      } else if(chartInstance.c1_tempx == 0U) {
        *((uint32_T *)get_PatientInformation_element(c1_O_PatientInfo, 0)) =
          *((uint32_T *)get_PatientInformation_element(c1_patientInfo, 0)
         );
        *((uint32_T *)get_PatientInformation_element(c1_O_PatientInfo, 1)) =
          *((uint32_T *)get_PatientInformation_element(c1_patientInfo, 1)
         );
        *((uint32_T *)get_PatientInformation_element(c1_O_PatientInfo, 2)) =
          *((uint32_T *)get_PatientInformation_element(c1_patientInfo, 2)
         );
        *((uint32_T *)get_PatientInformation_element(c1_O_PatientInfo, 3)) =
          *((uint32_T *)get_PatientInformation_element(c1_patientInfo, 3)
         );
        chartInstance.c1_is_CheckDrugRoutine =
          (uint8_T)c1_IN_DisplayPatientProfile;
        chartInstance.c1_was_CheckDrugRoutine =
          (uint8_T)c1_IN_DisplayPatientProfile;
        *c1_O_CurrentState = 18U;
        c1_d131 = (real_T)c1_const_MSG_PATIENTINFO;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d131, "GMsgConStr", 0, 0U,
          0U, 0), 0);
      }
      break;
     case c1_IN_Check_DrugUnits:
      if(chartInstance.c1_tempx != 0U) {
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_IncorrectDrugUnits;
        chartInstance.c1_was_CheckDrugRoutine =
          (uint8_T)c1_IN_IncorrectDrugUnits;
        *c1_O_CurrentState = 13U;
        c1_d132 = (real_T)c1_const_MSG_WRONGDU;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d132, "GMsgConStr", 0, 0U,
          0U, 0), 0);
      } else if(chartInstance.c1_tempx == 0U) {
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_Check_Concen;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_Check_Concen;
        *c1_O_CurrentState = 14U;
        c1_d133 = (real_T)c1_const_MSG_CHECKCON;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d133, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        chartInstance.c1_tempx = (uint32_T)c1_checkDrugConcentration();
      }
      break;
     case c1_IN_DisplayDrugInfo:
      if(_sfEvent_ == c1_event_E_CheckDrug) {
        chartInstance.c1_is_CheckDrugRoutine =
          (uint8_T)c1_IN_CheckDrug_CheckType;
        chartInstance.c1_was_CheckDrugRoutine =
          (uint8_T)c1_IN_CheckDrug_CheckType;
        *c1_O_CurrentState = 10U;
        c1_d134 = (real_T)c1_const_MSG_CHECKTYPE;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d134, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        chartInstance.c1_tempx = 0U;
        if(*((uint32_T *)get_DrugInformation_element(c1_drugInfo, 0)) !=
         *((uint32_T *)get_DrugLibrary_element(c1_drugLibInfo, 0))) {
          chartInstance.c1_tempx = 1U;
        } else if(*((uint32_T *)get_DrugInformation_element(c1_drugInfo, 0)) ==
         *((uint32_T *)get_DrugLibrary_element(c1_drugLibInfo, 0))) {
          if(*((real_T *)get_DrugInformation_element(c1_drugInfo, 1)) !=
           *((real_T *)get_DrugLibrary_element(c1_drugLibInfo, 1))) {
            chartInstance.c1_tempx = 1U;
          } else if(*((real_T *)get_DrugInformation_element(c1_drugInfo, 1)) ==
           *((real_T *)get_DrugLibrary_element(c1_drugLibInfo, 1))) {
            chartInstance.c1_tempx = 0U;
          }
        }
      } else if(_sfEvent_ == c1_event_E_Warning) {
        c1_warning();
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_DisplayDrugInfo;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_DisplayDrugInfo;
        *c1_O_CurrentState = 9U;
        chartInstance.c1_tempx = 0U;
        c1_d135 = (real_T)c1_const_MSG_DRUGINFO;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d135, "GMsgConStr", 0, 0U,
          0U, 0), 0);
      }
      break;
     case c1_IN_DisplayPatientProfile:
      if(_sfEvent_ == c1_event_E_ConfigureInfusionProgram) {
        c1_setDrugLibInfo();
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
        chartInstance.c1_is_InfusionStateMachine =
          (uint8_T)c1_IN_ConfigureInfusionProgram;
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_DisplayVTBI;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_DisplayVTBI;
        *c1_O_CurrentState = 19U;
        c1_d136 = (real_T)c1_const_MSG_VTBI;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d136, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        chartInstance.c1_vtbi = *((real_T
          *)get_DrugLibrary_element(c1_drugLibInfo, 9));
      } else if(_sfEvent_ == c1_event_E_Warning) {
        c1_warning();
        chartInstance.c1_is_CheckDrugRoutine =
          (uint8_T)c1_IN_DisplayPatientProfile;
        chartInstance.c1_was_CheckDrugRoutine =
          (uint8_T)c1_IN_DisplayPatientProfile;
        *c1_O_CurrentState = 18U;
        c1_d137 = (real_T)c1_const_MSG_PATIENTINFO;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d137, "GMsgConStr", 0, 0U,
          0U, 0), 0);
      } else if(_sfEvent_ == c1_event_E_Cancel) {
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_DisplayDrugInfo;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_DisplayDrugInfo;
        *c1_O_CurrentState = 9U;
        chartInstance.c1_tempx = 0U;
        c1_d138 = (real_T)c1_const_MSG_DRUGINFO;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d138, "GMsgConStr", 0, 0U,
          0U, 0), 0);
      }
      break;
     case c1_IN_IncorrectDrugUnits:
      if(_sfEvent_ == c1_event_E_CheckDrug) {
        chartInstance.c1_is_CheckDrugRoutine =
          (uint8_T)c1_IN_CheckDrug_CheckType;
        chartInstance.c1_was_CheckDrugRoutine =
          (uint8_T)c1_IN_CheckDrug_CheckType;
        *c1_O_CurrentState = 10U;
        c1_d139 = (real_T)c1_const_MSG_CHECKTYPE;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d139, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        chartInstance.c1_tempx = 0U;
        if(*((uint32_T *)get_DrugInformation_element(c1_drugInfo, 0)) !=
         *((uint32_T *)get_DrugLibrary_element(c1_drugLibInfo, 0))) {
          chartInstance.c1_tempx = 1U;
        } else if(*((uint32_T *)get_DrugInformation_element(c1_drugInfo, 0)) ==
         *((uint32_T *)get_DrugLibrary_element(c1_drugLibInfo, 0))) {
          if(*((real_T *)get_DrugInformation_element(c1_drugInfo, 1)) !=
           *((real_T *)get_DrugLibrary_element(c1_drugLibInfo, 1))) {
            chartInstance.c1_tempx = 1U;
          } else if(*((real_T *)get_DrugInformation_element(c1_drugInfo, 1)) ==
           *((real_T *)get_DrugLibrary_element(c1_drugLibInfo, 1))) {
            chartInstance.c1_tempx = 0U;
          }
        }
      } else if(_sfEvent_ == c1_event_E_Warning) {
        c1_warning();
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_IncorrectDrugUnits;
        chartInstance.c1_was_CheckDrugRoutine =
          (uint8_T)c1_IN_IncorrectDrugUnits;
        *c1_O_CurrentState = 13U;
        c1_d140 = (real_T)c1_const_MSG_WRONGDU;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d140, "GMsgConStr", 0, 0U,
          0U, 0), 0);
      }
      break;
     case c1_IN_PrimeFailed:
      if(_sfEvent_ == c1_event_E_Warning) {
        c1_warning();
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_PrimeFailed;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_PrimeFailed;
        *c1_O_CurrentState = 8U;
        c1_d141 = (real_T)c1_const_MSG_PRIMEFAIL;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d141, "GMsgConStr", 0, 0U,
          0U, 0), 0);
      } else if(_sfEvent_ == c1_event_E_Prime) {
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_CheckPrime;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_CheckPrime;
        *c1_O_CurrentState = 7U;
        chartInstance.c1_tempx = 0U;
        c1_d142 = (real_T)c1_const_MSG_PRIME;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d142, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        chartInstance.c1_tempx = (uint32_T)*((boolean_T
          *)get_PumpConfigurationsStatus_element(c1_pumpConfigData, 1));
      }
      break;
     case c1_IN_UnknownDrug:
      c1_UnknownDrug();
      break;
     case c1_IN_WRN_DangerCon:
      c1_WRN_DangerCon();
      break;
     case c1_IN_WrongConcentration:
      c1_WrongConcentration();
      break;
     default:
      chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
      break;
    }
  }
}

static void c1_enter_internal_ConfigureInfusionProgram(void)
{
  real_T c1_d143;
  real_T c1_d144;
  real_T c1_d145;
  real_T c1_d146;
  real_T c1_d147;
  real_T c1_inputVal;
  real_T c1_d148;
  real_T c1_d149;
  real_T c1_d150;
  real_T c1_d151;
  real_T c1_d152;
  real_T c1_d153;
  uint32_T *c1_O_CurrentState;
  void *c1_drugLibInfo;
  void *c1_infuParameters;
  c1_O_CurrentState = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 7);
  c1_drugLibInfo = (void *)ssGetInputPortSignal(chartInstance.S, 1);
  c1_infuParameters = (void *)ssGetInputPortSignal(chartInstance.S, 4);
  switch(chartInstance.c1_was_ConfigureInfusionProgram) {
   case c1_IN_ALM_DoseRateOutBound:
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_ALM_DoseRateOutBound;
    chartInstance.c1_was_ConfigureInfusionProgram =
      (uint8_T)c1_IN_ALM_DoseRateOutBound;
    *c1_O_CurrentState = 26U;
    c1_d143 = (real_T)c1_const_MSG_ALRMDR;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d143, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    break;
   case c1_IN_ALM_VTBIOutBound:
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_ALM_VTBIOutBound;
    chartInstance.c1_was_ConfigureInfusionProgram =
      (uint8_T)c1_IN_ALM_VTBIOutBound;
    *c1_O_CurrentState = 22U;
    c1_d144 = (real_T)c1_const_MSG_ALMVTBI;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d144, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    break;
   case c1_IN_ChangeDoseRate:
    chartInstance.c1_is_ConfigureInfusionProgram = (uint8_T)c1_IN_ChangeDoseRate;
    chartInstance.c1_was_ConfigureInfusionProgram =
      (uint8_T)c1_IN_ChangeDoseRate;
    *c1_O_CurrentState = 24U;
    c1_d145 = (real_T)c1_const_MSG_CHANGEDR;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d145, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    break;
   case c1_IN_ChangeVTBI:
    chartInstance.c1_is_ConfigureInfusionProgram = (uint8_T)c1_IN_ChangeVTBI;
    chartInstance.c1_was_ConfigureInfusionProgram = (uint8_T)c1_IN_ChangeVTBI;
    *c1_O_CurrentState = 20U;
    c1_d146 = (real_T)c1_const_MSG_CHANGEVTBI;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d146, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    break;
   case c1_IN_CheckDoseRate:
    chartInstance.c1_is_ConfigureInfusionProgram = (uint8_T)c1_IN_CheckDoseRate;
    chartInstance.c1_was_ConfigureInfusionProgram = (uint8_T)c1_IN_CheckDoseRate;
    *c1_O_CurrentState = 25U;
    c1_d147 = (real_T)c1_const_MSG_CHECKDR;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d147, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    c1_inputVal = *((real_T *)get_InfusionParameters_element(c1_infuParameters,
      1));
    chartInstance.c1_tempx = 0U;
    if((c1_inputVal > *((real_T *)get_DrugLibrary_element(c1_drugLibInfo, 4)))
     || (c1_inputVal < *((real_T *)get_DrugLibrary_element(
        c1_drugLibInfo, 6)))) {
      chartInstance.c1_tempx = 2U;
    } else if((c1_inputVal <= *((real_T
        *)get_DrugLibrary_element(c1_drugLibInfo, 4))) && (c1_inputVal >=
      *((real_T *)
       get_DrugLibrary_element(c1_drugLibInfo, 6)))) {
      if((c1_inputVal > *((real_T *)get_DrugLibrary_element(c1_drugLibInfo, 5)))
       || (c1_inputVal < *((real_T *)get_DrugLibrary_element(
          c1_drugLibInfo, 7)))) {
        chartInstance.c1_tempx = 1U;
      } else if((c1_inputVal <= *((real_T
          *)get_DrugLibrary_element(c1_drugLibInfo, 5))) && (c1_inputVal >=
        *((real_T *)
         get_DrugLibrary_element(c1_drugLibInfo, 7)))) {
        chartInstance.c1_tempx = 0U;
      }
    }
    break;
   case c1_IN_CheckVTBI:
    chartInstance.c1_is_ConfigureInfusionProgram = (uint8_T)c1_IN_CheckVTBI;
    chartInstance.c1_was_ConfigureInfusionProgram = (uint8_T)c1_IN_CheckVTBI;
    *c1_O_CurrentState = 21U;
    c1_d148 = (real_T)c1_const_MSG_CHECKVTBI;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d148, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    c1_inputVal = *((real_T *)get_InfusionParameters_element(c1_infuParameters,
      0));
    chartInstance.c1_tempx = 0U;
    if((c1_inputVal > *((real_T *)get_DrugLibrary_element(c1_drugLibInfo, 10)))
     || (c1_inputVal < *((real_T *)get_DrugLibrary_element(
        c1_drugLibInfo, 12)))) {
      chartInstance.c1_tempx = 2U;
    } else if((c1_inputVal <= *((real_T
        *)get_DrugLibrary_element(c1_drugLibInfo, 10))) && (c1_inputVal >=
      *((real_T *)
       get_DrugLibrary_element(c1_drugLibInfo, 12)))) {
      if((c1_inputVal > *((real_T *)get_DrugLibrary_element(c1_drugLibInfo,
          11))) || (c1_inputVal < *((real_T *)get_DrugLibrary_element(
          c1_drugLibInfo, 13)))) {
        chartInstance.c1_tempx = 1U;
      } else if((c1_inputVal <= *((real_T
          *)get_DrugLibrary_element(c1_drugLibInfo, 11))) && (c1_inputVal <=
        *((real_T *)
         get_DrugLibrary_element(c1_drugLibInfo, 13)))) {
        chartInstance.c1_tempx = 0U;
      }
    }
    break;
   case c1_IN_DisplayDoseRate:
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_DisplayDoseRate;
    chartInstance.c1_was_ConfigureInfusionProgram =
      (uint8_T)c1_IN_DisplayDoseRate;
    *c1_O_CurrentState = 23U;
    c1_d149 = (real_T)c1_const_MSG_DISPLAYDR;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d149, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    chartInstance.c1_tempx = 0U;
    chartInstance.c1_doseRate = *((real_T
      *)get_DrugLibrary_element(c1_drugLibInfo, 3));
    break;
   case c1_IN_DisplaySettings:
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_DisplaySettings;
    chartInstance.c1_was_ConfigureInfusionProgram =
      (uint8_T)c1_IN_DisplaySettings;
    *c1_O_CurrentState = 27U;
    c1_d150 = (real_T)c1_const_MSG_DISPLAYSET;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d150, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    break;
   case c1_IN_DisplayVTBI:
    chartInstance.c1_is_ConfigureInfusionProgram = (uint8_T)c1_IN_DisplayVTBI;
    chartInstance.c1_was_ConfigureInfusionProgram = (uint8_T)c1_IN_DisplayVTBI;
    *c1_O_CurrentState = 19U;
    c1_d151 = (real_T)c1_const_MSG_VTBI;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d151, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    chartInstance.c1_vtbi = *((real_T *)get_DrugLibrary_element(c1_drugLibInfo,
      9));
    break;
   case c1_IN_ReadyToStart:
    chartInstance.c1_is_ConfigureInfusionProgram = (uint8_T)c1_IN_ReadyToStart;
    chartInstance.c1_was_ConfigureInfusionProgram = (uint8_T)c1_IN_ReadyToStart;
    *c1_O_CurrentState = 48U;
    break;
   case c1_IN_WRN_DOSERATEOUTSOFTLIMITS:
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_WRN_DOSERATEOUTSOFTLIMITS;
    chartInstance.c1_was_ConfigureInfusionProgram =
      (uint8_T)c1_IN_WRN_DOSERATEOUTSOFTLIMITS;
    *c1_O_CurrentState = 47U;
    c1_d152 = (real_T)c1_const_MSG_WRNDR;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d152, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    break;
   case c1_IN_WRN_VTBIOutBound:
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_WRN_VTBIOutBound;
    chartInstance.c1_was_ConfigureInfusionProgram =
      (uint8_T)c1_IN_WRN_VTBIOutBound;
    *c1_O_CurrentState = 46U;
    c1_d153 = (real_T)c1_const_MSG_WRNVTBI;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d153, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    break;
  }
}

static void c1_ConfigureInfusionProgram(void)
{
  real_T c1_d154;
  real_T c1_d155;
  real_T c1_d156;
  real_T c1_d157;
  real_T c1_d158;
  real_T c1_d159;
  real_T c1_inputVal;
  real_T c1_d160;
  real_T c1_d161;
  real_T c1_d162;
  real_T c1_d163;
  real_T c1_d164;
  real_T c1_d165;
  real_T c1_d166;
  real_T c1_d167;
  real_T c1_d168;
  real_T c1_d169;
  real_T c1_d170;
  real_T c1_d171;
  real_T c1_d172;
  real_T c1_d173;
  real_T c1_d174;
  real_T c1_d175;
  real_T c1_d176;
  real_T c1_d177;
  real_T *c1_ErrCond;
  uint32_T *c1_O_CurrentState;
  void *c1_infuParameters;
  void *c1_drugLibInfo;
  c1_ErrCond = (real_T *)ssGetInputPortSignal(chartInstance.S, 0);
  c1_O_CurrentState = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 7);
  c1_drugLibInfo = (void *)ssGetInputPortSignal(chartInstance.S, 1);
  c1_infuParameters = (void *)ssGetInputPortSignal(chartInstance.S, 4);
  if(_sfEvent_ == c1_event_E_PowerButton) {
    chartInstance.c1_tempx = 2U;
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_ConfirmPowerDown;
    *c1_O_CurrentState = 2U;
    c1_d154 = (real_T)c1_const_MSG_POWEROFF;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d154, "GMsgConStr", 0, 0U, 0U,
      0), 0);
  } else if(c1_alrmLevel() == 1U) {
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_LEVELONEALRM;
    c1_setLOneMsg((uint32_T)*c1_ErrCond);
    *c1_O_CurrentState = 43U;
  } else {
    switch(chartInstance.c1_is_ConfigureInfusionProgram) {
     case c1_IN_ALM_DoseRateOutBound:
      if(_sfEvent_ == c1_event_E_Warning) {
        c1_warning();
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ALM_DoseRateOutBound;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ALM_DoseRateOutBound;
        *c1_O_CurrentState = 26U;
        c1_d155 = (real_T)c1_const_MSG_ALRMDR;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d155, "GMsgConStr", 0, 0U,
          0U, 0), 0);
      } else if(_sfEvent_ == c1_event_E_ChangeDoseRate) {
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ChangeDoseRate;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ChangeDoseRate;
        *c1_O_CurrentState = 24U;
        c1_d156 = (real_T)c1_const_MSG_CHANGEDR;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d156, "GMsgConStr", 0, 0U,
          0U, 0), 0);
      }
      break;
     case c1_IN_ALM_VTBIOutBound:
      if(_sfEvent_ == c1_event_E_Warning) {
        c1_warning();
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ALM_VTBIOutBound;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ALM_VTBIOutBound;
        *c1_O_CurrentState = 22U;
        c1_d157 = (real_T)c1_const_MSG_ALMVTBI;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d157, "GMsgConStr", 0, 0U,
          0U, 0), 0);
      } else if(_sfEvent_ == c1_event_E_ChangeVTBI) {
        chartInstance.c1_is_ConfigureInfusionProgram = (uint8_T)c1_IN_ChangeVTBI;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ChangeVTBI;
        *c1_O_CurrentState = 20U;
        c1_d158 = (real_T)c1_const_MSG_CHANGEVTBI;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d158, "GMsgConStr", 0, 0U,
          0U, 0), 0);
      }
      break;
     case c1_IN_ChangeDoseRate:
      if(_sfEvent_ == c1_event_E_ConfirmDoseRate) {
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_CheckDoseRate;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_CheckDoseRate;
        *c1_O_CurrentState = 25U;
        c1_d159 = (real_T)c1_const_MSG_CHECKDR;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d159, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        c1_inputVal = *((real_T
          *)get_InfusionParameters_element(c1_infuParameters, 1));
        chartInstance.c1_tempx = 0U;
        if((c1_inputVal > *((real_T *)get_DrugLibrary_element(c1_drugLibInfo,
            4))) || (c1_inputVal < *((real_T *)get_DrugLibrary_element(
            c1_drugLibInfo, 6)))) {
          chartInstance.c1_tempx = 2U;
        } else if((c1_inputVal <= *((real_T
            *)get_DrugLibrary_element(c1_drugLibInfo, 4))) && (c1_inputVal >=
          *((real_T *)
           get_DrugLibrary_element(c1_drugLibInfo, 6)))) {
          if((c1_inputVal > *((real_T *)get_DrugLibrary_element(c1_drugLibInfo,
              5))) || (c1_inputVal < *((real_T *)get_DrugLibrary_element(
              c1_drugLibInfo, 7)))) {
            chartInstance.c1_tempx = 1U;
          } else if((c1_inputVal <= *((real_T
              *)get_DrugLibrary_element(c1_drugLibInfo, 5))) && (c1_inputVal >=
            *((real_T *)
             get_DrugLibrary_element(c1_drugLibInfo, 7)))) {
            chartInstance.c1_tempx = 0U;
          }
        }
      } else if(_sfEvent_ == c1_event_E_Warning) {
        c1_warning();
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ChangeDoseRate;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ChangeDoseRate;
        *c1_O_CurrentState = 24U;
        c1_d160 = (real_T)c1_const_MSG_CHANGEDR;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d160, "GMsgConStr", 0, 0U,
          0U, 0), 0);
      } else if(_sfEvent_ == c1_event_E_Cancel) {
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_DisplayDoseRate;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_DisplayDoseRate;
        *c1_O_CurrentState = 23U;
        c1_d161 = (real_T)c1_const_MSG_DISPLAYDR;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d161, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        chartInstance.c1_tempx = 0U;
        chartInstance.c1_doseRate = *((real_T
          *)get_DrugLibrary_element(c1_drugLibInfo, 3));
      }
      break;
     case c1_IN_ChangeVTBI:
      if(_sfEvent_ == c1_event_E_ConfirmVTBI) {
        chartInstance.c1_is_ConfigureInfusionProgram = (uint8_T)c1_IN_CheckVTBI;
        chartInstance.c1_was_ConfigureInfusionProgram = (uint8_T)c1_IN_CheckVTBI;
        *c1_O_CurrentState = 21U;
        c1_d162 = (real_T)c1_const_MSG_CHECKVTBI;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d162, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        c1_inputVal = *((real_T
          *)get_InfusionParameters_element(c1_infuParameters, 0));
        chartInstance.c1_tempx = 0U;
        if((c1_inputVal > *((real_T *)get_DrugLibrary_element(c1_drugLibInfo,
            10))) || (c1_inputVal < *((real_T *)get_DrugLibrary_element(
            c1_drugLibInfo, 12)))) {
          chartInstance.c1_tempx = 2U;
        } else if((c1_inputVal <= *((real_T
            *)get_DrugLibrary_element(c1_drugLibInfo, 10))) && (c1_inputVal >=
          *((real_T *)
           get_DrugLibrary_element(c1_drugLibInfo, 12)))) {
          if((c1_inputVal > *((real_T *)get_DrugLibrary_element(c1_drugLibInfo,
              11))) || (c1_inputVal < *((real_T *)get_DrugLibrary_element(
              c1_drugLibInfo, 13)))) {
            chartInstance.c1_tempx = 1U;
          } else if((c1_inputVal <= *((real_T
              *)get_DrugLibrary_element(c1_drugLibInfo, 11))) && (c1_inputVal <=
            *((real_T *)
             get_DrugLibrary_element(c1_drugLibInfo, 13)))) {
            chartInstance.c1_tempx = 0U;
          }
        }
      } else if(_sfEvent_ == c1_event_E_Cancel) {
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_DisplayVTBI;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_DisplayVTBI;
        *c1_O_CurrentState = 19U;
        c1_d163 = (real_T)c1_const_MSG_VTBI;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d163, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        chartInstance.c1_vtbi = *((real_T
          *)get_DrugLibrary_element(c1_drugLibInfo, 9));
      } else if(_sfEvent_ == c1_event_E_Warning) {
        c1_warning();
        chartInstance.c1_is_ConfigureInfusionProgram = (uint8_T)c1_IN_ChangeVTBI;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ChangeVTBI;
        *c1_O_CurrentState = 20U;
        c1_d164 = (real_T)c1_const_MSG_CHANGEVTBI;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d164, "GMsgConStr", 0, 0U,
          0U, 0), 0);
      }
      break;
     case c1_IN_CheckDoseRate:
      if(chartInstance.c1_tempx == 1U) {
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_WRN_DOSERATEOUTSOFTLIMITS;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_WRN_DOSERATEOUTSOFTLIMITS;
        *c1_O_CurrentState = 47U;
        c1_d165 = (real_T)c1_const_MSG_WRNDR;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d165, "GMsgConStr", 0, 0U,
          0U, 0), 0);
      } else if(chartInstance.c1_tempx == 0U) {
        chartInstance.c1_doseRate = *((real_T
          *)get_InfusionParameters_element(c1_infuParameters, 1));
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_DisplaySettings;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_DisplaySettings;
        *c1_O_CurrentState = 27U;
        c1_d166 = (real_T)c1_const_MSG_DISPLAYSET;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d166, "GMsgConStr", 0, 0U,
          0U, 0), 0);
      } else if(chartInstance.c1_tempx == 2U) {
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ALM_DoseRateOutBound;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ALM_DoseRateOutBound;
        *c1_O_CurrentState = 26U;
        c1_d167 = (real_T)c1_const_MSG_ALRMDR;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d167, "GMsgConStr", 0, 0U,
          0U, 0), 0);
      }
      break;
     case c1_IN_CheckVTBI:
      if(chartInstance.c1_tempx == 1U) {
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_WRN_VTBIOutBound;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_WRN_VTBIOutBound;
        *c1_O_CurrentState = 46U;
        c1_d168 = (real_T)c1_const_MSG_WRNVTBI;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d168, "GMsgConStr", 0, 0U,
          0U, 0), 0);
      } else if(chartInstance.c1_tempx == 0U) {
        chartInstance.c1_vtbi = *((real_T
          *)get_InfusionParameters_element(c1_infuParameters, 0));
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_DisplayDoseRate;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_DisplayDoseRate;
        *c1_O_CurrentState = 23U;
        c1_d169 = (real_T)c1_const_MSG_DISPLAYDR;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d169, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        chartInstance.c1_tempx = 0U;
        chartInstance.c1_doseRate = *((real_T
          *)get_DrugLibrary_element(c1_drugLibInfo, 3));
      } else if(chartInstance.c1_tempx == 2U) {
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ALM_VTBIOutBound;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ALM_VTBIOutBound;
        *c1_O_CurrentState = 22U;
        c1_d170 = (real_T)c1_const_MSG_ALMVTBI;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d170, "GMsgConStr", 0, 0U,
          0U, 0), 0);
      }
      break;
     case c1_IN_DisplayDoseRate:
      if(_sfEvent_ == c1_event_E_ChangeDoseRate) {
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ChangeDoseRate;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ChangeDoseRate;
        *c1_O_CurrentState = 24U;
        c1_d171 = (real_T)c1_const_MSG_CHANGEDR;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d171, "GMsgConStr", 0, 0U,
          0U, 0), 0);
      } else if(_sfEvent_ == c1_event_E_ConfirmDoseRate) {
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_DisplaySettings;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_DisplaySettings;
        *c1_O_CurrentState = 27U;
        c1_d172 = (real_T)c1_const_MSG_DISPLAYSET;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d172, "GMsgConStr", 0, 0U,
          0U, 0), 0);
      } else if(_sfEvent_ == c1_event_E_Warning) {
        c1_warning();
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_DisplayDoseRate;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_DisplayDoseRate;
        *c1_O_CurrentState = 23U;
        c1_d173 = (real_T)c1_const_MSG_DISPLAYDR;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d173, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        chartInstance.c1_tempx = 0U;
        chartInstance.c1_doseRate = *((real_T
          *)get_DrugLibrary_element(c1_drugLibInfo, 3));
      }
      break;
     case c1_IN_DisplaySettings:
      if(_sfEvent_ == c1_event_E_StartInfusion) {
        sf_mex_printf("%s\\n", "E_RequestToStart");
        chartInstance.c1_E_RequestToStartEventCounter =
          chartInstance.c1_E_RequestToStartEventCounter + 1U;
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ReadyToStart;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ReadyToStart;
        *c1_O_CurrentState = 48U;
      } else if(_sfEvent_ == c1_event_E_ConfigureInfusionProgram) {
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_DisplayVTBI;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_DisplayVTBI;
        *c1_O_CurrentState = 19U;
        c1_d174 = (real_T)c1_const_MSG_VTBI;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d174, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        chartInstance.c1_vtbi = *((real_T
          *)get_DrugLibrary_element(c1_drugLibInfo, 9));
      } else if(_sfEvent_ == c1_event_E_Warning) {
        c1_warning();
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_DisplaySettings;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_DisplaySettings;
        *c1_O_CurrentState = 27U;
        c1_d175 = (real_T)c1_const_MSG_DISPLAYSET;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d175, "GMsgConStr", 0, 0U,
          0U, 0), 0);
      }
      break;
     case c1_IN_DisplayVTBI:
      c1_DisplayVTBI();
      break;
     case c1_IN_ReadyToStart:
      c1_ReadyToStart();
      break;
     case c1_IN_WRN_DOSERATEOUTSOFTLIMITS:
      if(_sfEvent_ == c1_event_E_ConfirmDoseRate) {
        chartInstance.c1_doseRate = *((real_T
          *)get_InfusionParameters_element(c1_infuParameters, 1));
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_DisplaySettings;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_DisplaySettings;
        *c1_O_CurrentState = 27U;
        c1_d176 = (real_T)c1_const_MSG_DISPLAYSET;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d176, "GMsgConStr", 0, 0U,
          0U, 0), 0);
      } else if(_sfEvent_ == c1_event_E_ChangeDoseRate) {
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ChangeDoseRate;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ChangeDoseRate;
        *c1_O_CurrentState = 24U;
        c1_d177 = (real_T)c1_const_MSG_CHANGEDR;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d177, "GMsgConStr", 0, 0U,
          0U, 0), 0);
      }
      break;
     case c1_IN_WRN_VTBIOutBound:
      c1_WRN_VTBIOutBound();
      break;
     default:
      chartInstance.c1_is_ConfigureInfusionProgram =
        (uint8_T)c1_IN_NO_ACTIVE_CHILD;
      break;
    }
  }
}

static void c1_InfusionStateMachine(void)
{
  real_T c1_d178;
  real_T c1_d179;
  real_T c1_d180;
  real_T c1_d181;
  real_T c1_d182;
  real_T c1_d183;
  real_T c1_d184;
  int32_T c1_x;
  real_T c1_d185;
  real_T c1_d186;
  real_T c1_d187;
  real_T c1_d188;
  real_T c1_d189;
  real_T c1_d190;
  real_T c1_d191;
  real_T c1_d192;
  real_T c1_d193;
  real_T c1_d194;
  real_T c1_d195;
  real_T c1_d196;
  real_T c1_d197;
  real_T c1_d198;
  real_T c1_d199;
  real_T c1_d200;
  uint32_T *c1_O_AlarmCond;
  uint32_T *c1_O_CurrentState;
  boolean_T *c1_O_InfusionInProgress;
  boolean_T *c1_O_InfusionPaused;
  boolean_T *c1_O_BolusRequested;
  real_T *c1_O_ProgrammedVTBI;
  real_T *c1_O_ProgrammedFlowRate;
  void *c1_pumpConfigData;
  void *c1_drugInfo;
  void *c1_drugLibInfo;
  void *c1_O_InfuStatus;
  void *c1_infuStatus;
  c1_O_CurrentState = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 7);
  c1_O_ProgrammedVTBI = (real_T *)ssGetOutputPortSignal(chartInstance.S, 5);
  c1_drugLibInfo = (void *)ssGetInputPortSignal(chartInstance.S, 1);
  c1_O_AlarmCond = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 11);
  c1_O_ProgrammedFlowRate = (real_T *)ssGetOutputPortSignal(chartInstance.S, 6);
  c1_pumpConfigData = (void *)ssGetInputPortSignal(chartInstance.S, 6);
  c1_infuStatus = (void *)ssGetInputPortSignal(chartInstance.S, 5);
  c1_O_InfuStatus = (void *)ssGetOutputPortSignal(chartInstance.S, 10);
  c1_O_InfusionInProgress = (boolean_T *)ssGetOutputPortSignal(chartInstance.S,
   2);
  c1_O_InfusionPaused = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 3);
  c1_O_BolusRequested = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 4);
  c1_drugInfo = (void *)ssGetInputPortSignal(chartInstance.S, 3);
  switch(chartInstance.c1_is_InfusionStateMachine) {
   case c1_IN_ALM_POSTFailed:
    if(_sfEvent_ == c1_event_E_PowerButton) {
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_PowerOff;
      *c1_O_CurrentState = 1U;
    } else if(_sfEvent_ == c1_event_E_Warning) {
      c1_warning();
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_ALM_POSTFailed;
      c1_d178 = (real_T)c1_const_MSG_POSTFAIL;
      sf_mex_export("GMsgConStr", sf_mex_create(&c1_d178, "GMsgConStr", 0, 0U,
        0U, 0), 0);
      *c1_O_CurrentState = 4U;
    }
    break;
   case c1_IN_CheckDrugRoutine:
    c1_CheckDrugRoutine();
    break;
   case c1_IN_ConfigureInfusionProgram:
    c1_ConfigureInfusionProgram();
    break;
   case c1_IN_ConfirmPowerDown:
    if((_sfEvent_ == c1_event_E_Cancel) && (chartInstance.c1_tempx == 3U)) {
      chartInstance.c1_is_InfusionStateMachine =
        (uint8_T)c1_IN_InfusionInSession;
      c1_enter_internal_InfusionInSession();
    } else if((_sfEvent_ == c1_event_E_Cancel) && (chartInstance.c1_tempx ==
      2U)) {
      chartInstance.c1_is_InfusionStateMachine =
        (uint8_T)c1_IN_ConfigureInfusionProgram;
      c1_enter_internal_ConfigureInfusionProgram();
    } else if((_sfEvent_ == c1_event_E_Cancel) && (chartInstance.c1_tempx ==
      1U)) {
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_CheckDrugRoutine;
      switch(chartInstance.c1_was_CheckDrugRoutine) {
       case c1_IN_ALM_WrongAdminCheck:
        chartInstance.c1_is_CheckDrugRoutine =
          (uint8_T)c1_IN_ALM_WrongAdminCheck;
        chartInstance.c1_was_CheckDrugRoutine =
          (uint8_T)c1_IN_ALM_WrongAdminCheck;
        *c1_O_CurrentState = 6U;
        c1_d179 = (real_T)c1_const_MSG_ADMINFAIL;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d179, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        break;
       case c1_IN_CheckAdminSet:
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_CheckAdminSet;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_CheckAdminSet;
        *c1_O_CurrentState = 5U;
        c1_d180 = (real_T)c1_const_MSG_ADMINCHECK;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d180, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        chartInstance.c1_tempx = (uint32_T)*((boolean_T
          *)get_PumpConfigurationsStatus_element(c1_pumpConfigData, 2));
        break;
       case c1_IN_CheckDrug_CheckType:
        chartInstance.c1_is_CheckDrugRoutine =
          (uint8_T)c1_IN_CheckDrug_CheckType;
        chartInstance.c1_was_CheckDrugRoutine =
          (uint8_T)c1_IN_CheckDrug_CheckType;
        *c1_O_CurrentState = 10U;
        c1_d181 = (real_T)c1_const_MSG_CHECKTYPE;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d181, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        chartInstance.c1_tempx = 0U;
        if(*((uint32_T *)get_DrugInformation_element(c1_drugInfo, 0)) !=
         *((uint32_T *)get_DrugLibrary_element(c1_drugLibInfo, 0))) {
          chartInstance.c1_tempx = 1U;
        } else if(*((uint32_T *)get_DrugInformation_element(c1_drugInfo, 0)) ==
         *((uint32_T *)get_DrugLibrary_element(c1_drugLibInfo, 0))) {
          if(*((real_T *)get_DrugInformation_element(c1_drugInfo, 1)) !=
           *((real_T *)get_DrugLibrary_element(c1_drugLibInfo, 1))) {
            chartInstance.c1_tempx = 1U;
          } else if(*((real_T *)get_DrugInformation_element(c1_drugInfo, 1)) ==
           *((real_T *)get_DrugLibrary_element(c1_drugLibInfo, 1))) {
            chartInstance.c1_tempx = 0U;
          }
        }
        break;
       case c1_IN_CheckPrime:
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_CheckPrime;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_CheckPrime;
        *c1_O_CurrentState = 7U;
        chartInstance.c1_tempx = 0U;
        c1_d182 = (real_T)c1_const_MSG_PRIME;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d182, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        chartInstance.c1_tempx = (uint32_T)*((boolean_T
          *)get_PumpConfigurationsStatus_element(c1_pumpConfigData, 1));
        break;
       case c1_IN_Check_Concen:
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_Check_Concen;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_Check_Concen;
        *c1_O_CurrentState = 14U;
        c1_d183 = (real_T)c1_const_MSG_CHECKCON;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d183, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        chartInstance.c1_tempx = (uint32_T)c1_checkDrugConcentration();
        break;
       case c1_IN_Check_DrugUnits:
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_Check_DrugUnits;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_Check_DrugUnits;
        *c1_O_CurrentState = 12U;
        c1_d184 = (real_T)c1_const_MSG_CHECKDU;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d184, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        c1_x = 0;
        if(*((uint32_T *)get_DrugInformation_element(c1_drugInfo, 4)) !=
         *((uint32_T *)get_DrugLibrary_element(c1_drugLibInfo, 8))) {
          c1_x = 1;
        } else if(*((uint32_T *)get_DrugInformation_element(c1_drugInfo, 4)) ==
         *((uint32_T *)get_DrugLibrary_element(c1_drugLibInfo, 8))) {
          if(*((uint32_T *)get_DrugInformation_element(c1_drugInfo, 5)) !=
           *((uint32_T *)get_DrugLibrary_element(c1_drugLibInfo, 14))) {
            c1_x = 1;
          } else if(*((uint32_T *)get_DrugInformation_element(c1_drugInfo, 5))
           == *((uint32_T *)get_DrugLibrary_element(c1_drugLibInfo, 14))) {
            c1_x = 0;
          }
        }
        chartInstance.c1_tempx = (uint32_T)c1_x;
        break;
       case c1_IN_DisplayDrugInfo:
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_DisplayDrugInfo;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_DisplayDrugInfo;
        *c1_O_CurrentState = 9U;
        chartInstance.c1_tempx = 0U;
        c1_d185 = (real_T)c1_const_MSG_DRUGINFO;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d185, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        break;
       case c1_IN_DisplayPatientProfile:
        chartInstance.c1_is_CheckDrugRoutine =
          (uint8_T)c1_IN_DisplayPatientProfile;
        chartInstance.c1_was_CheckDrugRoutine =
          (uint8_T)c1_IN_DisplayPatientProfile;
        *c1_O_CurrentState = 18U;
        c1_d186 = (real_T)c1_const_MSG_PATIENTINFO;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d186, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        break;
       case c1_IN_IncorrectDrugUnits:
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_IncorrectDrugUnits;
        chartInstance.c1_was_CheckDrugRoutine =
          (uint8_T)c1_IN_IncorrectDrugUnits;
        *c1_O_CurrentState = 13U;
        c1_d187 = (real_T)c1_const_MSG_WRONGDU;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d187, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        break;
       case c1_IN_PrimeFailed:
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_PrimeFailed;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_PrimeFailed;
        *c1_O_CurrentState = 8U;
        c1_d188 = (real_T)c1_const_MSG_PRIMEFAIL;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d188, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        break;
       case c1_IN_UnknownDrug:
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_UnknownDrug;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_UnknownDrug;
        *c1_O_CurrentState = 11U;
        c1_d189 = (real_T)c1_const_MSG_WRONGDRUG;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d189, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        break;
       case c1_IN_WRN_DangerCon:
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_WRN_DangerCon;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_WRN_DangerCon;
        *c1_O_CurrentState = 16U;
        c1_d190 = (real_T)c1_const_MSG_DANGECON;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d190, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        break;
       case c1_IN_WrongConcentration:
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_WrongConcentration;
        chartInstance.c1_was_CheckDrugRoutine =
          (uint8_T)c1_IN_WrongConcentration;
        *c1_O_CurrentState = 15U;
        c1_d191 = (real_T)c1_const_MSG_WRONGCON;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d191, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        break;
      }
    } else if((_sfEvent_ == c1_event_E_Cancel) && (chartInstance.c1_tempx ==
      4U)) {
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_POSTDONE;
      c1_d192 = (real_T)c1_const_MSG_POSTDONE;
      sf_mex_export("GMsgConStr", sf_mex_create(&c1_d192, "GMsgConStr", 0, 0U,
        0U, 0), 0);
      *c1_O_CurrentState = 45U;
      chartInstance.c1_tempx = 0U;
    } else if(_sfEvent_ == c1_event_E_Warning) {
      c1_warning();
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_ConfirmPowerDown;
      *c1_O_CurrentState = 2U;
      c1_d193 = (real_T)c1_const_MSG_POWEROFF;
      sf_mex_export("GMsgConStr", sf_mex_create(&c1_d193, "GMsgConStr", 0, 0U,
        0U, 0), 0);
    } else if(_sfEvent_ == c1_event_E_ConfirmPowerDown) {
      *c1_O_AlarmCond = 0U;
      c1_d194 = (real_T)c1_const_MSG_BLANK;
      sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d194, "GAlrmMsg", 0, 0U, 0U,
        0), 0);
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_PowerOff;
      *c1_O_CurrentState = 1U;
    }
    break;
   case c1_IN_InfusionInSession:
    c1_InfusionInSession();
    break;
   case c1_IN_Init:
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_PowerOff;
    *c1_O_CurrentState = 1U;
    break;
   case c1_IN_LEVELONEALRM:
    if(_sfEvent_ == c1_event_E_PowerButton) {
      *c1_O_AlarmCond = 0U;
      c1_d195 = (real_T)c1_const_MSG_BLANK;
      sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d195, "GAlrmMsg", 0, 0U, 0U,
        0), 0);
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_PowerOff;
      *c1_O_CurrentState = 1U;
    }
    break;
   case c1_IN_POST:
    if(chartInstance.c1_tempx == 1U) {
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_POSTDONE;
      c1_d196 = (real_T)c1_const_MSG_POSTDONE;
      sf_mex_export("GMsgConStr", sf_mex_create(&c1_d196, "GMsgConStr", 0, 0U,
        0U, 0), 0);
      *c1_O_CurrentState = 45U;
      chartInstance.c1_tempx = 0U;
    } else if(chartInstance.c1_tempx == 0U) {
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_ALM_POSTFailed;
      c1_d197 = (real_T)c1_const_MSG_POSTFAIL;
      sf_mex_export("GMsgConStr", sf_mex_create(&c1_d197, "GMsgConStr", 0, 0U,
        0U, 0), 0);
      *c1_O_CurrentState = 4U;
    }
    break;
   case c1_IN_POSTDONE:
    if(_sfEvent_ == c1_event_E_PowerButton) {
      chartInstance.c1_tempx = 4U;
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_ConfirmPowerDown;
      *c1_O_CurrentState = 2U;
      c1_d198 = (real_T)c1_const_MSG_POWEROFF;
      sf_mex_export("GMsgConStr", sf_mex_create(&c1_d198, "GMsgConStr", 0, 0U,
        0U, 0), 0);
    } else if(_sfEvent_ == c1_event_E_CheckAdminSet) {
      chartInstance.c1_infusing = 0U;
      chartInstance.c1_bolusing = 0U;
      *c1_O_InfusionInProgress = 0U;
      *c1_O_InfusionPaused = 0U;
      *c1_O_BolusRequested = 0U;
      *c1_O_ProgrammedVTBI = 0.0;
      *c1_O_ProgrammedFlowRate = 0.0;
      *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) = 0U;
      *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = 0.0;
      *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
        *)get_InfusionStatus_element(c1_infuStatus, 2));
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_CheckDrugRoutine;
      chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_CheckAdminSet;
      chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_CheckAdminSet;
      *c1_O_CurrentState = 5U;
      c1_d199 = (real_T)c1_const_MSG_ADMINCHECK;
      sf_mex_export("GMsgConStr", sf_mex_create(&c1_d199, "GMsgConStr", 0, 0U,
        0U, 0), 0);
      chartInstance.c1_tempx = (uint32_T)*((boolean_T
        *)get_PumpConfigurationsStatus_element(c1_pumpConfigData, 2));
    } else if(_sfEvent_ == c1_event_E_Warning) {
      c1_warning();
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_POSTDONE;
      c1_d200 = (real_T)c1_const_MSG_POSTDONE;
      sf_mex_export("GMsgConStr", sf_mex_create(&c1_d200, "GMsgConStr", 0, 0U,
        0U, 0), 0);
      *c1_O_CurrentState = 45U;
      chartInstance.c1_tempx = 0U;
    }
    break;
   case c1_IN_PowerOff:
    c1_PowerOff();
    break;
   default:
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
  }
}

static real_T c1_checkDrug(void)
{
  real_T c1_x;
  uint32_T c1_b_x;
  boolean_T c1_flag;
  int32_T c1_c_x;
  void *c1_drugInfo;
  void *c1_drugLibInfo;
  c1_drugLibInfo = (void *)ssGetInputPortSignal(chartInstance.S, 1);
  c1_drugInfo = (void *)ssGetInputPortSignal(chartInstance.S, 3);
  c1_x = 0.0;
  c1_b_x = 0U;
  if(*((uint32_T *)get_DrugInformation_element(c1_drugInfo, 0)) != *((uint32_T
     *)get_DrugLibrary_element(c1_drugLibInfo, 0))) {
    c1_b_x = 1U;
  } else if(*((uint32_T *)get_DrugInformation_element(c1_drugInfo, 0)) ==
   *((uint32_T *)get_DrugLibrary_element(c1_drugLibInfo, 0))) {
    if(*((real_T *)get_DrugInformation_element(c1_drugInfo, 1)) != *((real_T
       *)get_DrugLibrary_element(c1_drugLibInfo, 1))) {
      c1_b_x = 1U;
    } else if(*((real_T *)get_DrugInformation_element(c1_drugInfo, 1)) ==
     *((real_T *)get_DrugLibrary_element(c1_drugLibInfo, 1))) {
      c1_b_x = 0U;
    }
  }
  c1_flag = (c1_b_x != 0U);
  if(c1_flag == 1) {
    return 1.0;
  } else if(c1_flag == 0) {
    c1_c_x = 0;
    if(*((uint32_T *)get_DrugInformation_element(c1_drugInfo, 4)) != *((uint32_T
       *)get_DrugLibrary_element(c1_drugLibInfo, 8))) {
      c1_c_x = 1;
    } else if(*((uint32_T *)get_DrugInformation_element(c1_drugInfo, 4)) ==
     *((uint32_T *)get_DrugLibrary_element(c1_drugLibInfo, 8))) {
      if(*((uint32_T *)get_DrugInformation_element(c1_drugInfo, 5)) !=
       *((uint32_T *)get_DrugLibrary_element(c1_drugLibInfo, 14))) {
        c1_c_x = 1;
      } else if(*((uint32_T *)get_DrugInformation_element(c1_drugInfo, 5)) ==
       *((uint32_T *)get_DrugLibrary_element(c1_drugLibInfo, 14))) {
        c1_c_x = 0;
      }
    }
    c1_flag = (c1_c_x != 0);
    if(c1_flag == 1) {
      return 1.0;
    } else if(c1_flag == 0) {
      c1_flag = (c1_checkDrugConcentration() != 0.0);
      if(c1_flag > 0) {
        return 1.0;
      } else {
        return 0.0;
      }
    }
  }
  return c1_x;
}

static real_T c1_stopInfusion(void)
{
  real_T c1_x;
  boolean_T *c1_O_InfusionInProgress;
  boolean_T *c1_O_InfusionPaused;
  boolean_T *c1_O_BolusRequested;
  real_T *c1_O_ProgrammedVTBI;
  real_T *c1_O_ProgrammedFlowRate;
  c1_O_ProgrammedVTBI = (real_T *)ssGetOutputPortSignal(chartInstance.S, 5);
  c1_O_ProgrammedFlowRate = (real_T *)ssGetOutputPortSignal(chartInstance.S, 6);
  c1_O_InfusionInProgress = (boolean_T *)ssGetOutputPortSignal(chartInstance.S,
   2);
  c1_O_InfusionPaused = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 3);
  c1_O_BolusRequested = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 4);
  c1_x = 0.0;
  chartInstance.c1_infusing = 0U;
  chartInstance.c1_bolusing = 0U;
  *c1_O_InfusionInProgress = 0U;
  *c1_O_InfusionPaused = 0U;
  *c1_O_BolusRequested = 0U;
  *c1_O_ProgrammedVTBI = 0.0;
  *c1_O_ProgrammedFlowRate = 0.0;
  return c1_x;
}

static real_T c1_resetInfusionInstructions(void)
{
  real_T c1_x;
  boolean_T *c1_O_InfusionInProgress;
  boolean_T *c1_O_InfusionPaused;
  boolean_T *c1_O_BolusRequested;
  real_T *c1_O_ProgrammedVTBI;
  real_T *c1_O_ProgrammedFlowRate;
  c1_O_ProgrammedVTBI = (real_T *)ssGetOutputPortSignal(chartInstance.S, 5);
  c1_O_ProgrammedFlowRate = (real_T *)ssGetOutputPortSignal(chartInstance.S, 6);
  c1_O_InfusionInProgress = (boolean_T *)ssGetOutputPortSignal(chartInstance.S,
   2);
  c1_O_InfusionPaused = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 3);
  c1_O_BolusRequested = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 4);
  c1_x = 0.0;
  chartInstance.c1_infusing = 0U;
  chartInstance.c1_bolusing = 0U;
  *c1_O_InfusionInProgress = 0U;
  *c1_O_InfusionPaused = 0U;
  *c1_O_BolusRequested = 0U;
  *c1_O_ProgrammedVTBI = 0.0;
  *c1_O_ProgrammedFlowRate = 0.0;
  return c1_x;
}

static real_T c1_copyInfuStatus(void)
{
  real_T c1_x;
  void *c1_O_InfuStatus;
  void *c1_infuStatus;
  c1_infuStatus = (void *)ssGetInputPortSignal(chartInstance.S, 5);
  c1_O_InfuStatus = (void *)ssGetOutputPortSignal(chartInstance.S, 10);
  c1_x = 0.0;
  *((boolean_T *)get_InfusionStatus_element(c1_O_InfuStatus, 0)) = *((boolean_T
    *)get_InfusionStatus_element(c1_infuStatus, 0));
  *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 1)) = *((real_T
    *)get_InfusionStatus_element(c1_infuStatus, 1));
  *((real_T *)get_InfusionStatus_element(c1_O_InfuStatus, 2)) = *((real_T
    *)get_InfusionStatus_element(c1_infuStatus, 2));
  return c1_x;
}

static void c1_broadcast_E_Clock(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_Clock;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 3) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_GPCA_Extension == 0) {
    chartInstance.c1_is_active_c1_GPCA_Extension = 1U;
    chartInstance.c1_is_c1_GPCA_Extension = (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    3)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_Alarm(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_Alarm;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 3) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_GPCA_Extension == 0) {
    chartInstance.c1_is_active_c1_GPCA_Extension = 1U;
    chartInstance.c1_is_c1_GPCA_Extension = (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    3)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_Warning(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_Warning;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 3) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_GPCA_Extension == 0) {
    chartInstance.c1_is_active_c1_GPCA_Extension = 1U;
    chartInstance.c1_is_c1_GPCA_Extension = (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    3)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_Ready(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_Ready;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 3) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_GPCA_Extension == 0) {
    chartInstance.c1_is_active_c1_GPCA_Extension = 1U;
    chartInstance.c1_is_c1_GPCA_Extension = (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    3)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_NotReady(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_NotReady;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 3) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_GPCA_Extension == 0) {
    chartInstance.c1_is_active_c1_GPCA_Extension = 1U;
    chartInstance.c1_is_c1_GPCA_Extension = (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    3)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_StartSimulation(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_StartSimulation;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 3) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_GPCA_Extension == 0) {
    chartInstance.c1_is_active_c1_GPCA_Extension = 1U;
    chartInstance.c1_is_c1_GPCA_Extension = (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    3)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_PowerButton(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_PowerButton;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 3) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_GPCA_Extension == 0) {
    chartInstance.c1_is_active_c1_GPCA_Extension = 1U;
    chartInstance.c1_is_c1_GPCA_Extension = (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    3)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_NewInfusion(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_NewInfusion;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 3) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_GPCA_Extension == 0) {
    chartInstance.c1_is_active_c1_GPCA_Extension = 1U;
    chartInstance.c1_is_c1_GPCA_Extension = (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    3)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_CheckAdminSet(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_CheckAdminSet;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 3) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_GPCA_Extension == 0) {
    chartInstance.c1_is_active_c1_GPCA_Extension = 1U;
    chartInstance.c1_is_c1_GPCA_Extension = (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    3)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_Prime(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_Prime;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 3) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_GPCA_Extension == 0) {
    chartInstance.c1_is_active_c1_GPCA_Extension = 1U;
    chartInstance.c1_is_c1_GPCA_Extension = (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    3)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_CheckDrug(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_CheckDrug;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 3) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_GPCA_Extension == 0) {
    chartInstance.c1_is_active_c1_GPCA_Extension = 1U;
    chartInstance.c1_is_c1_GPCA_Extension = (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    3)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_ConfigureInfusionProgram(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_ConfigureInfusionProgram;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 3) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_GPCA_Extension == 0) {
    chartInstance.c1_is_active_c1_GPCA_Extension = 1U;
    chartInstance.c1_is_c1_GPCA_Extension = (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    3)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_ConfirmConcentration(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_ConfirmConcentration;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 3) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_GPCA_Extension == 0) {
    chartInstance.c1_is_active_c1_GPCA_Extension = 1U;
    chartInstance.c1_is_c1_GPCA_Extension = (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    3)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_ConfirmDoseRate(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_ConfirmDoseRate;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 3) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_GPCA_Extension == 0) {
    chartInstance.c1_is_active_c1_GPCA_Extension = 1U;
    chartInstance.c1_is_c1_GPCA_Extension = (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    3)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_ConfirmVTBI(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_ConfirmVTBI;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 3) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_GPCA_Extension == 0) {
    chartInstance.c1_is_active_c1_GPCA_Extension = 1U;
    chartInstance.c1_is_c1_GPCA_Extension = (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    3)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_StartInfusion(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_StartInfusion;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 3) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_GPCA_Extension == 0) {
    chartInstance.c1_is_active_c1_GPCA_Extension = 1U;
    chartInstance.c1_is_c1_GPCA_Extension = (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    3)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_ChangeDoseRate(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_ChangeDoseRate;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 3) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_GPCA_Extension == 0) {
    chartInstance.c1_is_active_c1_GPCA_Extension = 1U;
    chartInstance.c1_is_c1_GPCA_Extension = (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    3)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_ChangeVTBI(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_ChangeVTBI;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 3) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_GPCA_Extension == 0) {
    chartInstance.c1_is_active_c1_GPCA_Extension = 1U;
    chartInstance.c1_is_c1_GPCA_Extension = (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    3)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_PauseInfusion(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_PauseInfusion;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 3) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_GPCA_Extension == 0) {
    chartInstance.c1_is_active_c1_GPCA_Extension = 1U;
    chartInstance.c1_is_c1_GPCA_Extension = (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    3)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void init_script_number_translation(uint32_T c1_machineNumber, uint32_T
 c1_chartNumber)
{
}

const mxArray *sf_c1_GPCA_Extension_get_eml_resolved_functions_info(void)
{
  const mxArray *c1_nameCaptureInfo = NULL;
  c1_nameCaptureInfo = NULL;
  sf_mex_assign(&c1_nameCaptureInfo, sf_mex_create(NULL, "nameCaptureInfo", 0,
    0U, 1U, 2, 0, 1));
  return c1_nameCaptureInfo;
}

static void init_io_bus_offset(void)
{
  slDataTypeAccess *c1_dta;
  const char *c1_bpath;
  DTypeId c1_PumpConfigurationsStatusId;
  DTypeId c1_DrugLibraryId;
  DTypeId c1_DrugInformationId;
  DTypeId c1_InfusionParametersId;
  DTypeId c1_InfusionStatusId;
  DTypeId c1_PatientInformationId;
  c1_dta = ssGetDataTypeAccess(chartInstance.S);
  c1_bpath = ssGetPath(chartInstance.S);
  c1_PumpConfigurationsStatusId = ssGetDataTypeId(chartInstance.S,
   "PumpConfigurationsStatus");
  c1_DrugLibraryId = ssGetDataTypeId(chartInstance.S, "DrugLibrary");
  c1_DrugInformationId = ssGetDataTypeId(chartInstance.S, "DrugInformation");
  c1_InfusionParametersId = ssGetDataTypeId(chartInstance.S,
   "InfusionParameters");
  c1_InfusionStatusId = ssGetDataTypeId(chartInstance.S, "InfusionStatus");
  c1_PatientInformationId = ssGetDataTypeId(chartInstance.S,
   "PatientInformation");
  chartInstance.c1_ioBusOffset[35] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_PumpConfigurationsStatusId, 0);
  chartInstance.c1_ioBusOffset[36] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_PumpConfigurationsStatusId, 1);
  chartInstance.c1_ioBusOffset[37] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_PumpConfigurationsStatusId, 2);
  chartInstance.c1_ioBusOffset[0] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_DrugLibraryId, 0);
  chartInstance.c1_ioBusOffset[1] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_DrugLibraryId, 1);
  chartInstance.c1_ioBusOffset[2] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_DrugLibraryId, 2);
  chartInstance.c1_ioBusOffset[3] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_DrugLibraryId, 3);
  chartInstance.c1_ioBusOffset[4] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_DrugLibraryId, 4);
  chartInstance.c1_ioBusOffset[5] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_DrugLibraryId, 5);
  chartInstance.c1_ioBusOffset[6] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_DrugLibraryId, 6);
  chartInstance.c1_ioBusOffset[7] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_DrugLibraryId, 7);
  chartInstance.c1_ioBusOffset[8] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_DrugLibraryId, 8);
  chartInstance.c1_ioBusOffset[9] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_DrugLibraryId, 9);
  chartInstance.c1_ioBusOffset[10] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_DrugLibraryId, 10);
  chartInstance.c1_ioBusOffset[11] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_DrugLibraryId, 11);
  chartInstance.c1_ioBusOffset[12] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_DrugLibraryId, 12);
  chartInstance.c1_ioBusOffset[13] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_DrugLibraryId, 13);
  chartInstance.c1_ioBusOffset[14] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_DrugLibraryId, 14);
  chartInstance.c1_ioBusOffset[15] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_DrugLibraryId, 15);
  chartInstance.c1_ioBusOffset[16] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_DrugLibraryId, 16);
  chartInstance.c1_ioBusOffset[17] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_DrugLibraryId, 17);
  chartInstance.c1_ioBusOffset[18] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_DrugLibraryId, 18);
  chartInstance.c1_ioBusOffset[19] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_DrugLibraryId, 19);
  chartInstance.c1_ioBusOffset[24] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_DrugInformationId, 0);
  chartInstance.c1_ioBusOffset[25] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_DrugInformationId, 1);
  chartInstance.c1_ioBusOffset[26] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_DrugInformationId, 2);
  chartInstance.c1_ioBusOffset[27] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_DrugInformationId, 3);
  chartInstance.c1_ioBusOffset[28] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_DrugInformationId, 4);
  chartInstance.c1_ioBusOffset[29] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_DrugInformationId, 5);
  chartInstance.c1_ioBusOffset[30] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_InfusionParametersId, 0);
  chartInstance.c1_ioBusOffset[31] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_InfusionParametersId, 1);
  chartInstance.c1_ioBusOffset[32] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_InfusionStatusId, 0);
  chartInstance.c1_ioBusOffset[33] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_InfusionStatusId, 1);
  chartInstance.c1_ioBusOffset[34] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_InfusionStatusId, 2);
  chartInstance.c1_ioBusOffset[20] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_PatientInformationId, 0);
  chartInstance.c1_ioBusOffset[21] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_PatientInformationId, 1);
  chartInstance.c1_ioBusOffset[22] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_PatientInformationId, 2);
  chartInstance.c1_ioBusOffset[23] = dtaGetDataTypeElementOffset(c1_dta,
   c1_bpath, c1_PatientInformationId, 3);
}

static void *get_PumpConfigurationsStatus_element(void *c1_addr, int32_T c1_idx)
{
  return (void *)((char *)c1_addr + chartInstance.c1_ioBusOffset[c1_idx + 35]);
}

static void *get_DrugLibrary_element(void *c1_addr, int32_T c1_idx)
{
  return (void *)((char *)c1_addr + chartInstance.c1_ioBusOffset[c1_idx]);
}

static void *get_DrugInformation_element(void *c1_addr, int32_T c1_idx)
{
  return (void *)((char *)c1_addr + chartInstance.c1_ioBusOffset[c1_idx + 24]);
}

static void *get_InfusionParameters_element(void *c1_addr, int32_T c1_idx)
{
  return (void *)((char *)c1_addr + chartInstance.c1_ioBusOffset[c1_idx + 30]);
}

static void *get_InfusionStatus_element(void *c1_addr, int32_T c1_idx)
{
  return (void *)((char *)c1_addr + chartInstance.c1_ioBusOffset[c1_idx + 32]);
}

static void *get_PatientInformation_element(void *c1_addr, int32_T c1_idx)
{
  return (void *)((char *)c1_addr + chartInstance.c1_ioBusOffset[c1_idx + 20]);
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c1_GPCA_Extension_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1453731250U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(289198019U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(1699771068U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2872545887U);
}

mxArray *sf_c1_GPCA_Extension_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] =
  {"checksum","inputs","parameters","outputs"};
  mxArray *mxAutoinheritanceInfo =
  mxCreateStructMatrix(1,1,4,autoinheritanceFields);
  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(3899878108U);
    pr[1] = (double)(748102998U);
    pr[2] = (double)(12376132U);
    pr[3] = (double)(3075859838U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,7,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(13));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(14));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }
    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(13));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(15));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }
    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(13));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(16));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }
    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(13));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(23));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }
    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(13));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(20));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }
    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,6,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(13));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(21));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,6,"type",mxType);
    }
    mxSetField(mxData,6,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }
  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,mxREAL));
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,11,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(7));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }
    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }
    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }
    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }
    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }
    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,6,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(7));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,6,"type",mxType);
    }
    mxSetField(mxData,6,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,7,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(13));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(14));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,7,"type",mxType);
    }
    mxSetField(mxData,7,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,8,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(13));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(15));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,8,"type",mxType);
    }
    mxSetField(mxData,8,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,9,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(13));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(20));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,9,"type",mxType);
    }
    mxSetField(mxData,9,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,10,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(7));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,10,"type",mxType);
    }
    mxSetField(mxData,10,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }
  return(mxAutoinheritanceInfo);
}

static void sf_opaque_initialize_c1_GPCA_Extension(void *chartInstanceVar)
{
  initialize_params_c1_GPCA_Extension();
  initialize_c1_GPCA_Extension();
}

static void sf_opaque_enable_c1_GPCA_Extension(void *chartInstanceVar)
{
  enable_c1_GPCA_Extension();
}

static void sf_opaque_disable_c1_GPCA_Extension(void *chartInstanceVar)
{
  disable_c1_GPCA_Extension();
}

static void sf_opaque_gateway_c1_GPCA_Extension(void *chartInstanceVar)
{
  sf_c1_GPCA_Extension();
}

static void sf_opaque_terminate_c1_GPCA_Extension(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) ||
   sim_mode_is_external(chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }
  finalize_c1_GPCA_Extension();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c1_GPCA_Extension(SimStruct *S)
{
  int i;
  for(i=0;i<ssGetNumRunTimeParams(S);i++) {
    if(ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }
  if(sf_machine_global_initializer_called()) {
    initialize_params_c1_GPCA_Extension();
  }
}

static void mdlSetWorkWidths_c1_GPCA_Extension(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("GPCA_Extension",1);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("GPCA_Extension",1,"gatewayCannotBeInlinedMultipleTimes"));
    if(chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 5, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 6, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"GPCA_Extension",1,7);
      sf_mark_chart_reusable_outputs(S,"GPCA_Extension",1,11);
    }
    ssSetInputPortOptimOpts(S, 7, SS_REUSABLE_AND_LOCAL);
    sf_set_rtw_dwork_info(S,"GPCA_Extension",1);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(2269907395U));
  ssSetChecksum1(S,(1555322328U));
  ssSetChecksum2(S,(807148889U));
  ssSetChecksum3(S,(4075407077U));

  ssSetmdlDerivatives(S, NULL);

  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c1_GPCA_Extension(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "GPCA_Extension", 1);
    ssWriteRTWStrParam(S, "StateflowChartType", "Stateflow");
  }
}

static void mdlStart_c1_GPCA_Extension(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 0;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c1_GPCA_Extension;
  chartInstance.chartInfo.initializeChart =
    sf_opaque_initialize_c1_GPCA_Extension;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c1_GPCA_Extension;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c1_GPCA_Extension;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c1_GPCA_Extension;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c1_GPCA_Extension;
  chartInstance.chartInfo.mdlStart = mdlStart_c1_GPCA_Extension;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c1_GPCA_Extension;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo))); /* register the chart instance with simstruct */

  if(!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }
  init_io_bus_offset();
}

void c1_GPCA_Extension_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c1_GPCA_Extension(S);
    break;
   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c1_GPCA_Extension(S);
    break;
   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c1_GPCA_Extension(S);
    break;
   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
     "Error calling c1_GPCA_Extension_method_dispatcher.\n"
     "Can't handle method %d.\n", method);
    break;
  }
}

