/* Include files */
#include "StateChanger2_mod_sfun.h"
#include "c1_StateChanger2_mod.h"

/* Type Definitions */

/* Named Constants */
#define c1_event_E_Clock                (0U)
#define c1_event_E_Alarm                (25U)
#define c1_event_E_Warning              (5U)
#define c1_event_E_Ready                (1U)
#define c1_event_E_NotReady             (16U)
#define c1_event_E_StartSimulation      (17U)
#define c1_event_E_PowerButton          (13U)
#define c1_event_E_NewInfusion          (7U)
#define c1_event_E_CheckAdminSet        (3U)
#define c1_event_E_Prime                (6U)
#define c1_event_E_CheckDrug            (15U)
#define c1_event_E_ConfigureInfusionProgram (14U)
#define c1_event_E_ConfirmConcentration (26U)
#define c1_event_E_ConfirmDoseRate      (18U)
#define c1_event_E_ConfirmVTBI          (28U)
#define c1_event_E_StartInfusion        (29U)
#define c1_event_E_ChangeDoseRate       (9U)
#define c1_event_E_ChangeVTBI           (10U)
#define c1_event_E_PauseInfusion        (22U)
#define c1_event_E_ConfirmPauseInfusion (8U)
#define c1_event_E_StopInfusion         (20U)
#define c1_event_E_ConfirmStopInfusion  (2U)
#define c1_event_E_RequestBolus         (27U)
#define c1_event_E_ClearAlarm           (21U)
#define c1_event_E_ConfirmPowerDown     (12U)
#define c1_event_E_Cancel               (4U)
#define c1_IN_NO_ACTIVE_CHILD           (0)
#define c1_IN_ALM_VTBIOutBound          (2)
#define c1_IN_DisplayDoseRate           (7)
#define c1_IN_ConfirmPowerDown          (4)
#define c1_IN_PowerOff                  (10)
#define c1_IN_POST                      (8)
#define c1_IN_ALM_POSTFailed            (1)
#define c1_IN_CheckAdminSet             (2)
#define c1_IN_CheckPrime                (4)
#define c1_IN_ALM_WrongAdminCheck       (1)
#define c1_IN_PrimeFailed               (10)
#define c1_IN_DisplayDrugInfo           (7)
#define c1_IN_CheckDrug_CheckType       (3)
#define c1_IN_UnknownDrug               (11)
#define c1_IN_Check_DoseUnit            (6)
#define c1_IN_IncorrectDoseUnit         (9)
#define c1_IN_Check_Concen              (5)
#define c1_IN_WrongConcentration        (13)
#define c1_IN_WRN_DangerCon             (12)
#define c1_IN_DisplayPatientProfile     (8)
#define c1_IN_DisplayVTBI               (9)
#define c1_IN_ChangeVTBI                (4)
#define c1_IN_CheckVTBI                 (6)
#define c1_IN_ChangeDoseRate            (3)
#define c1_IN_CheckDoseRate             (5)
#define c1_IN_ALM_DoseRateOutBound      (1)
#define c1_IN_DisplaySettings           (8)
#define c1_IN_Infusing                  (7)
#define c1_IN_InfusionInSession         (5)
#define c1_IN_ChangeRate                (3)
#define c1_IN_CheckNewRate              (4)
#define c1_IN_ALM_NewRateOutBound       (1)
#define c1_IN_ConfirmStop               (6)
#define c1_IN_ConfirmPause              (5)
#define c1_IN_InfusionPaused            (4)
#define c1_IN_ReadyToStart              (10)
#define c1_IN_PausedStopConfirm         (8)
#define c1_IN_InfusionStopped           (5)
#define c1_IN_EmptyReservoir            (3)
#define c1_IN_CheckDrugWhileInfusing    (2)
#define c1_IN_ALMWrongDrug              (1)
#define c1_IN_Init                      (6)
#define c1_IN_LevelTwoAlarming          (7)
#define c1_IN_InfusionSubMachine        (6)
#define c1_IN_POSTDONE                  (9)
#define c1_IN_WRN_VTBIOutBound          (12)
#define c1_IN_LEVELONEALRM              (7)
#define c1_IN_BolusRequest              (2)
#define c1_IN_WRN_DOSERATEOUTSOFTLIMITS (11)
#define c1_IN_PausedTooLong             (9)
#define c1_IN_CheckDrugRoutine          (2)
#define c1_IN_ConfigureInfusionProgram  (3)
#define c1_IN_InfusionStateMachine      (1)
#define c1_const_MSG_WELCOME            (1U)
#define c1_const_MSG_POWEROFF           (2U)
#define c1_const_MSG_POST               (3U)
#define c1_const_MSG_POSTFAIL           (4U)
#define c1_const_MSG_ADMINCHECK         (5U)
#define c1_const_MSG_ADMINFAIL          (6U)
#define c1_const_MSG_PRIME              (7U)
#define c1_const_MSG_PRIMEFAIL          (8U)
#define c1_const_MSG_CHECKTYPE          (9U)
#define c1_const_MSG_WRONGDRUG          (10U)
#define c1_const_MSG_CHECKDU            (11U)
#define c1_const_MSG_WRONGDU            (12U)
#define c1_const_MSG_CHECKCON           (13U)
#define c1_const_MSG_WRONGCON           (14U)
#define c1_const_MSG_DANGECON           (15U)
#define c1_const_MSG_PATIENTINFO        (16U)
#define c1_const_MSG_CHANGEVTBI         (18U)
#define c1_const_MSG_VTBI               (17U)
#define c1_const_MSG_CHECKVTBI          (19U)
#define c1_const_MSG_ALMVTBI            (20U)
#define c1_const_MSG_DISPLAYDR          (21U)
#define c1_const_MSG_CHECKDR            (22U)
#define c1_const_MSG_CHANGEDR           (23U)
#define c1_const_MSG_DISPLAYSET         (24U)
#define c1_const_MSG_ALRMDR             (25U)
#define c1_const_MSG_INFUSING           (26U)
#define c1_const_MSG_DANGERENVTEMP      (23U)
#define c1_const_MSG_DANGERHUMD         (24U)
#define c1_const_MSG_DANGERAP           (25U)
#define c1_const_MSG_POSTDONE           (27U)
#define c1_const_MSG_DRUGINFO           (28U)
#define c1_const_MSG_BOLUSGRANT         (26U)
#define c1_const_MSG_BOLUSDENIED        (27U)
#define c1_const_MSG_STOPBOLUS          (28U)
#define c1_const_MSG_EMPTYRESERVOIR     (1U)
#define c1_const_MSG_DOOROPEN           (3U)
#define c1_const_MSG_AIRINLINE          (4U)
#define c1_const_MSG_OCCULUSION         (5U)
#define c1_const_MSG_TOOLONGPAUSE       (6U)
#define c1_const_MSG_FLOWRATEVARY       (7U)
#define c1_const_MSG_OVERINFUSION       (8U)
#define c1_const_MSG_UNDERINFUSION      (9U)
#define c1_const_MSG_LESSTHANKVO        (10U)
#define c1_const_MSG_RATEEXCEEDCAPACITY (11U)
#define c1_const_MSG_TEMPOUTRANGE       (12U)
#define c1_const_MSG_REALTIMECLOCK      (13U)
#define c1_const_MSG_WATCHDOGCORRUPT    (14U)
#define c1_const_MSG_WATCHDOGALERT      (15U)
#define c1_const_MSG_OUTOFPOWER         (16U)
#define c1_const_MSG_MEMORYCORRUPT      (17U)
#define c1_const_MSG_CPUFAILURE         (18U)
#define c1_const_MSG_INFUSIONSTOP       (29U)
#define c1_const_MSG_SPCHOOSE           (30U)
#define c1_const_MSG_INFUSIONPAUSED     (31U)
#define c1_const_MSG_CONFIRMPAUSE       (32U)
#define c1_const_MSG_CONFIRMSTOP        (33U)
#define c1_const_MSG_STOPPAUSE          (34U)
#define c1_const_MSG_LOGERR             (19U)
#define c1_const_MSG_LOWBATT            (20U)
#define c1_const_MSG_LOWRESR            (21U)
#define c1_const_MSG_DANGERTEMP         (22U)
#define c1_const_MSG_WRNDR              (35U)
#define c1_const_MSG_WRNVTBI            (36U)
#define c1_const_MSG_NOTREADY           (29U)
#define c1_const_MSG_BLANK              (33U)
#define c1_const_MSG_WRNBATTERYFUNCTION (31U)
#define c1_const_MSG_VOLTOUTRANGE       (32U)

/* Variable Declarations */

/* Variable Definitions */
static SFc1_StateChanger2_modInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c1_StateChanger2_mod(void);
static void initialize_params_c1_StateChanger2_mod(void);
static void enable_c1_StateChanger2_mod(void);
static void disable_c1_StateChanger2_mod(void);
static void finalize_c1_StateChanger2_mod(void);
static void sf_c1_StateChanger2_mod(void);
static void c1_DisplayDoseRate(void);
static void c1_PowerOff(void);
static void c1_PrimeFailed(void);
static void c1_UnknownDrug(void);
static void c1_WrongConcentration(void);
static void c1_WRN_DangerCon(void);
static void c1_DisplayPatientProfile(void);
static uint32_T c1_drugTypeMismatch(void);
static void c1_DisplayVTBI(void);
static uint32_T c1_warning(void);
static void c1_DisplaySettings(void);
static void c1_Infusing(void);
static void c1_enter_internal_InfusionInSession(void);
static void c1_InfusionInSession(void);
static void c1_exit_internal_InfusionInSession(void);
static void c1_ConfirmStop(void);
static void c1_ReadyToStart(void);
static void c1_PausedStopConfirm(void);
static void c1_enter_atomic_LevelTwoAlarming(void);
static void c1_LevelTwoAlarming(void);
static uint32_T c1_setLOneMsg(uint32_T c1_fcond);
static uint32_T c1_alrmLevel(void);
static void c1_InfusionSubMachine(void);
static void c1_exit_internal_InfusionSubMachine(void);
static void c1_WRN_VTBIOutBound(void);
static uint32_T c1_CheckDrug(void);
static uint32_T c1_checkAdminSet(void);
static void c1_PausedTooLong(void);
static void c1_CheckDrugRoutine(void);
static void c1_exit_internal_CheckDrugRoutine(void);
static void c1_enter_internal_ConfigureInfusionProgram(void);
static void c1_ConfigureInfusionProgram(void);
static void c1_exit_internal_ConfigureInfusionProgram(void);
static void c1_InfusionStateMachine(void);
static void c1_broadcast_E_Clock(void);
static void c1_broadcast_E_Alarm(void);
static void c1_broadcast_E_Warning(void);
static void c1_broadcast_E_Ready(void);
static void c1_broadcast_E_NotReady(void);
static void c1_broadcast_E_StartSimulation(void);
static void c1_broadcast_E_PowerButton(void);
static void c1_broadcast_E_NewInfusion(void);
static void c1_broadcast_E_CheckAdminSet(void);
static void c1_broadcast_E_Prime(void);
static void c1_broadcast_E_CheckDrug(void);
static void c1_broadcast_E_ConfigureInfusionProgram(void);
static void c1_broadcast_E_ConfirmConcentration(void);
static void c1_broadcast_E_ConfirmDoseRate(void);
static void c1_broadcast_E_ConfirmVTBI(void);
static void c1_broadcast_E_StartInfusion(void);
static void c1_broadcast_E_ChangeDoseRate(void);
static void c1_broadcast_E_ChangeVTBI(void);
static void c1_broadcast_E_PauseInfusion(void);
static void init_script_number_translation(uint32_T c1_machineNumber, uint32_T
 c1_chartNumber);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c1_StateChanger2_mod(void)
{
  uint32_T *c1_ClearCond;
  uint32_T *c1_infusing;
  real_T *c1_flowRate;
  uint32_T *c1_bolusing;
  uint32_T *c1_infusionPaused;
  real_T *c1_O_ProgrammedVTBI;
  boolean_T *c1_O_BolusRequest;
  real_T *c1_CurrentState;
  real_T *c1_O_VTBIUH;
  real_T *c1_O_VTBIUS;
  real_T *c1_O_VTBITypical;
  real_T *c1_O_VTBILS;
  real_T *c1_O_VTBILH;
  real_T *c1_O_VTBIUnit;
  real_T *c1_O_DRTypical;
  real_T *c1_O_DRUH;
  real_T *c1_O_DRUS;
  real_T *c1_O_DRLS;
  real_T *c1_O_DRLH;
  real_T *c1_O_CurrentVTBI;
  real_T *c1_O_RemainVolume;
  uint32_T *c1_O_PatientID;
  uint32_T *c1_O_PatientAge;
  uint32_T *c1_O_PatientGender;
  uint32_T *c1_O_PatientWeight;
  uint32_T *c1_O_DrugID;
  real_T *c1_O_DrugConc;
  real_T *c1_O_DrugDoseUnit;
  real_T *c1_O_DrugAmount;
  real_T *c1_O_DrugDilVolume;
  boolean_T *c1_E_Restart;
  boolean_T *c1_E_AlarmClear;
  boolean_T *c1_E_RequestToStart;
  boolean_T *c1_E_InfusionPaused;
  boolean_T *c1_E_InfusionStopped;
  c1_E_AlarmClear = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 32);
  c1_E_InfusionStopped = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 35);
  c1_E_Restart = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 31);
  c1_E_RequestToStart = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 33);
  c1_E_InfusionPaused = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 34);
  c1_infusing = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 2);
  c1_O_BolusRequest = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 7);
  c1_O_PatientAge = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 23);
  c1_O_DRTypical = (real_T *)ssGetOutputPortSignal(chartInstance.S, 15);
  c1_O_PatientWeight = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 25);
  c1_O_DrugID = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 26);
  c1_infusionPaused = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 5);
  c1_O_ProgrammedVTBI = (real_T *)ssGetOutputPortSignal(chartInstance.S, 6);
  c1_O_VTBILS = (real_T *)ssGetOutputPortSignal(chartInstance.S, 12);
  c1_O_VTBITypical = (real_T *)ssGetOutputPortSignal(chartInstance.S, 11);
  c1_O_PatientID = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 22);
  c1_O_DrugDilVolume = (real_T *)ssGetOutputPortSignal(chartInstance.S, 30);
  c1_ClearCond = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  c1_O_VTBIUS = (real_T *)ssGetOutputPortSignal(chartInstance.S, 10);
  c1_O_CurrentVTBI = (real_T *)ssGetOutputPortSignal(chartInstance.S, 20);
  c1_O_DrugDoseUnit = (real_T *)ssGetOutputPortSignal(chartInstance.S, 28);
  c1_CurrentState = (real_T *)ssGetOutputPortSignal(chartInstance.S, 8);
  c1_O_DRUS = (real_T *)ssGetOutputPortSignal(chartInstance.S, 17);
  c1_O_VTBILH = (real_T *)ssGetOutputPortSignal(chartInstance.S, 13);
  c1_O_PatientGender = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 24);
  c1_bolusing = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 4);
  c1_O_DrugConc = (real_T *)ssGetOutputPortSignal(chartInstance.S, 27);
  c1_O_DRUH = (real_T *)ssGetOutputPortSignal(chartInstance.S, 16);
  c1_O_DRLH = (real_T *)ssGetOutputPortSignal(chartInstance.S, 19);
  c1_O_RemainVolume = (real_T *)ssGetOutputPortSignal(chartInstance.S, 21);
  c1_O_VTBIUH = (real_T *)ssGetOutputPortSignal(chartInstance.S, 9);
  c1_flowRate = (real_T *)ssGetOutputPortSignal(chartInstance.S, 3);
  c1_O_DrugAmount = (real_T *)ssGetOutputPortSignal(chartInstance.S, 29);
  c1_O_VTBIUnit = (real_T *)ssGetOutputPortSignal(chartInstance.S, 14);
  c1_O_DRLS = (real_T *)ssGetOutputPortSignal(chartInstance.S, 18);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c1_is_InfusionStateMachine = 0U;
  chartInstance.c1_is_CheckDrugRoutine = 0U;
  chartInstance.c1_was_CheckDrugRoutine = 0U;
  chartInstance.c1_is_ConfigureInfusionProgram = 0U;
  chartInstance.c1_was_ConfigureInfusionProgram = 0U;
  chartInstance.c1_is_InfusionInSession = 0U;
  chartInstance.c1_was_InfusionInSession = 0U;
  chartInstance.c1_is_InfusionSubMachine = 0U;
  chartInstance.c1_is_active_c1_StateChanger2_mod = 0U;
  chartInstance.c1_is_c1_StateChanger2_mod = 0U;
  chartInstance.c1_temp = 0.0;
  chartInstance.c1_MSG_WRNBATTERYCHARGE = 30U;
  chartInstance.c1_tempx = 0U;
  chartInstance.c1_MSG_WELCOME = 1U;
  chartInstance.c1_MSG_POWEROFF = 2U;
  chartInstance.c1_MSG_POST = 3U;
  chartInstance.c1_MSG_POSTFAIL = 4U;
  chartInstance.c1_MSG_ADMINCHECK = 5U;
  chartInstance.c1_MSG_ADMINFAIL = 6U;
  chartInstance.c1_MSG_PRIME = 7U;
  chartInstance.c1_MSG_PRIMEFAIL = 8U;
  chartInstance.c1_MSG_CHECKTYPE = 9U;
  chartInstance.c1_MSG_WRONGDRUG = 10U;
  chartInstance.c1_MSG_CHECKDU = 11U;
  chartInstance.c1_MSG_WRONGDU = 12U;
  chartInstance.c1_MSG_CHECKCON = 13U;
  chartInstance.c1_MSG_WRONGCON = 14U;
  chartInstance.c1_MSG_DANGECON = 15U;
  chartInstance.c1_MSG_PATIENTINFO = 16U;
  chartInstance.c1_MSG_CHANGEVTBI = 18U;
  chartInstance.c1_MSG_VTBI = 17U;
  chartInstance.c1_MSG_CHECKVTBI = 19U;
  chartInstance.c1_MSG_ALMVTBI = 20U;
  chartInstance.c1_MSG_DISPLAYDR = 21U;
  chartInstance.c1_MSG_CHECKDR = 22U;
  chartInstance.c1_MSG_CHANGEDR = 23U;
  chartInstance.c1_MSG_DISPLAYSET = 24U;
  chartInstance.c1_MSG_ALRMDR = 25U;
  chartInstance.c1_MSG_INFUSING = 26U;
  chartInstance.c1_MSG_DANGERENVTEMP = 23U;
  chartInstance.c1_MSG_DANGERHUMD = 24U;
  chartInstance.c1_MSG_DANGERAP = 25U;
  chartInstance.c1_MSG_POSTDONE = 27U;
  chartInstance.c1_MSG_DRUGINFO = 28U;
  chartInstance.c1_MSG_BOLUSGRANT = 26U;
  chartInstance.c1_MSG_BOLUSDENIED = 27U;
  chartInstance.c1_MSG_STOPBOLUS = 28U;
  chartInstance.c1_MSG_EMPTYRESERVOIR = 1U;
  chartInstance.c1_MSG_DOOROPEN = 3U;
  chartInstance.c1_MSG_AIRINLINE = 4U;
  chartInstance.c1_MSG_OCCULUSION = 5U;
  chartInstance.c1_MSG_TOOLONGPAUSE = 6U;
  chartInstance.c1_MSG_FLOWRATEVARY = 7U;
  chartInstance.c1_MSG_OVERINFUSION = 8U;
  chartInstance.c1_MSG_UNDERINFUSION = 9U;
  chartInstance.c1_MSG_LESSTHANKVO = 10U;
  chartInstance.c1_MSG_RATEEXCEEDCAPACITY = 11U;
  chartInstance.c1_MSG_TEMPOUTRANGE = 12U;
  chartInstance.c1_MSG_REALTIMECLOCK = 13U;
  chartInstance.c1_MSG_WATCHDOGCORRUPT = 14U;
  chartInstance.c1_MSG_WATCHDOGALERT = 15U;
  chartInstance.c1_MSG_OUTOFPOWER = 16U;
  chartInstance.c1_MSG_MEMORYCORRUPT = 17U;
  chartInstance.c1_MSG_CPUFAILURE = 18U;
  chartInstance.c1_MSG_INFUSIONSTOP = 29U;
  chartInstance.c1_MSG_SPCHOOSE = 30U;
  chartInstance.c1_MSG_INFUSIONPAUSED = 31U;
  chartInstance.c1_MSG_CONFIRMPAUSE = 32U;
  chartInstance.c1_MSG_CONFIRMSTOP = 33U;
  chartInstance.c1_MSG_STOPPAUSE = 34U;
  chartInstance.c1_MSG_LOGERR = 19U;
  chartInstance.c1_MSG_LOWBATT = 20U;
  chartInstance.c1_MSG_LOWRESR = 21U;
  chartInstance.c1_MSG_DANGERTEMP = 22U;
  chartInstance.c1_MSG_WRNDR = 35U;
  chartInstance.c1_MSG_WRNVTBI = 36U;
  chartInstance.c1_MSG_NOTREADY = 29U;
  chartInstance.c1_MSG_BLANK = 33U;
  chartInstance.c1_MSG_WRNBATTERYFUNCTION = 31U;
  chartInstance.c1_MSG_VOLTOUTRANGE = 32U;
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 1) != 0)) {
    *c1_ClearCond = 0U;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 2) != 0)) {
    *c1_infusing = 0U;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 3) != 0)) {
    *c1_flowRate = 0.0;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 4) != 0)) {
    *c1_bolusing = 0U;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 5) != 0)) {
    *c1_infusionPaused = 0U;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 6) != 0)) {
    *c1_O_ProgrammedVTBI = 0.0;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 7) != 0)) {
    *c1_O_BolusRequest = 0U;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 8) != 0)) {
    *c1_CurrentState = 0.0;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 9) != 0)) {
    *c1_O_VTBIUH = 0.0;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 10) != 0)) {
    *c1_O_VTBIUS = 0.0;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 11) != 0)) {
    *c1_O_VTBITypical = 0.0;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 12) != 0)) {
    *c1_O_VTBILS = 0.0;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 13) != 0)) {
    *c1_O_VTBILH = 0.0;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 14) != 0)) {
    *c1_O_VTBIUnit = 0.0;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 15) != 0)) {
    *c1_O_DRTypical = 0.0;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 16) != 0)) {
    *c1_O_DRUH = 0.0;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 17) != 0)) {
    *c1_O_DRUS = 0.0;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 18) != 0)) {
    *c1_O_DRLS = 0.0;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 19) != 0)) {
    *c1_O_DRLH = 0.0;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 20) != 0)) {
    *c1_O_CurrentVTBI = 0.0;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 21) != 0)) {
    *c1_O_RemainVolume = 0.0;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 22) != 0)) {
    *c1_O_PatientID = 0U;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 23) != 0)) {
    *c1_O_PatientAge = 0U;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 24) != 0)) {
    *c1_O_PatientGender = 0U;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 25) != 0)) {
    *c1_O_PatientWeight = 0U;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 26) != 0)) {
    *c1_O_DrugID = 0U;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 27) != 0)) {
    *c1_O_DrugConc = 0.0;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 28) != 0)) {
    *c1_O_DrugDoseUnit = 0.0;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 29) != 0)) {
    *c1_O_DrugAmount = 0.0;
  }
  if(!((boolean_T)cdrGetOutputPortReusable(chartInstance.S, 30) != 0)) {
    *c1_O_DrugDilVolume = 0.0;
  }
  chartInstance.c1_E_RestartEventCounter = 0U;
  *c1_E_Restart = false;
  chartInstance.c1_E_AlarmClearEventCounter = 0U;
  *c1_E_AlarmClear = false;
  chartInstance.c1_E_RequestToStartEventCounter = 0U;
  *c1_E_RequestToStart = false;
  chartInstance.c1_E_InfusionPausedEventCounter = 0U;
  *c1_E_InfusionPaused = false;
  chartInstance.c1_E_InfusionStoppedEventCounter = 0U;
  *c1_E_InfusionStopped = false;
}

static void initialize_params_c1_StateChanger2_mod(void)
{
}

static void enable_c1_StateChanger2_mod(void)
{
}

static void disable_c1_StateChanger2_mod(void)
{
}

static void finalize_c1_StateChanger2_mod(void)
{
}

static void sf_c1_StateChanger2_mod(void)
{
  int32_T c1_inputEventFiredFlag;
  uint8_T c1_previousEvent;
  int8_T *c1_E_Clock;
  int8_T *c1_E_Alarm;
  int8_T *c1_E_Warning;
  int8_T *c1_E_Ready;
  int8_T *c1_E_NotReady;
  int8_T *c1_E_StartSimulation;
  int8_T *c1_E_PowerButton;
  int8_T *c1_E_NewInfusion;
  int8_T *c1_E_CheckAdminSet;
  int8_T *c1_E_Prime;
  int8_T *c1_E_CheckDrug;
  int8_T *c1_E_ConfigureInfusionProgram;
  int8_T *c1_E_ConfirmConcentration;
  int8_T *c1_E_ConfirmDoseRate;
  int8_T *c1_E_ConfirmVTBI;
  int8_T *c1_E_StartInfusion;
  int8_T *c1_E_ChangeDoseRate;
  int8_T *c1_E_ChangeVTBI;
  int8_T *c1_E_PauseInfusion;
  int8_T *c1_E_ConfirmPauseInfusion;
  int8_T *c1_E_StopInfusion;
  int8_T *c1_E_ConfirmStopInfusion;
  int8_T *c1_E_RequestBolus;
  int8_T *c1_E_ClearAlarm;
  int8_T *c1_E_ConfirmPowerDown;
  int8_T *c1_E_Cancel;
  boolean_T *c1_E_Restart;
  boolean_T *c1_E_AlarmClear;
  boolean_T *c1_E_RequestToStart;
  boolean_T *c1_E_InfusionPaused;
  boolean_T *c1_E_InfusionStopped;
  c1_E_PowerButton = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 38) +
   6);
  c1_E_ConfirmVTBI = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 38) +
   14);
  c1_E_Ready = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 38) + 3);
  c1_E_StartSimulation = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S,
    38) + 5);
  c1_E_CheckAdminSet = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 38)
   + 8);
  c1_E_PauseInfusion = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 38)
   + 18);
  c1_E_ConfirmPowerDown = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S,
    38) + 24);
  c1_E_Prime = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 38) + 9);
  c1_E_ConfirmConcentration = (int8_T
    *)*(ssGetInputPortSignalPtrs(chartInstance.S, 38) + 12);
  c1_E_AlarmClear = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 32);
  c1_E_Alarm = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 38) + 1);
  c1_E_NotReady = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 38) + 4);
  c1_E_CheckDrug = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 38) +
   10);
  c1_E_ConfirmDoseRate = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S,
    38) + 13);
  c1_E_ConfirmStopInfusion = (int8_T
    *)*(ssGetInputPortSignalPtrs(chartInstance.S, 38) + 21);
  c1_E_Warning = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 38) + 2);
  c1_E_ConfigureInfusionProgram = (int8_T
    *)*(ssGetInputPortSignalPtrs(chartInstance.S, 38) + 11);
  c1_E_StopInfusion = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 38)
   + 20);
  c1_E_Clock = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 38) + 0);
  c1_E_RequestBolus = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 38)
   + 22);
  c1_E_ClearAlarm = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 38) +
   23);
  c1_E_Cancel = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 38) + 25);
  c1_E_InfusionStopped = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 35);
  c1_E_ChangeVTBI = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 38) +
   17);
  c1_E_StartInfusion = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 38)
   + 15);
  c1_E_ConfirmPauseInfusion = (int8_T
    *)*(ssGetInputPortSignalPtrs(chartInstance.S, 38) + 19);
  c1_E_NewInfusion = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S, 38) +
   7);
  c1_E_Restart = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 31);
  c1_E_RequestToStart = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 33);
  c1_E_InfusionPaused = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 34);
  c1_E_ChangeDoseRate = (int8_T *)*(ssGetInputPortSignalPtrs(chartInstance.S,
    38) + 16);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  c1_inputEventFiredFlag = 0;
  if(*c1_E_Clock != 0) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_Clock();
  }
  if(*c1_E_Alarm == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_Alarm();
  }
  if(*c1_E_Warning == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_Warning();
  }
  if(*c1_E_Ready == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_Ready();
  }
  if(*c1_E_NotReady == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_NotReady();
  }
  if(*c1_E_StartSimulation == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_StartSimulation();
  }
  if(*c1_E_PowerButton == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_PowerButton();
  }
  if(*c1_E_NewInfusion == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_NewInfusion();
  }
  if(*c1_E_CheckAdminSet == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_CheckAdminSet();
  }
  if(*c1_E_Prime == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_Prime();
  }
  if(*c1_E_CheckDrug == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_CheckDrug();
  }
  if(*c1_E_ConfigureInfusionProgram == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_ConfigureInfusionProgram();
  }
  if(*c1_E_ConfirmConcentration == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_ConfirmConcentration();
  }
  if(*c1_E_ConfirmDoseRate == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_ConfirmDoseRate();
  }
  if(*c1_E_ConfirmVTBI == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_ConfirmVTBI();
  }
  if(*c1_E_StartInfusion == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_StartInfusion();
  }
  if(*c1_E_ChangeDoseRate == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_ChangeDoseRate();
  }
  if(*c1_E_ChangeVTBI == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_ChangeVTBI();
  }
  if(*c1_E_PauseInfusion == 1) {
    c1_inputEventFiredFlag = 1;
    c1_broadcast_E_PauseInfusion();
  }
  if(*c1_E_ConfirmPauseInfusion == 1) {
    c1_inputEventFiredFlag = 1;
    c1_previousEvent = _sfEvent_;
    _sfEvent_ = c1_event_E_ConfirmPauseInfusion;
    if(_sfEvent_ == c1_event_E_Clock) {
      if(chartInstance.c1_temporalCounter_i1 < 10) {
        chartInstance.c1_temporalCounter_i1 =
          (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
      } else {
        chartInstance.c1_temporalCounter_i1 = 1U;
      }
    }
    if(chartInstance.c1_is_active_c1_StateChanger2_mod == 0) {
      chartInstance.c1_is_active_c1_StateChanger2_mod = 1U;
      chartInstance.c1_is_c1_StateChanger2_mod =
        (uint8_T)c1_IN_InfusionStateMachine;
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
    } else {
      c1_InfusionStateMachine();
    }
    if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1
      == 10)) {
      chartInstance.c1_temporalCounter_i1 = 0U;
    }
    _sfEvent_ = c1_previousEvent;
  }
  if(*c1_E_StopInfusion == 1) {
    c1_inputEventFiredFlag = 1;
    c1_previousEvent = _sfEvent_;
    _sfEvent_ = c1_event_E_StopInfusion;
    if(_sfEvent_ == c1_event_E_Clock) {
      if(chartInstance.c1_temporalCounter_i1 < 10) {
        chartInstance.c1_temporalCounter_i1 =
          (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
      } else {
        chartInstance.c1_temporalCounter_i1 = 1U;
      }
    }
    if(chartInstance.c1_is_active_c1_StateChanger2_mod == 0) {
      chartInstance.c1_is_active_c1_StateChanger2_mod = 1U;
      chartInstance.c1_is_c1_StateChanger2_mod =
        (uint8_T)c1_IN_InfusionStateMachine;
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
    } else {
      c1_InfusionStateMachine();
    }
    if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1
      == 10)) {
      chartInstance.c1_temporalCounter_i1 = 0U;
    }
    _sfEvent_ = c1_previousEvent;
  }
  if(*c1_E_ConfirmStopInfusion == 1) {
    c1_inputEventFiredFlag = 1;
    c1_previousEvent = _sfEvent_;
    _sfEvent_ = c1_event_E_ConfirmStopInfusion;
    if(_sfEvent_ == c1_event_E_Clock) {
      if(chartInstance.c1_temporalCounter_i1 < 10) {
        chartInstance.c1_temporalCounter_i1 =
          (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
      } else {
        chartInstance.c1_temporalCounter_i1 = 1U;
      }
    }
    if(chartInstance.c1_is_active_c1_StateChanger2_mod == 0) {
      chartInstance.c1_is_active_c1_StateChanger2_mod = 1U;
      chartInstance.c1_is_c1_StateChanger2_mod =
        (uint8_T)c1_IN_InfusionStateMachine;
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
    } else {
      c1_InfusionStateMachine();
    }
    if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1
      == 10)) {
      chartInstance.c1_temporalCounter_i1 = 0U;
    }
    _sfEvent_ = c1_previousEvent;
  }
  if(*c1_E_RequestBolus == 1) {
    c1_inputEventFiredFlag = 1;
    c1_previousEvent = _sfEvent_;
    _sfEvent_ = c1_event_E_RequestBolus;
    if(_sfEvent_ == c1_event_E_Clock) {
      if(chartInstance.c1_temporalCounter_i1 < 10) {
        chartInstance.c1_temporalCounter_i1 =
          (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
      } else {
        chartInstance.c1_temporalCounter_i1 = 1U;
      }
    }
    if(chartInstance.c1_is_active_c1_StateChanger2_mod == 0) {
      chartInstance.c1_is_active_c1_StateChanger2_mod = 1U;
      chartInstance.c1_is_c1_StateChanger2_mod =
        (uint8_T)c1_IN_InfusionStateMachine;
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
    } else {
      c1_InfusionStateMachine();
    }
    if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1
      == 10)) {
      chartInstance.c1_temporalCounter_i1 = 0U;
    }
    _sfEvent_ = c1_previousEvent;
  }
  if(*c1_E_ClearAlarm == 1) {
    c1_inputEventFiredFlag = 1;
    c1_previousEvent = _sfEvent_;
    _sfEvent_ = c1_event_E_ClearAlarm;
    if(_sfEvent_ == c1_event_E_Clock) {
      if(chartInstance.c1_temporalCounter_i1 < 10) {
        chartInstance.c1_temporalCounter_i1 =
          (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
      } else {
        chartInstance.c1_temporalCounter_i1 = 1U;
      }
    }
    if(chartInstance.c1_is_active_c1_StateChanger2_mod == 0) {
      chartInstance.c1_is_active_c1_StateChanger2_mod = 1U;
      chartInstance.c1_is_c1_StateChanger2_mod =
        (uint8_T)c1_IN_InfusionStateMachine;
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
    } else {
      c1_InfusionStateMachine();
    }
    if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1
      == 10)) {
      chartInstance.c1_temporalCounter_i1 = 0U;
    }
    _sfEvent_ = c1_previousEvent;
  }
  if(*c1_E_ConfirmPowerDown == 1) {
    c1_inputEventFiredFlag = 1;
    c1_previousEvent = _sfEvent_;
    _sfEvent_ = c1_event_E_ConfirmPowerDown;
    if(_sfEvent_ == c1_event_E_Clock) {
      if(chartInstance.c1_temporalCounter_i1 < 10) {
        chartInstance.c1_temporalCounter_i1 =
          (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
      } else {
        chartInstance.c1_temporalCounter_i1 = 1U;
      }
    }
    if(chartInstance.c1_is_active_c1_StateChanger2_mod == 0) {
      chartInstance.c1_is_active_c1_StateChanger2_mod = 1U;
      chartInstance.c1_is_c1_StateChanger2_mod =
        (uint8_T)c1_IN_InfusionStateMachine;
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
    } else {
      c1_InfusionStateMachine();
    }
    if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1
      == 10)) {
      chartInstance.c1_temporalCounter_i1 = 0U;
    }
    _sfEvent_ = c1_previousEvent;
  }
  if(*c1_E_Cancel == 1) {
    c1_inputEventFiredFlag = 1;
    c1_previousEvent = _sfEvent_;
    _sfEvent_ = c1_event_E_Cancel;
    if(_sfEvent_ == c1_event_E_Clock) {
      if(chartInstance.c1_temporalCounter_i1 < 10) {
        chartInstance.c1_temporalCounter_i1 =
          (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
      } else {
        chartInstance.c1_temporalCounter_i1 = 1U;
      }
    }
    if(chartInstance.c1_is_active_c1_StateChanger2_mod == 0) {
      chartInstance.c1_is_active_c1_StateChanger2_mod = 1U;
      chartInstance.c1_is_c1_StateChanger2_mod =
        (uint8_T)c1_IN_InfusionStateMachine;
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
    } else {
      c1_InfusionStateMachine();
    }
    if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1
      == 10)) {
      chartInstance.c1_temporalCounter_i1 = 0U;
    }
    _sfEvent_ = c1_previousEvent;
  }
  if((c1_inputEventFiredFlag != 0) && (chartInstance.c1_E_RestartEventCounter >
    0U)) {
    *c1_E_Restart = !(*c1_E_Restart);
    chartInstance.c1_E_RestartEventCounter =
      chartInstance.c1_E_RestartEventCounter - 1U;
  }
  if((c1_inputEventFiredFlag != 0) && (chartInstance.c1_E_AlarmClearEventCounter
    > 0U)) {
    *c1_E_AlarmClear = !(*c1_E_AlarmClear);
    chartInstance.c1_E_AlarmClearEventCounter =
      chartInstance.c1_E_AlarmClearEventCounter - 1U;
  }
  if((c1_inputEventFiredFlag != 0) &&
   (chartInstance.c1_E_RequestToStartEventCounter > 0U)) {
    *c1_E_RequestToStart = !(*c1_E_RequestToStart);
    chartInstance.c1_E_RequestToStartEventCounter =
      chartInstance.c1_E_RequestToStartEventCounter - 1U;
  }
  if((c1_inputEventFiredFlag != 0) &&
   (chartInstance.c1_E_InfusionPausedEventCounter > 0U)) {
    *c1_E_InfusionPaused = !(*c1_E_InfusionPaused);
    chartInstance.c1_E_InfusionPausedEventCounter =
      chartInstance.c1_E_InfusionPausedEventCounter - 1U;
  }
  if((c1_inputEventFiredFlag != 0) &&
   (chartInstance.c1_E_InfusionStoppedEventCounter > 0U)) {
    *c1_E_InfusionStopped = !(*c1_E_InfusionStopped);
    chartInstance.c1_E_InfusionStoppedEventCounter =
      chartInstance.c1_E_InfusionStoppedEventCounter - 1U;
  }
}

static void c1_DisplayDoseRate(void)
{
  real_T c1_d0;
  real_T c1_x;
  real_T c1_d1;
  real_T c1_d2;
  real_T *c1_flowRate;
  real_T *c1_CurrentState;
  real_T *c1_drugConcentration;
  real_T *c1_drtypical;
  c1_drtypical = (real_T *)ssGetInputPortSignal(chartInstance.S, 31);
  c1_CurrentState = (real_T *)ssGetOutputPortSignal(chartInstance.S, 8);
  c1_flowRate = (real_T *)ssGetOutputPortSignal(chartInstance.S, 3);
  c1_drugConcentration = (real_T *)ssGetInputPortSignal(chartInstance.S, 14);
  if(_sfEvent_ == c1_event_E_ChangeDoseRate) {
    chartInstance.c1_is_ConfigureInfusionProgram = (uint8_T)c1_IN_ChangeDoseRate;
    chartInstance.c1_was_ConfigureInfusionProgram =
      (uint8_T)c1_IN_ChangeDoseRate;
    c1_d0 = (real_T)c1_const_MSG_CHANGEDR;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d0, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 24.0;
  } else if(_sfEvent_ == c1_event_E_ConfirmDoseRate) {
    c1_x = *c1_drtypical / *c1_drugConcentration;
    sf_mex_printf("%s =\\n", "x");
    sf_mex_call("disp", 0U, 1U, 6, c1_x);
    *c1_flowRate = c1_x;
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_DisplaySettings;
    chartInstance.c1_was_ConfigureInfusionProgram =
      (uint8_T)c1_IN_DisplaySettings;
    c1_d1 = (real_T)c1_const_MSG_DISPLAYSET;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d1, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 27.0;
  } else if(_sfEvent_ == c1_event_E_Warning) {
    c1_warning();
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_DisplayDoseRate;
    chartInstance.c1_was_ConfigureInfusionProgram =
      (uint8_T)c1_IN_DisplayDoseRate;
    c1_d2 = (real_T)c1_const_MSG_DISPLAYDR;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d2, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    chartInstance.c1_tempx = 0U;
    *c1_CurrentState = 23.0;
  }
}

static void c1_PowerOff(void)
{
  real_T c1_d3;
  real_T c1_d4;
  real_T c1_d5;
  real_T c1_d6;
  real_T *c1_POST;
  real_T *c1_CurrentState;
  real_T *c1_O_VTBIUH;
  real_T *c1_O_VTBIUS;
  real_T *c1_O_VTBITypical;
  real_T *c1_O_VTBILS;
  real_T *c1_O_VTBILH;
  real_T *c1_O_VTBIUnit;
  real_T *c1_O_DRUH;
  real_T *c1_O_DRUS;
  real_T *c1_O_DRTypical;
  real_T *c1_O_DRLS;
  real_T *c1_O_DRLH;
  uint32_T *c1_O_PatientID;
  uint32_T *c1_O_PatientAge;
  uint32_T *c1_O_PatientGender;
  uint32_T *c1_O_PatientWeight;
  real_T *c1_O_CurrentVTBI;
  real_T *c1_O_RemainVolume;
  uint32_T *c1_O_DrugID;
  real_T *c1_O_DrugConc;
  real_T *c1_O_DrugDoseUnit;
  real_T *c1_O_DrugAmount;
  real_T *c1_O_DrugDilVolume;
  uint32_T *c1_infusing;
  uint32_T *c1_bolusing;
  real_T *c1_flowRate;
  uint32_T *c1_infusionPaused;
  real_T *c1_O_ProgrammedVTBI;
  boolean_T *c1_O_BolusRequest;
  c1_infusing = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 2);
  c1_O_BolusRequest = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 7);
  c1_O_PatientAge = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 23);
  c1_O_DRTypical = (real_T *)ssGetOutputPortSignal(chartInstance.S, 15);
  c1_O_PatientWeight = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 25);
  c1_O_DrugID = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 26);
  c1_infusionPaused = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 5);
  c1_O_ProgrammedVTBI = (real_T *)ssGetOutputPortSignal(chartInstance.S, 6);
  c1_O_VTBILS = (real_T *)ssGetOutputPortSignal(chartInstance.S, 12);
  c1_POST = (real_T *)ssGetInputPortSignal(chartInstance.S, 3);
  c1_O_VTBITypical = (real_T *)ssGetOutputPortSignal(chartInstance.S, 11);
  c1_O_PatientID = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 22);
  c1_O_DrugDilVolume = (real_T *)ssGetOutputPortSignal(chartInstance.S, 30);
  c1_O_VTBIUS = (real_T *)ssGetOutputPortSignal(chartInstance.S, 10);
  c1_O_CurrentVTBI = (real_T *)ssGetOutputPortSignal(chartInstance.S, 20);
  c1_O_DrugDoseUnit = (real_T *)ssGetOutputPortSignal(chartInstance.S, 28);
  c1_CurrentState = (real_T *)ssGetOutputPortSignal(chartInstance.S, 8);
  c1_O_DRUS = (real_T *)ssGetOutputPortSignal(chartInstance.S, 17);
  c1_O_VTBILH = (real_T *)ssGetOutputPortSignal(chartInstance.S, 13);
  c1_O_PatientGender = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 24);
  c1_bolusing = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 4);
  c1_O_DrugConc = (real_T *)ssGetOutputPortSignal(chartInstance.S, 27);
  c1_O_DRUH = (real_T *)ssGetOutputPortSignal(chartInstance.S, 16);
  c1_O_DRLH = (real_T *)ssGetOutputPortSignal(chartInstance.S, 19);
  c1_O_RemainVolume = (real_T *)ssGetOutputPortSignal(chartInstance.S, 21);
  c1_O_VTBIUH = (real_T *)ssGetOutputPortSignal(chartInstance.S, 9);
  c1_flowRate = (real_T *)ssGetOutputPortSignal(chartInstance.S, 3);
  c1_O_DrugAmount = (real_T *)ssGetOutputPortSignal(chartInstance.S, 29);
  c1_O_VTBIUnit = (real_T *)ssGetOutputPortSignal(chartInstance.S, 14);
  c1_O_DRLS = (real_T *)ssGetOutputPortSignal(chartInstance.S, 18);
  if(_sfEvent_ == c1_event_E_PowerButton) {
    *c1_infusing = 0U;
    *c1_bolusing = 0U;
    *c1_flowRate = 0.0;
    *c1_infusionPaused = 0U;
    chartInstance.c1_temp = 0.0;
    chartInstance.c1_tempx = 0U;
    c1_d3 = 0.0;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d3, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    c1_d4 = (real_T)c1_const_MSG_BLANK;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d4, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
    *c1_O_ProgrammedVTBI = 0.0;
    *c1_O_BolusRequest = 0U;
    *c1_O_VTBIUH = -1.0;
    *c1_O_VTBIUS = -1.0;
    *c1_O_VTBITypical = -1.0;
    *c1_O_VTBILS = -1.0;
    *c1_O_VTBILH = -1.0;
    *c1_O_VTBIUnit = -1.0;
    *c1_O_DRUH = -1.0;
    *c1_O_DRUS = -1.0;
    *c1_O_DRTypical = -1.0;
    *c1_O_DRLS = -1.0;
    *c1_O_DRLH = -1.0;
    *c1_O_PatientID = 0U;
    *c1_O_PatientAge = 0U;
    *c1_O_PatientGender = 0U;
    *c1_O_PatientWeight = 0U;
    *c1_O_CurrentVTBI = -1.0;
    *c1_O_RemainVolume = -1.0;
    *c1_O_DrugID = 0U;
    *c1_O_DrugConc = -1.0;
    *c1_O_DrugDoseUnit = -1.0;
    *c1_O_DrugAmount = -1.0;
    *c1_O_DrugDilVolume = -1.0;
    c1_d5 = (real_T)c1_const_MSG_POST;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d5, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    c1_d6 = (real_T)c1_const_MSG_WELCOME;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d6, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_POST;
    *c1_CurrentState = 3.0;
    chartInstance.c1_tempx = 0U;
    if(*c1_POST == 1.0) {
      chartInstance.c1_tempx = 1U;
    } else if(*c1_POST != 1.0) {
      chartInstance.c1_tempx = 0U;
    }
  }
}

static void c1_PrimeFailed(void)
{
  real_T c1_d7;
  real_T c1_d8;
  real_T *c1_CurrentState;
  real_T *c1_prime;
  c1_CurrentState = (real_T *)ssGetOutputPortSignal(chartInstance.S, 8);
  c1_prime = (real_T *)ssGetInputPortSignal(chartInstance.S, 18);
  if(_sfEvent_ == c1_event_E_Warning) {
    c1_warning();
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_PrimeFailed;
    chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_PrimeFailed;
    c1_d7 = (real_T)c1_const_MSG_PRIMEFAIL;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d7, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 8.0;
  } else if(_sfEvent_ == c1_event_E_Prime) {
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_CheckPrime;
    chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_CheckPrime;
    c1_d8 = (real_T)c1_const_MSG_PRIME;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d8, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 7.0;
    chartInstance.c1_tempx = 0U;
    if(*c1_prime == 1.0) {
      chartInstance.c1_tempx = 1U;
    } else if(*c1_prime != 1.0) {
      chartInstance.c1_tempx = 0U;
    }
  }
}

static void c1_UnknownDrug(void)
{
  real_T c1_d9;
  real_T c1_d10;
  real_T *c1_CurrentState;
  c1_CurrentState = (real_T *)ssGetOutputPortSignal(chartInstance.S, 8);
  if(_sfEvent_ == c1_event_E_Warning) {
    c1_warning();
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_UnknownDrug;
    chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_UnknownDrug;
    c1_d9 = (real_T)c1_const_MSG_WRONGDRUG;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d9, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 11.0;
  } else if(_sfEvent_ == c1_event_E_CheckDrug) {
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_CheckDrug_CheckType;
    chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_CheckDrug_CheckType;
    c1_d10 = (real_T)c1_const_MSG_CHECKTYPE;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d10, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 10.0;
  }
}

static void c1_WrongConcentration(void)
{
  real_T c1_d11;
  real_T c1_d12;
  real_T *c1_CurrentState;
  c1_CurrentState = (real_T *)ssGetOutputPortSignal(chartInstance.S, 8);
  if(_sfEvent_ == c1_event_E_CheckDrug) {
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_CheckDrug_CheckType;
    chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_CheckDrug_CheckType;
    c1_d11 = (real_T)c1_const_MSG_CHECKTYPE;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d11, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 10.0;
  } else if(_sfEvent_ == c1_event_E_Warning) {
    c1_warning();
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_WrongConcentration;
    chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_WrongConcentration;
    c1_d12 = (real_T)c1_const_MSG_WRONGCON;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d12, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 15.0;
  }
}

static void c1_WRN_DangerCon(void)
{
  real_T c1_d13;
  real_T c1_d14;
  real_T c1_d15;
  real_T *c1_CurrentState;
  c1_CurrentState = (real_T *)ssGetOutputPortSignal(chartInstance.S, 8);
  if(_sfEvent_ == c1_event_E_CheckDrug) {
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_CheckDrug_CheckType;
    chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_CheckDrug_CheckType;
    c1_d13 = (real_T)c1_const_MSG_CHECKTYPE;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d13, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 10.0;
  } else if(_sfEvent_ == c1_event_E_ConfirmConcentration) {
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_DisplayPatientProfile;
    chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_DisplayPatientProfile;
    c1_d14 = (real_T)c1_const_MSG_PATIENTINFO;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d14, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 18.0;
  } else if(_sfEvent_ == c1_event_E_Warning) {
    c1_warning();
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_WRN_DangerCon;
    chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_WRN_DangerCon;
    c1_d15 = (real_T)c1_const_MSG_DANGECON;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d15, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 16.0;
  }
}

static void c1_DisplayPatientProfile(void)
{
  real_T c1_d16;
  real_T c1_d17;
  real_T c1_d18;
  real_T *c1_CurrentState;
  c1_CurrentState = (real_T *)ssGetOutputPortSignal(chartInstance.S, 8);
  if(_sfEvent_ == c1_event_E_ConfigureInfusionProgram) {
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    chartInstance.c1_is_InfusionStateMachine =
      (uint8_T)c1_IN_ConfigureInfusionProgram;
    chartInstance.c1_is_ConfigureInfusionProgram = (uint8_T)c1_IN_DisplayVTBI;
    chartInstance.c1_was_ConfigureInfusionProgram = (uint8_T)c1_IN_DisplayVTBI;
    c1_d16 = (real_T)c1_const_MSG_VTBI;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d16, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 19.0;
  } else if(_sfEvent_ == c1_event_E_Warning) {
    c1_warning();
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_DisplayPatientProfile;
    chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_DisplayPatientProfile;
    c1_d17 = (real_T)c1_const_MSG_PATIENTINFO;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d17, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 18.0;
  } else if(_sfEvent_ == c1_event_E_Cancel) {
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_DisplayDrugInfo;
    chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_DisplayDrugInfo;
    chartInstance.c1_tempx = 0U;
    c1_d18 = (real_T)c1_const_MSG_DRUGINFO;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d18, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 9.0;
  }
}

static uint32_T c1_drugTypeMismatch(void)
{
  uint32_T c1_x;
  uint32_T c1_b_x;
  boolean_T c1_guard1 = false;
  real_T *c1_dlDiluentVolume;
  real_T *c1_diluentVolume;
  real_T *c1_dlDrugID;
  real_T *c1_drugID;
  c1_diluentVolume = (real_T *)ssGetInputPortSignal(chartInstance.S, 7);
  c1_dlDrugID = (real_T *)ssGetInputPortSignal(chartInstance.S, 19);
  c1_drugID = (real_T *)ssGetInputPortSignal(chartInstance.S, 5);
  c1_dlDiluentVolume = (real_T *)ssGetInputPortSignal(chartInstance.S, 6);
  c1_b_x = 0U;
  if(*c1_dlDrugID == *c1_drugID) {
    c1_b_x = 0U;
  } else if(*c1_dlDrugID != *c1_drugID) {
    c1_b_x = 1U;
  }
  c1_guard1 = false;
  if(c1_b_x == 0U) {
    c1_b_x = 0U;
    if(*c1_dlDiluentVolume == *c1_diluentVolume) {
      c1_b_x = 0U;
    } else if(*c1_dlDiluentVolume != *c1_diluentVolume) {
      c1_b_x = 1U;
    }
    if(c1_b_x == 0U) {
      c1_x = 0U;
    } else {
      c1_guard1 = true;
    }
  } else {
    c1_guard1 = true;
  }
  if(c1_guard1 == true) {
    return 1U;
  }
  return c1_x;
}

static void c1_DisplayVTBI(void)
{
  real_T c1_d19;
  real_T c1_d20;
  real_T c1_d21;
  real_T *c1_vtbitypical;
  real_T *c1_O_ProgrammedVTBI;
  real_T *c1_CurrentState;
  c1_O_ProgrammedVTBI = (real_T *)ssGetOutputPortSignal(chartInstance.S, 6);
  c1_vtbitypical = (real_T *)ssGetInputPortSignal(chartInstance.S, 26);
  c1_CurrentState = (real_T *)ssGetOutputPortSignal(chartInstance.S, 8);
  if(_sfEvent_ == c1_event_E_ChangeVTBI) {
    chartInstance.c1_is_ConfigureInfusionProgram = (uint8_T)c1_IN_ChangeVTBI;
    chartInstance.c1_was_ConfigureInfusionProgram = (uint8_T)c1_IN_ChangeVTBI;
    c1_d19 = (real_T)c1_const_MSG_CHANGEVTBI;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d19, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 20.0;
  } else if(_sfEvent_ == c1_event_E_ConfirmVTBI) {
    *c1_O_ProgrammedVTBI = *c1_vtbitypical;
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_DisplayDoseRate;
    chartInstance.c1_was_ConfigureInfusionProgram =
      (uint8_T)c1_IN_DisplayDoseRate;
    c1_d20 = (real_T)c1_const_MSG_DISPLAYDR;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d20, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    chartInstance.c1_tempx = 0U;
    *c1_CurrentState = 23.0;
  } else if(_sfEvent_ == c1_event_E_Warning) {
    c1_warning();
    chartInstance.c1_is_ConfigureInfusionProgram = (uint8_T)c1_IN_DisplayVTBI;
    chartInstance.c1_was_ConfigureInfusionProgram = (uint8_T)c1_IN_DisplayVTBI;
    c1_d21 = (real_T)c1_const_MSG_VTBI;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d21, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 19.0;
  }
}

static uint32_T c1_warning(void)
{
  uint32_T c1_x;
  real_T c1_d22;
  real_T c1_d23;
  real_T c1_d24;
  real_T c1_d25;
  real_T c1_d26;
  real_T c1_d27;
  real_T c1_b_MSG_WRNBATTERYCHARGE;
  real_T c1_d28;
  real_T c1_d29;
  real_T *c1_ErrCond;
  c1_ErrCond = (real_T *)ssGetInputPortSignal(chartInstance.S, 2);
  c1_x = 1U;
  if(*c1_ErrCond == 20.0) {
    c1_d22 = (real_T)c1_const_MSG_LOGERR;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d22, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(*c1_ErrCond == 21.0) {
    c1_d23 = (real_T)c1_const_MSG_LOWBATT;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d23, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(*c1_ErrCond == 22.0) {
    c1_d24 = (real_T)c1_const_MSG_LOWRESR;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d24, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(*c1_ErrCond == 23.0) {
    c1_d25 = (real_T)c1_const_MSG_DANGERENVTEMP;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d25, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(*c1_ErrCond == 24.0) {
    c1_d26 = (real_T)c1_const_MSG_DANGERHUMD;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d26, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(*c1_ErrCond == 25.0) {
    c1_d27 = (real_T)c1_const_MSG_DANGERAP;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d27, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(*c1_ErrCond == 26.0) {
    c1_b_MSG_WRNBATTERYCHARGE = (real_T)chartInstance.c1_MSG_WRNBATTERYCHARGE;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_b_MSG_WRNBATTERYCHARGE,
      "GAlrmMsg", 0, 0U, 0U, 0), 0);
  } else if(*c1_ErrCond == 27.0) {
    c1_d28 = (real_T)c1_const_MSG_WRNBATTERYFUNCTION;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d28, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
    sf_mex_printf("%s =\\n", "ml.GAlrmMsg");
    sf_mex_call("disp", 0U, 1U, 14, sf_mex_get_ml_var("GAlrmMsg", 0));
  } else if(*c1_ErrCond == 19.0) {
    c1_d29 = (real_T)c1_const_MSG_FLOWRATEVARY;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d29, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
    sf_mex_printf("%s =\\n", "ml.GAlrmMsg");
    sf_mex_call("disp", 0U, 1U, 14, sf_mex_get_ml_var("GAlrmMsg", 0));
  }
  return c1_x;
}

static void c1_DisplaySettings(void)
{
  real_T c1_d30;
  real_T c1_d31;
  real_T *c1_CurrentState;
  c1_CurrentState = (real_T *)ssGetOutputPortSignal(chartInstance.S, 8);
  if(_sfEvent_ == c1_event_E_StartInfusion) {
    sf_mex_printf("%s\\n", "E_RequestToStart");
    chartInstance.c1_E_RequestToStartEventCounter =
      chartInstance.c1_E_RequestToStartEventCounter + 1U;
    chartInstance.c1_is_ConfigureInfusionProgram = (uint8_T)c1_IN_ReadyToStart;
    chartInstance.c1_was_ConfigureInfusionProgram = (uint8_T)c1_IN_ReadyToStart;
    *c1_CurrentState = 48.0;
  } else if(_sfEvent_ == c1_event_E_ConfigureInfusionProgram) {
    chartInstance.c1_is_ConfigureInfusionProgram = (uint8_T)c1_IN_DisplayVTBI;
    chartInstance.c1_was_ConfigureInfusionProgram = (uint8_T)c1_IN_DisplayVTBI;
    c1_d30 = (real_T)c1_const_MSG_VTBI;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d30, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 19.0;
  } else if(_sfEvent_ == c1_event_E_Warning) {
    c1_warning();
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_DisplaySettings;
    chartInstance.c1_was_ConfigureInfusionProgram =
      (uint8_T)c1_IN_DisplaySettings;
    c1_d31 = (real_T)c1_const_MSG_DISPLAYSET;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d31, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 27.0;
  }
}

static void c1_Infusing(void)
{
  real_T c1_d32;
  boolean_T c1_guard1 = false;
  real_T c1_d33;
  real_T c1_d34;
  real_T c1_d35;
  real_T c1_d36;
  real_T c1_d37;
  real_T c1_d38;
  real_T c1_d39;
  real_T c1_d40;
  real_T *c1_currentVTBI;
  uint32_T *c1_bolusing;
  boolean_T *c1_O_BolusRequest;
  boolean_T *c1_StopBolus;
  real_T *c1_O_CurrentVTBI;
  real_T *c1_remainVolume;
  real_T *c1_O_RemainVolume;
  uint32_T *c1_infusing;
  real_T *c1_CurrentState;
  c1_infusing = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 2);
  c1_O_BolusRequest = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 7);
  c1_currentVTBI = (real_T *)ssGetInputPortSignal(chartInstance.S, 16);
  c1_O_CurrentVTBI = (real_T *)ssGetOutputPortSignal(chartInstance.S, 20);
  c1_CurrentState = (real_T *)ssGetOutputPortSignal(chartInstance.S, 8);
  c1_bolusing = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 4);
  c1_StopBolus = (boolean_T *)ssGetInputPortSignal(chartInstance.S, 15);
  c1_O_RemainVolume = (real_T *)ssGetOutputPortSignal(chartInstance.S, 21);
  c1_remainVolume = (real_T *)ssGetInputPortSignal(chartInstance.S, 17);
  if(*c1_currentVTBI == 0.0) {
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionStopped;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_InfusionStopped;
    c1_d32 = (real_T)c1_const_MSG_INFUSIONSTOP;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d32, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 39.0;
    *c1_infusing = 0U;
    *c1_bolusing = 0U;
    sf_mex_printf("%s\\n", "E_InfusionStopped");
    chartInstance.c1_E_InfusionStoppedEventCounter =
      chartInstance.c1_E_InfusionStoppedEventCounter + 1U;
  } else {
    c1_guard1 = false;
    if(_sfEvent_ == c1_event_E_ChangeDoseRate) {
      chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_ChangeRate;
      c1_d33 = (real_T)c1_const_MSG_CHANGEDR;
      sf_mex_export("GMsgConStr", sf_mex_create(&c1_d33, "GMsgConStr", 0, 0U,
        0U, 0), 0);
      sf_mex_export("GSetConVal", sf_mex_create(&chartInstance.c1_temp,
        "GSetConVal", 0, 0U, 0U, 0), 0);
      *c1_CurrentState = 30.0;
    } else if(_sfEvent_ == c1_event_E_StopInfusion) {
      chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_ConfirmStop;
      c1_d34 = (real_T)c1_const_MSG_CONFIRMSTOP;
      sf_mex_export("GMsgConStr", sf_mex_create(&c1_d34, "GMsgConStr", 0, 0U,
        0U, 0), 0);
      *c1_CurrentState = 35.0;
    } else if(_sfEvent_ == c1_event_E_PauseInfusion) {
      chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_ConfirmPause;
      c1_d35 = (real_T)c1_const_MSG_CONFIRMPAUSE;
      sf_mex_export("GMsgConStr", sf_mex_create(&c1_d35, "GMsgConStr", 0, 0U,
        0U, 0), 0);
      *c1_CurrentState = 34.0;
    } else if(_sfEvent_ == c1_event_E_RequestBolus) {
      if(*c1_bolusing == 1U) {
        c1_d36 = (real_T)c1_const_MSG_BOLUSDENIED;
        sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d36, "GAlrmMsg", 0, 0U, 0U,
          0), 0);
        chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
        chartInstance.c1_temporalCounter_i1 = 0U;
        c1_d37 = (real_T)c1_const_MSG_INFUSING;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d37, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_infusing = 1U;
        *c1_CurrentState = 28.0;
      } else if(*c1_bolusing == 0U) {
        *c1_O_BolusRequest = 1U;
        chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_BolusRequest;
        *c1_CurrentState = 29.0;
      } else {
        c1_guard1 = true;
      }
    } else {
      c1_guard1 = true;
    }
    if(c1_guard1 == true) {
      if(_sfEvent_ == c1_event_E_Warning) {
        c1_warning();
        chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
        chartInstance.c1_temporalCounter_i1 = 0U;
        c1_d38 = (real_T)c1_const_MSG_INFUSING;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d38, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_infusing = 1U;
        *c1_CurrentState = 28.0;
      } else if((*c1_bolusing == 1U) && (*c1_StopBolus == 1)) {
        *c1_bolusing = 0U;
        c1_d39 = (real_T)c1_const_MSG_STOPBOLUS;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d39, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
        chartInstance.c1_temporalCounter_i1 = 0U;
        c1_d40 = (real_T)c1_const_MSG_INFUSING;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d40, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_infusing = 1U;
        *c1_CurrentState = 28.0;
      } else {
        if((_sfEvent_ == c1_event_E_Clock) &&
         (chartInstance.c1_temporalCounter_i1 == 10)) {
          *c1_O_CurrentVTBI = *c1_currentVTBI;
        }
        if((_sfEvent_ == c1_event_E_Clock) &&
         (chartInstance.c1_temporalCounter_i1 == 10)) {
          *c1_O_RemainVolume = *c1_remainVolume;
        }
      }
    }
  }
}

static void c1_enter_internal_InfusionInSession(void)
{
  real_T c1_d41;
  real_T c1_d42;
  real_T c1_d43;
  real_T c1_d44;
  real_T c1_d45;
  real_T c1_d46;
  real_T c1_d47;
  real_T c1_d48;
  real_T c1_d49;
  uint32_T *c1_infusing;
  uint32_T *c1_bolusing;
  real_T *c1_CurrentState;
  c1_infusing = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 2);
  c1_CurrentState = (real_T *)ssGetOutputPortSignal(chartInstance.S, 8);
  c1_bolusing = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 4);
  switch(chartInstance.c1_was_InfusionInSession) {
   case c1_IN_ALMWrongDrug:
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_ALMWrongDrug;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_ALMWrongDrug;
    c1_d41 = (real_T)c1_const_MSG_WRONGDRUG;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d41, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 42.0;
    break;
   case c1_IN_CheckDrugWhileInfusing:
    chartInstance.c1_is_InfusionInSession =
      (uint8_T)c1_IN_CheckDrugWhileInfusing;
    chartInstance.c1_was_InfusionInSession =
      (uint8_T)c1_IN_CheckDrugWhileInfusing;
    c1_d42 = (real_T)c1_const_MSG_CHECKTYPE;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d42, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    sf_mex_printf("%s =\\n", "ml.GMsgConStr");
    sf_mex_call("disp", 0U, 1U, 14, sf_mex_get_ml_var("GMsgConStr", 0));
    *c1_CurrentState = 41.0;
    break;
   case c1_IN_EmptyReservoir:
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_EmptyReservoir;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_EmptyReservoir;
    c1_d43 = (real_T)c1_const_MSG_EMPTYRESERVOIR;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d43, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
    *c1_infusing = 0U;
    *c1_bolusing = 0U;
    *c1_CurrentState = 40.0;
    break;
   case c1_IN_InfusionPaused:
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionPaused;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_InfusionPaused;
    c1_d44 = (real_T)c1_const_MSG_INFUSIONPAUSED;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d44, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 36.0;
    *c1_infusing = 0U;
    break;
   case c1_IN_InfusionStopped:
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionStopped;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_InfusionStopped;
    c1_d45 = (real_T)c1_const_MSG_INFUSIONSTOP;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d45, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 39.0;
    *c1_infusing = 0U;
    *c1_bolusing = 0U;
    sf_mex_printf("%s\\n", "E_InfusionStopped");
    chartInstance.c1_E_InfusionStoppedEventCounter =
      chartInstance.c1_E_InfusionStoppedEventCounter + 1U;
    break;
   case c1_IN_InfusionSubMachine:
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionSubMachine;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_InfusionSubMachine;
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
    chartInstance.c1_temporalCounter_i1 = 0U;
    c1_d46 = (real_T)c1_const_MSG_INFUSING;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d46, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_infusing = 1U;
    *c1_CurrentState = 28.0;
    break;
   case c1_IN_LevelTwoAlarming:
    c1_enter_atomic_LevelTwoAlarming();
    break;
   case c1_IN_PausedStopConfirm:
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_PausedStopConfirm;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_PausedStopConfirm;
    c1_d47 = (real_T)c1_const_MSG_SPCHOOSE;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d47, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 38.0;
    break;
   case c1_IN_PausedTooLong:
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_PausedTooLong;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_PausedTooLong;
    c1_d48 = (real_T)c1_const_MSG_TOOLONGPAUSE;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d48, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
    *c1_CurrentState = 37.0;
    break;
   default:
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionSubMachine;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_InfusionSubMachine;
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
    chartInstance.c1_temporalCounter_i1 = 0U;
    c1_d49 = (real_T)c1_const_MSG_INFUSING;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d49, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_infusing = 1U;
    *c1_CurrentState = 28.0;
    break;
  }
}

static void c1_InfusionInSession(void)
{
  uint32_T c1_b_tempx;
  real_T c1_d50;
  real_T c1_d51;
  real_T c1_d52;
  real_T c1_d53;
  real_T c1_d54;
  real_T c1_d55;
  real_T c1_d56;
  real_T c1_d57;
  real_T c1_d58;
  real_T c1_d59;
  real_T c1_d60;
  real_T c1_d61;
  real_T c1_d62;
  real_T c1_d63;
  real_T c1_d64;
  uint32_T *c1_infusing;
  uint32_T *c1_bolusing;
  real_T *c1_ErrCond;
  real_T *c1_CurrentState;
  uint32_T *c1_infusionPaused;
  real_T *c1_adminSetPassed;
  c1_infusing = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 2);
  c1_infusionPaused = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 5);
  c1_CurrentState = (real_T *)ssGetOutputPortSignal(chartInstance.S, 8);
  c1_ErrCond = (real_T *)ssGetInputPortSignal(chartInstance.S, 2);
  c1_bolusing = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 4);
  c1_adminSetPassed = (real_T *)ssGetInputPortSignal(chartInstance.S, 10);
  if(_sfEvent_ == c1_event_E_PowerButton) {
    chartInstance.c1_tempx = 3U;
    c1_b_tempx = chartInstance.c1_tempx;
    sf_mex_printf("%s =\\n", "tempx");
    sf_mex_call("disp", 0U, 1U, 6, (real_T)c1_b_tempx);
    c1_exit_internal_InfusionInSession();
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_ConfirmPowerDown;
    c1_d50 = (real_T)c1_const_MSG_POWEROFF;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d50, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 2.0;
  } else {
    c1_b_tempx = 0U;
    if((*c1_ErrCond > 0.0) && (*c1_ErrCond < 7.0)) {
      c1_b_tempx = 1U;
    } else if((*c1_ErrCond >= 7.0) && (*c1_ErrCond < 18.0)) {
      c1_b_tempx = 2U;
    } else if(*c1_ErrCond >= 18.0) {
      c1_b_tempx = 3U;
    } else if(*c1_ErrCond == 0.0) {
      c1_b_tempx = 0U;
    }
    if(c1_b_tempx == 1U) {
      c1_exit_internal_InfusionInSession();
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_LEVELONEALRM;
      c1_setLOneMsg((uint32_T)*c1_ErrCond);
      *c1_CurrentState = 43.0;
    } else {
      switch(chartInstance.c1_is_InfusionInSession) {
       case c1_IN_ALMWrongDrug:
        if(_sfEvent_ == c1_event_E_StopInfusion) {
          chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionStopped;
          chartInstance.c1_was_InfusionInSession =
            (uint8_T)c1_IN_InfusionStopped;
          c1_d51 = (real_T)c1_const_MSG_INFUSIONSTOP;
          sf_mex_export("GMsgConStr", sf_mex_create(&c1_d51, "GMsgConStr", 0,
            0U, 0U, 0), 0);
          *c1_CurrentState = 39.0;
          *c1_infusing = 0U;
          *c1_bolusing = 0U;
          sf_mex_printf("%s\\n", "E_InfusionStopped");
          chartInstance.c1_E_InfusionStoppedEventCounter =
            chartInstance.c1_E_InfusionStoppedEventCounter + 1U;
        } else if(_sfEvent_ == c1_event_E_CheckDrug) {
          chartInstance.c1_is_InfusionInSession =
            (uint8_T)c1_IN_CheckDrugWhileInfusing;
          chartInstance.c1_was_InfusionInSession =
            (uint8_T)c1_IN_CheckDrugWhileInfusing;
          c1_d52 = (real_T)c1_const_MSG_CHECKTYPE;
          sf_mex_export("GMsgConStr", sf_mex_create(&c1_d52, "GMsgConStr", 0,
            0U, 0U, 0), 0);
          sf_mex_printf("%s =\\n", "ml.GMsgConStr");
          sf_mex_call("disp", 0U, 1U, 14, sf_mex_get_ml_var("GMsgConStr", 0));
          *c1_CurrentState = 41.0;
        } else if(_sfEvent_ == c1_event_E_Warning) {
          c1_warning();
          chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_ALMWrongDrug;
          chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_ALMWrongDrug;
          c1_d53 = (real_T)c1_const_MSG_WRONGDRUG;
          sf_mex_export("GMsgConStr", sf_mex_create(&c1_d53, "GMsgConStr", 0,
            0U, 0U, 0), 0);
          *c1_CurrentState = 42.0;
        }
        break;
       case c1_IN_CheckDrugWhileInfusing:
        if(c1_CheckDrug() == 1U) {
          chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_ALMWrongDrug;
          chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_ALMWrongDrug;
          c1_d54 = (real_T)c1_const_MSG_WRONGDRUG;
          sf_mex_export("GMsgConStr", sf_mex_create(&c1_d54, "GMsgConStr", 0,
            0U, 0U, 0), 0);
          *c1_CurrentState = 42.0;
        } else if(c1_CheckDrug() == 0U) {
          chartInstance.c1_is_InfusionInSession =
            (uint8_T)c1_IN_InfusionSubMachine;
          chartInstance.c1_was_InfusionInSession =
            (uint8_T)c1_IN_InfusionSubMachine;
          chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
          chartInstance.c1_temporalCounter_i1 = 0U;
          c1_d55 = (real_T)c1_const_MSG_INFUSING;
          sf_mex_export("GMsgConStr", sf_mex_create(&c1_d55, "GMsgConStr", 0,
            0U, 0U, 0), 0);
          *c1_infusing = 1U;
          *c1_CurrentState = 28.0;
        }
        break;
       case c1_IN_EmptyReservoir:
        if(_sfEvent_ == c1_event_E_Warning) {
          c1_warning();
          chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_EmptyReservoir;
          chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_EmptyReservoir;
          c1_d56 = (real_T)c1_const_MSG_EMPTYRESERVOIR;
          sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d56, "GAlrmMsg", 0, 0U,
            0U, 0), 0);
          *c1_infusing = 0U;
          *c1_bolusing = 0U;
          *c1_CurrentState = 40.0;
        } else if(_sfEvent_ == c1_event_E_CheckDrug) {
          chartInstance.c1_is_InfusionInSession =
            (uint8_T)c1_IN_CheckDrugWhileInfusing;
          chartInstance.c1_was_InfusionInSession =
            (uint8_T)c1_IN_CheckDrugWhileInfusing;
          c1_d57 = (real_T)c1_const_MSG_CHECKTYPE;
          sf_mex_export("GMsgConStr", sf_mex_create(&c1_d57, "GMsgConStr", 0,
            0U, 0U, 0), 0);
          sf_mex_printf("%s =\\n", "ml.GMsgConStr");
          sf_mex_call("disp", 0U, 1U, 14, sf_mex_get_ml_var("GMsgConStr", 0));
          *c1_CurrentState = 41.0;
        } else if(_sfEvent_ == c1_event_E_StopInfusion) {
          chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionStopped;
          chartInstance.c1_was_InfusionInSession =
            (uint8_T)c1_IN_InfusionStopped;
          c1_d58 = (real_T)c1_const_MSG_INFUSIONSTOP;
          sf_mex_export("GMsgConStr", sf_mex_create(&c1_d58, "GMsgConStr", 0,
            0U, 0U, 0), 0);
          *c1_CurrentState = 39.0;
          *c1_infusing = 0U;
          *c1_bolusing = 0U;
          sf_mex_printf("%s\\n", "E_InfusionStopped");
          chartInstance.c1_E_InfusionStoppedEventCounter =
            chartInstance.c1_E_InfusionStoppedEventCounter + 1U;
        }
        break;
       case c1_IN_InfusionPaused:
        if((_sfEvent_ == c1_event_E_Alarm) && (*c1_ErrCond == 13.0)) {
          chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_PausedTooLong;
          chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_PausedTooLong;
          c1_d59 = (real_T)c1_const_MSG_TOOLONGPAUSE;
          sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d59, "GAlrmMsg", 0, 0U,
            0U, 0), 0);
          *c1_CurrentState = 37.0;
        } else if(_sfEvent_ == c1_event_E_Warning) {
          c1_warning();
          chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionPaused;
          chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_InfusionPaused;
          c1_d60 = (real_T)c1_const_MSG_INFUSIONPAUSED;
          sf_mex_export("GMsgConStr", sf_mex_create(&c1_d60, "GMsgConStr", 0,
            0U, 0U, 0), 0);
          *c1_CurrentState = 36.0;
          *c1_infusing = 0U;
        } else if(_sfEvent_ == c1_event_E_StopInfusion) {
          chartInstance.c1_is_InfusionInSession =
            (uint8_T)c1_IN_PausedStopConfirm;
          chartInstance.c1_was_InfusionInSession =
            (uint8_T)c1_IN_PausedStopConfirm;
          c1_d61 = (real_T)c1_const_MSG_SPCHOOSE;
          sf_mex_export("GMsgConStr", sf_mex_create(&c1_d61, "GMsgConStr", 0,
            0U, 0U, 0), 0);
          *c1_CurrentState = 38.0;
        } else if(_sfEvent_ == c1_event_E_Cancel) {
          *c1_infusionPaused = 0U;
          chartInstance.c1_is_InfusionInSession =
            (uint8_T)c1_IN_InfusionSubMachine;
          chartInstance.c1_was_InfusionInSession =
            (uint8_T)c1_IN_InfusionSubMachine;
          chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
          chartInstance.c1_temporalCounter_i1 = 0U;
          c1_d62 = (real_T)c1_const_MSG_INFUSING;
          sf_mex_export("GMsgConStr", sf_mex_create(&c1_d62, "GMsgConStr", 0,
            0U, 0U, 0), 0);
          *c1_infusing = 1U;
          *c1_CurrentState = 28.0;
        } else {
          c1_b_tempx = 0U;
          if((*c1_ErrCond > 0.0) && (*c1_ErrCond < 7.0)) {
            c1_b_tempx = 1U;
          } else if((*c1_ErrCond >= 7.0) && (*c1_ErrCond < 18.0)) {
            c1_b_tempx = 2U;
          } else if(*c1_ErrCond >= 18.0) {
            c1_b_tempx = 3U;
          } else if(*c1_ErrCond == 0.0) {
            c1_b_tempx = 0U;
          }
          if(c1_b_tempx == 2U) {
            chartInstance.c1_is_InfusionInSession =
              (uint8_T)c1_IN_NO_ACTIVE_CHILD;
            c1_enter_atomic_LevelTwoAlarming();
          }
        }
        break;
       case c1_IN_InfusionStopped:
        if(_sfEvent_ == c1_event_E_NewInfusion) {
          chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
          chartInstance.c1_is_InfusionStateMachine =
            (uint8_T)c1_IN_CheckDrugRoutine;
          chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_CheckAdminSet;
          chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_CheckAdminSet;
          c1_d63 = (real_T)c1_const_MSG_ADMINCHECK;
          sf_mex_export("GMsgConStr", sf_mex_create(&c1_d63, "GMsgConStr", 0,
            0U, 0U, 0), 0);
          *c1_CurrentState = 5.0;
          chartInstance.c1_tempx = 0U;
          if(*c1_adminSetPassed == 1.0) {
            chartInstance.c1_tempx = 1U;
          } else if(*c1_adminSetPassed != 1.0) {
            chartInstance.c1_tempx = 0U;
          }
        } else if(_sfEvent_ == c1_event_E_Warning) {
          c1_warning();
          chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionStopped;
          chartInstance.c1_was_InfusionInSession =
            (uint8_T)c1_IN_InfusionStopped;
          c1_d64 = (real_T)c1_const_MSG_INFUSIONSTOP;
          sf_mex_export("GMsgConStr", sf_mex_create(&c1_d64, "GMsgConStr", 0,
            0U, 0U, 0), 0);
          *c1_CurrentState = 39.0;
          *c1_infusing = 0U;
          *c1_bolusing = 0U;
          sf_mex_printf("%s\\n", "E_InfusionStopped");
          chartInstance.c1_E_InfusionStoppedEventCounter =
            chartInstance.c1_E_InfusionStoppedEventCounter + 1U;
        }
        break;
       case c1_IN_InfusionSubMachine:
        c1_InfusionSubMachine();
        break;
       case c1_IN_LevelTwoAlarming:
        c1_LevelTwoAlarming();
        break;
       case c1_IN_PausedStopConfirm:
        c1_PausedStopConfirm();
        break;
       case c1_IN_PausedTooLong:
        c1_PausedTooLong();
        break;
       default:
        chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
        break;
      }
    }
  }
}

static void c1_exit_internal_InfusionInSession(void)
{
  switch(chartInstance.c1_is_InfusionInSession) {
   case c1_IN_ALMWrongDrug:
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_CheckDrugWhileInfusing:
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_EmptyReservoir:
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_InfusionPaused:
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_InfusionStopped:
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_InfusionSubMachine:
    c1_exit_internal_InfusionSubMachine();
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_LevelTwoAlarming:
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_PausedStopConfirm:
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_PausedTooLong:
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   default:
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
  }
}

static void c1_ConfirmStop(void)
{
  real_T c1_d65;
  real_T c1_d66;
  real_T c1_d67;
  real_T c1_d68;
  real_T *c1_currentVTBI;
  uint32_T *c1_infusing;
  uint32_T *c1_bolusing;
  real_T *c1_CurrentState;
  c1_infusing = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 2);
  c1_currentVTBI = (real_T *)ssGetInputPortSignal(chartInstance.S, 16);
  c1_CurrentState = (real_T *)ssGetOutputPortSignal(chartInstance.S, 8);
  c1_bolusing = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 4);
  if(_sfEvent_ == c1_event_E_ConfirmStopInfusion) {
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionStopped;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_InfusionStopped;
    c1_d65 = (real_T)c1_const_MSG_INFUSIONSTOP;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d65, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 39.0;
    *c1_infusing = 0U;
    *c1_bolusing = 0U;
    sf_mex_printf("%s\\n", "E_InfusionStopped");
    chartInstance.c1_E_InfusionStoppedEventCounter =
      chartInstance.c1_E_InfusionStoppedEventCounter + 1U;
  } else if(_sfEvent_ == c1_event_E_Warning) {
    c1_warning();
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_ConfirmStop;
    c1_d66 = (real_T)c1_const_MSG_CONFIRMSTOP;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d66, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 35.0;
  } else if(_sfEvent_ == c1_event_E_Cancel) {
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
    chartInstance.c1_temporalCounter_i1 = 0U;
    c1_d67 = (real_T)c1_const_MSG_INFUSING;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d67, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_infusing = 1U;
    *c1_CurrentState = 28.0;
  } else if(*c1_currentVTBI == 0.0) {
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
    chartInstance.c1_temporalCounter_i1 = 0U;
    c1_d68 = (real_T)c1_const_MSG_INFUSING;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d68, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_infusing = 1U;
    *c1_CurrentState = 28.0;
  }
}

static void c1_ReadyToStart(void)
{
  real_T c1_d69;
  real_T c1_d70;
  real_T c1_d71;
  uint32_T *c1_infusing;
  real_T *c1_CurrentState;
  uint32_T *c1_bolusing;
  uint32_T *c1_infusionPaused;
  boolean_T *c1_O_BolusRequest;
  real_T *c1_programmedVTBI;
  real_T *c1_O_CurrentVTBI;
  real_T *c1_remainVolume;
  real_T *c1_O_RemainVolume;
  c1_infusing = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 2);
  c1_O_BolusRequest = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 7);
  c1_infusionPaused = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 5);
  c1_O_CurrentVTBI = (real_T *)ssGetOutputPortSignal(chartInstance.S, 20);
  c1_programmedVTBI = (real_T *)ssGetInputPortSignal(chartInstance.S, 0);
  c1_CurrentState = (real_T *)ssGetOutputPortSignal(chartInstance.S, 8);
  c1_bolusing = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 4);
  c1_O_RemainVolume = (real_T *)ssGetOutputPortSignal(chartInstance.S, 21);
  c1_remainVolume = (real_T *)ssGetInputPortSignal(chartInstance.S, 17);
  if(_sfEvent_ == c1_event_E_Ready) {
    *c1_infusing = 0U;
    *c1_bolusing = 0U;
    *c1_infusionPaused = 0U;
    *c1_O_BolusRequest = 0U;
    *c1_O_CurrentVTBI = *c1_programmedVTBI;
    *c1_O_RemainVolume = *c1_remainVolume;
    sf_mex_printf("%s =\\n", "init_infusion()");
    sf_mex_call("disp", 0U, 1U, 6, 0.0);
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_InfusionInSession;
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionSubMachine;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_InfusionSubMachine;
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
    chartInstance.c1_temporalCounter_i1 = 0U;
    c1_d69 = (real_T)c1_const_MSG_INFUSING;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d69, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_infusing = 1U;
    *c1_CurrentState = 28.0;
  } else if(_sfEvent_ == c1_event_E_Warning) {
    c1_warning();
    chartInstance.c1_is_ConfigureInfusionProgram = (uint8_T)c1_IN_ReadyToStart;
    chartInstance.c1_was_ConfigureInfusionProgram = (uint8_T)c1_IN_ReadyToStart;
    *c1_CurrentState = 48.0;
  } else if(_sfEvent_ == c1_event_E_NotReady) {
    c1_d70 = (real_T)c1_const_MSG_NOTREADY;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d70, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_DisplaySettings;
    chartInstance.c1_was_ConfigureInfusionProgram =
      (uint8_T)c1_IN_DisplaySettings;
    c1_d71 = (real_T)c1_const_MSG_DISPLAYSET;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d71, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 27.0;
  }
}

static void c1_PausedStopConfirm(void)
{
  real_T c1_d72;
  real_T c1_d73;
  real_T c1_d74;
  uint32_T c1_x;
  uint32_T *c1_infusing;
  uint32_T *c1_bolusing;
  real_T *c1_CurrentState;
  real_T *c1_ErrCond;
  c1_infusing = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 2);
  c1_CurrentState = (real_T *)ssGetOutputPortSignal(chartInstance.S, 8);
  c1_ErrCond = (real_T *)ssGetInputPortSignal(chartInstance.S, 2);
  c1_bolusing = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 4);
  if(_sfEvent_ == c1_event_E_Cancel) {
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionPaused;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_InfusionPaused;
    c1_d72 = (real_T)c1_const_MSG_INFUSIONPAUSED;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d72, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 36.0;
    *c1_infusing = 0U;
  } else if(_sfEvent_ == c1_event_E_Warning) {
    c1_warning();
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_PausedStopConfirm;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_PausedStopConfirm;
    c1_d73 = (real_T)c1_const_MSG_SPCHOOSE;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d73, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 38.0;
  } else if(_sfEvent_ == c1_event_E_ConfirmStopInfusion) {
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionStopped;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_InfusionStopped;
    c1_d74 = (real_T)c1_const_MSG_INFUSIONSTOP;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d74, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 39.0;
    *c1_infusing = 0U;
    *c1_bolusing = 0U;
    sf_mex_printf("%s\\n", "E_InfusionStopped");
    chartInstance.c1_E_InfusionStoppedEventCounter =
      chartInstance.c1_E_InfusionStoppedEventCounter + 1U;
  } else {
    c1_x = 0U;
    if((*c1_ErrCond > 0.0) && (*c1_ErrCond < 7.0)) {
      c1_x = 1U;
    } else if((*c1_ErrCond >= 7.0) && (*c1_ErrCond < 18.0)) {
      c1_x = 2U;
    } else if(*c1_ErrCond >= 18.0) {
      c1_x = 3U;
    } else if(*c1_ErrCond == 0.0) {
      c1_x = 0U;
    }
    if(c1_x == 2U) {
      chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
      c1_enter_atomic_LevelTwoAlarming();
    }
  }
}

static void c1_enter_atomic_LevelTwoAlarming(void)
{
  uint32_T c1_fCond;
  real_T c1_d75;
  real_T c1_d76;
  real_T c1_d77;
  real_T c1_d78;
  real_T c1_d79;
  real_T c1_d80;
  real_T c1_d81;
  real_T c1_d82;
  real_T c1_d83;
  real_T c1_d84;
  real_T c1_d85;
  uint32_T *c1_infusing;
  uint32_T *c1_bolusing;
  boolean_T *c1_O_BolusRequest;
  uint32_T *c1_infusionPaused;
  real_T *c1_ErrCond;
  real_T *c1_CurrentState;
  c1_infusing = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 2);
  c1_O_BolusRequest = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 7);
  c1_infusionPaused = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 5);
  c1_CurrentState = (real_T *)ssGetOutputPortSignal(chartInstance.S, 8);
  c1_ErrCond = (real_T *)ssGetInputPortSignal(chartInstance.S, 2);
  c1_bolusing = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 4);
  chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_LevelTwoAlarming;
  chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_LevelTwoAlarming;
  *c1_CurrentState = 44.0;
  *c1_infusing = 0U;
  *c1_bolusing = 0U;
  *c1_O_BolusRequest = 0U;
  *c1_infusionPaused = 0U;
  c1_fCond = (uint32_T)*c1_ErrCond;
  if(c1_fCond == 7U) {
    c1_d75 = (real_T)c1_const_MSG_EMPTYRESERVOIR;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d75, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(c1_fCond == 8U) {
    c1_d76 = (real_T)c1_const_MSG_VOLTOUTRANGE;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d76, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(c1_fCond == 9U) {
    c1_d77 = (real_T)c1_const_MSG_TEMPOUTRANGE;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d77, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(c1_fCond == 10U) {
    c1_d78 = (real_T)c1_const_MSG_DOOROPEN;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d78, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(c1_fCond == 11U) {
    c1_d79 = (real_T)c1_const_MSG_AIRINLINE;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d79, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(c1_fCond == 12U) {
    c1_d80 = (real_T)c1_const_MSG_OCCULUSION;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d80, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(c1_fCond == 13U) {
    c1_d81 = (real_T)c1_const_MSG_TOOLONGPAUSE;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d81, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(c1_fCond == 14U) {
    c1_d82 = (real_T)c1_const_MSG_RATEEXCEEDCAPACITY;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d82, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(c1_fCond == 15U) {
    c1_d83 = (real_T)c1_const_MSG_OVERINFUSION;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d83, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(c1_fCond == 16U) {
    c1_d84 = (real_T)c1_const_MSG_UNDERINFUSION;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d84, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(c1_fCond == 17U) {
    c1_d85 = (real_T)c1_const_MSG_LESSTHANKVO;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d85, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  }
  sf_mex_printf("%s\\n", "E_InfusionStopped");
  chartInstance.c1_E_InfusionStoppedEventCounter =
    chartInstance.c1_E_InfusionStoppedEventCounter + 1U;
}

static void c1_LevelTwoAlarming(void)
{
  real_T c1_d86;
  real_T c1_d87;
  real_T c1_d88;
  real_T c1_d89;
  real_T c1_d90;
  real_T *c1_ErrCond;
  uint32_T *c1_infusing;
  uint32_T *c1_bolusing;
  real_T *c1_CurrentState;
  c1_infusing = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 2);
  c1_CurrentState = (real_T *)ssGetOutputPortSignal(chartInstance.S, 8);
  c1_ErrCond = (real_T *)ssGetInputPortSignal(chartInstance.S, 2);
  c1_bolusing = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 4);
  if(_sfEvent_ == c1_event_E_Warning) {
    c1_warning();
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    c1_enter_atomic_LevelTwoAlarming();
  } else if(_sfEvent_ == c1_event_E_StopInfusion) {
    c1_d86 = (real_T)c1_const_MSG_BLANK;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d86, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
    chartInstance.c1_E_AlarmClearEventCounter =
      chartInstance.c1_E_AlarmClearEventCounter + 1U;
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionStopped;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_InfusionStopped;
    c1_d87 = (real_T)c1_const_MSG_INFUSIONSTOP;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d87, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 39.0;
    *c1_infusing = 0U;
    *c1_bolusing = 0U;
    sf_mex_printf("%s\\n", "E_InfusionStopped");
    chartInstance.c1_E_InfusionStoppedEventCounter =
      chartInstance.c1_E_InfusionStoppedEventCounter + 1U;
  } else if(_sfEvent_ == c1_event_E_ClearAlarm) {
    c1_d88 = (real_T)c1_const_MSG_BLANK;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d88, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
    chartInstance.c1_E_AlarmClearEventCounter =
      chartInstance.c1_E_AlarmClearEventCounter + 1U;
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionSubMachine;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_InfusionSubMachine;
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
    chartInstance.c1_temporalCounter_i1 = 0U;
    c1_d89 = (real_T)c1_const_MSG_INFUSING;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d89, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_infusing = 1U;
    *c1_CurrentState = 28.0;
  } else if(*c1_ErrCond == 7.0) {
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_EmptyReservoir;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_EmptyReservoir;
    c1_d90 = (real_T)c1_const_MSG_EMPTYRESERVOIR;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d90, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
    *c1_infusing = 0U;
    *c1_bolusing = 0U;
    *c1_CurrentState = 40.0;
  }
}

static uint32_T c1_setLOneMsg(uint32_T c1_fcond)
{
  uint32_T c1_x;
  real_T c1_d91;
  real_T c1_d92;
  real_T c1_d93;
  real_T c1_d94;
  real_T c1_d95;
  real_T c1_d96;
  c1_x = 1U;
  if(c1_fcond == 2U) {
    c1_d91 = (real_T)c1_const_MSG_WATCHDOGCORRUPT;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d91, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(c1_fcond == 1U) {
    c1_d92 = (real_T)c1_const_MSG_REALTIMECLOCK;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d92, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(c1_fcond == 3U) {
    c1_d93 = (real_T)c1_const_MSG_WATCHDOGALERT;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d93, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(c1_fcond == 4U) {
    c1_d94 = (real_T)c1_const_MSG_OUTOFPOWER;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d94, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(c1_fcond == 5U) {
    c1_d95 = (real_T)c1_const_MSG_MEMORYCORRUPT;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d95, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  } else if(c1_fcond == 6U) {
    c1_d96 = (real_T)c1_const_MSG_CPUFAILURE;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d96, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
  }
  return c1_x;
}

static uint32_T c1_alrmLevel(void)
{
  uint32_T c1_x;
  real_T *c1_ErrCond;
  c1_ErrCond = (real_T *)ssGetInputPortSignal(chartInstance.S, 2);
  c1_x = 0U;
  if((*c1_ErrCond > 0.0) && (*c1_ErrCond < 7.0)) {
    return 1U;
  } else if((*c1_ErrCond >= 7.0) && (*c1_ErrCond < 18.0)) {
    return 2U;
  } else if(*c1_ErrCond >= 18.0) {
    return 3U;
  } else if(*c1_ErrCond == 0.0) {
    return 0U;
  }
  return c1_x;
}

static void c1_InfusionSubMachine(void)
{
  uint32_T c1_x;
  real_T c1_d97;
  real_T c1_d98;
  real_T c1_d99;
  real_T c1_d100;
  real_T c1_d101;
  real_T c1_d102;
  real_T c1_d103;
  real_T c1_d104;
  real_T c1_d105;
  real_T c1_d106;
  real_T c1_b_x;
  real_T c1_d107;
  real_T c1_d108;
  real_T c1_d109;
  real_T c1_d110;
  real_T c1_d111;
  real_T c1_d112;
  real_T c1_d113;
  real_T c1_d114;
  uint32_T *c1_infusionPaused;
  real_T *c1_currentVTBI;
  uint32_T *c1_infusing;
  boolean_T *c1_O_BolusRequest;
  boolean_T *c1_BolusInProgress;
  uint32_T *c1_bolusing;
  real_T *c1_CurrentState;
  real_T *c1_drupperhard;
  real_T *c1_drlowerhard;
  real_T *c1_druppersoft;
  real_T *c1_drlowersoft;
  real_T *c1_flowRate;
  real_T *c1_drugConcentration;
  real_T *c1_ErrCond;
  real_T *c1_programmedDoseRate;
  c1_infusing = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 2);
  c1_O_BolusRequest = (boolean_T *)ssGetOutputPortSignal(chartInstance.S, 7);
  c1_drlowerhard = (real_T *)ssGetInputPortSignal(chartInstance.S, 29);
  c1_infusionPaused = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 5);
  c1_programmedDoseRate = (real_T *)ssGetInputPortSignal(chartInstance.S, 1);
  c1_currentVTBI = (real_T *)ssGetInputPortSignal(chartInstance.S, 16);
  c1_CurrentState = (real_T *)ssGetOutputPortSignal(chartInstance.S, 8);
  c1_ErrCond = (real_T *)ssGetInputPortSignal(chartInstance.S, 2);
  c1_bolusing = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 4);
  c1_BolusInProgress = (boolean_T *)ssGetInputPortSignal(chartInstance.S, 4);
  c1_drupperhard = (real_T *)ssGetInputPortSignal(chartInstance.S, 33);
  c1_flowRate = (real_T *)ssGetOutputPortSignal(chartInstance.S, 3);
  c1_druppersoft = (real_T *)ssGetInputPortSignal(chartInstance.S, 32);
  c1_drugConcentration = (real_T *)ssGetInputPortSignal(chartInstance.S, 14);
  c1_drlowersoft = (real_T *)ssGetInputPortSignal(chartInstance.S, 30);
  c1_x = 0U;
  if((*c1_ErrCond > 0.0) && (*c1_ErrCond < 7.0)) {
    c1_x = 1U;
  } else if((*c1_ErrCond >= 7.0) && (*c1_ErrCond < 18.0)) {
    c1_x = 2U;
  } else if(*c1_ErrCond >= 18.0) {
    c1_x = 3U;
  } else if(*c1_ErrCond == 0.0) {
    c1_x = 0U;
  }
  if(c1_x == 2U) {
    *c1_infusionPaused = 1U;
    c1_exit_internal_InfusionSubMachine();
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    c1_enter_atomic_LevelTwoAlarming();
  } else {
    switch(chartInstance.c1_is_InfusionSubMachine) {
     case c1_IN_ALM_NewRateOutBound:
      if(_sfEvent_ == c1_event_E_Warning) {
        c1_warning();
        chartInstance.c1_is_InfusionSubMachine =
          (uint8_T)c1_IN_ALM_NewRateOutBound;
        c1_d97 = (real_T)c1_const_MSG_ALRMDR;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d97, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 32.0;
      } else if(_sfEvent_ == c1_event_E_ChangeDoseRate) {
        chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_ChangeRate;
        c1_d98 = (real_T)c1_const_MSG_CHANGEDR;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d98, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        sf_mex_export("GSetConVal", sf_mex_create(&chartInstance.c1_temp,
          "GSetConVal", 0, 0U, 0U, 0), 0);
        *c1_CurrentState = 30.0;
      } else if(_sfEvent_ == c1_event_E_Cancel) {
        chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
        chartInstance.c1_temporalCounter_i1 = 0U;
        c1_d99 = (real_T)c1_const_MSG_INFUSING;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d99, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_infusing = 1U;
        *c1_CurrentState = 28.0;
      } else if(*c1_currentVTBI == 0.0) {
        chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
        chartInstance.c1_temporalCounter_i1 = 0U;
        c1_d100 = (real_T)c1_const_MSG_INFUSING;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d100, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_infusing = 1U;
        *c1_CurrentState = 28.0;
      }
      break;
     case c1_IN_BolusRequest:
      *c1_O_BolusRequest = 0U;
      if(*c1_BolusInProgress == 0) {
        c1_d101 = (real_T)c1_const_MSG_BOLUSDENIED;
        sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d101, "GAlrmMsg", 0, 0U, 0U,
          0), 0);
        chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
        chartInstance.c1_temporalCounter_i1 = 0U;
        c1_d102 = (real_T)c1_const_MSG_INFUSING;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d102, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_infusing = 1U;
        *c1_CurrentState = 28.0;
      } else if(*c1_BolusInProgress == 1) {
        *c1_bolusing = 1U;
        c1_d103 = (real_T)c1_const_MSG_BOLUSGRANT;
        sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d103, "GAlrmMsg", 0, 0U, 0U,
          0), 0);
        chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
        chartInstance.c1_temporalCounter_i1 = 0U;
        c1_d104 = (real_T)c1_const_MSG_INFUSING;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d104, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_infusing = 1U;
        *c1_CurrentState = 28.0;
      }
      break;
     case c1_IN_ChangeRate:
      if(_sfEvent_ == c1_event_E_Warning) {
        c1_warning();
        chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_ChangeRate;
        c1_d105 = (real_T)c1_const_MSG_CHANGEDR;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d105, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        sf_mex_export("GSetConVal", sf_mex_create(&chartInstance.c1_temp,
          "GSetConVal", 0, 0U, 0U, 0), 0);
        *c1_CurrentState = 30.0;
      } else if(_sfEvent_ == c1_event_E_ConfirmDoseRate) {
        chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_CheckNewRate;
        c1_d106 = (real_T)c1_const_MSG_CHECKDR;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d106, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        c1_b_x = chartInstance.c1_temp;
        chartInstance.c1_tempx = 0U;
        if((c1_b_x > *c1_drupperhard) || (c1_b_x < *c1_drlowerhard)) {
          chartInstance.c1_tempx = 2U;
        } else if((c1_b_x <= *c1_drupperhard) && (c1_b_x >= *c1_drlowerhard)) {
          if((c1_b_x > *c1_druppersoft) || (c1_b_x < *c1_drlowersoft)) {
            chartInstance.c1_tempx = 1U;
          } else if((c1_b_x <= *c1_druppersoft) && (c1_b_x >= *c1_drlowersoft)) {
            chartInstance.c1_tempx = 0U;
          }
        }
        *c1_CurrentState = 31.0;
      } else if(_sfEvent_ == c1_event_E_Cancel) {
        chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
        chartInstance.c1_temporalCounter_i1 = 0U;
        c1_d107 = (real_T)c1_const_MSG_INFUSING;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d107, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_infusing = 1U;
        *c1_CurrentState = 28.0;
      } else if(*c1_currentVTBI == 0.0) {
        chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
        chartInstance.c1_temporalCounter_i1 = 0U;
        c1_d108 = (real_T)c1_const_MSG_INFUSING;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d108, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_infusing = 1U;
        *c1_CurrentState = 28.0;
      }
      break;
     case c1_IN_CheckNewRate:
      if(chartInstance.c1_tempx > 0U) {
        chartInstance.c1_is_InfusionSubMachine =
          (uint8_T)c1_IN_ALM_NewRateOutBound;
        c1_d109 = (real_T)c1_const_MSG_ALRMDR;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d109, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 32.0;
      } else if(chartInstance.c1_tempx == 0U) {
        c1_b_x = *c1_programmedDoseRate / *c1_drugConcentration;
        sf_mex_printf("%s =\\n", "x");
        sf_mex_call("disp", 0U, 1U, 6, c1_b_x);
        *c1_flowRate = c1_b_x;
        chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
        chartInstance.c1_temporalCounter_i1 = 0U;
        c1_d110 = (real_T)c1_const_MSG_INFUSING;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d110, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_infusing = 1U;
        *c1_CurrentState = 28.0;
      }
      break;
     case c1_IN_ConfirmPause:
      if(_sfEvent_ == c1_event_E_ConfirmPauseInfusion) {
        *c1_infusionPaused = 1U;
        chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
        chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionPaused;
        chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_InfusionPaused;
        c1_d111 = (real_T)c1_const_MSG_INFUSIONPAUSED;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d111, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 36.0;
        *c1_infusing = 0U;
      } else if(_sfEvent_ == c1_event_E_Warning) {
        c1_warning();
        chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_ConfirmPause;
        c1_d112 = (real_T)c1_const_MSG_CONFIRMPAUSE;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d112, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 34.0;
      } else if(_sfEvent_ == c1_event_E_Cancel) {
        chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
        chartInstance.c1_temporalCounter_i1 = 0U;
        c1_d113 = (real_T)c1_const_MSG_INFUSING;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d113, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_infusing = 1U;
        *c1_CurrentState = 28.0;
      } else if(*c1_currentVTBI == 0.0) {
        chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
        chartInstance.c1_temporalCounter_i1 = 0U;
        c1_d114 = (real_T)c1_const_MSG_INFUSING;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d114, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_infusing = 1U;
        *c1_CurrentState = 28.0;
      }
      break;
     case c1_IN_ConfirmStop:
      c1_ConfirmStop();
      break;
     case c1_IN_Infusing:
      c1_Infusing();
      break;
     default:
      chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
      break;
    }
  }
}

static void c1_exit_internal_InfusionSubMachine(void)
{
  switch(chartInstance.c1_is_InfusionSubMachine) {
   case c1_IN_ALM_NewRateOutBound:
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_BolusRequest:
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_ChangeRate:
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_CheckNewRate:
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_ConfirmPause:
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_ConfirmStop:
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_Infusing:
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   default:
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
  }
}

static void c1_WRN_VTBIOutBound(void)
{
  real_T c1_d115;
  real_T c1_d116;
  real_T c1_d117;
  real_T *c1_programmedVTBI;
  real_T *c1_O_ProgrammedVTBI;
  real_T *c1_CurrentState;
  c1_O_ProgrammedVTBI = (real_T *)ssGetOutputPortSignal(chartInstance.S, 6);
  c1_programmedVTBI = (real_T *)ssGetInputPortSignal(chartInstance.S, 0);
  c1_CurrentState = (real_T *)ssGetOutputPortSignal(chartInstance.S, 8);
  if(_sfEvent_ == c1_event_E_Warning) {
    c1_warning();
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_WRN_VTBIOutBound;
    chartInstance.c1_was_ConfigureInfusionProgram =
      (uint8_T)c1_IN_WRN_VTBIOutBound;
    c1_d115 = (real_T)c1_const_MSG_WRNVTBI;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d115, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 46.0;
  } else if(_sfEvent_ == c1_event_E_ConfirmVTBI) {
    *c1_O_ProgrammedVTBI = *c1_programmedVTBI;
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_DisplayDoseRate;
    chartInstance.c1_was_ConfigureInfusionProgram =
      (uint8_T)c1_IN_DisplayDoseRate;
    c1_d116 = (real_T)c1_const_MSG_DISPLAYDR;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d116, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    chartInstance.c1_tempx = 0U;
    *c1_CurrentState = 23.0;
  } else if(_sfEvent_ == c1_event_E_ChangeVTBI) {
    chartInstance.c1_is_ConfigureInfusionProgram = (uint8_T)c1_IN_ChangeVTBI;
    chartInstance.c1_was_ConfigureInfusionProgram = (uint8_T)c1_IN_ChangeVTBI;
    c1_d117 = (real_T)c1_const_MSG_CHANGEVTBI;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d117, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 20.0;
  }
}

static uint32_T c1_CheckDrug(void)
{
  uint32_T c1_x;
  uint32_T c1_b_x;
  boolean_T c1_guard1 = false;
  boolean_T c1_guard2 = false;
  boolean_T c1_guard3 = false;
  boolean_T c1_guard4 = false;
  real_T *c1_doseUnitMismatch;
  real_T *c1_doseAmountMismatch;
  real_T *c1_dlDrugID;
  real_T *c1_drugID;
  real_T *c1_dlDiluentVolume;
  real_T *c1_diluentVolume;
  real_T *c1_drugConcentration;
  real_T *c1_dcupperhard;
  real_T *c1_dclowerhard;
  real_T *c1_dclowersoft;
  real_T *c1_dcuppersoft;
  c1_doseAmountMismatch = (real_T *)ssGetInputPortSignal(chartInstance.S, 9);
  c1_dclowerhard = (real_T *)ssGetInputPortSignal(chartInstance.S, 37);
  c1_dclowersoft = (real_T *)ssGetInputPortSignal(chartInstance.S, 36);
  c1_diluentVolume = (real_T *)ssGetInputPortSignal(chartInstance.S, 7);
  c1_dlDrugID = (real_T *)ssGetInputPortSignal(chartInstance.S, 19);
  c1_drugID = (real_T *)ssGetInputPortSignal(chartInstance.S, 5);
  c1_dlDiluentVolume = (real_T *)ssGetInputPortSignal(chartInstance.S, 6);
  c1_dcupperhard = (real_T *)ssGetInputPortSignal(chartInstance.S, 34);
  c1_dcuppersoft = (real_T *)ssGetInputPortSignal(chartInstance.S, 35);
  c1_doseUnitMismatch = (real_T *)ssGetInputPortSignal(chartInstance.S, 8);
  c1_drugConcentration = (real_T *)ssGetInputPortSignal(chartInstance.S, 14);
  c1_x = 0U;
  c1_b_x = 0U;
  if(*c1_dlDrugID == *c1_drugID) {
    c1_b_x = 0U;
  } else if(*c1_dlDrugID != *c1_drugID) {
    c1_b_x = 1U;
  }
  c1_guard1 = false;
  c1_guard2 = false;
  c1_guard3 = false;
  c1_guard4 = false;
  if(c1_b_x == 0U) {
    c1_b_x = 0U;
    if(*c1_dlDiluentVolume == *c1_diluentVolume) {
      c1_b_x = 0U;
    } else if(*c1_dlDiluentVolume != *c1_diluentVolume) {
      c1_b_x = 1U;
    }
    if((c1_b_x == 0U) && (*c1_doseUnitMismatch == 0.0)) {
      c1_b_x = 0U;
      if((*c1_drugConcentration > *c1_dcupperhard) || (*c1_drugConcentration <
        *c1_dclowerhard)) {
        c1_b_x = 2U;
      } else if((*c1_drugConcentration <= *c1_dcupperhard) &&
       (*c1_drugConcentration >= *c1_dclowerhard)) {
        if((*c1_drugConcentration >= *c1_dclowersoft) && (*c1_drugConcentration
          <= *c1_dcuppersoft)) {
          c1_b_x = 0U;
        } else if((*c1_drugConcentration > *c1_dcuppersoft) &&
         (*c1_drugConcentration < *c1_dclowersoft)) {
          c1_b_x = 1U;
        }
      }
      if(c1_b_x == 0U) {
        if(*c1_doseAmountMismatch == 0.0) {
          if(*c1_doseAmountMismatch > 0.0) {
            c1_guard1 = true;
          } else {
            c1_x = 0U;
          }
        } else {
          c1_b_x = 0U;
          if((*c1_drugConcentration > *c1_dcupperhard) || (*c1_drugConcentration
            < *c1_dclowerhard)) {
            c1_b_x = 2U;
          } else if((*c1_drugConcentration <= *c1_dcupperhard) &&
           (*c1_drugConcentration >= *c1_dclowerhard)) {
            if((*c1_drugConcentration >= *c1_dclowersoft) &&
             (*c1_drugConcentration <= *c1_dcuppersoft)) {
              c1_b_x = 0U;
            } else if((*c1_drugConcentration > *c1_dcuppersoft) &&
             (*c1_drugConcentration < *c1_dclowersoft)) {
              c1_b_x = 1U;
            }
          }
          if(c1_b_x > 0U) {
            c1_guard1 = true;
          } else {
            c1_guard4 = true;
          }
        }
      } else {
        c1_guard4 = true;
      }
    } else {
      c1_guard3 = true;
    }
  } else {
    c1_guard2 = true;
  }
  if(c1_guard4 == true) {
    if(*c1_doseUnitMismatch > 0.0) {
      c1_guard1 = true;
    } else {
      c1_guard3 = true;
    }
  }
  if(c1_guard3 == true) {
    c1_b_x = 0U;
    if(*c1_dlDiluentVolume == *c1_diluentVolume) {
      c1_b_x = 0U;
    } else if(*c1_dlDiluentVolume != *c1_diluentVolume) {
      c1_b_x = 1U;
    }
    if(c1_b_x > 0U) {
      c1_guard1 = true;
    } else {
      c1_guard2 = true;
    }
  }
  if(c1_guard2 == true) {
    c1_b_x = 0U;
    if(*c1_dlDrugID == *c1_drugID) {
      c1_b_x = 0U;
    } else if(*c1_dlDrugID != *c1_drugID) {
      c1_b_x = 1U;
    }
    if(c1_b_x > 0U) {
      c1_guard1 = true;
    }
  }
  if(c1_guard1 == true) {
    return 1U;
  }
  return c1_x;
}

static uint32_T c1_checkAdminSet(void)
{
  uint32_T c1_x;
  real_T *c1_adminSetPassed;
  c1_adminSetPassed = (real_T *)ssGetInputPortSignal(chartInstance.S, 10);
  c1_x = 0U;
  if(*c1_adminSetPassed == 1.0) {
    return 1U;
  } else if(*c1_adminSetPassed != 1.0) {
    return 0U;
  }
  return c1_x;
}

static void c1_PausedTooLong(void)
{
  real_T c1_d118;
  real_T c1_d119;
  real_T c1_d120;
  uint32_T *c1_infusionPaused;
  uint32_T *c1_ClearCond;
  uint32_T *c1_infusing;
  uint32_T *c1_bolusing;
  real_T *c1_CurrentState;
  c1_infusing = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 2);
  c1_infusionPaused = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 5);
  c1_ClearCond = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  c1_CurrentState = (real_T *)ssGetOutputPortSignal(chartInstance.S, 8);
  c1_bolusing = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 4);
  if(_sfEvent_ == c1_event_E_StopInfusion) {
    *c1_infusionPaused = 0U;
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionStopped;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_InfusionStopped;
    c1_d118 = (real_T)c1_const_MSG_INFUSIONSTOP;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d118, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 39.0;
    *c1_infusing = 0U;
    *c1_bolusing = 0U;
    sf_mex_printf("%s\\n", "E_InfusionStopped");
    chartInstance.c1_E_InfusionStoppedEventCounter =
      chartInstance.c1_E_InfusionStoppedEventCounter + 1U;
  } else if(_sfEvent_ == c1_event_E_Warning) {
    c1_warning();
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_PausedTooLong;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_PausedTooLong;
    c1_d119 = (real_T)c1_const_MSG_TOOLONGPAUSE;
    sf_mex_export("GAlrmMsg", sf_mex_create(&c1_d119, "GAlrmMsg", 0, 0U, 0U, 0),
     0);
    *c1_CurrentState = 37.0;
  } else if(_sfEvent_ == c1_event_E_ClearAlarm) {
    *c1_ClearCond = 13U;
    sf_mex_printf("%s\\n", "E_AlarmClear");
    chartInstance.c1_E_AlarmClearEventCounter =
      chartInstance.c1_E_AlarmClearEventCounter + 1U;
    chartInstance.c1_is_InfusionInSession = (uint8_T)c1_IN_InfusionSubMachine;
    chartInstance.c1_was_InfusionInSession = (uint8_T)c1_IN_InfusionSubMachine;
    chartInstance.c1_is_InfusionSubMachine = (uint8_T)c1_IN_Infusing;
    chartInstance.c1_temporalCounter_i1 = 0U;
    c1_d120 = (real_T)c1_const_MSG_INFUSING;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d120, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_infusing = 1U;
    *c1_CurrentState = 28.0;
  }
}

static void c1_CheckDrugRoutine(void)
{
  uint32_T c1_b_tempx;
  real_T c1_d121;
  real_T c1_d122;
  real_T c1_d123;
  real_T c1_d124;
  real_T c1_d125;
  real_T c1_d126;
  real_T c1_d127;
  real_T c1_d128;
  real_T c1_d129;
  real_T c1_d130;
  real_T c1_d131;
  real_T c1_d132;
  real_T c1_d133;
  real_T c1_d134;
  real_T c1_d135;
  real_T c1_d136;
  real_T c1_d137;
  real_T c1_d138;
  real_T *c1_ErrCond;
  real_T *c1_CurrentState;
  real_T *c1_prime;
  real_T *c1_patientID;
  uint32_T *c1_O_PatientID;
  real_T *c1_patientAge;
  uint32_T *c1_O_PatientAge;
  real_T *c1_patientGender;
  uint32_T *c1_O_PatientGender;
  real_T *c1_patientWeight;
  uint32_T *c1_O_PatientWeight;
  real_T *c1_drugID;
  uint32_T *c1_O_DrugID;
  real_T *c1_drugConcentration;
  real_T *c1_O_DrugConc;
  real_T *c1_drunit;
  real_T *c1_O_DrugDoseUnit;
  real_T *c1_infusionAmount;
  real_T *c1_O_DrugAmount;
  real_T *c1_diluentVolume;
  real_T *c1_O_DrugDilVolume;
  real_T *c1_vtbiupperhard;
  real_T *c1_O_VTBIUH;
  real_T *c1_vtbiuppersoft;
  real_T *c1_O_VTBIUS;
  real_T *c1_vtbitypical;
  real_T *c1_O_VTBITypical;
  real_T *c1_vtbilowersoft;
  real_T *c1_O_VTBILS;
  real_T *c1_vtbilowerhard;
  real_T *c1_O_VTBILH;
  real_T *c1_vtbiunit;
  real_T *c1_O_VTBIUnit;
  real_T *c1_drupperhard;
  real_T *c1_O_DRUH;
  real_T *c1_druppersoft;
  real_T *c1_O_DRUS;
  real_T *c1_drtypical;
  real_T *c1_O_DRTypical;
  real_T *c1_drlowersoft;
  real_T *c1_O_DRLS;
  real_T *c1_drlowerhard;
  real_T *c1_O_DRLH;
  real_T *c1_doseUnitMismatch;
  real_T *c1_dcupperhard;
  real_T *c1_dclowerhard;
  real_T *c1_dclowersoft;
  real_T *c1_dcuppersoft;
  c1_O_PatientAge = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 23);
  c1_O_DRTypical = (real_T *)ssGetOutputPortSignal(chartInstance.S, 15);
  c1_vtbiupperhard = (real_T *)ssGetInputPortSignal(chartInstance.S, 28);
  c1_drlowerhard = (real_T *)ssGetInputPortSignal(chartInstance.S, 29);
  c1_O_PatientWeight = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 25);
  c1_O_DrugID = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 26);
  c1_dclowerhard = (real_T *)ssGetInputPortSignal(chartInstance.S, 37);
  c1_vtbilowerhard = (real_T *)ssGetInputPortSignal(chartInstance.S, 24);
  c1_drtypical = (real_T *)ssGetInputPortSignal(chartInstance.S, 31);
  c1_dclowersoft = (real_T *)ssGetInputPortSignal(chartInstance.S, 36);
  c1_O_VTBILS = (real_T *)ssGetOutputPortSignal(chartInstance.S, 12);
  c1_vtbilowersoft = (real_T *)ssGetInputPortSignal(chartInstance.S, 25);
  c1_diluentVolume = (real_T *)ssGetInputPortSignal(chartInstance.S, 7);
  c1_vtbitypical = (real_T *)ssGetInputPortSignal(chartInstance.S, 26);
  c1_patientWeight = (real_T *)ssGetInputPortSignal(chartInstance.S, 23);
  c1_O_VTBITypical = (real_T *)ssGetOutputPortSignal(chartInstance.S, 11);
  c1_O_PatientID = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 22);
  c1_O_DrugDilVolume = (real_T *)ssGetOutputPortSignal(chartInstance.S, 30);
  c1_O_VTBIUS = (real_T *)ssGetOutputPortSignal(chartInstance.S, 10);
  c1_O_DrugDoseUnit = (real_T *)ssGetOutputPortSignal(chartInstance.S, 28);
  c1_patientGender = (real_T *)ssGetInputPortSignal(chartInstance.S, 22);
  c1_CurrentState = (real_T *)ssGetOutputPortSignal(chartInstance.S, 8);
  c1_O_DRUS = (real_T *)ssGetOutputPortSignal(chartInstance.S, 17);
  c1_ErrCond = (real_T *)ssGetInputPortSignal(chartInstance.S, 2);
  c1_O_VTBILH = (real_T *)ssGetOutputPortSignal(chartInstance.S, 13);
  c1_drugID = (real_T *)ssGetInputPortSignal(chartInstance.S, 5);
  c1_O_PatientGender = (uint32_T *)ssGetOutputPortSignal(chartInstance.S, 24);
  c1_O_DrugConc = (real_T *)ssGetOutputPortSignal(chartInstance.S, 27);
  c1_drunit = (real_T *)ssGetInputPortSignal(chartInstance.S, 11);
  c1_infusionAmount = (real_T *)ssGetInputPortSignal(chartInstance.S, 13);
  c1_O_DRUH = (real_T *)ssGetOutputPortSignal(chartInstance.S, 16);
  c1_vtbiuppersoft = (real_T *)ssGetInputPortSignal(chartInstance.S, 27);
  c1_patientID = (real_T *)ssGetInputPortSignal(chartInstance.S, 20);
  c1_dcupperhard = (real_T *)ssGetInputPortSignal(chartInstance.S, 34);
  c1_O_DRLH = (real_T *)ssGetOutputPortSignal(chartInstance.S, 19);
  c1_vtbiunit = (real_T *)ssGetInputPortSignal(chartInstance.S, 12);
  c1_dcuppersoft = (real_T *)ssGetInputPortSignal(chartInstance.S, 35);
  c1_drupperhard = (real_T *)ssGetInputPortSignal(chartInstance.S, 33);
  c1_O_VTBIUH = (real_T *)ssGetOutputPortSignal(chartInstance.S, 9);
  c1_patientAge = (real_T *)ssGetInputPortSignal(chartInstance.S, 21);
  c1_prime = (real_T *)ssGetInputPortSignal(chartInstance.S, 18);
  c1_O_DrugAmount = (real_T *)ssGetOutputPortSignal(chartInstance.S, 29);
  c1_O_VTBIUnit = (real_T *)ssGetOutputPortSignal(chartInstance.S, 14);
  c1_O_DRLS = (real_T *)ssGetOutputPortSignal(chartInstance.S, 18);
  c1_druppersoft = (real_T *)ssGetInputPortSignal(chartInstance.S, 32);
  c1_doseUnitMismatch = (real_T *)ssGetInputPortSignal(chartInstance.S, 8);
  c1_drugConcentration = (real_T *)ssGetInputPortSignal(chartInstance.S, 14);
  c1_drlowersoft = (real_T *)ssGetInputPortSignal(chartInstance.S, 30);
  if(_sfEvent_ == c1_event_E_PowerButton) {
    chartInstance.c1_tempx = 1U;
    c1_b_tempx = chartInstance.c1_tempx;
    sf_mex_printf("%s =\\n", "tempx");
    sf_mex_call("disp", 0U, 1U, 6, (real_T)c1_b_tempx);
    c1_exit_internal_CheckDrugRoutine();
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_ConfirmPowerDown;
    c1_d121 = (real_T)c1_const_MSG_POWEROFF;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d121, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 2.0;
  } else if(c1_alrmLevel() == 1U) {
    c1_exit_internal_CheckDrugRoutine();
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_LEVELONEALRM;
    c1_setLOneMsg((uint32_T)*c1_ErrCond);
    *c1_CurrentState = 43.0;
  } else {
    switch(chartInstance.c1_is_CheckDrugRoutine) {
     case c1_IN_ALM_WrongAdminCheck:
      if(_sfEvent_ == c1_event_E_Warning) {
        c1_warning();
        chartInstance.c1_is_CheckDrugRoutine =
          (uint8_T)c1_IN_ALM_WrongAdminCheck;
        chartInstance.c1_was_CheckDrugRoutine =
          (uint8_T)c1_IN_ALM_WrongAdminCheck;
        c1_d122 = (real_T)c1_const_MSG_ADMINFAIL;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d122, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 6.0;
      } else if(_sfEvent_ == c1_event_E_CheckAdminSet) {
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_CheckAdminSet;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_CheckAdminSet;
        c1_d123 = (real_T)c1_const_MSG_ADMINCHECK;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d123, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 5.0;
        chartInstance.c1_tempx = c1_checkAdminSet();
      }
      break;
     case c1_IN_CheckAdminSet:
      if(chartInstance.c1_tempx == 0U) {
        chartInstance.c1_is_CheckDrugRoutine =
          (uint8_T)c1_IN_ALM_WrongAdminCheck;
        chartInstance.c1_was_CheckDrugRoutine =
          (uint8_T)c1_IN_ALM_WrongAdminCheck;
        c1_d124 = (real_T)c1_const_MSG_ADMINFAIL;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d124, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 6.0;
      } else if(chartInstance.c1_tempx == 1U) {
        chartInstance.c1_E_RestartEventCounter =
          chartInstance.c1_E_RestartEventCounter + 1U;
        *c1_O_VTBIUH = *c1_vtbiupperhard;
        *c1_O_VTBIUS = *c1_vtbiuppersoft;
        *c1_O_VTBITypical = *c1_vtbitypical;
        *c1_O_VTBILS = *c1_vtbilowersoft;
        *c1_O_VTBILH = *c1_vtbilowerhard;
        *c1_O_VTBIUnit = *c1_vtbiunit;
        *c1_O_DRUH = *c1_drupperhard;
        *c1_O_DRUS = *c1_druppersoft;
        *c1_O_DRTypical = *c1_drtypical;
        *c1_O_DRLS = *c1_drlowersoft;
        *c1_O_DRLH = *c1_drlowerhard;
        *c1_O_PatientID = (uint32_T)*c1_patientID;
        *c1_O_PatientAge = (uint32_T)*c1_patientAge;
        *c1_O_PatientGender = (uint32_T)*c1_patientGender;
        *c1_O_PatientWeight = (uint32_T)*c1_patientWeight;
        *c1_O_DrugID = (uint32_T)*c1_drugID;
        *c1_O_DrugConc = *c1_drugConcentration;
        *c1_O_DrugDoseUnit = *c1_drunit;
        *c1_O_DrugAmount = *c1_infusionAmount;
        *c1_O_DrugDilVolume = *c1_diluentVolume;
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_CheckPrime;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_CheckPrime;
        c1_d125 = (real_T)c1_const_MSG_PRIME;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d125, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 7.0;
        chartInstance.c1_tempx = 0U;
        if(*c1_prime == 1.0) {
          chartInstance.c1_tempx = 1U;
        } else if(*c1_prime != 1.0) {
          chartInstance.c1_tempx = 0U;
        }
      }
      break;
     case c1_IN_CheckDrug_CheckType:
      if(c1_drugTypeMismatch() == 1U) {
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_UnknownDrug;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_UnknownDrug;
        c1_d126 = (real_T)c1_const_MSG_WRONGDRUG;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d126, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 11.0;
      } else if(c1_drugTypeMismatch() == 0U) {
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_Check_DoseUnit;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_Check_DoseUnit;
        c1_d127 = (real_T)c1_const_MSG_CHECKDU;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d127, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 12.0;
      }
      break;
     case c1_IN_CheckPrime:
      if(chartInstance.c1_tempx == 0U) {
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_PrimeFailed;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_PrimeFailed;
        c1_d128 = (real_T)c1_const_MSG_PRIMEFAIL;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d128, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 8.0;
      } else if(chartInstance.c1_tempx == 1U) {
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_DisplayDrugInfo;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_DisplayDrugInfo;
        chartInstance.c1_tempx = 0U;
        c1_d129 = (real_T)c1_const_MSG_DRUGINFO;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d129, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 9.0;
      }
      break;
     case c1_IN_Check_Concen:
      if(chartInstance.c1_tempx == 2U) {
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_WrongConcentration;
        chartInstance.c1_was_CheckDrugRoutine =
          (uint8_T)c1_IN_WrongConcentration;
        c1_d130 = (real_T)c1_const_MSG_WRONGCON;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d130, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 15.0;
      } else if(chartInstance.c1_tempx == 1U) {
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_WRN_DangerCon;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_WRN_DangerCon;
        c1_d131 = (real_T)c1_const_MSG_DANGECON;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d131, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 16.0;
      } else if(chartInstance.c1_tempx == 0U) {
        chartInstance.c1_is_CheckDrugRoutine =
          (uint8_T)c1_IN_DisplayPatientProfile;
        chartInstance.c1_was_CheckDrugRoutine =
          (uint8_T)c1_IN_DisplayPatientProfile;
        c1_d132 = (real_T)c1_const_MSG_PATIENTINFO;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d132, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 18.0;
      }
      break;
     case c1_IN_Check_DoseUnit:
      if(*c1_doseUnitMismatch != 0.0) {
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_IncorrectDoseUnit;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_IncorrectDoseUnit;
        c1_d133 = (real_T)c1_const_MSG_WRONGDU;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d133, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 13.0;
      } else if(*c1_doseUnitMismatch == 0.0) {
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_Check_Concen;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_Check_Concen;
        c1_d134 = (real_T)c1_const_MSG_CHECKCON;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d134, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 14.0;
        chartInstance.c1_tempx = 0U;
        if((*c1_drugConcentration > *c1_dcupperhard) || (*c1_drugConcentration <
          *c1_dclowerhard)) {
          chartInstance.c1_tempx = 2U;
        } else if((*c1_drugConcentration <= *c1_dcupperhard) &&
         (*c1_drugConcentration >= *c1_dclowerhard)) {
          if((*c1_drugConcentration >= *c1_dclowersoft) &&
           (*c1_drugConcentration <= *c1_dcuppersoft)) {
            chartInstance.c1_tempx = 0U;
          } else if((*c1_drugConcentration > *c1_dcuppersoft) &&
           (*c1_drugConcentration < *c1_dclowersoft)) {
            chartInstance.c1_tempx = 1U;
          }
        }
      }
      break;
     case c1_IN_DisplayDrugInfo:
      if(_sfEvent_ == c1_event_E_CheckDrug) {
        chartInstance.c1_is_CheckDrugRoutine =
          (uint8_T)c1_IN_CheckDrug_CheckType;
        chartInstance.c1_was_CheckDrugRoutine =
          (uint8_T)c1_IN_CheckDrug_CheckType;
        c1_d135 = (real_T)c1_const_MSG_CHECKTYPE;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d135, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 10.0;
      } else if(_sfEvent_ == c1_event_E_Warning) {
        c1_warning();
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_DisplayDrugInfo;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_DisplayDrugInfo;
        chartInstance.c1_tempx = 0U;
        c1_d136 = (real_T)c1_const_MSG_DRUGINFO;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d136, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 9.0;
      }
      break;
     case c1_IN_DisplayPatientProfile:
      c1_DisplayPatientProfile();
      break;
     case c1_IN_IncorrectDoseUnit:
      if(_sfEvent_ == c1_event_E_CheckDrug) {
        chartInstance.c1_is_CheckDrugRoutine =
          (uint8_T)c1_IN_CheckDrug_CheckType;
        chartInstance.c1_was_CheckDrugRoutine =
          (uint8_T)c1_IN_CheckDrug_CheckType;
        c1_d137 = (real_T)c1_const_MSG_CHECKTYPE;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d137, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 10.0;
      } else if(_sfEvent_ == c1_event_E_Warning) {
        c1_warning();
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_IncorrectDoseUnit;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_IncorrectDoseUnit;
        c1_d138 = (real_T)c1_const_MSG_WRONGDU;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d138, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 13.0;
      }
      break;
     case c1_IN_PrimeFailed:
      c1_PrimeFailed();
      break;
     case c1_IN_UnknownDrug:
      c1_UnknownDrug();
      break;
     case c1_IN_WRN_DangerCon:
      c1_WRN_DangerCon();
      break;
     case c1_IN_WrongConcentration:
      c1_WrongConcentration();
      break;
     default:
      chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
      break;
    }
  }
}

static void c1_exit_internal_CheckDrugRoutine(void)
{
  switch(chartInstance.c1_is_CheckDrugRoutine) {
   case c1_IN_ALM_WrongAdminCheck:
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_CheckAdminSet:
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_CheckDrug_CheckType:
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_CheckPrime:
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_Check_Concen:
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_Check_DoseUnit:
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_DisplayDrugInfo:
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_DisplayPatientProfile:
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_IncorrectDoseUnit:
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_PrimeFailed:
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_UnknownDrug:
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_WRN_DangerCon:
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_WrongConcentration:
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   default:
    chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
  }
}

static void c1_enter_internal_ConfigureInfusionProgram(void)
{
  real_T c1_d139;
  real_T c1_d140;
  real_T c1_d141;
  real_T c1_d142;
  real_T c1_d143;
  real_T c1_d144;
  real_T c1_d145;
  real_T c1_d146;
  real_T c1_d147;
  real_T c1_d148;
  real_T c1_d149;
  real_T *c1_CurrentState;
  real_T *c1_vtbiupperhard;
  real_T *c1_vtbilowerhard;
  real_T *c1_vtbiuppersoft;
  real_T *c1_vtbilowersoft;
  real_T *c1_drupperhard;
  real_T *c1_drlowerhard;
  real_T *c1_druppersoft;
  real_T *c1_drlowersoft;
  real_T *c1_programmedVTBI;
  real_T *c1_programmedDoseRate;
  c1_vtbiupperhard = (real_T *)ssGetInputPortSignal(chartInstance.S, 28);
  c1_drlowerhard = (real_T *)ssGetInputPortSignal(chartInstance.S, 29);
  c1_vtbilowerhard = (real_T *)ssGetInputPortSignal(chartInstance.S, 24);
  c1_programmedDoseRate = (real_T *)ssGetInputPortSignal(chartInstance.S, 1);
  c1_vtbilowersoft = (real_T *)ssGetInputPortSignal(chartInstance.S, 25);
  c1_programmedVTBI = (real_T *)ssGetInputPortSignal(chartInstance.S, 0);
  c1_CurrentState = (real_T *)ssGetOutputPortSignal(chartInstance.S, 8);
  c1_vtbiuppersoft = (real_T *)ssGetInputPortSignal(chartInstance.S, 27);
  c1_drupperhard = (real_T *)ssGetInputPortSignal(chartInstance.S, 33);
  c1_druppersoft = (real_T *)ssGetInputPortSignal(chartInstance.S, 32);
  c1_drlowersoft = (real_T *)ssGetInputPortSignal(chartInstance.S, 30);
  switch(chartInstance.c1_was_ConfigureInfusionProgram) {
   case c1_IN_ALM_DoseRateOutBound:
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_ALM_DoseRateOutBound;
    chartInstance.c1_was_ConfigureInfusionProgram =
      (uint8_T)c1_IN_ALM_DoseRateOutBound;
    c1_d139 = (real_T)c1_const_MSG_ALRMDR;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d139, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 26.0;
    break;
   case c1_IN_ALM_VTBIOutBound:
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_ALM_VTBIOutBound;
    chartInstance.c1_was_ConfigureInfusionProgram =
      (uint8_T)c1_IN_ALM_VTBIOutBound;
    c1_d140 = (real_T)c1_const_MSG_ALMVTBI;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d140, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 22.0;
    break;
   case c1_IN_ChangeDoseRate:
    chartInstance.c1_is_ConfigureInfusionProgram = (uint8_T)c1_IN_ChangeDoseRate;
    chartInstance.c1_was_ConfigureInfusionProgram =
      (uint8_T)c1_IN_ChangeDoseRate;
    c1_d141 = (real_T)c1_const_MSG_CHANGEDR;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d141, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 24.0;
    break;
   case c1_IN_ChangeVTBI:
    chartInstance.c1_is_ConfigureInfusionProgram = (uint8_T)c1_IN_ChangeVTBI;
    chartInstance.c1_was_ConfigureInfusionProgram = (uint8_T)c1_IN_ChangeVTBI;
    c1_d142 = (real_T)c1_const_MSG_CHANGEVTBI;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d142, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 20.0;
    break;
   case c1_IN_CheckDoseRate:
    chartInstance.c1_is_ConfigureInfusionProgram = (uint8_T)c1_IN_CheckDoseRate;
    chartInstance.c1_was_ConfigureInfusionProgram = (uint8_T)c1_IN_CheckDoseRate;
    c1_d143 = (real_T)c1_const_MSG_CHECKDR;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d143, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 25.0;
    chartInstance.c1_tempx = 0U;
    if((*c1_programmedDoseRate > *c1_drupperhard) || (*c1_programmedDoseRate <
      *c1_drlowerhard)) {
      chartInstance.c1_tempx = 2U;
    } else if((*c1_programmedDoseRate <= *c1_drupperhard) &&
     (*c1_programmedDoseRate >= *c1_drlowerhard)) {
      if((*c1_programmedDoseRate > *c1_druppersoft) || (*c1_programmedDoseRate <
        *c1_drlowersoft)) {
        chartInstance.c1_tempx = 1U;
      } else if((*c1_programmedDoseRate <= *c1_druppersoft) &&
       (*c1_programmedDoseRate >= *c1_drlowersoft)) {
        chartInstance.c1_tempx = 0U;
      }
    }
    break;
   case c1_IN_CheckVTBI:
    chartInstance.c1_is_ConfigureInfusionProgram = (uint8_T)c1_IN_CheckVTBI;
    chartInstance.c1_was_ConfigureInfusionProgram = (uint8_T)c1_IN_CheckVTBI;
    c1_d144 = (real_T)c1_const_MSG_CHECKVTBI;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d144, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    chartInstance.c1_tempx = 0U;
    if((*c1_programmedVTBI > *c1_vtbiupperhard) || (*c1_programmedVTBI <
      *c1_vtbilowerhard)) {
      chartInstance.c1_tempx = 2U;
    } else if((*c1_programmedVTBI > *c1_vtbiuppersoft) || (*c1_programmedVTBI <
      *c1_vtbilowersoft)) {
      chartInstance.c1_tempx = 1U;
    } else if((*c1_programmedVTBI <= *c1_vtbiuppersoft) && (*c1_programmedVTBI
      >= *c1_vtbilowersoft)) {
      chartInstance.c1_tempx = 0U;
    }
    *c1_CurrentState = 21.0;
    break;
   case c1_IN_DisplayDoseRate:
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_DisplayDoseRate;
    chartInstance.c1_was_ConfigureInfusionProgram =
      (uint8_T)c1_IN_DisplayDoseRate;
    c1_d145 = (real_T)c1_const_MSG_DISPLAYDR;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d145, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    chartInstance.c1_tempx = 0U;
    *c1_CurrentState = 23.0;
    break;
   case c1_IN_DisplaySettings:
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_DisplaySettings;
    chartInstance.c1_was_ConfigureInfusionProgram =
      (uint8_T)c1_IN_DisplaySettings;
    c1_d146 = (real_T)c1_const_MSG_DISPLAYSET;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d146, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 27.0;
    break;
   case c1_IN_DisplayVTBI:
    chartInstance.c1_is_ConfigureInfusionProgram = (uint8_T)c1_IN_DisplayVTBI;
    chartInstance.c1_was_ConfigureInfusionProgram = (uint8_T)c1_IN_DisplayVTBI;
    c1_d147 = (real_T)c1_const_MSG_VTBI;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d147, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 19.0;
    break;
   case c1_IN_ReadyToStart:
    chartInstance.c1_is_ConfigureInfusionProgram = (uint8_T)c1_IN_ReadyToStart;
    chartInstance.c1_was_ConfigureInfusionProgram = (uint8_T)c1_IN_ReadyToStart;
    *c1_CurrentState = 48.0;
    break;
   case c1_IN_WRN_DOSERATEOUTSOFTLIMITS:
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_WRN_DOSERATEOUTSOFTLIMITS;
    chartInstance.c1_was_ConfigureInfusionProgram =
      (uint8_T)c1_IN_WRN_DOSERATEOUTSOFTLIMITS;
    c1_d148 = (real_T)c1_const_MSG_WRNDR;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d148, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 47.0;
    break;
   case c1_IN_WRN_VTBIOutBound:
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_WRN_VTBIOutBound;
    chartInstance.c1_was_ConfigureInfusionProgram =
      (uint8_T)c1_IN_WRN_VTBIOutBound;
    c1_d149 = (real_T)c1_const_MSG_WRNVTBI;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d149, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 46.0;
    break;
  }
}

static void c1_ConfigureInfusionProgram(void)
{
  uint32_T c1_b_tempx;
  real_T c1_d150;
  real_T c1_d151;
  real_T c1_d152;
  real_T c1_d153;
  real_T c1_d154;
  real_T c1_d155;
  real_T c1_d156;
  real_T c1_d157;
  real_T c1_d158;
  real_T c1_d159;
  real_T c1_d160;
  real_T c1_d161;
  real_T c1_x;
  real_T c1_d162;
  real_T c1_d163;
  real_T c1_d164;
  real_T c1_d165;
  real_T c1_d166;
  real_T c1_d167;
  real_T c1_d168;
  real_T *c1_ErrCond;
  real_T *c1_CurrentState;
  real_T *c1_drupperhard;
  real_T *c1_drlowerhard;
  real_T *c1_druppersoft;
  real_T *c1_drlowersoft;
  real_T *c1_vtbiupperhard;
  real_T *c1_vtbilowerhard;
  real_T *c1_vtbiuppersoft;
  real_T *c1_vtbilowersoft;
  real_T *c1_flowRate;
  real_T *c1_drugConcentration;
  real_T *c1_programmedVTBI;
  real_T *c1_O_ProgrammedVTBI;
  real_T *c1_programmedDoseRate;
  c1_vtbiupperhard = (real_T *)ssGetInputPortSignal(chartInstance.S, 28);
  c1_drlowerhard = (real_T *)ssGetInputPortSignal(chartInstance.S, 29);
  c1_O_ProgrammedVTBI = (real_T *)ssGetOutputPortSignal(chartInstance.S, 6);
  c1_vtbilowerhard = (real_T *)ssGetInputPortSignal(chartInstance.S, 24);
  c1_programmedDoseRate = (real_T *)ssGetInputPortSignal(chartInstance.S, 1);
  c1_vtbilowersoft = (real_T *)ssGetInputPortSignal(chartInstance.S, 25);
  c1_programmedVTBI = (real_T *)ssGetInputPortSignal(chartInstance.S, 0);
  c1_CurrentState = (real_T *)ssGetOutputPortSignal(chartInstance.S, 8);
  c1_ErrCond = (real_T *)ssGetInputPortSignal(chartInstance.S, 2);
  c1_vtbiuppersoft = (real_T *)ssGetInputPortSignal(chartInstance.S, 27);
  c1_drupperhard = (real_T *)ssGetInputPortSignal(chartInstance.S, 33);
  c1_flowRate = (real_T *)ssGetOutputPortSignal(chartInstance.S, 3);
  c1_druppersoft = (real_T *)ssGetInputPortSignal(chartInstance.S, 32);
  c1_drugConcentration = (real_T *)ssGetInputPortSignal(chartInstance.S, 14);
  c1_drlowersoft = (real_T *)ssGetInputPortSignal(chartInstance.S, 30);
  if(_sfEvent_ == c1_event_E_PowerButton) {
    chartInstance.c1_tempx = 2U;
    c1_b_tempx = chartInstance.c1_tempx;
    sf_mex_printf("%s =\\n", "tempx");
    sf_mex_call("disp", 0U, 1U, 6, (real_T)c1_b_tempx);
    c1_exit_internal_ConfigureInfusionProgram();
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_ConfirmPowerDown;
    c1_d150 = (real_T)c1_const_MSG_POWEROFF;
    sf_mex_export("GMsgConStr", sf_mex_create(&c1_d150, "GMsgConStr", 0, 0U, 0U,
      0), 0);
    *c1_CurrentState = 2.0;
  } else if(c1_alrmLevel() == 1U) {
    c1_exit_internal_ConfigureInfusionProgram();
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_LEVELONEALRM;
    c1_setLOneMsg((uint32_T)*c1_ErrCond);
    *c1_CurrentState = 43.0;
  } else {
    switch(chartInstance.c1_is_ConfigureInfusionProgram) {
     case c1_IN_ALM_DoseRateOutBound:
      if(_sfEvent_ == c1_event_E_Warning) {
        c1_warning();
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ALM_DoseRateOutBound;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ALM_DoseRateOutBound;
        c1_d151 = (real_T)c1_const_MSG_ALRMDR;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d151, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 26.0;
      } else if(_sfEvent_ == c1_event_E_ChangeDoseRate) {
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ChangeDoseRate;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ChangeDoseRate;
        c1_d152 = (real_T)c1_const_MSG_CHANGEDR;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d152, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 24.0;
      }
      break;
     case c1_IN_ALM_VTBIOutBound:
      if(_sfEvent_ == c1_event_E_Warning) {
        c1_warning();
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ALM_VTBIOutBound;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ALM_VTBIOutBound;
        c1_d153 = (real_T)c1_const_MSG_ALMVTBI;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d153, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 22.0;
      } else if(_sfEvent_ == c1_event_E_ChangeVTBI) {
        chartInstance.c1_is_ConfigureInfusionProgram = (uint8_T)c1_IN_ChangeVTBI;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ChangeVTBI;
        c1_d154 = (real_T)c1_const_MSG_CHANGEVTBI;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d154, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 20.0;
      }
      break;
     case c1_IN_ChangeDoseRate:
      if(_sfEvent_ == c1_event_E_ConfirmDoseRate) {
        chartInstance.c1_tempx = 2U;
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_CheckDoseRate;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_CheckDoseRate;
        c1_d155 = (real_T)c1_const_MSG_CHECKDR;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d155, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 25.0;
        chartInstance.c1_tempx = 0U;
        if((*c1_programmedDoseRate > *c1_drupperhard) || (*c1_programmedDoseRate
          < *c1_drlowerhard)) {
          chartInstance.c1_tempx = 2U;
        } else if((*c1_programmedDoseRate <= *c1_drupperhard) &&
         (*c1_programmedDoseRate >= *c1_drlowerhard)) {
          if((*c1_programmedDoseRate > *c1_druppersoft) ||
           (*c1_programmedDoseRate < *c1_drlowersoft)) {
            chartInstance.c1_tempx = 1U;
          } else if((*c1_programmedDoseRate <= *c1_druppersoft) &&
           (*c1_programmedDoseRate >= *c1_drlowersoft)) {
            chartInstance.c1_tempx = 0U;
          }
        }
      } else if(_sfEvent_ == c1_event_E_Warning) {
        c1_warning();
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ChangeDoseRate;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ChangeDoseRate;
        c1_d156 = (real_T)c1_const_MSG_CHANGEDR;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d156, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 24.0;
      } else if(_sfEvent_ == c1_event_E_Cancel) {
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_DisplayDoseRate;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_DisplayDoseRate;
        c1_d157 = (real_T)c1_const_MSG_DISPLAYDR;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d157, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        chartInstance.c1_tempx = 0U;
        *c1_CurrentState = 23.0;
      }
      break;
     case c1_IN_ChangeVTBI:
      if(_sfEvent_ == c1_event_E_ConfirmVTBI) {
        chartInstance.c1_is_ConfigureInfusionProgram = (uint8_T)c1_IN_CheckVTBI;
        chartInstance.c1_was_ConfigureInfusionProgram = (uint8_T)c1_IN_CheckVTBI;
        c1_d158 = (real_T)c1_const_MSG_CHECKVTBI;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d158, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        chartInstance.c1_tempx = 0U;
        if((*c1_programmedVTBI > *c1_vtbiupperhard) || (*c1_programmedVTBI <
          *c1_vtbilowerhard)) {
          chartInstance.c1_tempx = 2U;
        } else if((*c1_programmedVTBI > *c1_vtbiuppersoft) ||
         (*c1_programmedVTBI < *c1_vtbilowersoft)) {
          chartInstance.c1_tempx = 1U;
        } else if((*c1_programmedVTBI <= *c1_vtbiuppersoft) &&
         (*c1_programmedVTBI >= *c1_vtbilowersoft)) {
          chartInstance.c1_tempx = 0U;
        }
        *c1_CurrentState = 21.0;
      } else if(_sfEvent_ == c1_event_E_Cancel) {
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_DisplayVTBI;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_DisplayVTBI;
        c1_d159 = (real_T)c1_const_MSG_VTBI;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d159, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 19.0;
      } else if(_sfEvent_ == c1_event_E_Warning) {
        c1_warning();
        chartInstance.c1_is_ConfigureInfusionProgram = (uint8_T)c1_IN_ChangeVTBI;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ChangeVTBI;
        c1_d160 = (real_T)c1_const_MSG_CHANGEVTBI;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d160, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 20.0;
      }
      break;
     case c1_IN_CheckDoseRate:
      if(chartInstance.c1_tempx == 2U) {
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ALM_DoseRateOutBound;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ALM_DoseRateOutBound;
        c1_d161 = (real_T)c1_const_MSG_ALRMDR;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d161, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 26.0;
      } else if(chartInstance.c1_tempx == 0U) {
        c1_x = *c1_programmedDoseRate / *c1_drugConcentration;
        sf_mex_printf("%s =\\n", "x");
        sf_mex_call("disp", 0U, 1U, 6, c1_x);
        *c1_flowRate = c1_x;
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_DisplaySettings;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_DisplaySettings;
        c1_d162 = (real_T)c1_const_MSG_DISPLAYSET;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d162, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 27.0;
      } else if(chartInstance.c1_tempx == 1U) {
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_WRN_DOSERATEOUTSOFTLIMITS;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_WRN_DOSERATEOUTSOFTLIMITS;
        c1_d163 = (real_T)c1_const_MSG_WRNDR;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d163, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 47.0;
      }
      break;
     case c1_IN_CheckVTBI:
      if(chartInstance.c1_tempx == 1U) {
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_WRN_VTBIOutBound;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_WRN_VTBIOutBound;
        c1_d164 = (real_T)c1_const_MSG_WRNVTBI;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d164, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 46.0;
      } else if(chartInstance.c1_tempx == 0U) {
        *c1_O_ProgrammedVTBI = *c1_programmedVTBI;
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_DisplayDoseRate;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_DisplayDoseRate;
        c1_d165 = (real_T)c1_const_MSG_DISPLAYDR;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d165, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        chartInstance.c1_tempx = 0U;
        *c1_CurrentState = 23.0;
      } else if(chartInstance.c1_tempx == 2U) {
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ALM_VTBIOutBound;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ALM_VTBIOutBound;
        c1_d166 = (real_T)c1_const_MSG_ALMVTBI;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d166, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 22.0;
      }
      break;
     case c1_IN_DisplayDoseRate:
      c1_DisplayDoseRate();
      break;
     case c1_IN_DisplaySettings:
      c1_DisplaySettings();
      break;
     case c1_IN_DisplayVTBI:
      c1_DisplayVTBI();
      break;
     case c1_IN_ReadyToStart:
      c1_ReadyToStart();
      break;
     case c1_IN_WRN_DOSERATEOUTSOFTLIMITS:
      if(_sfEvent_ == c1_event_E_ConfirmDoseRate) {
        c1_x = *c1_programmedDoseRate / *c1_drugConcentration;
        sf_mex_printf("%s =\\n", "x");
        sf_mex_call("disp", 0U, 1U, 6, c1_x);
        *c1_flowRate = c1_x;
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_DisplaySettings;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_DisplaySettings;
        c1_d167 = (real_T)c1_const_MSG_DISPLAYSET;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d167, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 27.0;
      } else if(_sfEvent_ == c1_event_E_ChangeDoseRate) {
        chartInstance.c1_is_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ChangeDoseRate;
        chartInstance.c1_was_ConfigureInfusionProgram =
          (uint8_T)c1_IN_ChangeDoseRate;
        c1_d168 = (real_T)c1_const_MSG_CHANGEDR;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d168, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 24.0;
      }
      break;
     case c1_IN_WRN_VTBIOutBound:
      c1_WRN_VTBIOutBound();
      break;
     default:
      chartInstance.c1_is_ConfigureInfusionProgram =
        (uint8_T)c1_IN_NO_ACTIVE_CHILD;
      break;
    }
  }
}

static void c1_exit_internal_ConfigureInfusionProgram(void)
{
  switch(chartInstance.c1_is_ConfigureInfusionProgram) {
   case c1_IN_ALM_DoseRateOutBound:
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_ALM_VTBIOutBound:
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_ChangeDoseRate:
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_ChangeVTBI:
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_CheckDoseRate:
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_CheckVTBI:
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_DisplayDoseRate:
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_DisplaySettings:
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_DisplayVTBI:
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_ReadyToStart:
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_WRN_DOSERATEOUTSOFTLIMITS:
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   case c1_IN_WRN_VTBIOutBound:
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
   default:
    chartInstance.c1_is_ConfigureInfusionProgram =
      (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
  }
}

static void c1_InfusionStateMachine(void)
{
  real_T c1_d169;
  real_T c1_d170;
  real_T c1_d171;
  real_T c1_d172;
  real_T c1_d173;
  real_T c1_d174;
  real_T c1_d175;
  real_T c1_d176;
  real_T c1_d177;
  real_T c1_d178;
  real_T c1_d179;
  real_T c1_d180;
  real_T c1_d181;
  real_T c1_d182;
  real_T c1_d183;
  real_T c1_d184;
  real_T c1_d185;
  real_T c1_d186;
  uint32_T c1_b_tempx;
  real_T c1_d187;
  real_T c1_d188;
  real_T c1_d189;
  real_T *c1_CurrentState;
  real_T *c1_drugConcentration;
  real_T *c1_dcupperhard;
  real_T *c1_dclowerhard;
  real_T *c1_dclowersoft;
  real_T *c1_dcuppersoft;
  real_T *c1_prime;
  real_T *c1_adminSetPassed;
  c1_dclowerhard = (real_T *)ssGetInputPortSignal(chartInstance.S, 37);
  c1_dclowersoft = (real_T *)ssGetInputPortSignal(chartInstance.S, 36);
  c1_CurrentState = (real_T *)ssGetOutputPortSignal(chartInstance.S, 8);
  c1_dcupperhard = (real_T *)ssGetInputPortSignal(chartInstance.S, 34);
  c1_dcuppersoft = (real_T *)ssGetInputPortSignal(chartInstance.S, 35);
  c1_prime = (real_T *)ssGetInputPortSignal(chartInstance.S, 18);
  c1_adminSetPassed = (real_T *)ssGetInputPortSignal(chartInstance.S, 10);
  c1_drugConcentration = (real_T *)ssGetInputPortSignal(chartInstance.S, 14);
  switch(chartInstance.c1_is_InfusionStateMachine) {
   case c1_IN_ALM_POSTFailed:
    if(_sfEvent_ == c1_event_E_PowerButton) {
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_PowerOff;
      *c1_CurrentState = 1.0;
    } else if(_sfEvent_ == c1_event_E_Warning) {
      c1_warning();
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_ALM_POSTFailed;
      c1_d169 = (real_T)c1_const_MSG_POSTFAIL;
      sf_mex_export("GMsgConStr", sf_mex_create(&c1_d169, "GMsgConStr", 0, 0U,
        0U, 0), 0);
      *c1_CurrentState = 4.0;
    }
    break;
   case c1_IN_CheckDrugRoutine:
    c1_CheckDrugRoutine();
    break;
   case c1_IN_ConfigureInfusionProgram:
    c1_ConfigureInfusionProgram();
    break;
   case c1_IN_ConfirmPowerDown:
    if((_sfEvent_ == c1_event_E_Cancel) && (chartInstance.c1_tempx == 3U)) {
      chartInstance.c1_is_InfusionStateMachine =
        (uint8_T)c1_IN_InfusionInSession;
      c1_enter_internal_InfusionInSession();
    } else if((_sfEvent_ == c1_event_E_Cancel) && (chartInstance.c1_tempx ==
      2U)) {
      chartInstance.c1_is_InfusionStateMachine =
        (uint8_T)c1_IN_ConfigureInfusionProgram;
      c1_enter_internal_ConfigureInfusionProgram();
    } else if((_sfEvent_ == c1_event_E_Cancel) && (chartInstance.c1_tempx ==
      1U)) {
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_CheckDrugRoutine;
      switch(chartInstance.c1_was_CheckDrugRoutine) {
       case c1_IN_ALM_WrongAdminCheck:
        chartInstance.c1_is_CheckDrugRoutine =
          (uint8_T)c1_IN_ALM_WrongAdminCheck;
        chartInstance.c1_was_CheckDrugRoutine =
          (uint8_T)c1_IN_ALM_WrongAdminCheck;
        c1_d170 = (real_T)c1_const_MSG_ADMINFAIL;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d170, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 6.0;
        break;
       case c1_IN_CheckAdminSet:
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_CheckAdminSet;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_CheckAdminSet;
        c1_d171 = (real_T)c1_const_MSG_ADMINCHECK;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d171, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 5.0;
        chartInstance.c1_tempx = 0U;
        if(*c1_adminSetPassed == 1.0) {
          chartInstance.c1_tempx = 1U;
        } else if(*c1_adminSetPassed != 1.0) {
          chartInstance.c1_tempx = 0U;
        }
        break;
       case c1_IN_CheckDrug_CheckType:
        chartInstance.c1_is_CheckDrugRoutine =
          (uint8_T)c1_IN_CheckDrug_CheckType;
        chartInstance.c1_was_CheckDrugRoutine =
          (uint8_T)c1_IN_CheckDrug_CheckType;
        c1_d172 = (real_T)c1_const_MSG_CHECKTYPE;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d172, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 10.0;
        break;
       case c1_IN_CheckPrime:
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_CheckPrime;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_CheckPrime;
        c1_d173 = (real_T)c1_const_MSG_PRIME;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d173, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 7.0;
        chartInstance.c1_tempx = 0U;
        if(*c1_prime == 1.0) {
          chartInstance.c1_tempx = 1U;
        } else if(*c1_prime != 1.0) {
          chartInstance.c1_tempx = 0U;
        }
        break;
       case c1_IN_Check_Concen:
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_Check_Concen;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_Check_Concen;
        c1_d174 = (real_T)c1_const_MSG_CHECKCON;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d174, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 14.0;
        chartInstance.c1_tempx = 0U;
        if((*c1_drugConcentration > *c1_dcupperhard) || (*c1_drugConcentration <
          *c1_dclowerhard)) {
          chartInstance.c1_tempx = 2U;
        } else if((*c1_drugConcentration <= *c1_dcupperhard) &&
         (*c1_drugConcentration >= *c1_dclowerhard)) {
          if((*c1_drugConcentration >= *c1_dclowersoft) &&
           (*c1_drugConcentration <= *c1_dcuppersoft)) {
            chartInstance.c1_tempx = 0U;
          } else if((*c1_drugConcentration > *c1_dcuppersoft) &&
           (*c1_drugConcentration < *c1_dclowersoft)) {
            chartInstance.c1_tempx = 1U;
          }
        }
        break;
       case c1_IN_Check_DoseUnit:
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_Check_DoseUnit;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_Check_DoseUnit;
        c1_d175 = (real_T)c1_const_MSG_CHECKDU;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d175, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 12.0;
        break;
       case c1_IN_DisplayDrugInfo:
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_DisplayDrugInfo;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_DisplayDrugInfo;
        chartInstance.c1_tempx = 0U;
        c1_d176 = (real_T)c1_const_MSG_DRUGINFO;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d176, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 9.0;
        break;
       case c1_IN_DisplayPatientProfile:
        chartInstance.c1_is_CheckDrugRoutine =
          (uint8_T)c1_IN_DisplayPatientProfile;
        chartInstance.c1_was_CheckDrugRoutine =
          (uint8_T)c1_IN_DisplayPatientProfile;
        c1_d177 = (real_T)c1_const_MSG_PATIENTINFO;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d177, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 18.0;
        break;
       case c1_IN_IncorrectDoseUnit:
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_IncorrectDoseUnit;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_IncorrectDoseUnit;
        c1_d178 = (real_T)c1_const_MSG_WRONGDU;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d178, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 13.0;
        break;
       case c1_IN_PrimeFailed:
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_PrimeFailed;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_PrimeFailed;
        c1_d179 = (real_T)c1_const_MSG_PRIMEFAIL;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d179, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 8.0;
        break;
       case c1_IN_UnknownDrug:
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_UnknownDrug;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_UnknownDrug;
        c1_d180 = (real_T)c1_const_MSG_WRONGDRUG;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d180, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 11.0;
        break;
       case c1_IN_WRN_DangerCon:
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_WRN_DangerCon;
        chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_WRN_DangerCon;
        c1_d181 = (real_T)c1_const_MSG_DANGECON;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d181, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 16.0;
        break;
       case c1_IN_WrongConcentration:
        chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_WrongConcentration;
        chartInstance.c1_was_CheckDrugRoutine =
          (uint8_T)c1_IN_WrongConcentration;
        c1_d182 = (real_T)c1_const_MSG_WRONGCON;
        sf_mex_export("GMsgConStr", sf_mex_create(&c1_d182, "GMsgConStr", 0, 0U,
          0U, 0), 0);
        *c1_CurrentState = 15.0;
        break;
      }
    } else if((_sfEvent_ == c1_event_E_Cancel) && (chartInstance.c1_tempx ==
      4U)) {
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_POSTDONE;
      c1_d183 = (real_T)c1_const_MSG_POSTDONE;
      sf_mex_export("GMsgConStr", sf_mex_create(&c1_d183, "GMsgConStr", 0, 0U,
        0U, 0), 0);
      *c1_CurrentState = 45.0;
      chartInstance.c1_tempx = 0U;
    } else if(_sfEvent_ == c1_event_E_Warning) {
      c1_warning();
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_ConfirmPowerDown;
      c1_d184 = (real_T)c1_const_MSG_POWEROFF;
      sf_mex_export("GMsgConStr", sf_mex_create(&c1_d184, "GMsgConStr", 0, 0U,
        0U, 0), 0);
      *c1_CurrentState = 2.0;
    } else if(_sfEvent_ == c1_event_E_ConfirmPowerDown) {
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_PowerOff;
      *c1_CurrentState = 1.0;
    }
    break;
   case c1_IN_InfusionInSession:
    c1_InfusionInSession();
    break;
   case c1_IN_Init:
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_PowerOff;
    *c1_CurrentState = 1.0;
    break;
   case c1_IN_LEVELONEALRM:
    if(_sfEvent_ == c1_event_E_PowerButton) {
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_PowerOff;
      *c1_CurrentState = 1.0;
    }
    break;
   case c1_IN_POST:
    if(chartInstance.c1_tempx == 1U) {
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_POSTDONE;
      c1_d185 = (real_T)c1_const_MSG_POSTDONE;
      sf_mex_export("GMsgConStr", sf_mex_create(&c1_d185, "GMsgConStr", 0, 0U,
        0U, 0), 0);
      *c1_CurrentState = 45.0;
      chartInstance.c1_tempx = 0U;
    } else if(chartInstance.c1_tempx == 0U) {
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_ALM_POSTFailed;
      c1_d186 = (real_T)c1_const_MSG_POSTFAIL;
      sf_mex_export("GMsgConStr", sf_mex_create(&c1_d186, "GMsgConStr", 0, 0U,
        0U, 0), 0);
      *c1_CurrentState = 4.0;
    }
    break;
   case c1_IN_POSTDONE:
    if(_sfEvent_ == c1_event_E_PowerButton) {
      chartInstance.c1_tempx = 4U;
      c1_b_tempx = chartInstance.c1_tempx;
      sf_mex_printf("%s =\\n", "tempx");
      sf_mex_call("disp", 0U, 1U, 6, (real_T)c1_b_tempx);
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_ConfirmPowerDown;
      c1_d187 = (real_T)c1_const_MSG_POWEROFF;
      sf_mex_export("GMsgConStr", sf_mex_create(&c1_d187, "GMsgConStr", 0, 0U,
        0U, 0), 0);
      *c1_CurrentState = 2.0;
    } else if(_sfEvent_ == c1_event_E_CheckAdminSet) {
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_CheckDrugRoutine;
      chartInstance.c1_is_CheckDrugRoutine = (uint8_T)c1_IN_CheckAdminSet;
      chartInstance.c1_was_CheckDrugRoutine = (uint8_T)c1_IN_CheckAdminSet;
      c1_d188 = (real_T)c1_const_MSG_ADMINCHECK;
      sf_mex_export("GMsgConStr", sf_mex_create(&c1_d188, "GMsgConStr", 0, 0U,
        0U, 0), 0);
      *c1_CurrentState = 5.0;
      chartInstance.c1_tempx = 0U;
      if(*c1_adminSetPassed == 1.0) {
        chartInstance.c1_tempx = 1U;
      } else if(*c1_adminSetPassed != 1.0) {
        chartInstance.c1_tempx = 0U;
      }
    } else if(_sfEvent_ == c1_event_E_Warning) {
      c1_warning();
      chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_POSTDONE;
      c1_d189 = (real_T)c1_const_MSG_POSTDONE;
      sf_mex_export("GMsgConStr", sf_mex_create(&c1_d189, "GMsgConStr", 0, 0U,
        0U, 0), 0);
      *c1_CurrentState = 45.0;
      chartInstance.c1_tempx = 0U;
    }
    break;
   case c1_IN_PowerOff:
    c1_PowerOff();
    break;
   default:
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_NO_ACTIVE_CHILD;
    break;
  }
}

static void c1_broadcast_E_Clock(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_Clock;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 10) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_StateChanger2_mod == 0) {
    chartInstance.c1_is_active_c1_StateChanger2_mod = 1U;
    chartInstance.c1_is_c1_StateChanger2_mod =
      (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    10)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_Alarm(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_Alarm;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 10) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_StateChanger2_mod == 0) {
    chartInstance.c1_is_active_c1_StateChanger2_mod = 1U;
    chartInstance.c1_is_c1_StateChanger2_mod =
      (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    10)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_Warning(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_Warning;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 10) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_StateChanger2_mod == 0) {
    chartInstance.c1_is_active_c1_StateChanger2_mod = 1U;
    chartInstance.c1_is_c1_StateChanger2_mod =
      (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    10)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_Ready(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_Ready;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 10) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_StateChanger2_mod == 0) {
    chartInstance.c1_is_active_c1_StateChanger2_mod = 1U;
    chartInstance.c1_is_c1_StateChanger2_mod =
      (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    10)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_NotReady(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_NotReady;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 10) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_StateChanger2_mod == 0) {
    chartInstance.c1_is_active_c1_StateChanger2_mod = 1U;
    chartInstance.c1_is_c1_StateChanger2_mod =
      (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    10)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_StartSimulation(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_StartSimulation;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 10) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_StateChanger2_mod == 0) {
    chartInstance.c1_is_active_c1_StateChanger2_mod = 1U;
    chartInstance.c1_is_c1_StateChanger2_mod =
      (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    10)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_PowerButton(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_PowerButton;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 10) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_StateChanger2_mod == 0) {
    chartInstance.c1_is_active_c1_StateChanger2_mod = 1U;
    chartInstance.c1_is_c1_StateChanger2_mod =
      (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    10)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_NewInfusion(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_NewInfusion;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 10) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_StateChanger2_mod == 0) {
    chartInstance.c1_is_active_c1_StateChanger2_mod = 1U;
    chartInstance.c1_is_c1_StateChanger2_mod =
      (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    10)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_CheckAdminSet(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_CheckAdminSet;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 10) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_StateChanger2_mod == 0) {
    chartInstance.c1_is_active_c1_StateChanger2_mod = 1U;
    chartInstance.c1_is_c1_StateChanger2_mod =
      (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    10)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_Prime(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_Prime;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 10) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_StateChanger2_mod == 0) {
    chartInstance.c1_is_active_c1_StateChanger2_mod = 1U;
    chartInstance.c1_is_c1_StateChanger2_mod =
      (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    10)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_CheckDrug(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_CheckDrug;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 10) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_StateChanger2_mod == 0) {
    chartInstance.c1_is_active_c1_StateChanger2_mod = 1U;
    chartInstance.c1_is_c1_StateChanger2_mod =
      (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    10)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_ConfigureInfusionProgram(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_ConfigureInfusionProgram;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 10) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_StateChanger2_mod == 0) {
    chartInstance.c1_is_active_c1_StateChanger2_mod = 1U;
    chartInstance.c1_is_c1_StateChanger2_mod =
      (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    10)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_ConfirmConcentration(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_ConfirmConcentration;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 10) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_StateChanger2_mod == 0) {
    chartInstance.c1_is_active_c1_StateChanger2_mod = 1U;
    chartInstance.c1_is_c1_StateChanger2_mod =
      (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    10)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_ConfirmDoseRate(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_ConfirmDoseRate;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 10) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_StateChanger2_mod == 0) {
    chartInstance.c1_is_active_c1_StateChanger2_mod = 1U;
    chartInstance.c1_is_c1_StateChanger2_mod =
      (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    10)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_ConfirmVTBI(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_ConfirmVTBI;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 10) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_StateChanger2_mod == 0) {
    chartInstance.c1_is_active_c1_StateChanger2_mod = 1U;
    chartInstance.c1_is_c1_StateChanger2_mod =
      (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    10)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_StartInfusion(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_StartInfusion;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 10) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_StateChanger2_mod == 0) {
    chartInstance.c1_is_active_c1_StateChanger2_mod = 1U;
    chartInstance.c1_is_c1_StateChanger2_mod =
      (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    10)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_ChangeDoseRate(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_ChangeDoseRate;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 10) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_StateChanger2_mod == 0) {
    chartInstance.c1_is_active_c1_StateChanger2_mod = 1U;
    chartInstance.c1_is_c1_StateChanger2_mod =
      (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    10)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_ChangeVTBI(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_ChangeVTBI;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 10) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_StateChanger2_mod == 0) {
    chartInstance.c1_is_active_c1_StateChanger2_mod = 1U;
    chartInstance.c1_is_c1_StateChanger2_mod =
      (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    10)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void c1_broadcast_E_PauseInfusion(void)
{
  uint8_T c1_previousEvent;
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = c1_event_E_PauseInfusion;
  if(_sfEvent_ == c1_event_E_Clock) {
    if(chartInstance.c1_temporalCounter_i1 < 10) {
      chartInstance.c1_temporalCounter_i1 =
        (uint8_T)(chartInstance.c1_temporalCounter_i1 + 1);
    } else {
      chartInstance.c1_temporalCounter_i1 = 1U;
    }
  }
  if(chartInstance.c1_is_active_c1_StateChanger2_mod == 0) {
    chartInstance.c1_is_active_c1_StateChanger2_mod = 1U;
    chartInstance.c1_is_c1_StateChanger2_mod =
      (uint8_T)c1_IN_InfusionStateMachine;
    chartInstance.c1_is_InfusionStateMachine = (uint8_T)c1_IN_Init;
  } else {
    c1_InfusionStateMachine();
  }
  if((_sfEvent_ == c1_event_E_Clock) && (chartInstance.c1_temporalCounter_i1 ==
    10)) {
    chartInstance.c1_temporalCounter_i1 = 0U;
  }
  _sfEvent_ = c1_previousEvent;
}

static void init_script_number_translation(uint32_T c1_machineNumber, uint32_T
 c1_chartNumber)
{
}

const mxArray *sf_c1_StateChanger2_mod_get_eml_resolved_functions_info(void)
{
  const mxArray *c1_nameCaptureInfo = NULL;
  c1_nameCaptureInfo = NULL;
  sf_mex_assign(&c1_nameCaptureInfo, sf_mex_create(NULL, "nameCaptureInfo", 0,
    0U, 1U, 2, 0, 1));
  return c1_nameCaptureInfo;
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c1_StateChanger2_mod_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2556101102U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2679827699U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2046216774U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2425751229U);
}

mxArray *sf_c1_StateChanger2_mod_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] =
  {"checksum","inputs","parameters","outputs"};
  mxArray *mxAutoinheritanceInfo =
  mxCreateStructMatrix(1,1,4,autoinheritanceFields);
  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(2484647734U);
    pr[1] = (double)(1155112931U);
    pr[2] = (double)(975863979U);
    pr[3] = (double)(1571402531U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,38,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }
    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }
    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }
    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(8));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }
    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }
    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,6,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,6,"type",mxType);
    }
    mxSetField(mxData,6,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,7,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,7,"type",mxType);
    }
    mxSetField(mxData,7,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,8,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,8,"type",mxType);
    }
    mxSetField(mxData,8,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,9,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,9,"type",mxType);
    }
    mxSetField(mxData,9,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,10,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,10,"type",mxType);
    }
    mxSetField(mxData,10,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,11,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,11,"type",mxType);
    }
    mxSetField(mxData,11,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,12,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,12,"type",mxType);
    }
    mxSetField(mxData,12,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,13,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,13,"type",mxType);
    }
    mxSetField(mxData,13,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,14,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,14,"type",mxType);
    }
    mxSetField(mxData,14,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,15,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(8));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,15,"type",mxType);
    }
    mxSetField(mxData,15,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,16,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,16,"type",mxType);
    }
    mxSetField(mxData,16,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,17,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,17,"type",mxType);
    }
    mxSetField(mxData,17,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,18,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,18,"type",mxType);
    }
    mxSetField(mxData,18,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,19,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,19,"type",mxType);
    }
    mxSetField(mxData,19,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,20,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,20,"type",mxType);
    }
    mxSetField(mxData,20,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,21,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,21,"type",mxType);
    }
    mxSetField(mxData,21,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,22,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,22,"type",mxType);
    }
    mxSetField(mxData,22,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,23,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,23,"type",mxType);
    }
    mxSetField(mxData,23,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,24,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,24,"type",mxType);
    }
    mxSetField(mxData,24,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,25,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,25,"type",mxType);
    }
    mxSetField(mxData,25,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,26,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,26,"type",mxType);
    }
    mxSetField(mxData,26,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,27,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,27,"type",mxType);
    }
    mxSetField(mxData,27,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,28,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,28,"type",mxType);
    }
    mxSetField(mxData,28,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,29,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,29,"type",mxType);
    }
    mxSetField(mxData,29,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,30,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,30,"type",mxType);
    }
    mxSetField(mxData,30,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,31,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,31,"type",mxType);
    }
    mxSetField(mxData,31,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,32,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,32,"type",mxType);
    }
    mxSetField(mxData,32,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,33,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,33,"type",mxType);
    }
    mxSetField(mxData,33,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,34,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,34,"type",mxType);
    }
    mxSetField(mxData,34,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,35,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,35,"type",mxType);
    }
    mxSetField(mxData,35,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,36,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,36,"type",mxType);
    }
    mxSetField(mxData,36,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,37,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,37,"type",mxType);
    }
    mxSetField(mxData,37,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }
  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,mxREAL));
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,30,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(7));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(7));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }
    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }
    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(7));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }
    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(7));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }
    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }
    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,6,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,6,"type",mxType);
    }
    mxSetField(mxData,6,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,7,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,7,"type",mxType);
    }
    mxSetField(mxData,7,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,8,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,8,"type",mxType);
    }
    mxSetField(mxData,8,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,9,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,9,"type",mxType);
    }
    mxSetField(mxData,9,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,10,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,10,"type",mxType);
    }
    mxSetField(mxData,10,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,11,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,11,"type",mxType);
    }
    mxSetField(mxData,11,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,12,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,12,"type",mxType);
    }
    mxSetField(mxData,12,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,13,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,13,"type",mxType);
    }
    mxSetField(mxData,13,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,14,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,14,"type",mxType);
    }
    mxSetField(mxData,14,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,15,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,15,"type",mxType);
    }
    mxSetField(mxData,15,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,16,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,16,"type",mxType);
    }
    mxSetField(mxData,16,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,17,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,17,"type",mxType);
    }
    mxSetField(mxData,17,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,18,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,18,"type",mxType);
    }
    mxSetField(mxData,18,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,19,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,19,"type",mxType);
    }
    mxSetField(mxData,19,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,20,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,20,"type",mxType);
    }
    mxSetField(mxData,20,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,21,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(7));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,21,"type",mxType);
    }
    mxSetField(mxData,21,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,22,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(7));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,22,"type",mxType);
    }
    mxSetField(mxData,22,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,23,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(7));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,23,"type",mxType);
    }
    mxSetField(mxData,23,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,24,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(7));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,24,"type",mxType);
    }
    mxSetField(mxData,24,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,25,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(7));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,25,"type",mxType);
    }
    mxSetField(mxData,25,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,26,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,26,"type",mxType);
    }
    mxSetField(mxData,26,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,27,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,27,"type",mxType);
    }
    mxSetField(mxData,27,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,28,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,28,"type",mxType);
    }
    mxSetField(mxData,28,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,29,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,29,"type",mxType);
    }
    mxSetField(mxData,29,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }
  return(mxAutoinheritanceInfo);
}

static void sf_opaque_initialize_c1_StateChanger2_mod(void *chartInstanceVar)
{
  initialize_params_c1_StateChanger2_mod();
  initialize_c1_StateChanger2_mod();
}

static void sf_opaque_enable_c1_StateChanger2_mod(void *chartInstanceVar)
{
  enable_c1_StateChanger2_mod();
}

static void sf_opaque_disable_c1_StateChanger2_mod(void *chartInstanceVar)
{
  disable_c1_StateChanger2_mod();
}

static void sf_opaque_gateway_c1_StateChanger2_mod(void *chartInstanceVar)
{
  sf_c1_StateChanger2_mod();
}

static void sf_opaque_terminate_c1_StateChanger2_mod(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) ||
   sim_mode_is_external(chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }
  finalize_c1_StateChanger2_mod();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c1_StateChanger2_mod(SimStruct *S)
{
  int i;
  for(i=0;i<ssGetNumRunTimeParams(S);i++) {
    if(ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }
  if(sf_machine_global_initializer_called()) {
    initialize_params_c1_StateChanger2_mod();
  }
}

static void mdlSetWorkWidths_c1_StateChanger2_mod(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("StateChanger2_mod",1);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("StateChanger2_mod",1,"gatewayCannotBeInlinedMultipleTimes"));
    if(chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 5, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 6, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 7, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 8, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 9, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 10, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 11, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 12, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 13, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 14, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 15, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 16, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 17, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 18, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 19, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 20, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 21, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 22, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 23, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 24, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 25, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 26, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 27, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 28, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 29, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 30, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 31, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 32, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 33, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 34, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 35, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 36, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 37, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"StateChanger2_mod",1,38);
      sf_mark_chart_reusable_outputs(S,"StateChanger2_mod",1,30);
    }
    ssSetInputPortOptimOpts(S, 38, SS_REUSABLE_AND_LOCAL);
    sf_set_rtw_dwork_info(S,"StateChanger2_mod",1);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(1470012291U));
  ssSetChecksum1(S,(3630709963U));
  ssSetChecksum2(S,(2543530388U));
  ssSetChecksum3(S,(3639541600U));

  ssSetmdlDerivatives(S, NULL);

  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c1_StateChanger2_mod(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "StateChanger2_mod", 1);
    ssWriteRTWStrParam(S, "StateflowChartType", "Stateflow");
  }
}

static void mdlStart_c1_StateChanger2_mod(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 0;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway =
    sf_opaque_gateway_c1_StateChanger2_mod;
  chartInstance.chartInfo.initializeChart =
    sf_opaque_initialize_c1_StateChanger2_mod;
  chartInstance.chartInfo.terminateChart =
    sf_opaque_terminate_c1_StateChanger2_mod;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c1_StateChanger2_mod;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c1_StateChanger2_mod;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c1_StateChanger2_mod;
  chartInstance.chartInfo.mdlStart = mdlStart_c1_StateChanger2_mod;
  chartInstance.chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c1_StateChanger2_mod;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo))); /* register the chart instance with simstruct */

  if(!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }
}

void c1_StateChanger2_mod_method_dispatcher(SimStruct *S, int_T method, void
 *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c1_StateChanger2_mod(S);
    break;
   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c1_StateChanger2_mod(S);
    break;
   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c1_StateChanger2_mod(S);
    break;
   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
     "Error calling c1_StateChanger2_mod_method_dispatcher.\n"
     "Can't handle method %d.\n", method);
    break;
  }
}

